/* valagidlparser.c generated by valac, the Vala compiler
 * generated from valagidlparser.vala, do not modify */

/* valagidlparser.vala
 *
 * Copyright (C) 2006-2010  Jürg Billeter
 * Copyright (C) 2006-2008  Raffaele Sandrini
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.

 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.

 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 *
 * Author:
 * 	Jürg Billeter <j@bitron.ch>
 *	Raffaele Sandrini <raffaele@sandrini.ch>
 */

#include <glib.h>
#include <glib-object.h>
#include <vala.h>
#include <valagee.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <gidlmodule.h>
#include <gidlparser.h>
#include <gidlnode.h>
#include <float.h>
#include <math.h>
#include <gmetadata.h>
#include <stdio.h>


#define VALA_TYPE_GIDL_PARSER (vala_gidl_parser_get_type ())
#define VALA_GIDL_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), VALA_TYPE_GIDL_PARSER, ValaGIdlParser))
#define VALA_GIDL_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), VALA_TYPE_GIDL_PARSER, ValaGIdlParserClass))
#define VALA_IS_GIDL_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), VALA_TYPE_GIDL_PARSER))
#define VALA_IS_GIDL_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), VALA_TYPE_GIDL_PARSER))
#define VALA_GIDL_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), VALA_TYPE_GIDL_PARSER, ValaGIdlParserClass))

typedef struct _ValaGIdlParser ValaGIdlParser;
typedef struct _ValaGIdlParserClass ValaGIdlParserClass;
typedef struct _ValaGIdlParserPrivate ValaGIdlParserPrivate;
#define _vala_code_context_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_context_unref (var), NULL)))
#define _vala_source_file_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_file_unref (var), NULL)))
#define _vala_source_reference_unref0(var) ((var == NULL) ? NULL : (var = (vala_source_reference_unref (var), NULL)))
#define _vala_code_node_unref0(var) ((var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL)))
#define _vala_map_unref0(var) ((var == NULL) ? NULL : (var = (vala_map_unref (var), NULL)))
#define _vala_iterable_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterable_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __g_list_free__g_idl_module_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_idl_module_free0_ (var), NULL)))
#define __g_list_free__vala_code_node_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__vala_code_node_unref0_ (var), NULL)))
#define _vala_iterator_unref0(var) ((var == NULL) ? NULL : (var = (vala_iterator_unref (var), NULL)))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_match_info_free0(var) ((var == NULL) ? NULL : (var = (g_match_info_free (var), NULL)))
#define __g_slist_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_free0_ (var), NULL)))

struct _ValaGIdlParser {
	ValaCodeVisitor parent_instance;
	ValaGIdlParserPrivate * priv;
};

struct _ValaGIdlParserClass {
	ValaCodeVisitorClass parent_class;
};

struct _ValaGIdlParserPrivate {
	ValaCodeContext* context;
	ValaSourceFile* current_source_file;
	ValaSourceReference* current_source_reference;
	ValaNamespace* current_namespace;
	ValaTypeSymbol* current_data_type;
	ValaMap* codenode_attributes_map;
	ValaMap* codenode_attributes_patterns;
	ValaSet* current_type_symbol_set;
	ValaMap* cname_type_map;
};


static gpointer vala_gidl_parser_parent_class = NULL;
static GRegex* vala_gidl_parser_type_from_string_regex;
static GRegex* vala_gidl_parser_type_from_string_regex = NULL;

GType vala_gidl_parser_get_type (void) G_GNUC_CONST;
#define VALA_GIDL_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), VALA_TYPE_GIDL_PARSER, ValaGIdlParserPrivate))
enum  {
	VALA_GIDL_PARSER_DUMMY_PROPERTY
};
void vala_gidl_parser_parse (ValaGIdlParser* self, ValaCodeContext* context);
static void vala_gidl_parser_real_visit_namespace (ValaCodeVisitor* base, ValaNamespace* ns);
static void vala_gidl_parser_real_visit_class (ValaCodeVisitor* base, ValaClass* cl);
static void vala_gidl_parser_visit_type (ValaGIdlParser* self, ValaTypeSymbol* t);
static void vala_gidl_parser_real_visit_struct (ValaCodeVisitor* base, ValaStruct* st);
static void vala_gidl_parser_real_visit_interface (ValaCodeVisitor* base, ValaInterface* iface);
static void vala_gidl_parser_real_visit_enum (ValaCodeVisitor* base, ValaEnum* en);
static void vala_gidl_parser_real_visit_error_domain (ValaCodeVisitor* base, ValaErrorDomain* ed);
static void vala_gidl_parser_real_visit_delegate (ValaCodeVisitor* base, ValaDelegate* d);
static gchar* vala_gidl_parser_get_cname (ValaGIdlParser* self, ValaSymbol* sym, ValaSymbol* container);
static void vala_gidl_parser_real_visit_source_file (ValaCodeVisitor* base, ValaSourceFile* source_file);
static void vala_gidl_parser_parse_file (ValaGIdlParser* self, ValaSourceFile* source_file);
static ValaNamespace* vala_gidl_parser_parse_module (ValaGIdlParser* self, GIdlModule* module);
static void _g_idl_module_free0_ (gpointer var);
static void _g_list_free__g_idl_module_free0_ (GList* self);
static gchar* vala_gidl_parser_fix_type_name (ValaGIdlParser* self, const gchar* type_name, ValaSymbol* container);
static gchar** vala_gidl_parser_get_attributes (ValaGIdlParser* self, const gchar* codenode, int* result_length1);
static gchar* vala_gidl_parser_eval (ValaGIdlParser* self, const gchar* s);
gchar* vala_gidl_parser_get_cprefix (ValaGIdlParser* self, ValaSymbol* sym);
static gchar* vala_gidl_parser_fix_const_name (ValaGIdlParser* self, const gchar* const_name, ValaSymbol* container);
static gchar* vala_gidl_parser_get_lower_case_cprefix (ValaGIdlParser* self, ValaSymbol* sym);
static gchar* vala_gidl_parser_get_cheader_filename (ValaGIdlParser* self, ValaSymbol* sym);
static gchar* vala_gidl_parser_get_finish_cname (ValaGIdlParser* self, ValaMethod* m);
static gchar* vala_gidl_parser_get_lower_case_cname (ValaGIdlParser* self, ValaSymbol* sym);
static gchar** vala_gidl_parser_get_attributes_for_node (ValaGIdlParser* self, GIdlNode* node, int* result_length1);
static void vala_gidl_parser_add_symbol_to_container (ValaGIdlParser* self, ValaSymbol* container, ValaSymbol* sym);
static void vala_gidl_parser_parse_node (ValaGIdlParser* self, GIdlNode* node, GIdlModule* module, ValaSymbol* container);
static ValaDelegate* vala_gidl_parser_parse_delegate (ValaGIdlParser* self, GIdlNodeFunction* f_node);
static void vala_gidl_parser_parse_struct (ValaGIdlParser* self, GIdlNodeStruct* st_node, ValaSymbol* container, GIdlModule* module);
static void vala_gidl_parser_parse_union (ValaGIdlParser* self, GIdlNodeUnion* un_node, ValaSymbol* container, GIdlModule* module);
static void vala_gidl_parser_parse_boxed (ValaGIdlParser* self, GIdlNodeBoxed* boxed_node, ValaSymbol* container, GIdlModule* module);
static void vala_gidl_parser_parse_enum (ValaGIdlParser* self, GIdlNodeEnum* en_node, ValaSymbol* container, GIdlModule* module, gboolean is_flags);
static void vala_gidl_parser_parse_object (ValaGIdlParser* self, GIdlNodeInterface* node, ValaSymbol* container, GIdlModule* module);
static void vala_gidl_parser_parse_interface (ValaGIdlParser* self, GIdlNodeInterface* node, ValaSymbol* container, GIdlModule* module);
static ValaConstant* vala_gidl_parser_parse_constant (ValaGIdlParser* self, GIdlNodeConstant* const_node);
static ValaMethod* vala_gidl_parser_parse_function (ValaGIdlParser* self, GIdlNodeFunction* f, gboolean is_interface);
static ValaSymbol* vala_gidl_parser_get_container_from_name (ValaGIdlParser* self, const gchar* name);
static void _vala_code_node_unref0_ (gpointer var);
static void _g_list_free__vala_code_node_unref0_ (GList* self);
static ValaDataType* vala_gidl_parser_parse_param (ValaGIdlParser* self, GIdlNodeParam* param, ValaParameterDirection* direction);
static ValaDataType* vala_gidl_parser_parse_type_from_string (ValaGIdlParser* self, const gchar* type_string, gboolean owned_by_default, ValaSourceReference* source_reference);
static gboolean vala_gidl_parser_parse_type_arguments_from_string (ValaGIdlParser* self, ValaDataType* parent_type, const gchar* type_arguments, ValaSourceReference* source_reference);
static gboolean vala_gidl_parser_param_is_exception (ValaGIdlParser* self, GIdlNodeParam* param);
static ValaDataType* vala_gidl_parser_parse_type (ValaGIdlParser* self, GIdlNodeType* type_node, ValaParameterDirection* direction);
static gboolean vala_gidl_parser_is_reference_type (ValaGIdlParser* self, const gchar* cname);
static ValaDataType* vala_gidl_parser_parse_type_string (ValaGIdlParser* self, const gchar* n);
static ValaField* vala_gidl_parser_parse_field (ValaGIdlParser* self, GIdlNodeField* field_node);
static ValaMethod* vala_gidl_parser_parse_virtual (ValaGIdlParser* self, GIdlNodeVFunc* v, GIdlNodeFunction* func, gboolean is_interface);
static ValaProperty* vala_gidl_parser_parse_property (ValaGIdlParser* self, GIdlNodeProperty* prop_node);
static ValaSignal* vala_gidl_parser_parse_signal (ValaGIdlParser* self, GIdlNodeSignal* sig_node);
static void vala_gidl_parser_handle_async_methods (ValaGIdlParser* self, ValaObjectTypeSymbol* type_symbol);
static gboolean vala_gidl_parser_is_simple_type (ValaGIdlParser* self, const gchar* type_name);
static ValaUnresolvedSymbol* vala_gidl_parser_parse_symbol_from_string (ValaGIdlParser* self, const gchar* symbol_string, ValaSourceReference* source_reference);
static ValaMethod* vala_gidl_parser_create_method (ValaGIdlParser* self, const gchar* name, const gchar* symbol, GIdlNodeParam* res, GList* parameters, gboolean is_constructor, gboolean is_interface);
static gchar* vala_gidl_parser_fix_prop_name (ValaGIdlParser* self, const gchar* name);
static void _g_free0_ (gpointer var);
static void _g_slist_free__g_free0_ (GSList* self);
ValaGIdlParser* vala_gidl_parser_new (void);
ValaGIdlParser* vala_gidl_parser_construct (GType object_type);
static void vala_gidl_parser_finalize (ValaCodeVisitor* obj);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


/**
 * Parse all source files in the specified code context and build a
 * code tree.
 *
 * @param context a code context
 */
static gpointer _vala_code_context_ref0 (gpointer self) {
	return self ? vala_code_context_ref (self) : NULL;
}


void vala_gidl_parser_parse (ValaGIdlParser* self, ValaCodeContext* context) {
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	GEqualFunc _tmp2_ = NULL;
	ValaHashMap* _tmp3_ = NULL;
	ValaCodeContext* _tmp4_ = NULL;
	ValaCodeContext* _tmp5_ = NULL;
	ValaCodeContext* _tmp6_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = g_str_hash;
	_tmp1_ = g_str_equal;
	_tmp2_ = g_direct_equal;
	_tmp3_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, VALA_TYPE_TYPESYMBOL, (GBoxedCopyFunc) vala_code_node_ref, vala_code_node_unref, _tmp0_, _tmp1_, _tmp2_);
	_vala_map_unref0 (self->priv->cname_type_map);
	self->priv->cname_type_map = (ValaMap*) _tmp3_;
	_tmp4_ = context;
	_tmp5_ = _vala_code_context_ref0 (_tmp4_);
	_vala_code_context_unref0 (self->priv->context);
	self->priv->context = _tmp5_;
	_tmp6_ = context;
	vala_code_context_accept (_tmp6_, (ValaCodeVisitor*) self);
	_vala_map_unref0 (self->priv->cname_type_map);
	self->priv->cname_type_map = NULL;
}


static void vala_gidl_parser_real_visit_namespace (ValaCodeVisitor* base, ValaNamespace* ns) {
	ValaGIdlParser * self;
	ValaNamespace* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (ns != NULL);
	_tmp0_ = ns;
	vala_code_node_accept_children ((ValaCodeNode*) _tmp0_, (ValaCodeVisitor*) self);
}


static void vala_gidl_parser_real_visit_class (ValaCodeVisitor* base, ValaClass* cl) {
	ValaGIdlParser * self;
	ValaClass* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (cl != NULL);
	_tmp0_ = cl;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_real_visit_struct (ValaCodeVisitor* base, ValaStruct* st) {
	ValaGIdlParser * self;
	ValaStruct* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (st != NULL);
	_tmp0_ = st;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_real_visit_interface (ValaCodeVisitor* base, ValaInterface* iface) {
	ValaGIdlParser * self;
	ValaInterface* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (iface != NULL);
	_tmp0_ = iface;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_real_visit_enum (ValaCodeVisitor* base, ValaEnum* en) {
	ValaGIdlParser * self;
	ValaEnum* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (en != NULL);
	_tmp0_ = en;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_real_visit_error_domain (ValaCodeVisitor* base, ValaErrorDomain* ed) {
	ValaGIdlParser * self;
	ValaErrorDomain* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (ed != NULL);
	_tmp0_ = ed;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_real_visit_delegate (ValaCodeVisitor* base, ValaDelegate* d) {
	ValaGIdlParser * self;
	ValaDelegate* _tmp0_ = NULL;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (d != NULL);
	_tmp0_ = d;
	vala_gidl_parser_visit_type (self, (ValaTypeSymbol*) _tmp0_);
}


static void vala_gidl_parser_visit_type (ValaGIdlParser* self, ValaTypeSymbol* t) {
	ValaMap* _tmp0_ = NULL;
	ValaTypeSymbol* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (t != NULL);
	_tmp0_ = self->priv->cname_type_map;
	_tmp1_ = t;
	_tmp2_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp1_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = vala_map_contains (_tmp0_, _tmp3_);
	_tmp5_ = !_tmp4_;
	_g_free0 (_tmp3_);
	if (_tmp5_) {
		ValaMap* _tmp6_ = NULL;
		ValaTypeSymbol* _tmp7_ = NULL;
		gchar* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		ValaTypeSymbol* _tmp10_ = NULL;
		_tmp6_ = self->priv->cname_type_map;
		_tmp7_ = t;
		_tmp8_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp7_, NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = t;
		vala_map_set (_tmp6_, _tmp9_, _tmp10_);
		_g_free0 (_tmp9_);
	}
}


static void vala_gidl_parser_real_visit_source_file (ValaCodeVisitor* base, ValaSourceFile* source_file) {
	ValaGIdlParser * self;
	ValaSourceFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	self = (ValaGIdlParser*) base;
	g_return_if_fail (source_file != NULL);
	_tmp0_ = source_file;
	_tmp1_ = vala_source_file_get_filename (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_str_has_suffix (_tmp2_, ".gi");
	if (_tmp3_) {
		ValaSourceFile* _tmp4_ = NULL;
		_tmp4_ = source_file;
		vala_gidl_parser_parse_file (self, _tmp4_);
	}
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_ = NULL;
	glong _tmp1_ = 0L;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_ = 0L;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_ = NULL;
		gchar* _tmp6_ = NULL;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_ = 0L;
	gboolean _tmp3_ = FALSE;
	glong _tmp9_ = 0L;
	glong _tmp15_ = 0L;
	glong _tmp18_ = 0L;
	glong _tmp19_ = 0L;
	glong _tmp20_ = 0L;
	glong _tmp21_ = 0L;
	glong _tmp22_ = 0L;
	gchar* _tmp23_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_ = 0L;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	_tmp3_ = _tmp0_;
	if (_tmp3_) {
		glong _tmp4_ = 0L;
		glong _tmp5_ = 0L;
		glong _tmp6_ = 0L;
		_tmp4_ = offset;
		_tmp5_ = len;
		_tmp6_ = string_strnlen ((gchar*) self, _tmp4_ + _tmp5_);
		string_length = _tmp6_;
	} else {
		gint _tmp7_ = 0;
		gint _tmp8_ = 0;
		_tmp7_ = strlen (self);
		_tmp8_ = _tmp7_;
		string_length = (glong) _tmp8_;
	}
	_tmp9_ = offset;
	if (_tmp9_ < ((glong) 0)) {
		glong _tmp10_ = 0L;
		glong _tmp11_ = 0L;
		glong _tmp12_ = 0L;
		_tmp10_ = string_length;
		_tmp11_ = offset;
		offset = _tmp10_ + _tmp11_;
		_tmp12_ = offset;
		g_return_val_if_fail (_tmp12_ >= ((glong) 0), NULL);
	} else {
		glong _tmp13_ = 0L;
		glong _tmp14_ = 0L;
		_tmp13_ = offset;
		_tmp14_ = string_length;
		g_return_val_if_fail (_tmp13_ <= _tmp14_, NULL);
	}
	_tmp15_ = len;
	if (_tmp15_ < ((glong) 0)) {
		glong _tmp16_ = 0L;
		glong _tmp17_ = 0L;
		_tmp16_ = string_length;
		_tmp17_ = offset;
		len = _tmp16_ - _tmp17_;
	}
	_tmp18_ = offset;
	_tmp19_ = len;
	_tmp20_ = string_length;
	g_return_val_if_fail ((_tmp18_ + _tmp19_) <= _tmp20_, NULL);
	_tmp21_ = offset;
	_tmp22_ = len;
	_tmp23_ = g_strndup (((gchar*) self) + _tmp21_, (gsize) _tmp22_);
	result = _tmp23_;
	return result;
}


static gpointer _vala_source_file_ref0 (gpointer self) {
	return self ? vala_source_file_ref (self) : NULL;
}


static gint string_index_of_char (const gchar* self, gunichar c, gint start_index) {
	gint result = 0;
	gchar* _result_ = NULL;
	gint _tmp0_ = 0;
	gunichar _tmp1_ = 0U;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = start_index;
	_tmp1_ = c;
	_tmp2_ = g_utf8_strchr (((gchar*) self) + _tmp0_, (gssize) (-1), _tmp1_);
	_result_ = _tmp2_;
	_tmp3_ = _result_;
	if (_tmp3_ != NULL) {
		gchar* _tmp4_ = NULL;
		_tmp4_ = _result_;
		result = (gint) (_tmp4_ - ((gchar*) self));
		return result;
	} else {
		result = -1;
		return result;
	}
}


static void _g_idl_module_free0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_idl_module_free (var), NULL));
}


static void _g_list_free__g_idl_module_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_idl_module_free0_, NULL);
	g_list_free (self);
}


static void vala_gidl_parser_parse_file (ValaGIdlParser* self, ValaSourceFile* source_file) {
	gchar* metadata_filename = NULL;
	ValaSourceFile* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	ValaSourceFile* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	ValaSourceFile* _tmp14_ = NULL;
	ValaSourceFile* _tmp15_ = NULL;
	GHashFunc _tmp16_ = NULL;
	GEqualFunc _tmp17_ = NULL;
	GEqualFunc _tmp18_ = NULL;
	ValaHashMap* _tmp19_ = NULL;
	GHashFunc _tmp20_ = NULL;
	GEqualFunc _tmp21_ = NULL;
	ValaHashMap* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source_file != NULL);
	_tmp0_ = source_file;
	_tmp1_ = vala_source_file_get_filename (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = source_file;
	_tmp4_ = vala_source_file_get_filename (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = strlen (".gi");
	_tmp9_ = _tmp8_;
	_tmp10_ = string_substring (_tmp2_, (glong) 0, (glong) (_tmp7_ - _tmp9_));
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strdup_printf ("%s.metadata", _tmp11_);
	_tmp13_ = _tmp12_;
	_g_free0 (_tmp11_);
	metadata_filename = _tmp13_;
	_tmp14_ = source_file;
	_tmp15_ = _vala_source_file_ref0 (_tmp14_);
	_vala_source_file_unref0 (self->priv->current_source_file);
	self->priv->current_source_file = _tmp15_;
	_tmp16_ = g_str_hash;
	_tmp17_ = g_str_equal;
	_tmp18_ = g_direct_equal;
	_tmp19_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp16_, _tmp17_, _tmp18_);
	_vala_map_unref0 (self->priv->codenode_attributes_map);
	self->priv->codenode_attributes_map = (ValaMap*) _tmp19_;
	_tmp20_ = g_direct_hash;
	_tmp21_ = g_direct_equal;
	_tmp22_ = vala_hash_map_new (G_TYPE_POINTER, NULL, NULL, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp20_, (GEqualFunc) g_pattern_spec_equal, _tmp21_);
	_vala_map_unref0 (self->priv->codenode_attributes_patterns);
	self->priv->codenode_attributes_patterns = (ValaMap*) _tmp22_;
	_tmp23_ = metadata_filename;
	_tmp24_ = g_file_test (_tmp23_, G_FILE_TEST_EXISTS);
	if (_tmp24_) {
		{
			gchar* metadata = NULL;
			const gchar* _tmp25_ = NULL;
			gchar* _tmp26_ = NULL;
			const gchar* _tmp27_ = NULL;
			gchar** _tmp28_ = NULL;
			gchar** _tmp29_ = NULL;
			_tmp25_ = metadata_filename;
			g_file_get_contents (_tmp25_, &_tmp26_, NULL, &_inner_error_);
			_g_free0 (metadata);
			metadata = _tmp26_;
			if (_inner_error_ != NULL) {
				_g_free0 (metadata);
				if (_inner_error_->domain == G_FILE_ERROR) {
					goto __catch0_g_file_error;
				}
				_g_free0 (metadata);
				_g_free0 (metadata_filename);
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp27_ = metadata;
			_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, "\n", 0);
			{
				gchar** line_collection = NULL;
				gint line_collection_length1 = 0;
				gint _line_collection_size_ = 0;
				gint line_it = 0;
				line_collection = _tmp29_;
				line_collection_length1 = _vala_array_length (_tmp28_);
				for (line_it = 0; line_it < _vala_array_length (_tmp28_); line_it = line_it + 1) {
					gchar* _tmp30_ = NULL;
					gchar* line = NULL;
					_tmp30_ = g_strdup (line_collection[line_it]);
					line = _tmp30_;
					{
						const gchar* _tmp31_ = NULL;
						gboolean _tmp32_ = FALSE;
						gchar** tokens = NULL;
						const gchar* _tmp33_ = NULL;
						gchar** _tmp34_ = NULL;
						gchar** _tmp35_ = NULL;
						gint tokens_length1 = 0;
						gint _tokens_size_ = 0;
						gchar** _tmp36_ = NULL;
						gint _tmp36__length1 = 0;
						const gchar* _tmp37_ = NULL;
						gchar** _tmp38_ = NULL;
						gint _tmp38__length1 = 0;
						const gchar* _tmp39_ = NULL;
						gint _tmp40_ = 0;
						ValaMap* _tmp48_ = NULL;
						gchar** _tmp49_ = NULL;
						gint _tmp49__length1 = 0;
						const gchar* _tmp50_ = NULL;
						gchar** _tmp51_ = NULL;
						gint _tmp51__length1 = 0;
						const gchar* _tmp52_ = NULL;
						_tmp31_ = line;
						_tmp32_ = g_str_has_prefix (_tmp31_, "#");
						if (_tmp32_) {
							_g_free0 (line);
							continue;
						}
						_tmp33_ = line;
						_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, " ", 2);
						tokens = _tmp35_;
						tokens_length1 = _vala_array_length (_tmp34_);
						_tokens_size_ = tokens_length1;
						_tmp36_ = tokens;
						_tmp36__length1 = tokens_length1;
						_tmp37_ = _tmp36_[0];
						if (NULL == _tmp37_) {
							tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (line);
							continue;
						}
						_tmp38_ = tokens;
						_tmp38__length1 = tokens_length1;
						_tmp39_ = _tmp38_[0];
						_tmp40_ = string_index_of_char (_tmp39_, (gunichar) '*', 0);
						if ((-1) != _tmp40_) {
							GPatternSpec* pattern = NULL;
							gchar** _tmp41_ = NULL;
							gint _tmp41__length1 = 0;
							const gchar* _tmp42_ = NULL;
							GPatternSpec* _tmp43_ = NULL;
							ValaMap* _tmp44_ = NULL;
							GPatternSpec* _tmp45_ = NULL;
							gchar** _tmp46_ = NULL;
							gint _tmp46__length1 = 0;
							const gchar* _tmp47_ = NULL;
							_tmp41_ = tokens;
							_tmp41__length1 = tokens_length1;
							_tmp42_ = _tmp41_[0];
							_tmp43_ = g_pattern_spec_new (_tmp42_);
							pattern = _tmp43_;
							_tmp44_ = self->priv->codenode_attributes_patterns;
							_tmp45_ = pattern;
							_tmp46_ = tokens;
							_tmp46__length1 = tokens_length1;
							_tmp47_ = _tmp46_[0];
							vala_map_set (_tmp44_, _tmp45_, _tmp47_);
						}
						_tmp48_ = self->priv->codenode_attributes_map;
						_tmp49_ = tokens;
						_tmp49__length1 = tokens_length1;
						_tmp50_ = _tmp49_[0];
						_tmp51_ = tokens;
						_tmp51__length1 = tokens_length1;
						_tmp52_ = _tmp51_[1];
						vala_map_set (_tmp48_, _tmp50_, _tmp52_);
						tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (line);
					}
				}
				line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
			}
			_g_free0 (metadata);
		}
		goto __finally0;
		__catch0_g_file_error:
		{
			GError* e = NULL;
			GError* _tmp53_ = NULL;
			const gchar* _tmp54_ = NULL;
			gchar* _tmp55_ = NULL;
			gchar* _tmp56_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp53_ = e;
			_tmp54_ = _tmp53_->message;
			_tmp55_ = g_strdup_printf ("Unable to read metadata file: %s", _tmp54_);
			_tmp56_ = _tmp55_;
			vala_report_error (NULL, _tmp56_);
			_g_free0 (_tmp56_);
			_g_error_free0 (e);
		}
		__finally0:
		if (_inner_error_ != NULL) {
			_g_free0 (metadata_filename);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	{
		GList* modules = NULL;
		ValaSourceFile* _tmp57_ = NULL;
		const gchar* _tmp58_ = NULL;
		const gchar* _tmp59_ = NULL;
		GList* _tmp60_ = NULL;
		ValaSourceFile* _tmp61_ = NULL;
		ValaSourceLocation _tmp62_ = {0};
		ValaSourceLocation _tmp63_ = {0};
		ValaSourceReference* _tmp64_ = NULL;
		_tmp57_ = source_file;
		_tmp58_ = vala_source_file_get_filename (_tmp57_);
		_tmp59_ = _tmp58_;
		_tmp60_ = g_idl_parse_file (_tmp59_, &_inner_error_);
		modules = _tmp60_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_MARKUP_ERROR) {
				goto __catch1_g_markup_error;
			}
			_g_free0 (metadata_filename);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp61_ = source_file;
		vala_source_location_init (&_tmp62_, NULL, 0, 0);
		vala_source_location_init (&_tmp63_, NULL, 0, 0);
		_tmp64_ = vala_source_reference_new (_tmp61_, &_tmp62_, &_tmp63_);
		_vala_source_reference_unref0 (self->priv->current_source_reference);
		self->priv->current_source_reference = _tmp64_;
		{
			GList* module_collection = NULL;
			GList* module_it = NULL;
			module_collection = modules;
			for (module_it = module_collection; module_it != NULL; module_it = module_it->next) {
				GIdlModule* module = NULL;
				module = (GIdlModule*) module_it->data;
				{
					ValaNamespace* ns = NULL;
					GIdlModule* _tmp65_ = NULL;
					ValaNamespace* _tmp66_ = NULL;
					ValaNamespace* _tmp67_ = NULL;
					_tmp65_ = module;
					_tmp66_ = vala_gidl_parser_parse_module (self, _tmp65_);
					ns = _tmp66_;
					_tmp67_ = ns;
					if (_tmp67_ != NULL) {
						ValaCodeContext* _tmp68_ = NULL;
						ValaNamespace* _tmp69_ = NULL;
						ValaNamespace* _tmp70_ = NULL;
						ValaNamespace* _tmp71_ = NULL;
						_tmp68_ = self->priv->context;
						_tmp69_ = vala_code_context_get_root (_tmp68_);
						_tmp70_ = _tmp69_;
						_tmp71_ = ns;
						vala_symbol_add_namespace ((ValaSymbol*) _tmp70_, _tmp71_);
					}
					_vala_code_node_unref0 (ns);
				}
			}
		}
		__g_list_free__g_idl_module_free0_0 (modules);
	}
	goto __finally1;
	__catch1_g_markup_error:
	{
		GError* e = NULL;
		GError* _tmp72_ = NULL;
		const gchar* _tmp73_ = NULL;
		gchar* _tmp74_ = NULL;
		gchar* _tmp75_ = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp72_ = e;
		_tmp73_ = _tmp72_->message;
		_tmp74_ = g_strdup_printf ("Unable to parse GIDL file: %s", _tmp73_);
		_tmp75_ = _tmp74_;
		vala_report_error (NULL, _tmp75_);
		_g_free0 (_tmp75_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_free0 (metadata_filename);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_free0 (metadata_filename);
}


static gchar* vala_gidl_parser_fix_type_name (ValaGIdlParser* self, const gchar* type_name, ValaSymbol* container) {
	gchar* result = NULL;
	gchar** attributes = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	const gchar* _tmp14_ = NULL;
	ValaSymbol* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gboolean _tmp18_ = FALSE;
	const gchar* _tmp36_ = NULL;
	gchar* _tmp37_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (type_name != NULL, NULL);
	g_return_val_if_fail (container != NULL, NULL);
	_tmp0_ = type_name;
	_tmp2_ = vala_gidl_parser_get_attributes (self, _tmp0_, &_tmp1_);
	attributes = _tmp2_;
	attributes_length1 = _tmp1_;
	_attributes_size_ = attributes_length1;
	_tmp3_ = attributes;
	_tmp3__length1 = attributes_length1;
	if (_tmp3_ != NULL) {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = attributes;
		_tmp4__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp4_;
			attr_collection_length1 = _tmp4__length1;
			for (attr_it = 0; attr_it < _tmp4__length1; attr_it = attr_it + 1) {
				gchar* _tmp5_ = NULL;
				gchar* attr = NULL;
				_tmp5_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp5_;
				{
					gchar** nv = NULL;
					const gchar* _tmp6_ = NULL;
					gchar** _tmp7_ = NULL;
					gchar** _tmp8_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp9_ = NULL;
					gint _tmp9__length1 = 0;
					const gchar* _tmp10_ = NULL;
					_tmp6_ = attr;
					_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "=", 2);
					nv = _tmp8_;
					nv_length1 = _vala_array_length (_tmp7_);
					_nv_size_ = nv_length1;
					_tmp9_ = nv;
					_tmp9__length1 = nv_length1;
					_tmp10_ = _tmp9_[0];
					if (g_strcmp0 (_tmp10_, "name") == 0) {
						gchar** _tmp11_ = NULL;
						gint _tmp11__length1 = 0;
						const gchar* _tmp12_ = NULL;
						gchar* _tmp13_ = NULL;
						_tmp11_ = nv;
						_tmp11__length1 = nv_length1;
						_tmp12_ = _tmp11_[1];
						_tmp13_ = vala_gidl_parser_eval (self, _tmp12_);
						result = _tmp13_;
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
						attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp14_ = type_name;
	_tmp15_ = container;
	_tmp16_ = vala_symbol_get_name (_tmp15_);
	_tmp17_ = _tmp16_;
	_tmp18_ = g_str_has_prefix (_tmp14_, _tmp17_);
	if (_tmp18_) {
		const gchar* _tmp19_ = NULL;
		ValaSymbol* _tmp20_ = NULL;
		const gchar* _tmp21_ = NULL;
		const gchar* _tmp22_ = NULL;
		gint _tmp23_ = 0;
		gint _tmp24_ = 0;
		gchar* _tmp25_ = NULL;
		_tmp19_ = type_name;
		_tmp20_ = container;
		_tmp21_ = vala_symbol_get_name (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = strlen (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = string_substring (_tmp19_, (glong) _tmp24_, (glong) (-1));
		result = _tmp25_;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		return result;
	} else {
		gchar* cprefix = NULL;
		ValaSymbol* _tmp26_ = NULL;
		gchar* _tmp27_ = NULL;
		const gchar* _tmp28_ = NULL;
		const gchar* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		_tmp26_ = container;
		_tmp27_ = vala_gidl_parser_get_cprefix (self, _tmp26_);
		cprefix = _tmp27_;
		_tmp28_ = type_name;
		_tmp29_ = cprefix;
		_tmp30_ = g_str_has_prefix (_tmp28_, _tmp29_);
		if (_tmp30_) {
			const gchar* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			gint _tmp33_ = 0;
			gint _tmp34_ = 0;
			gchar* _tmp35_ = NULL;
			_tmp31_ = type_name;
			_tmp32_ = cprefix;
			_tmp33_ = strlen (_tmp32_);
			_tmp34_ = _tmp33_;
			_tmp35_ = string_substring (_tmp31_, (glong) _tmp34_, (glong) (-1));
			result = _tmp35_;
			_g_free0 (cprefix);
			attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
			return result;
		}
		_g_free0 (cprefix);
	}
	_tmp36_ = type_name;
	_tmp37_ = g_strdup (_tmp36_);
	result = _tmp37_;
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static gchar* vala_gidl_parser_fix_const_name (ValaGIdlParser* self, const gchar* const_name, ValaSymbol* container) {
	gchar* result = NULL;
	gchar* pref = NULL;
	ValaSymbol* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	const gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (const_name != NULL, NULL);
	g_return_val_if_fail (container != NULL, NULL);
	_tmp0_ = container;
	_tmp1_ = vala_gidl_parser_get_lower_case_cprefix (self, _tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_utf8_strup (_tmp2_, (gssize) (-1));
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	pref = _tmp4_;
	_tmp5_ = const_name;
	_tmp6_ = pref;
	_tmp7_ = g_str_has_prefix (_tmp5_, _tmp6_);
	if (_tmp7_) {
		const gchar* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gchar* _tmp12_ = NULL;
		_tmp8_ = const_name;
		_tmp9_ = pref;
		_tmp10_ = strlen (_tmp9_);
		_tmp11_ = _tmp10_;
		_tmp12_ = string_substring (_tmp8_, (glong) _tmp11_, (glong) (-1));
		result = _tmp12_;
		_g_free0 (pref);
		return result;
	}
	_tmp13_ = const_name;
	_tmp14_ = g_strdup (_tmp13_);
	result = _tmp14_;
	_g_free0 (pref);
	return result;
}


static gchar* vala_gidl_parser_get_cheader_filename (ValaGIdlParser* self, ValaSymbol* sym) {
	gchar* result = NULL;
	gchar* cheader_filename = NULL;
	ValaSymbol* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	ValaSymbol* _tmp3_ = NULL;
	ValaSymbol* _tmp4_ = NULL;
	ValaSymbol* _tmp5_ = NULL;
	gchar* _tmp19_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	_tmp0_ = sym;
	_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp0_, "CCode", "cheader_filename", NULL);
	cheader_filename = _tmp1_;
	_tmp2_ = cheader_filename;
	if (_tmp2_ != NULL) {
		result = cheader_filename;
		return result;
	}
	_tmp3_ = sym;
	_tmp4_ = vala_symbol_get_parent_symbol (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ != NULL) {
		ValaSymbol* _tmp6_ = NULL;
		ValaSymbol* _tmp7_ = NULL;
		ValaSymbol* _tmp8_ = NULL;
		gchar* _tmp9_ = NULL;
		_tmp6_ = sym;
		_tmp7_ = vala_symbol_get_parent_symbol (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = vala_gidl_parser_get_cheader_filename (self, _tmp8_);
		result = _tmp9_;
		_g_free0 (cheader_filename);
		return result;
	} else {
		ValaSymbol* _tmp10_ = NULL;
		ValaSourceReference* _tmp11_ = NULL;
		ValaSourceReference* _tmp12_ = NULL;
		_tmp10_ = sym;
		_tmp11_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp10_);
		_tmp12_ = _tmp11_;
		if (_tmp12_ != NULL) {
			ValaSymbol* _tmp13_ = NULL;
			ValaSourceReference* _tmp14_ = NULL;
			ValaSourceReference* _tmp15_ = NULL;
			ValaSourceFile* _tmp16_ = NULL;
			ValaSourceFile* _tmp17_ = NULL;
			gchar* _tmp18_ = NULL;
			_tmp13_ = sym;
			_tmp14_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = vala_source_reference_get_file (_tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = vala_source_file_get_cinclude_filename (_tmp17_);
			result = _tmp18_;
			_g_free0 (cheader_filename);
			return result;
		}
	}
	_tmp19_ = g_strdup ("");
	result = _tmp19_;
	_g_free0 (cheader_filename);
	return result;
}


static gchar* vala_gidl_parser_get_cname (ValaGIdlParser* self, ValaSymbol* sym, ValaSymbol* container) {
	gchar* result = NULL;
	ValaSymbol* _tmp0_ = NULL;
	gchar* cname = NULL;
	ValaSymbol* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	ValaSymbol* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	_tmp0_ = container;
	if (_tmp0_ == NULL) {
		ValaSymbol* _tmp1_ = NULL;
		ValaSymbol* _tmp2_ = NULL;
		ValaSymbol* _tmp3_ = NULL;
		_tmp1_ = sym;
		_tmp2_ = vala_symbol_get_parent_symbol (_tmp1_);
		_tmp3_ = _tmp2_;
		container = _tmp3_;
	}
	_tmp4_ = sym;
	_tmp5_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp4_, "CCode", "cname", NULL);
	cname = _tmp5_;
	_tmp6_ = cname;
	if (_tmp6_ != NULL) {
		result = cname;
		return result;
	}
	_tmp7_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, VALA_TYPE_METHOD)) {
		gchar* name = NULL;
		ValaSymbol* _tmp8_ = NULL;
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		ValaSymbol* _tmp12_ = NULL;
		ValaSymbol* _tmp20_ = NULL;
		_tmp8_ = sym;
		_tmp9_ = vala_symbol_get_name (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = g_strdup (_tmp10_);
		name = _tmp11_;
		_tmp12_ = sym;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp12_, VALA_TYPE_CREATION_METHOD)) {
			gboolean _tmp13_ = FALSE;
			const gchar* _tmp14_ = NULL;
			gboolean _tmp16_ = FALSE;
			_tmp14_ = name;
			if (_tmp14_ == NULL) {
				_tmp13_ = TRUE;
			} else {
				const gchar* _tmp15_ = NULL;
				_tmp15_ = name;
				_tmp13_ = g_strcmp0 (_tmp15_, ".new") == 0;
			}
			_tmp16_ = _tmp13_;
			if (_tmp16_) {
				gchar* _tmp17_ = NULL;
				_tmp17_ = g_strdup ("new");
				_g_free0 (name);
				name = _tmp17_;
			} else {
				const gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				_tmp18_ = name;
				_tmp19_ = g_strconcat ("new_", _tmp18_, NULL);
				_g_free0 (name);
				name = _tmp19_;
			}
		}
		_tmp20_ = container;
		if (_tmp20_ != NULL) {
			ValaSymbol* _tmp21_ = NULL;
			gchar* _tmp22_ = NULL;
			gchar* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			gchar* _tmp25_ = NULL;
			gchar* _tmp26_ = NULL;
			_tmp21_ = container;
			_tmp22_ = vala_gidl_parser_get_lower_case_cprefix (self, _tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = name;
			_tmp25_ = g_strdup_printf ("%s%s", _tmp23_, _tmp24_);
			_tmp26_ = _tmp25_;
			_g_free0 (_tmp23_);
			result = _tmp26_;
			_g_free0 (name);
			_g_free0 (cname);
			return result;
		} else {
			result = name;
			_g_free0 (cname);
			return result;
		}
		_g_free0 (name);
	} else {
		ValaSymbol* _tmp27_ = NULL;
		_tmp27_ = container;
		if (_tmp27_ != NULL) {
			ValaSymbol* _tmp28_ = NULL;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_ = NULL;
			ValaSymbol* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			const gchar* _tmp33_ = NULL;
			gchar* _tmp34_ = NULL;
			gchar* _tmp35_ = NULL;
			_tmp28_ = container;
			_tmp29_ = vala_gidl_parser_get_cprefix (self, _tmp28_);
			_tmp30_ = _tmp29_;
			_tmp31_ = sym;
			_tmp32_ = vala_symbol_get_name (_tmp31_);
			_tmp33_ = _tmp32_;
			_tmp34_ = g_strdup_printf ("%s%s", _tmp30_, _tmp33_);
			_tmp35_ = _tmp34_;
			_g_free0 (_tmp30_);
			result = _tmp35_;
			_g_free0 (cname);
			return result;
		} else {
			ValaSymbol* _tmp36_ = NULL;
			const gchar* _tmp37_ = NULL;
			const gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			_tmp36_ = sym;
			_tmp37_ = vala_symbol_get_name (_tmp36_);
			_tmp38_ = _tmp37_;
			_tmp39_ = g_strdup (_tmp38_);
			result = _tmp39_;
			_g_free0 (cname);
			return result;
		}
	}
	_g_free0 (cname);
}


static gchar* vala_gidl_parser_get_finish_cname (ValaGIdlParser* self, ValaMethod* m) {
	gchar* result = NULL;
	gchar* finish_cname = NULL;
	ValaMethod* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _result_ = NULL;
	ValaMethod* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (m != NULL, NULL);
	_tmp0_ = m;
	_tmp1_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp0_, "CCode", "finish_name", NULL);
	finish_cname = _tmp1_;
	_tmp2_ = finish_cname;
	if (_tmp2_ != NULL) {
		result = finish_cname;
		return result;
	}
	_tmp3_ = m;
	_tmp4_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp3_, NULL);
	_result_ = _tmp4_;
	_tmp5_ = _result_;
	_tmp6_ = g_str_has_suffix (_tmp5_, "_async");
	if (_tmp6_) {
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		gint _tmp9_ = 0;
		gint _tmp10_ = 0;
		gint _tmp11_ = 0;
		gint _tmp12_ = 0;
		gchar* _tmp13_ = NULL;
		_tmp7_ = _result_;
		_tmp8_ = _result_;
		_tmp9_ = strlen (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp11_ = strlen ("_async");
		_tmp12_ = _tmp11_;
		_tmp13_ = string_substring (_tmp7_, (glong) 0, (glong) (_tmp10_ - _tmp12_));
		_g_free0 (_result_);
		_result_ = _tmp13_;
	}
	_tmp14_ = _result_;
	_tmp15_ = g_strconcat (_tmp14_, "_finish", NULL);
	result = _tmp15_;
	_g_free0 (_result_);
	_g_free0 (finish_cname);
	return result;
}


static gchar* vala_gidl_parser_get_lower_case_cname (ValaGIdlParser* self, ValaSymbol* sym) {
	gchar* result = NULL;
	gchar* lower_case_csuffix = NULL;
	ValaSymbol* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	ValaSymbol* _tmp4_ = NULL;
	ValaSymbol* _tmp32_ = NULL;
	ValaSymbol* _tmp33_ = NULL;
	ValaSymbol* _tmp34_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	_tmp0_ = sym;
	_tmp1_ = vala_symbol_get_name (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_symbol_camel_case_to_lower_case (_tmp2_);
	lower_case_csuffix = _tmp3_;
	_tmp4_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
		const gchar* _tmp5_ = NULL;
		gboolean _tmp6_ = FALSE;
		const gchar* _tmp21_ = NULL;
		gboolean _tmp22_ = FALSE;
		_tmp5_ = lower_case_csuffix;
		_tmp6_ = g_str_has_prefix (_tmp5_, "type_");
		if (_tmp6_) {
			const gchar* _tmp7_ = NULL;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			_tmp7_ = lower_case_csuffix;
			_tmp8_ = strlen ("type_");
			_tmp9_ = _tmp8_;
			_tmp10_ = string_substring (_tmp7_, (glong) _tmp9_, (glong) (-1));
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strconcat ("type", _tmp11_, NULL);
			_g_free0 (lower_case_csuffix);
			lower_case_csuffix = _tmp12_;
			_g_free0 (_tmp11_);
		} else {
			const gchar* _tmp13_ = NULL;
			gboolean _tmp14_ = FALSE;
			_tmp13_ = lower_case_csuffix;
			_tmp14_ = g_str_has_prefix (_tmp13_, "is_");
			if (_tmp14_) {
				const gchar* _tmp15_ = NULL;
				gint _tmp16_ = 0;
				gint _tmp17_ = 0;
				gchar* _tmp18_ = NULL;
				gchar* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				_tmp15_ = lower_case_csuffix;
				_tmp16_ = strlen ("is_");
				_tmp17_ = _tmp16_;
				_tmp18_ = string_substring (_tmp15_, (glong) _tmp17_, (glong) (-1));
				_tmp19_ = _tmp18_;
				_tmp20_ = g_strconcat ("is", _tmp19_, NULL);
				_g_free0 (lower_case_csuffix);
				lower_case_csuffix = _tmp20_;
				_g_free0 (_tmp19_);
			}
		}
		_tmp21_ = lower_case_csuffix;
		_tmp22_ = g_str_has_suffix (_tmp21_, "_class");
		if (_tmp22_) {
			const gchar* _tmp23_ = NULL;
			const gchar* _tmp24_ = NULL;
			gint _tmp25_ = 0;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			gint _tmp28_ = 0;
			gchar* _tmp29_ = NULL;
			gchar* _tmp30_ = NULL;
			gchar* _tmp31_ = NULL;
			_tmp23_ = lower_case_csuffix;
			_tmp24_ = lower_case_csuffix;
			_tmp25_ = strlen (_tmp24_);
			_tmp26_ = _tmp25_;
			_tmp27_ = strlen ("_class");
			_tmp28_ = _tmp27_;
			_tmp29_ = string_substring (_tmp23_, (glong) 0, (glong) (_tmp26_ - _tmp28_));
			_tmp30_ = _tmp29_;
			_tmp31_ = g_strconcat (_tmp30_, "class", NULL);
			_g_free0 (lower_case_csuffix);
			lower_case_csuffix = _tmp31_;
			_g_free0 (_tmp30_);
		}
	}
	_tmp32_ = sym;
	_tmp33_ = vala_symbol_get_parent_symbol (_tmp32_);
	_tmp34_ = _tmp33_;
	if (_tmp34_ != NULL) {
		ValaSymbol* _tmp35_ = NULL;
		ValaSymbol* _tmp36_ = NULL;
		ValaSymbol* _tmp37_ = NULL;
		gchar* _tmp38_ = NULL;
		gchar* _tmp39_ = NULL;
		const gchar* _tmp40_ = NULL;
		gchar* _tmp41_ = NULL;
		gchar* _tmp42_ = NULL;
		_tmp35_ = sym;
		_tmp36_ = vala_symbol_get_parent_symbol (_tmp35_);
		_tmp37_ = _tmp36_;
		_tmp38_ = vala_gidl_parser_get_lower_case_cprefix (self, _tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = lower_case_csuffix;
		_tmp41_ = g_strdup_printf ("%s%s", _tmp39_, _tmp40_);
		_tmp42_ = _tmp41_;
		_g_free0 (_tmp39_);
		result = _tmp42_;
		_g_free0 (lower_case_csuffix);
		return result;
	} else {
		result = lower_case_csuffix;
		return result;
	}
	_g_free0 (lower_case_csuffix);
}


static gchar* vala_gidl_parser_get_lower_case_cprefix (ValaGIdlParser* self, ValaSymbol* sym) {
	gchar* result = NULL;
	ValaSymbol* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	gchar* cprefix = NULL;
	ValaSymbol* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gboolean _tmp6_ = FALSE;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp12_ = FALSE;
	const gchar* _tmp15_ = NULL;
	ValaSymbol* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	_tmp0_ = sym;
	_tmp1_ = vala_symbol_get_name (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == NULL) {
		gchar* _tmp3_ = NULL;
		_tmp3_ = g_strdup ("");
		result = _tmp3_;
		return result;
	}
	_tmp4_ = sym;
	_tmp5_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp4_, "CCode", "lower_case_cprefix", NULL);
	_g_free0 (cprefix);
	cprefix = _tmp5_;
	_tmp7_ = cprefix;
	if (_tmp7_ == NULL) {
		gboolean _tmp8_ = FALSE;
		ValaSymbol* _tmp9_ = NULL;
		gboolean _tmp11_ = FALSE;
		_tmp9_ = sym;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
			_tmp8_ = TRUE;
		} else {
			ValaSymbol* _tmp10_ = NULL;
			_tmp10_ = sym;
			_tmp8_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, VALA_TYPE_STRUCT);
		}
		_tmp11_ = _tmp8_;
		_tmp6_ = _tmp11_;
	} else {
		_tmp6_ = FALSE;
	}
	_tmp12_ = _tmp6_;
	if (_tmp12_) {
		ValaSymbol* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp13_ = sym;
		_tmp14_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp13_, "CCode", "cprefix", NULL);
		_g_free0 (cprefix);
		cprefix = _tmp14_;
	}
	_tmp15_ = cprefix;
	if (_tmp15_ != NULL) {
		result = cprefix;
		return result;
	}
	_tmp16_ = sym;
	_tmp17_ = vala_gidl_parser_get_lower_case_cname (self, _tmp16_);
	_tmp18_ = _tmp17_;
	_tmp19_ = g_strconcat (_tmp18_, "_", NULL);
	_tmp20_ = _tmp19_;
	_g_free0 (_tmp18_);
	result = _tmp20_;
	_g_free0 (cprefix);
	return result;
}


gchar* vala_gidl_parser_get_cprefix (ValaGIdlParser* self, ValaSymbol* sym) {
	gchar* result = NULL;
	ValaSymbol* _tmp0_ = NULL;
	gchar* _tmp46_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sym != NULL, NULL);
	_tmp0_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, VALA_TYPE_OBJECT_TYPE_SYMBOL)) {
		ValaSymbol* _tmp1_ = NULL;
		gchar* _tmp2_ = NULL;
		_tmp1_ = sym;
		_tmp2_ = vala_gidl_parser_get_cname (self, _tmp1_, NULL);
		result = _tmp2_;
		return result;
	} else {
		gboolean _tmp3_ = FALSE;
		ValaSymbol* _tmp4_ = NULL;
		gboolean _tmp6_ = FALSE;
		_tmp4_ = sym;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, VALA_TYPE_ENUM)) {
			_tmp3_ = TRUE;
		} else {
			ValaSymbol* _tmp5_ = NULL;
			_tmp5_ = sym;
			_tmp3_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, VALA_TYPE_ERROR_DOMAIN);
		}
		_tmp6_ = _tmp3_;
		if (_tmp6_) {
			ValaSymbol* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			gchar* _tmp10_ = NULL;
			gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			gchar* _tmp13_ = NULL;
			_tmp7_ = sym;
			_tmp8_ = vala_gidl_parser_get_lower_case_cname (self, _tmp7_);
			_tmp9_ = _tmp8_;
			_tmp10_ = g_utf8_strup (_tmp9_, (gssize) (-1));
			_tmp11_ = _tmp10_;
			_tmp12_ = g_strdup_printf ("%s_", _tmp11_);
			_tmp13_ = _tmp12_;
			_g_free0 (_tmp11_);
			_g_free0 (_tmp9_);
			result = _tmp13_;
			return result;
		} else {
			ValaSymbol* _tmp14_ = NULL;
			_tmp14_ = sym;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, VALA_TYPE_NAMESPACE)) {
				ValaSymbol* _tmp15_ = NULL;
				const gchar* _tmp16_ = NULL;
				const gchar* _tmp17_ = NULL;
				_tmp15_ = sym;
				_tmp16_ = vala_symbol_get_name (_tmp15_);
				_tmp17_ = _tmp16_;
				if (_tmp17_ != NULL) {
					gchar* cprefix = NULL;
					ValaSymbol* _tmp18_ = NULL;
					gchar* _tmp19_ = NULL;
					const gchar* _tmp20_ = NULL;
					ValaSymbol* _tmp21_ = NULL;
					ValaSymbol* _tmp22_ = NULL;
					ValaSymbol* _tmp23_ = NULL;
					_tmp18_ = sym;
					_tmp19_ = vala_code_node_get_attribute_string ((ValaCodeNode*) _tmp18_, "CCode", "cprefix", NULL);
					cprefix = _tmp19_;
					_tmp20_ = cprefix;
					if (_tmp20_ != NULL) {
						result = cprefix;
						return result;
					}
					_tmp21_ = sym;
					_tmp22_ = vala_symbol_get_parent_symbol (_tmp21_);
					_tmp23_ = _tmp22_;
					if (_tmp23_ != NULL) {
						ValaSymbol* _tmp24_ = NULL;
						ValaSymbol* _tmp25_ = NULL;
						ValaSymbol* _tmp26_ = NULL;
						gchar* _tmp27_ = NULL;
						gchar* _tmp28_ = NULL;
						ValaSymbol* _tmp29_ = NULL;
						const gchar* _tmp30_ = NULL;
						const gchar* _tmp31_ = NULL;
						gchar* _tmp32_ = NULL;
						gchar* _tmp33_ = NULL;
						_tmp24_ = sym;
						_tmp25_ = vala_symbol_get_parent_symbol (_tmp24_);
						_tmp26_ = _tmp25_;
						_tmp27_ = vala_gidl_parser_get_cprefix (self, _tmp26_);
						_tmp28_ = _tmp27_;
						_tmp29_ = sym;
						_tmp30_ = vala_symbol_get_name (_tmp29_);
						_tmp31_ = _tmp30_;
						_tmp32_ = g_strdup_printf ("%s%s", _tmp28_, _tmp31_);
						_tmp33_ = _tmp32_;
						_g_free0 (_tmp28_);
						result = _tmp33_;
						_g_free0 (cprefix);
						return result;
					} else {
						ValaSymbol* _tmp34_ = NULL;
						const gchar* _tmp35_ = NULL;
						const gchar* _tmp36_ = NULL;
						gchar* _tmp37_ = NULL;
						_tmp34_ = sym;
						_tmp35_ = vala_symbol_get_name (_tmp34_);
						_tmp36_ = _tmp35_;
						_tmp37_ = g_strdup (_tmp36_);
						result = _tmp37_;
						_g_free0 (cprefix);
						return result;
					}
					_g_free0 (cprefix);
				} else {
					gchar* _tmp38_ = NULL;
					_tmp38_ = g_strdup ("");
					result = _tmp38_;
					return result;
				}
			} else {
				ValaSymbol* _tmp39_ = NULL;
				const gchar* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				_tmp39_ = sym;
				_tmp40_ = vala_symbol_get_name (_tmp39_);
				_tmp41_ = _tmp40_;
				if (_tmp41_ != NULL) {
					ValaSymbol* _tmp42_ = NULL;
					const gchar* _tmp43_ = NULL;
					const gchar* _tmp44_ = NULL;
					gchar* _tmp45_ = NULL;
					_tmp42_ = sym;
					_tmp43_ = vala_symbol_get_name (_tmp42_);
					_tmp44_ = _tmp43_;
					_tmp45_ = g_strdup (_tmp44_);
					result = _tmp45_;
					return result;
				}
			}
		}
	}
	_tmp46_ = g_strdup ("");
	result = _tmp46_;
	return result;
}


static gchar** vala_gidl_parser_get_attributes_for_node (ValaGIdlParser* self, GIdlNode* node, int* result_length1) {
	gchar** result = NULL;
	gchar* name = NULL;
	GIdlNode* _tmp0_ = NULL;
	GIdlNodeTypeId _tmp1_ = 0;
	const gchar* _tmp32_ = NULL;
	gint _tmp33_ = 0;
	gchar** _tmp34_ = NULL;
	gchar** _tmp35_ = NULL;
	gint _tmp35__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (node != NULL, NULL);
	_tmp0_ = node;
	_tmp1_ = _tmp0_->type;
	if (_tmp1_ == G_IDL_NODE_FUNCTION) {
		GIdlNode* _tmp2_ = NULL;
		const gchar* _tmp3_ = NULL;
		gchar* _tmp4_ = NULL;
		_tmp2_ = node;
		_tmp3_ = ((GIdlNodeFunction*) _tmp2_)->symbol;
		_tmp4_ = g_strdup (_tmp3_);
		_g_free0 (name);
		name = _tmp4_;
	} else {
		GIdlNode* _tmp5_ = NULL;
		GIdlNodeTypeId _tmp6_ = 0;
		_tmp5_ = node;
		_tmp6_ = _tmp5_->type;
		if (_tmp6_ == G_IDL_NODE_SIGNAL) {
			ValaTypeSymbol* _tmp7_ = NULL;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_ = NULL;
			GIdlNode* _tmp10_ = NULL;
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_ = NULL;
			_tmp7_ = self->priv->current_data_type;
			_tmp8_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp7_, NULL);
			_tmp9_ = _tmp8_;
			_tmp10_ = node;
			_tmp11_ = _tmp10_->name;
			_tmp12_ = g_strdup_printf ("%s::%s", _tmp9_, _tmp11_);
			_g_free0 (name);
			name = _tmp12_;
			_g_free0 (_tmp9_);
		} else {
			GIdlNode* _tmp13_ = NULL;
			GIdlNodeTypeId _tmp14_ = 0;
			_tmp13_ = node;
			_tmp14_ = _tmp13_->type;
			if (_tmp14_ == G_IDL_NODE_PROPERTY) {
				ValaTypeSymbol* _tmp15_ = NULL;
				gchar* _tmp16_ = NULL;
				gchar* _tmp17_ = NULL;
				GIdlNode* _tmp18_ = NULL;
				const gchar* _tmp19_ = NULL;
				gchar* _tmp20_ = NULL;
				_tmp15_ = self->priv->current_data_type;
				_tmp16_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp15_, NULL);
				_tmp17_ = _tmp16_;
				_tmp18_ = node;
				_tmp19_ = _tmp18_->name;
				_tmp20_ = g_strdup_printf ("%s:%s", _tmp17_, _tmp19_);
				_g_free0 (name);
				name = _tmp20_;
				_g_free0 (_tmp17_);
			} else {
				GIdlNode* _tmp21_ = NULL;
				GIdlNodeTypeId _tmp22_ = 0;
				_tmp21_ = node;
				_tmp22_ = _tmp21_->type;
				if (_tmp22_ == G_IDL_NODE_FIELD) {
					ValaTypeSymbol* _tmp23_ = NULL;
					gchar* _tmp24_ = NULL;
					gchar* _tmp25_ = NULL;
					GIdlNode* _tmp26_ = NULL;
					const gchar* _tmp27_ = NULL;
					gchar* _tmp28_ = NULL;
					_tmp23_ = self->priv->current_data_type;
					_tmp24_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp23_, NULL);
					_tmp25_ = _tmp24_;
					_tmp26_ = node;
					_tmp27_ = _tmp26_->name;
					_tmp28_ = g_strdup_printf ("%s.%s", _tmp25_, _tmp27_);
					_g_free0 (name);
					name = _tmp28_;
					_g_free0 (_tmp25_);
				} else {
					GIdlNode* _tmp29_ = NULL;
					const gchar* _tmp30_ = NULL;
					gchar* _tmp31_ = NULL;
					_tmp29_ = node;
					_tmp30_ = _tmp29_->name;
					_tmp31_ = g_strdup (_tmp30_);
					_g_free0 (name);
					name = _tmp31_;
				}
			}
		}
	}
	_tmp32_ = name;
	_tmp34_ = vala_gidl_parser_get_attributes (self, _tmp32_, &_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp35__length1 = _tmp33_;
	if (result_length1) {
		*result_length1 = _tmp35__length1;
	}
	result = _tmp35_;
	_g_free0 (name);
	return result;
}


static void vala_gidl_parser_add_symbol_to_container (ValaGIdlParser* self, ValaSymbol* container, ValaSymbol* sym) {
	ValaSymbol* _tmp0_ = NULL;
	gboolean _tmp112_ = FALSE;
	ValaSymbol* _tmp113_ = NULL;
	gboolean _tmp115_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (sym != NULL);
	_tmp0_ = container;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, VALA_TYPE_CLASS)) {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp1_ = NULL;
		ValaSymbol* _tmp2_ = NULL;
		_tmp1_ = container;
		cl = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, VALA_TYPE_CLASS, ValaClass);
		_tmp2_ = sym;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, VALA_TYPE_CLASS)) {
			ValaClass* _tmp3_ = NULL;
			ValaSymbol* _tmp4_ = NULL;
			_tmp3_ = cl;
			_tmp4_ = sym;
			vala_symbol_add_class ((ValaSymbol*) _tmp3_, G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, VALA_TYPE_CLASS, ValaClass));
		} else {
			ValaSymbol* _tmp5_ = NULL;
			_tmp5_ = sym;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, VALA_TYPE_CONSTANT)) {
				ValaClass* _tmp6_ = NULL;
				ValaSymbol* _tmp7_ = NULL;
				_tmp6_ = cl;
				_tmp7_ = sym;
				vala_symbol_add_constant ((ValaSymbol*) _tmp6_, G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, VALA_TYPE_CONSTANT, ValaConstant));
			} else {
				ValaSymbol* _tmp8_ = NULL;
				_tmp8_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, VALA_TYPE_ENUM)) {
					ValaClass* _tmp9_ = NULL;
					ValaSymbol* _tmp10_ = NULL;
					_tmp9_ = cl;
					_tmp10_ = sym;
					vala_symbol_add_enum ((ValaSymbol*) _tmp9_, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, VALA_TYPE_ENUM, ValaEnum));
				} else {
					ValaSymbol* _tmp11_ = NULL;
					_tmp11_ = sym;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp11_, VALA_TYPE_FIELD)) {
						ValaClass* _tmp12_ = NULL;
						ValaSymbol* _tmp13_ = NULL;
						_tmp12_ = cl;
						_tmp13_ = sym;
						vala_symbol_add_field ((ValaSymbol*) _tmp12_, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, VALA_TYPE_FIELD, ValaField));
					} else {
						ValaSymbol* _tmp14_ = NULL;
						_tmp14_ = sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, VALA_TYPE_METHOD)) {
							ValaClass* _tmp15_ = NULL;
							ValaSymbol* _tmp16_ = NULL;
							_tmp15_ = cl;
							_tmp16_ = sym;
							vala_symbol_add_method ((ValaSymbol*) _tmp15_, G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, VALA_TYPE_METHOD, ValaMethod));
						} else {
							ValaSymbol* _tmp17_ = NULL;
							_tmp17_ = sym;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp17_, VALA_TYPE_PROPERTY)) {
								ValaClass* _tmp18_ = NULL;
								ValaSymbol* _tmp19_ = NULL;
								_tmp18_ = cl;
								_tmp19_ = sym;
								vala_symbol_add_property ((ValaSymbol*) _tmp18_, G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_PROPERTY, ValaProperty));
							} else {
								ValaSymbol* _tmp20_ = NULL;
								_tmp20_ = sym;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, VALA_TYPE_SIGNAL)) {
									ValaClass* _tmp21_ = NULL;
									ValaSymbol* _tmp22_ = NULL;
									_tmp21_ = cl;
									_tmp22_ = sym;
									vala_symbol_add_signal ((ValaSymbol*) _tmp21_, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, VALA_TYPE_SIGNAL, ValaSignal));
								} else {
									ValaSymbol* _tmp23_ = NULL;
									_tmp23_ = sym;
									if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp23_, VALA_TYPE_STRUCT)) {
										ValaClass* _tmp24_ = NULL;
										ValaSymbol* _tmp25_ = NULL;
										_tmp24_ = cl;
										_tmp25_ = sym;
										vala_symbol_add_struct ((ValaSymbol*) _tmp24_, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, VALA_TYPE_STRUCT, ValaStruct));
									}
								}
							}
						}
					}
				}
			}
		}
	} else {
		ValaSymbol* _tmp26_ = NULL;
		_tmp26_ = container;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp26_, VALA_TYPE_ENUM)) {
			ValaEnum* en = NULL;
			ValaSymbol* _tmp27_ = NULL;
			ValaSymbol* _tmp28_ = NULL;
			_tmp27_ = container;
			en = G_TYPE_CHECK_INSTANCE_CAST (_tmp27_, VALA_TYPE_ENUM, ValaEnum);
			_tmp28_ = sym;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp28_, VALA_TYPE_ENUM_VALUE)) {
				ValaEnum* _tmp29_ = NULL;
				ValaSymbol* _tmp30_ = NULL;
				_tmp29_ = en;
				_tmp30_ = sym;
				vala_enum_add_value (_tmp29_, G_TYPE_CHECK_INSTANCE_CAST (_tmp30_, VALA_TYPE_ENUM_VALUE, ValaEnumValue));
			} else {
				ValaSymbol* _tmp31_ = NULL;
				_tmp31_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp31_, VALA_TYPE_CONSTANT)) {
					ValaEnum* _tmp32_ = NULL;
					ValaSymbol* _tmp33_ = NULL;
					_tmp32_ = en;
					_tmp33_ = sym;
					vala_symbol_add_constant ((ValaSymbol*) _tmp32_, G_TYPE_CHECK_INSTANCE_CAST (_tmp33_, VALA_TYPE_CONSTANT, ValaConstant));
				} else {
					ValaSymbol* _tmp34_ = NULL;
					_tmp34_ = sym;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp34_, VALA_TYPE_METHOD)) {
						ValaEnum* _tmp35_ = NULL;
						ValaSymbol* _tmp36_ = NULL;
						_tmp35_ = en;
						_tmp36_ = sym;
						vala_symbol_add_method ((ValaSymbol*) _tmp35_, G_TYPE_CHECK_INSTANCE_CAST (_tmp36_, VALA_TYPE_METHOD, ValaMethod));
					}
				}
			}
		} else {
			ValaSymbol* _tmp37_ = NULL;
			_tmp37_ = container;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp37_, VALA_TYPE_INTERFACE)) {
				ValaInterface* iface = NULL;
				ValaSymbol* _tmp38_ = NULL;
				ValaSymbol* _tmp39_ = NULL;
				_tmp38_ = container;
				iface = G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, VALA_TYPE_INTERFACE, ValaInterface);
				_tmp39_ = sym;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp39_, VALA_TYPE_CLASS)) {
					ValaInterface* _tmp40_ = NULL;
					ValaSymbol* _tmp41_ = NULL;
					_tmp40_ = iface;
					_tmp41_ = sym;
					vala_symbol_add_class ((ValaSymbol*) _tmp40_, G_TYPE_CHECK_INSTANCE_CAST (_tmp41_, VALA_TYPE_CLASS, ValaClass));
				} else {
					ValaSymbol* _tmp42_ = NULL;
					_tmp42_ = sym;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, VALA_TYPE_CONSTANT)) {
						ValaInterface* _tmp43_ = NULL;
						ValaSymbol* _tmp44_ = NULL;
						_tmp43_ = iface;
						_tmp44_ = sym;
						vala_symbol_add_constant ((ValaSymbol*) _tmp43_, G_TYPE_CHECK_INSTANCE_CAST (_tmp44_, VALA_TYPE_CONSTANT, ValaConstant));
					} else {
						ValaSymbol* _tmp45_ = NULL;
						_tmp45_ = sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp45_, VALA_TYPE_ENUM)) {
							ValaInterface* _tmp46_ = NULL;
							ValaSymbol* _tmp47_ = NULL;
							_tmp46_ = iface;
							_tmp47_ = sym;
							vala_symbol_add_enum ((ValaSymbol*) _tmp46_, G_TYPE_CHECK_INSTANCE_CAST (_tmp47_, VALA_TYPE_ENUM, ValaEnum));
						} else {
							ValaSymbol* _tmp48_ = NULL;
							_tmp48_ = sym;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp48_, VALA_TYPE_FIELD)) {
								ValaInterface* _tmp49_ = NULL;
								ValaSymbol* _tmp50_ = NULL;
								_tmp49_ = iface;
								_tmp50_ = sym;
								vala_symbol_add_field ((ValaSymbol*) _tmp49_, G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, VALA_TYPE_FIELD, ValaField));
							} else {
								ValaSymbol* _tmp51_ = NULL;
								_tmp51_ = sym;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp51_, VALA_TYPE_METHOD)) {
									ValaInterface* _tmp52_ = NULL;
									ValaSymbol* _tmp53_ = NULL;
									_tmp52_ = iface;
									_tmp53_ = sym;
									vala_symbol_add_method ((ValaSymbol*) _tmp52_, G_TYPE_CHECK_INSTANCE_CAST (_tmp53_, VALA_TYPE_METHOD, ValaMethod));
								} else {
									ValaSymbol* _tmp54_ = NULL;
									_tmp54_ = sym;
									if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp54_, VALA_TYPE_PROPERTY)) {
										ValaInterface* _tmp55_ = NULL;
										ValaSymbol* _tmp56_ = NULL;
										_tmp55_ = iface;
										_tmp56_ = sym;
										vala_symbol_add_property ((ValaSymbol*) _tmp55_, G_TYPE_CHECK_INSTANCE_CAST (_tmp56_, VALA_TYPE_PROPERTY, ValaProperty));
									} else {
										ValaSymbol* _tmp57_ = NULL;
										_tmp57_ = sym;
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp57_, VALA_TYPE_SIGNAL)) {
											ValaInterface* _tmp58_ = NULL;
											ValaSymbol* _tmp59_ = NULL;
											_tmp58_ = iface;
											_tmp59_ = sym;
											vala_symbol_add_signal ((ValaSymbol*) _tmp58_, G_TYPE_CHECK_INSTANCE_CAST (_tmp59_, VALA_TYPE_SIGNAL, ValaSignal));
										} else {
											ValaSymbol* _tmp60_ = NULL;
											_tmp60_ = sym;
											if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp60_, VALA_TYPE_STRUCT)) {
												ValaInterface* _tmp61_ = NULL;
												ValaSymbol* _tmp62_ = NULL;
												_tmp61_ = iface;
												_tmp62_ = sym;
												vala_symbol_add_struct ((ValaSymbol*) _tmp61_, G_TYPE_CHECK_INSTANCE_CAST (_tmp62_, VALA_TYPE_STRUCT, ValaStruct));
											}
										}
									}
								}
							}
						}
					}
				}
			} else {
				ValaSymbol* _tmp63_ = NULL;
				_tmp63_ = container;
				if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp63_, VALA_TYPE_NAMESPACE)) {
					ValaNamespace* ns = NULL;
					ValaSymbol* _tmp64_ = NULL;
					ValaSymbol* _tmp65_ = NULL;
					_tmp64_ = container;
					ns = G_TYPE_CHECK_INSTANCE_CAST (_tmp64_, VALA_TYPE_NAMESPACE, ValaNamespace);
					_tmp65_ = sym;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp65_, VALA_TYPE_NAMESPACE)) {
						ValaNamespace* _tmp66_ = NULL;
						ValaSymbol* _tmp67_ = NULL;
						_tmp66_ = ns;
						_tmp67_ = sym;
						vala_symbol_add_namespace ((ValaSymbol*) _tmp66_, G_TYPE_CHECK_INSTANCE_CAST (_tmp67_, VALA_TYPE_NAMESPACE, ValaNamespace));
					} else {
						ValaSymbol* _tmp68_ = NULL;
						_tmp68_ = sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp68_, VALA_TYPE_CLASS)) {
							ValaNamespace* _tmp69_ = NULL;
							ValaSymbol* _tmp70_ = NULL;
							_tmp69_ = ns;
							_tmp70_ = sym;
							vala_symbol_add_class ((ValaSymbol*) _tmp69_, G_TYPE_CHECK_INSTANCE_CAST (_tmp70_, VALA_TYPE_CLASS, ValaClass));
						} else {
							ValaSymbol* _tmp71_ = NULL;
							_tmp71_ = sym;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp71_, VALA_TYPE_CONSTANT)) {
								ValaNamespace* _tmp72_ = NULL;
								ValaSymbol* _tmp73_ = NULL;
								_tmp72_ = ns;
								_tmp73_ = sym;
								vala_symbol_add_constant ((ValaSymbol*) _tmp72_, G_TYPE_CHECK_INSTANCE_CAST (_tmp73_, VALA_TYPE_CONSTANT, ValaConstant));
							} else {
								ValaSymbol* _tmp74_ = NULL;
								_tmp74_ = sym;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp74_, VALA_TYPE_DELEGATE)) {
									ValaNamespace* _tmp75_ = NULL;
									ValaSymbol* _tmp76_ = NULL;
									_tmp75_ = ns;
									_tmp76_ = sym;
									vala_symbol_add_delegate ((ValaSymbol*) _tmp75_, G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, VALA_TYPE_DELEGATE, ValaDelegate));
								} else {
									ValaSymbol* _tmp77_ = NULL;
									_tmp77_ = sym;
									if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp77_, VALA_TYPE_ENUM)) {
										ValaNamespace* _tmp78_ = NULL;
										ValaSymbol* _tmp79_ = NULL;
										_tmp78_ = ns;
										_tmp79_ = sym;
										vala_symbol_add_enum ((ValaSymbol*) _tmp78_, G_TYPE_CHECK_INSTANCE_CAST (_tmp79_, VALA_TYPE_ENUM, ValaEnum));
									} else {
										ValaSymbol* _tmp80_ = NULL;
										_tmp80_ = sym;
										if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp80_, VALA_TYPE_ERROR_DOMAIN)) {
											ValaNamespace* _tmp81_ = NULL;
											ValaSymbol* _tmp82_ = NULL;
											_tmp81_ = ns;
											_tmp82_ = sym;
											vala_symbol_add_error_domain ((ValaSymbol*) _tmp81_, G_TYPE_CHECK_INSTANCE_CAST (_tmp82_, VALA_TYPE_ERROR_DOMAIN, ValaErrorDomain));
										} else {
											ValaSymbol* _tmp83_ = NULL;
											_tmp83_ = sym;
											if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp83_, VALA_TYPE_FIELD)) {
												ValaNamespace* _tmp84_ = NULL;
												ValaSymbol* _tmp85_ = NULL;
												_tmp84_ = ns;
												_tmp85_ = sym;
												vala_symbol_add_field ((ValaSymbol*) _tmp84_, G_TYPE_CHECK_INSTANCE_CAST (_tmp85_, VALA_TYPE_FIELD, ValaField));
											} else {
												ValaSymbol* _tmp86_ = NULL;
												_tmp86_ = sym;
												if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp86_, VALA_TYPE_INTERFACE)) {
													ValaNamespace* _tmp87_ = NULL;
													ValaSymbol* _tmp88_ = NULL;
													_tmp87_ = ns;
													_tmp88_ = sym;
													vala_symbol_add_interface ((ValaSymbol*) _tmp87_, G_TYPE_CHECK_INSTANCE_CAST (_tmp88_, VALA_TYPE_INTERFACE, ValaInterface));
												} else {
													ValaSymbol* _tmp89_ = NULL;
													_tmp89_ = sym;
													if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp89_, VALA_TYPE_METHOD)) {
														ValaNamespace* _tmp90_ = NULL;
														ValaSymbol* _tmp91_ = NULL;
														_tmp90_ = ns;
														_tmp91_ = sym;
														vala_symbol_add_method ((ValaSymbol*) _tmp90_, G_TYPE_CHECK_INSTANCE_CAST (_tmp91_, VALA_TYPE_METHOD, ValaMethod));
													} else {
														ValaSymbol* _tmp92_ = NULL;
														_tmp92_ = sym;
														if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp92_, VALA_TYPE_NAMESPACE)) {
															ValaNamespace* _tmp93_ = NULL;
															ValaSymbol* _tmp94_ = NULL;
															_tmp93_ = ns;
															_tmp94_ = sym;
															vala_symbol_add_namespace ((ValaSymbol*) _tmp93_, G_TYPE_CHECK_INSTANCE_CAST (_tmp94_, VALA_TYPE_NAMESPACE, ValaNamespace));
														} else {
															ValaSymbol* _tmp95_ = NULL;
															_tmp95_ = sym;
															if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp95_, VALA_TYPE_STRUCT)) {
																ValaNamespace* _tmp96_ = NULL;
																ValaSymbol* _tmp97_ = NULL;
																_tmp96_ = ns;
																_tmp97_ = sym;
																vala_symbol_add_struct ((ValaSymbol*) _tmp96_, G_TYPE_CHECK_INSTANCE_CAST (_tmp97_, VALA_TYPE_STRUCT, ValaStruct));
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				} else {
					ValaSymbol* _tmp98_ = NULL;
					_tmp98_ = container;
					if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp98_, VALA_TYPE_STRUCT)) {
						ValaStruct* st = NULL;
						ValaSymbol* _tmp99_ = NULL;
						ValaSymbol* _tmp100_ = NULL;
						_tmp99_ = container;
						st = G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, VALA_TYPE_STRUCT, ValaStruct);
						_tmp100_ = sym;
						if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp100_, VALA_TYPE_CONSTANT)) {
							ValaStruct* _tmp101_ = NULL;
							ValaSymbol* _tmp102_ = NULL;
							_tmp101_ = st;
							_tmp102_ = sym;
							vala_symbol_add_constant ((ValaSymbol*) _tmp101_, G_TYPE_CHECK_INSTANCE_CAST (_tmp102_, VALA_TYPE_CONSTANT, ValaConstant));
						} else {
							ValaSymbol* _tmp103_ = NULL;
							_tmp103_ = sym;
							if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp103_, VALA_TYPE_FIELD)) {
								ValaStruct* _tmp104_ = NULL;
								ValaSymbol* _tmp105_ = NULL;
								_tmp104_ = st;
								_tmp105_ = sym;
								vala_symbol_add_field ((ValaSymbol*) _tmp104_, G_TYPE_CHECK_INSTANCE_CAST (_tmp105_, VALA_TYPE_FIELD, ValaField));
							} else {
								ValaSymbol* _tmp106_ = NULL;
								_tmp106_ = sym;
								if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp106_, VALA_TYPE_METHOD)) {
									ValaStruct* _tmp107_ = NULL;
									ValaSymbol* _tmp108_ = NULL;
									_tmp107_ = st;
									_tmp108_ = sym;
									vala_symbol_add_method ((ValaSymbol*) _tmp107_, G_TYPE_CHECK_INSTANCE_CAST (_tmp108_, VALA_TYPE_METHOD, ValaMethod));
								} else {
									ValaSymbol* _tmp109_ = NULL;
									_tmp109_ = sym;
									if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp109_, VALA_TYPE_PROPERTY)) {
										ValaStruct* _tmp110_ = NULL;
										ValaSymbol* _tmp111_ = NULL;
										_tmp110_ = st;
										_tmp111_ = sym;
										vala_symbol_add_property ((ValaSymbol*) _tmp110_, G_TYPE_CHECK_INSTANCE_CAST (_tmp111_, VALA_TYPE_PROPERTY, ValaProperty));
									}
								}
							}
						}
					}
				}
			}
		}
	}
	_tmp113_ = sym;
	if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp113_, VALA_TYPE_NAMESPACE)) {
		ValaSymbol* _tmp114_ = NULL;
		_tmp114_ = container;
		_tmp112_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp114_, VALA_TYPE_NAMESPACE);
	} else {
		_tmp112_ = FALSE;
	}
	_tmp115_ = _tmp112_;
	if (_tmp115_) {
		ValaSymbol* _tmp116_ = NULL;
		ValaSymbol* _tmp117_ = NULL;
		gchar* _tmp118_ = NULL;
		gchar* _tmp119_ = NULL;
		_tmp116_ = sym;
		_tmp117_ = sym;
		_tmp118_ = vala_gidl_parser_get_cheader_filename (self, _tmp117_);
		_tmp119_ = _tmp118_;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp116_, "CCode", "cheader_filename", _tmp119_, NULL);
		_g_free0 (_tmp119_);
	}
}


static void vala_gidl_parser_parse_node (ValaGIdlParser* self, GIdlNode* node, GIdlModule* module, ValaSymbol* container) {
	GIdlNode* _tmp0_ = NULL;
	GIdlNodeTypeId _tmp1_ = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	g_return_if_fail (module != NULL);
	g_return_if_fail (container != NULL);
	_tmp0_ = node;
	_tmp1_ = _tmp0_->type;
	if (_tmp1_ == G_IDL_NODE_CALLBACK) {
		ValaDelegate* cb = NULL;
		GIdlNode* _tmp2_ = NULL;
		ValaDelegate* _tmp3_ = NULL;
		ValaDelegate* _tmp4_ = NULL;
		ValaDelegate* _tmp5_ = NULL;
		ValaDelegate* _tmp6_ = NULL;
		const gchar* _tmp7_ = NULL;
		const gchar* _tmp8_ = NULL;
		ValaSymbol* _tmp9_ = NULL;
		gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		ValaSymbol* _tmp12_ = NULL;
		ValaDelegate* _tmp13_ = NULL;
		ValaSourceFile* _tmp14_ = NULL;
		ValaDelegate* _tmp15_ = NULL;
		_tmp2_ = node;
		_tmp3_ = vala_gidl_parser_parse_delegate (self, (GIdlNodeFunction*) _tmp2_);
		cb = _tmp3_;
		_tmp4_ = cb;
		if (_tmp4_ == NULL) {
			_vala_code_node_unref0 (cb);
			return;
		}
		_tmp5_ = cb;
		_tmp6_ = cb;
		_tmp7_ = vala_symbol_get_name ((ValaSymbol*) _tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = container;
		_tmp10_ = vala_gidl_parser_fix_type_name (self, _tmp8_, _tmp9_);
		_tmp11_ = _tmp10_;
		vala_symbol_set_name ((ValaSymbol*) _tmp5_, _tmp11_);
		_g_free0 (_tmp11_);
		_tmp12_ = container;
		_tmp13_ = cb;
		vala_gidl_parser_add_symbol_to_container (self, _tmp12_, (ValaSymbol*) _tmp13_);
		_tmp14_ = self->priv->current_source_file;
		_tmp15_ = cb;
		vala_source_file_add_node (_tmp14_, (ValaCodeNode*) _tmp15_);
		_vala_code_node_unref0 (cb);
	} else {
		GIdlNode* _tmp16_ = NULL;
		GIdlNodeTypeId _tmp17_ = 0;
		_tmp16_ = node;
		_tmp17_ = _tmp16_->type;
		if (_tmp17_ == G_IDL_NODE_STRUCT) {
			GIdlNode* _tmp18_ = NULL;
			ValaSymbol* _tmp19_ = NULL;
			GIdlModule* _tmp20_ = NULL;
			_tmp18_ = node;
			_tmp19_ = container;
			_tmp20_ = module;
			vala_gidl_parser_parse_struct (self, (GIdlNodeStruct*) _tmp18_, _tmp19_, _tmp20_);
		} else {
			GIdlNode* _tmp21_ = NULL;
			GIdlNodeTypeId _tmp22_ = 0;
			_tmp21_ = node;
			_tmp22_ = _tmp21_->type;
			if (_tmp22_ == G_IDL_NODE_UNION) {
				GIdlNode* _tmp23_ = NULL;
				ValaSymbol* _tmp24_ = NULL;
				GIdlModule* _tmp25_ = NULL;
				_tmp23_ = node;
				_tmp24_ = container;
				_tmp25_ = module;
				vala_gidl_parser_parse_union (self, (GIdlNodeUnion*) _tmp23_, _tmp24_, _tmp25_);
			} else {
				GIdlNode* _tmp26_ = NULL;
				GIdlNodeTypeId _tmp27_ = 0;
				_tmp26_ = node;
				_tmp27_ = _tmp26_->type;
				if (_tmp27_ == G_IDL_NODE_BOXED) {
					GIdlNode* _tmp28_ = NULL;
					ValaSymbol* _tmp29_ = NULL;
					GIdlModule* _tmp30_ = NULL;
					_tmp28_ = node;
					_tmp29_ = container;
					_tmp30_ = module;
					vala_gidl_parser_parse_boxed (self, (GIdlNodeBoxed*) _tmp28_, _tmp29_, _tmp30_);
				} else {
					GIdlNode* _tmp31_ = NULL;
					GIdlNodeTypeId _tmp32_ = 0;
					_tmp31_ = node;
					_tmp32_ = _tmp31_->type;
					if (_tmp32_ == G_IDL_NODE_ENUM) {
						GIdlNode* _tmp33_ = NULL;
						ValaSymbol* _tmp34_ = NULL;
						GIdlModule* _tmp35_ = NULL;
						_tmp33_ = node;
						_tmp34_ = container;
						_tmp35_ = module;
						vala_gidl_parser_parse_enum (self, (GIdlNodeEnum*) _tmp33_, _tmp34_, _tmp35_, FALSE);
					} else {
						GIdlNode* _tmp36_ = NULL;
						GIdlNodeTypeId _tmp37_ = 0;
						_tmp36_ = node;
						_tmp37_ = _tmp36_->type;
						if (_tmp37_ == G_IDL_NODE_FLAGS) {
							GIdlNode* _tmp38_ = NULL;
							ValaSymbol* _tmp39_ = NULL;
							GIdlModule* _tmp40_ = NULL;
							_tmp38_ = node;
							_tmp39_ = container;
							_tmp40_ = module;
							vala_gidl_parser_parse_enum (self, (GIdlNodeEnum*) _tmp38_, _tmp39_, _tmp40_, TRUE);
						} else {
							GIdlNode* _tmp41_ = NULL;
							GIdlNodeTypeId _tmp42_ = 0;
							_tmp41_ = node;
							_tmp42_ = _tmp41_->type;
							if (_tmp42_ == G_IDL_NODE_OBJECT) {
								GIdlNode* _tmp43_ = NULL;
								ValaSymbol* _tmp44_ = NULL;
								GIdlModule* _tmp45_ = NULL;
								_tmp43_ = node;
								_tmp44_ = container;
								_tmp45_ = module;
								vala_gidl_parser_parse_object (self, (GIdlNodeInterface*) _tmp43_, _tmp44_, _tmp45_);
							} else {
								GIdlNode* _tmp46_ = NULL;
								GIdlNodeTypeId _tmp47_ = 0;
								_tmp46_ = node;
								_tmp47_ = _tmp46_->type;
								if (_tmp47_ == G_IDL_NODE_INTERFACE) {
									GIdlNode* _tmp48_ = NULL;
									ValaSymbol* _tmp49_ = NULL;
									GIdlModule* _tmp50_ = NULL;
									_tmp48_ = node;
									_tmp49_ = container;
									_tmp50_ = module;
									vala_gidl_parser_parse_interface (self, (GIdlNodeInterface*) _tmp48_, _tmp49_, _tmp50_);
								} else {
									GIdlNode* _tmp51_ = NULL;
									GIdlNodeTypeId _tmp52_ = 0;
									_tmp51_ = node;
									_tmp52_ = _tmp51_->type;
									if (_tmp52_ == G_IDL_NODE_CONSTANT) {
										ValaConstant* c = NULL;
										GIdlNode* _tmp53_ = NULL;
										ValaConstant* _tmp54_ = NULL;
										ValaConstant* _tmp55_ = NULL;
										_tmp53_ = node;
										_tmp54_ = vala_gidl_parser_parse_constant (self, (GIdlNodeConstant*) _tmp53_);
										c = _tmp54_;
										_tmp55_ = c;
										if (_tmp55_ != NULL) {
											ValaConstant* _tmp56_ = NULL;
											ValaConstant* _tmp57_ = NULL;
											const gchar* _tmp58_ = NULL;
											const gchar* _tmp59_ = NULL;
											ValaSymbol* _tmp60_ = NULL;
											gchar* _tmp61_ = NULL;
											gchar* _tmp62_ = NULL;
											ValaSymbol* _tmp63_ = NULL;
											ValaConstant* _tmp64_ = NULL;
											ValaSourceFile* _tmp65_ = NULL;
											ValaConstant* _tmp66_ = NULL;
											_tmp56_ = c;
											_tmp57_ = c;
											_tmp58_ = vala_symbol_get_name ((ValaSymbol*) _tmp57_);
											_tmp59_ = _tmp58_;
											_tmp60_ = container;
											_tmp61_ = vala_gidl_parser_fix_const_name (self, _tmp59_, _tmp60_);
											_tmp62_ = _tmp61_;
											vala_symbol_set_name ((ValaSymbol*) _tmp56_, _tmp62_);
											_g_free0 (_tmp62_);
											_tmp63_ = container;
											_tmp64_ = c;
											vala_gidl_parser_add_symbol_to_container (self, _tmp63_, (ValaSymbol*) _tmp64_);
											_tmp65_ = self->priv->current_source_file;
											_tmp66_ = c;
											vala_source_file_add_node (_tmp65_, (ValaCodeNode*) _tmp66_);
										}
										_vala_code_node_unref0 (c);
									} else {
										GIdlNode* _tmp67_ = NULL;
										GIdlNodeTypeId _tmp68_ = 0;
										_tmp67_ = node;
										_tmp68_ = _tmp67_->type;
										if (_tmp68_ == G_IDL_NODE_FUNCTION) {
											ValaMethod* m = NULL;
											GIdlNode* _tmp69_ = NULL;
											ValaMethod* _tmp70_ = NULL;
											ValaMethod* _tmp71_ = NULL;
											_tmp69_ = node;
											_tmp70_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp69_, FALSE);
											m = _tmp70_;
											_tmp71_ = m;
											if (_tmp71_ != NULL) {
												ValaMethod* _tmp72_ = NULL;
												ValaSymbol* _tmp73_ = NULL;
												ValaMethod* _tmp74_ = NULL;
												ValaSourceFile* _tmp75_ = NULL;
												ValaMethod* _tmp76_ = NULL;
												_tmp72_ = m;
												vala_method_set_binding (_tmp72_, VALA_MEMBER_BINDING_STATIC);
												_tmp73_ = container;
												_tmp74_ = m;
												vala_gidl_parser_add_symbol_to_container (self, _tmp73_, (ValaSymbol*) _tmp74_);
												_tmp75_ = self->priv->current_source_file;
												_tmp76_ = m;
												vala_source_file_add_node (_tmp75_, (ValaCodeNode*) _tmp76_);
											}
											_vala_code_node_unref0 (m);
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
}


static gpointer _vala_code_node_ref0 (gpointer self) {
	return self ? vala_code_node_ref (self) : NULL;
}


static ValaSymbol* vala_gidl_parser_get_container_from_name (ValaGIdlParser* self, const gchar* name) {
	ValaSymbol* result = NULL;
	gchar** path = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	gint path_length1 = 0;
	gint _path_size_ = 0;
	ValaSymbol* cp = NULL;
	ValaNamespace* _tmp3_ = NULL;
	ValaSymbol* _tmp4_ = NULL;
	ValaSymbol* _tmp5_ = NULL;
	ValaSymbol* _tmp6_ = NULL;
	ValaSymbol* _tmp7_ = NULL;
	ValaCodeContext* _tmp8_ = NULL;
	ValaNamespace* _tmp9_ = NULL;
	ValaNamespace* _tmp10_ = NULL;
	ValaSymbol* cc = NULL;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = name;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	path = _tmp2_;
	path_length1 = _vala_array_length (_tmp1_);
	_path_size_ = path_length1;
	_tmp3_ = self->priv->current_namespace;
	_tmp4_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp3_);
	cp = _tmp4_;
	_tmp5_ = cp;
	_tmp6_ = vala_symbol_get_parent_symbol (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = self->priv->context;
	_tmp9_ = vala_code_context_get_root (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp7_ != G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, VALA_TYPE_SYMBOL, ValaSymbol)) {
		ValaSymbol* _tmp11_ = NULL;
		ValaSymbol* _tmp12_ = NULL;
		ValaSymbol* _tmp13_ = NULL;
		ValaSymbol* _tmp14_ = NULL;
		_tmp11_ = cp;
		_tmp12_ = vala_symbol_get_parent_symbol (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp14_ = _vala_code_node_ref0 (_tmp13_);
		_vala_code_node_unref0 (cp);
		cp = _tmp14_;
	}
	cc = NULL;
	_tmp15_ = path;
	_tmp15__length1 = path_length1;
	{
		gchar** tok_collection = NULL;
		gint tok_collection_length1 = 0;
		gint _tok_collection_size_ = 0;
		gint tok_it = 0;
		tok_collection = _tmp15_;
		tok_collection_length1 = _tmp15__length1;
		for (tok_it = 0; tok_it < _tmp15__length1; tok_it = tok_it + 1) {
			const gchar* tok = NULL;
			tok = tok_collection[tok_it];
			{
				ValaSymbol* _tmp16_ = NULL;
				ValaScope* _tmp17_ = NULL;
				ValaScope* _tmp18_ = NULL;
				const gchar* _tmp19_ = NULL;
				ValaSymbol* _tmp20_ = NULL;
				ValaSymbol* _tmp21_ = NULL;
				ValaSymbol* _tmp22_ = NULL;
				ValaSymbol* _tmp28_ = NULL;
				ValaSymbol* _tmp29_ = NULL;
				_tmp16_ = cp;
				_tmp17_ = vala_symbol_get_scope (_tmp16_);
				_tmp18_ = _tmp17_;
				_tmp19_ = tok;
				_tmp20_ = vala_scope_lookup (_tmp18_, _tmp19_);
				_tmp21_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp20_, VALA_TYPE_SYMBOL) ? ((ValaSymbol*) _tmp20_) : NULL;
				if (_tmp21_ == NULL) {
					_vala_code_node_unref0 (_tmp20_);
				}
				_vala_code_node_unref0 (cc);
				cc = _tmp21_;
				_tmp22_ = cc;
				if (_tmp22_ == NULL) {
					const gchar* _tmp23_ = NULL;
					ValaSourceReference* _tmp24_ = NULL;
					ValaNamespace* _tmp25_ = NULL;
					ValaSymbol* _tmp26_ = NULL;
					ValaSymbol* _tmp27_ = NULL;
					_tmp23_ = tok;
					_tmp24_ = self->priv->current_source_reference;
					_tmp25_ = vala_namespace_new (_tmp23_, _tmp24_);
					_vala_code_node_unref0 (cc);
					cc = (ValaSymbol*) _tmp25_;
					_tmp26_ = cp;
					_tmp27_ = cc;
					vala_gidl_parser_add_symbol_to_container (self, _tmp26_, _tmp27_);
				}
				_tmp28_ = cc;
				_tmp29_ = _vala_code_node_ref0 (_tmp28_);
				_vala_code_node_unref0 (cp);
				cp = _tmp29_;
			}
		}
	}
	result = cc;
	_vala_code_node_unref0 (cp);
	path = (_vala_array_free (path, path_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void _vala_code_node_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (vala_code_node_unref (var), NULL));
}


static void _g_list_free__vala_code_node_unref0_ (GList* self) {
	g_list_foreach (self, (GFunc) _vala_code_node_unref0_, NULL);
	g_list_free (self);
}


static gpointer _vala_iterable_ref0 (gpointer self) {
	return self ? vala_iterable_ref (self) : NULL;
}


static ValaNamespace* vala_gidl_parser_parse_module (ValaGIdlParser* self, GIdlModule* module) {
	ValaNamespace* result = NULL;
	ValaSymbol* sym = NULL;
	ValaCodeContext* _tmp0_ = NULL;
	ValaNamespace* _tmp1_ = NULL;
	ValaNamespace* _tmp2_ = NULL;
	ValaScope* _tmp3_ = NULL;
	ValaScope* _tmp4_ = NULL;
	GIdlModule* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	ValaSymbol* _tmp7_ = NULL;
	ValaNamespace* ns = NULL;
	ValaSymbol* _tmp8_ = NULL;
	ValaNamespace* _tmp21_ = NULL;
	ValaNamespace* _tmp22_ = NULL;
	gchar** attributes = NULL;
	ValaNamespace* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	const gchar* _tmp25_ = NULL;
	gint _tmp26_ = 0;
	gchar** _tmp27_ = NULL;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp28_ = NULL;
	gint _tmp28__length1 = 0;
	ValaArrayList* deferred = NULL;
	GEqualFunc _tmp109_ = NULL;
	ValaArrayList* _tmp110_ = NULL;
	GIdlModule* _tmp111_ = NULL;
	GList* _tmp112_ = NULL;
	ValaSymbol* _tmp167_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (module != NULL, NULL);
	_tmp0_ = self->priv->context;
	_tmp1_ = vala_code_context_get_root (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = vala_symbol_get_scope ((ValaSymbol*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = module;
	_tmp6_ = _tmp5_->name;
	_tmp7_ = vala_scope_lookup (_tmp4_, _tmp6_);
	sym = _tmp7_;
	_tmp8_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, VALA_TYPE_NAMESPACE)) {
		ValaSymbol* _tmp9_ = NULL;
		ValaNamespace* _tmp10_ = NULL;
		ValaNamespace* _tmp11_ = NULL;
		gboolean _tmp12_ = FALSE;
		gboolean _tmp13_ = FALSE;
		_tmp9_ = sym;
		_tmp10_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, VALA_TYPE_NAMESPACE, ValaNamespace));
		_vala_code_node_unref0 (ns);
		ns = _tmp10_;
		_tmp11_ = ns;
		_tmp12_ = vala_symbol_get_external_package ((ValaSymbol*) _tmp11_);
		_tmp13_ = _tmp12_;
		if (_tmp13_) {
			ValaNamespace* _tmp14_ = NULL;
			ValaNamespace* _tmp15_ = NULL;
			ValaSourceReference* _tmp16_ = NULL;
			_tmp14_ = ns;
			__g_list_free__vala_code_node_unref0_0 (((ValaCodeNode*) _tmp14_)->attributes);
			((ValaCodeNode*) _tmp14_)->attributes = NULL;
			_tmp15_ = ns;
			_tmp16_ = self->priv->current_source_reference;
			vala_code_node_set_source_reference ((ValaCodeNode*) _tmp15_, _tmp16_);
		}
	} else {
		GIdlModule* _tmp17_ = NULL;
		const gchar* _tmp18_ = NULL;
		ValaSourceReference* _tmp19_ = NULL;
		ValaNamespace* _tmp20_ = NULL;
		_tmp17_ = module;
		_tmp18_ = _tmp17_->name;
		_tmp19_ = self->priv->current_source_reference;
		_tmp20_ = vala_namespace_new (_tmp18_, _tmp19_);
		_vala_code_node_unref0 (ns);
		ns = _tmp20_;
	}
	_tmp21_ = ns;
	_tmp22_ = _vala_code_node_ref0 (_tmp21_);
	_vala_code_node_unref0 (self->priv->current_namespace);
	self->priv->current_namespace = _tmp22_;
	_tmp23_ = ns;
	_tmp24_ = vala_symbol_get_name ((ValaSymbol*) _tmp23_);
	_tmp25_ = _tmp24_;
	_tmp27_ = vala_gidl_parser_get_attributes (self, _tmp25_, &_tmp26_);
	attributes = _tmp27_;
	attributes_length1 = _tmp26_;
	_attributes_size_ = attributes_length1;
	_tmp28_ = attributes;
	_tmp28__length1 = attributes_length1;
	if (_tmp28_ != NULL) {
		gchar** _tmp29_ = NULL;
		gint _tmp29__length1 = 0;
		_tmp29_ = attributes;
		_tmp29__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp29_;
			attr_collection_length1 = _tmp29__length1;
			for (attr_it = 0; attr_it < _tmp29__length1; attr_it = attr_it + 1) {
				gchar* _tmp30_ = NULL;
				gchar* attr = NULL;
				_tmp30_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp30_;
				{
					gchar** nv = NULL;
					const gchar* _tmp31_ = NULL;
					gchar** _tmp32_ = NULL;
					gchar** _tmp33_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp34_ = NULL;
					gint _tmp34__length1 = 0;
					const gchar* _tmp35_ = NULL;
					_tmp31_ = attr;
					_tmp33_ = _tmp32_ = g_strsplit (_tmp31_, "=", 2);
					nv = _tmp33_;
					nv_length1 = _vala_array_length (_tmp32_);
					_nv_size_ = nv_length1;
					_tmp34_ = nv;
					_tmp34__length1 = nv_length1;
					_tmp35_ = _tmp34_[0];
					if (g_strcmp0 (_tmp35_, "cheader_filename") == 0) {
						ValaNamespace* _tmp36_ = NULL;
						gchar** _tmp37_ = NULL;
						gint _tmp37__length1 = 0;
						const gchar* _tmp38_ = NULL;
						gchar* _tmp39_ = NULL;
						gchar* _tmp40_ = NULL;
						_tmp36_ = ns;
						_tmp37_ = nv;
						_tmp37__length1 = nv_length1;
						_tmp38_ = _tmp37_[1];
						_tmp39_ = vala_gidl_parser_eval (self, _tmp38_);
						_tmp40_ = _tmp39_;
						vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp36_, "CCode", "cheader_filename", _tmp40_, NULL);
						_g_free0 (_tmp40_);
					} else {
						gchar** _tmp41_ = NULL;
						gint _tmp41__length1 = 0;
						const gchar* _tmp42_ = NULL;
						_tmp41_ = nv;
						_tmp41__length1 = nv_length1;
						_tmp42_ = _tmp41_[0];
						if (g_strcmp0 (_tmp42_, "cprefix") == 0) {
							ValaNamespace* _tmp43_ = NULL;
							gchar** _tmp44_ = NULL;
							gint _tmp44__length1 = 0;
							const gchar* _tmp45_ = NULL;
							gchar* _tmp46_ = NULL;
							gchar* _tmp47_ = NULL;
							_tmp43_ = ns;
							_tmp44_ = nv;
							_tmp44__length1 = nv_length1;
							_tmp45_ = _tmp44_[1];
							_tmp46_ = vala_gidl_parser_eval (self, _tmp45_);
							_tmp47_ = _tmp46_;
							vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp43_, "CCode", "cprefix", _tmp47_, NULL);
							_g_free0 (_tmp47_);
						} else {
							gchar** _tmp48_ = NULL;
							gint _tmp48__length1 = 0;
							const gchar* _tmp49_ = NULL;
							_tmp48_ = nv;
							_tmp48__length1 = nv_length1;
							_tmp49_ = _tmp48_[0];
							if (g_strcmp0 (_tmp49_, "lower_case_cprefix") == 0) {
								ValaNamespace* _tmp50_ = NULL;
								gchar** _tmp51_ = NULL;
								gint _tmp51__length1 = 0;
								const gchar* _tmp52_ = NULL;
								gchar* _tmp53_ = NULL;
								gchar* _tmp54_ = NULL;
								_tmp50_ = ns;
								_tmp51_ = nv;
								_tmp51__length1 = nv_length1;
								_tmp52_ = _tmp51_[1];
								_tmp53_ = vala_gidl_parser_eval (self, _tmp52_);
								_tmp54_ = _tmp53_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp50_, "CCode", "lower_case_cprefix", _tmp54_, NULL);
								_g_free0 (_tmp54_);
							} else {
								gchar** _tmp55_ = NULL;
								gint _tmp55__length1 = 0;
								const gchar* _tmp56_ = NULL;
								_tmp55_ = nv;
								_tmp55__length1 = nv_length1;
								_tmp56_ = _tmp55_[0];
								if (g_strcmp0 (_tmp56_, "gir_namespace") == 0) {
									ValaNamespace* _tmp57_ = NULL;
									ValaSourceReference* _tmp58_ = NULL;
									ValaSourceReference* _tmp59_ = NULL;
									ValaSourceFile* _tmp60_ = NULL;
									ValaSourceFile* _tmp61_ = NULL;
									gchar** _tmp62_ = NULL;
									gint _tmp62__length1 = 0;
									const gchar* _tmp63_ = NULL;
									gchar* _tmp64_ = NULL;
									gchar* _tmp65_ = NULL;
									ValaNamespace* _tmp66_ = NULL;
									gchar** _tmp67_ = NULL;
									gint _tmp67__length1 = 0;
									const gchar* _tmp68_ = NULL;
									gchar* _tmp69_ = NULL;
									gchar* _tmp70_ = NULL;
									_tmp57_ = ns;
									_tmp58_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp57_);
									_tmp59_ = _tmp58_;
									_tmp60_ = vala_source_reference_get_file (_tmp59_);
									_tmp61_ = _tmp60_;
									_tmp62_ = nv;
									_tmp62__length1 = nv_length1;
									_tmp63_ = _tmp62_[1];
									_tmp64_ = vala_gidl_parser_eval (self, _tmp63_);
									_tmp65_ = _tmp64_;
									vala_source_file_set_gir_namespace (_tmp61_, _tmp65_);
									_g_free0 (_tmp65_);
									_tmp66_ = ns;
									_tmp67_ = nv;
									_tmp67__length1 = nv_length1;
									_tmp68_ = _tmp67_[1];
									_tmp69_ = vala_gidl_parser_eval (self, _tmp68_);
									_tmp70_ = _tmp69_;
									vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp66_, "CCode", "gir_namespace", _tmp70_, NULL);
									_g_free0 (_tmp70_);
								} else {
									gchar** _tmp71_ = NULL;
									gint _tmp71__length1 = 0;
									const gchar* _tmp72_ = NULL;
									_tmp71_ = nv;
									_tmp71__length1 = nv_length1;
									_tmp72_ = _tmp71_[0];
									if (g_strcmp0 (_tmp72_, "gir_version") == 0) {
										ValaNamespace* _tmp73_ = NULL;
										ValaSourceReference* _tmp74_ = NULL;
										ValaSourceReference* _tmp75_ = NULL;
										ValaSourceFile* _tmp76_ = NULL;
										ValaSourceFile* _tmp77_ = NULL;
										gchar** _tmp78_ = NULL;
										gint _tmp78__length1 = 0;
										const gchar* _tmp79_ = NULL;
										gchar* _tmp80_ = NULL;
										gchar* _tmp81_ = NULL;
										ValaNamespace* _tmp82_ = NULL;
										gchar** _tmp83_ = NULL;
										gint _tmp83__length1 = 0;
										const gchar* _tmp84_ = NULL;
										gchar* _tmp85_ = NULL;
										gchar* _tmp86_ = NULL;
										_tmp73_ = ns;
										_tmp74_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp73_);
										_tmp75_ = _tmp74_;
										_tmp76_ = vala_source_reference_get_file (_tmp75_);
										_tmp77_ = _tmp76_;
										_tmp78_ = nv;
										_tmp78__length1 = nv_length1;
										_tmp79_ = _tmp78_[1];
										_tmp80_ = vala_gidl_parser_eval (self, _tmp79_);
										_tmp81_ = _tmp80_;
										vala_source_file_set_gir_version (_tmp77_, _tmp81_);
										_g_free0 (_tmp81_);
										_tmp82_ = ns;
										_tmp83_ = nv;
										_tmp83__length1 = nv_length1;
										_tmp84_ = _tmp83_[1];
										_tmp85_ = vala_gidl_parser_eval (self, _tmp84_);
										_tmp86_ = _tmp85_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp82_, "CCode", "gir_version", _tmp86_, NULL);
										_g_free0 (_tmp86_);
									} else {
										gchar** _tmp87_ = NULL;
										gint _tmp87__length1 = 0;
										const gchar* _tmp88_ = NULL;
										_tmp87_ = nv;
										_tmp87__length1 = nv_length1;
										_tmp88_ = _tmp87_[0];
										if (g_strcmp0 (_tmp88_, "deprecated") == 0) {
											gchar** _tmp89_ = NULL;
											gint _tmp89__length1 = 0;
											const gchar* _tmp90_ = NULL;
											gchar* _tmp91_ = NULL;
											gchar* _tmp92_ = NULL;
											gboolean _tmp93_ = FALSE;
											_tmp89_ = nv;
											_tmp89__length1 = nv_length1;
											_tmp90_ = _tmp89_[1];
											_tmp91_ = vala_gidl_parser_eval (self, _tmp90_);
											_tmp92_ = _tmp91_;
											_tmp93_ = g_strcmp0 (_tmp92_, "1") == 0;
											_g_free0 (_tmp92_);
											if (_tmp93_) {
												ValaNamespace* _tmp94_ = NULL;
												_tmp94_ = ns;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp94_, "Deprecated", TRUE, NULL);
											}
										} else {
											gchar** _tmp95_ = NULL;
											gint _tmp95__length1 = 0;
											const gchar* _tmp96_ = NULL;
											_tmp95_ = nv;
											_tmp95__length1 = nv_length1;
											_tmp96_ = _tmp95_[0];
											if (g_strcmp0 (_tmp96_, "replacement") == 0) {
												ValaNamespace* _tmp97_ = NULL;
												gchar** _tmp98_ = NULL;
												gint _tmp98__length1 = 0;
												const gchar* _tmp99_ = NULL;
												gchar* _tmp100_ = NULL;
												gchar* _tmp101_ = NULL;
												_tmp97_ = ns;
												_tmp98_ = nv;
												_tmp98__length1 = nv_length1;
												_tmp99_ = _tmp98_[1];
												_tmp100_ = vala_gidl_parser_eval (self, _tmp99_);
												_tmp101_ = _tmp100_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp97_, "Deprecated", "replacement", _tmp101_, NULL);
												_g_free0 (_tmp101_);
											} else {
												gchar** _tmp102_ = NULL;
												gint _tmp102__length1 = 0;
												const gchar* _tmp103_ = NULL;
												_tmp102_ = nv;
												_tmp102__length1 = nv_length1;
												_tmp103_ = _tmp102_[0];
												if (g_strcmp0 (_tmp103_, "deprecated_since") == 0) {
													ValaNamespace* _tmp104_ = NULL;
													gchar** _tmp105_ = NULL;
													gint _tmp105__length1 = 0;
													const gchar* _tmp106_ = NULL;
													gchar* _tmp107_ = NULL;
													gchar* _tmp108_ = NULL;
													_tmp104_ = ns;
													_tmp105_ = nv;
													_tmp105__length1 = nv_length1;
													_tmp106_ = _tmp105_[1];
													_tmp107_ = vala_gidl_parser_eval (self, _tmp106_);
													_tmp108_ = _tmp107_;
													vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp104_, "Deprecated", "since", _tmp108_, NULL);
													_g_free0 (_tmp108_);
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp109_ = g_direct_equal;
	_tmp110_ = vala_array_list_new (G_TYPE_POINTER, NULL, NULL, _tmp109_);
	deferred = _tmp110_;
	_tmp111_ = module;
	_tmp112_ = _tmp111_->entries;
	{
		GList* node_collection = NULL;
		GList* node_it = NULL;
		node_collection = _tmp112_;
		for (node_it = node_collection; node_it != NULL; node_it = node_it->next) {
			GIdlNode* node = NULL;
			node = (GIdlNode*) node_it->data;
			{
				gboolean is_deferred = FALSE;
				gchar** child_attributes = NULL;
				GIdlNode* _tmp113_ = NULL;
				gint _tmp114_ = 0;
				gchar** _tmp115_ = NULL;
				gint child_attributes_length1 = 0;
				gint _child_attributes_size_ = 0;
				gchar** _tmp116_ = NULL;
				gint _tmp116__length1 = 0;
				gboolean _tmp125_ = FALSE;
				is_deferred = FALSE;
				_tmp113_ = node;
				_tmp115_ = vala_gidl_parser_get_attributes_for_node (self, _tmp113_, &_tmp114_);
				child_attributes = _tmp115_;
				child_attributes_length1 = _tmp114_;
				_child_attributes_size_ = child_attributes_length1;
				_tmp116_ = child_attributes;
				_tmp116__length1 = child_attributes_length1;
				if (_tmp116_ != NULL) {
					gchar** _tmp117_ = NULL;
					gint _tmp117__length1 = 0;
					_tmp117_ = child_attributes;
					_tmp117__length1 = child_attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp117_;
						attr_collection_length1 = _tmp117__length1;
						for (attr_it = 0; attr_it < _tmp117__length1; attr_it = attr_it + 1) {
							const gchar* attr = NULL;
							attr = attr_collection[attr_it];
							{
								gchar** nv = NULL;
								const gchar* _tmp118_ = NULL;
								gchar** _tmp119_ = NULL;
								gchar** _tmp120_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gchar** _tmp121_ = NULL;
								gint _tmp121__length1 = 0;
								const gchar* _tmp122_ = NULL;
								_tmp118_ = attr;
								_tmp120_ = _tmp119_ = g_strsplit (_tmp118_, "=", 2);
								nv = _tmp120_;
								nv_length1 = _vala_array_length (_tmp119_);
								_nv_size_ = nv_length1;
								_tmp121_ = nv;
								_tmp121__length1 = nv_length1;
								_tmp122_ = _tmp121_[0];
								if (g_strcmp0 (_tmp122_, "parent") == 0) {
									ValaArrayList* _tmp123_ = NULL;
									GIdlNode* _tmp124_ = NULL;
									_tmp123_ = deferred;
									_tmp124_ = node;
									vala_collection_add ((ValaCollection*) _tmp123_, _tmp124_);
									is_deferred = TRUE;
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							}
						}
					}
				}
				_tmp125_ = is_deferred;
				if (!_tmp125_) {
					GIdlNode* _tmp126_ = NULL;
					GIdlModule* _tmp127_ = NULL;
					ValaNamespace* _tmp128_ = NULL;
					_tmp126_ = node;
					_tmp127_ = module;
					_tmp128_ = ns;
					vala_gidl_parser_parse_node (self, _tmp126_, _tmp127_, (ValaSymbol*) _tmp128_);
				}
				child_attributes = (_vala_array_free (child_attributes, child_attributes_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	{
		ValaArrayList* _node_list = NULL;
		ValaArrayList* _tmp129_ = NULL;
		ValaArrayList* _tmp130_ = NULL;
		gint _node_size = 0;
		ValaArrayList* _tmp131_ = NULL;
		gint _tmp132_ = 0;
		gint _tmp133_ = 0;
		gint _node_index = 0;
		_tmp129_ = deferred;
		_tmp130_ = _vala_iterable_ref0 (_tmp129_);
		_node_list = _tmp130_;
		_tmp131_ = _node_list;
		_tmp132_ = vala_collection_get_size ((ValaCollection*) _tmp131_);
		_tmp133_ = _tmp132_;
		_node_size = _tmp133_;
		_node_index = -1;
		while (TRUE) {
			gint _tmp134_ = 0;
			gint _tmp135_ = 0;
			gint _tmp136_ = 0;
			GIdlNode* node = NULL;
			ValaArrayList* _tmp137_ = NULL;
			gint _tmp138_ = 0;
			gpointer _tmp139_ = NULL;
			ValaSymbol* container = NULL;
			ValaNamespace* _tmp140_ = NULL;
			ValaSymbol* _tmp141_ = NULL;
			gchar** child_attributes = NULL;
			GIdlNode* _tmp142_ = NULL;
			gint _tmp143_ = 0;
			gchar** _tmp144_ = NULL;
			gint child_attributes_length1 = 0;
			gint _child_attributes_size_ = 0;
			gchar** _tmp145_ = NULL;
			gint _tmp145__length1 = 0;
			ValaSymbol* _tmp157_ = NULL;
			GIdlNode* _tmp162_ = NULL;
			GIdlModule* _tmp163_ = NULL;
			ValaSymbol* _tmp164_ = NULL;
			ValaNamespace* _tmp165_ = NULL;
			ValaNamespace* _tmp166_ = NULL;
			_tmp134_ = _node_index;
			_node_index = _tmp134_ + 1;
			_tmp135_ = _node_index;
			_tmp136_ = _node_size;
			if (!(_tmp135_ < _tmp136_)) {
				break;
			}
			_tmp137_ = _node_list;
			_tmp138_ = _node_index;
			_tmp139_ = vala_list_get ((ValaList*) _tmp137_, _tmp138_);
			node = (GIdlNode*) _tmp139_;
			_tmp140_ = ns;
			_tmp141_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp140_);
			container = _tmp141_;
			_tmp142_ = node;
			_tmp144_ = vala_gidl_parser_get_attributes_for_node (self, _tmp142_, &_tmp143_);
			child_attributes = _tmp144_;
			child_attributes_length1 = _tmp143_;
			_child_attributes_size_ = child_attributes_length1;
			_tmp145_ = child_attributes;
			_tmp145__length1 = child_attributes_length1;
			if (_tmp145_ != NULL) {
				gchar** _tmp146_ = NULL;
				gint _tmp146__length1 = 0;
				_tmp146_ = child_attributes;
				_tmp146__length1 = child_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp146_;
					attr_collection_length1 = _tmp146__length1;
					for (attr_it = 0; attr_it < _tmp146__length1; attr_it = attr_it + 1) {
						const gchar* attr = NULL;
						attr = attr_collection[attr_it];
						{
							gchar** nv = NULL;
							const gchar* _tmp147_ = NULL;
							gchar** _tmp148_ = NULL;
							gchar** _tmp149_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp150_ = NULL;
							gint _tmp150__length1 = 0;
							const gchar* _tmp151_ = NULL;
							_tmp147_ = attr;
							_tmp149_ = _tmp148_ = g_strsplit (_tmp147_, "=", 2);
							nv = _tmp149_;
							nv_length1 = _vala_array_length (_tmp148_);
							_nv_size_ = nv_length1;
							_tmp150_ = nv;
							_tmp150__length1 = nv_length1;
							_tmp151_ = _tmp150_[0];
							if (g_strcmp0 (_tmp151_, "parent") == 0) {
								gchar** _tmp152_ = NULL;
								gint _tmp152__length1 = 0;
								const gchar* _tmp153_ = NULL;
								gchar* _tmp154_ = NULL;
								gchar* _tmp155_ = NULL;
								ValaSymbol* _tmp156_ = NULL;
								_tmp152_ = nv;
								_tmp152__length1 = nv_length1;
								_tmp153_ = _tmp152_[1];
								_tmp154_ = vala_gidl_parser_eval (self, _tmp153_);
								_tmp155_ = _tmp154_;
								_tmp156_ = vala_gidl_parser_get_container_from_name (self, _tmp155_);
								_vala_code_node_unref0 (container);
								container = _tmp156_;
								_g_free0 (_tmp155_);
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						}
					}
				}
			}
			_tmp157_ = container;
			if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp157_, VALA_TYPE_NAMESPACE)) {
				ValaSymbol* _tmp158_ = NULL;
				ValaNamespace* _tmp159_ = NULL;
				_tmp158_ = container;
				_tmp159_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp158_, VALA_TYPE_NAMESPACE, ValaNamespace));
				_vala_code_node_unref0 (self->priv->current_namespace);
				self->priv->current_namespace = _tmp159_;
			} else {
				ValaSymbol* _tmp160_ = NULL;
				ValaTypeSymbol* _tmp161_ = NULL;
				_tmp160_ = container;
				_tmp161_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp160_, VALA_TYPE_TYPESYMBOL, ValaTypeSymbol));
				_vala_code_node_unref0 (self->priv->current_data_type);
				self->priv->current_data_type = _tmp161_;
			}
			_tmp162_ = node;
			_tmp163_ = module;
			_tmp164_ = container;
			vala_gidl_parser_parse_node (self, _tmp162_, _tmp163_, _tmp164_);
			_tmp165_ = ns;
			_tmp166_ = _vala_code_node_ref0 (_tmp165_);
			_vala_code_node_unref0 (self->priv->current_namespace);
			self->priv->current_namespace = _tmp166_;
			_vala_code_node_unref0 (self->priv->current_data_type);
			self->priv->current_data_type = NULL;
			child_attributes = (_vala_array_free (child_attributes, child_attributes_length1, (GDestroyNotify) g_free), NULL);
			_vala_code_node_unref0 (container);
		}
		_vala_iterable_unref0 (_node_list);
	}
	_vala_code_node_unref0 (self->priv->current_namespace);
	self->priv->current_namespace = NULL;
	_tmp167_ = sym;
	if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp167_, VALA_TYPE_NAMESPACE)) {
		result = NULL;
		_vala_iterable_unref0 (deferred);
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_vala_code_node_unref0 (ns);
		_vala_code_node_unref0 (sym);
		return result;
	}
	result = ns;
	_vala_iterable_unref0 (deferred);
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_vala_code_node_unref0 (sym);
	return result;
}


static gdouble double_parse (const gchar* str) {
	gdouble result = 0.0;
	const gchar* _tmp0_ = NULL;
	gdouble _tmp1_ = 0.0;
	g_return_val_if_fail (str != NULL, 0.0);
	_tmp0_ = str;
	_tmp1_ = g_ascii_strtod (_tmp0_, NULL);
	result = _tmp1_;
	return result;
}


static ValaDelegate* vala_gidl_parser_parse_delegate (ValaGIdlParser* self, GIdlNodeFunction* f_node) {
	ValaDelegate* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeFunction* _tmp0_ = NULL;
	ValaDataType* return_type = NULL;
	GIdlNodeFunction* _tmp1_ = NULL;
	GIdlNodeParam* _tmp2_ = NULL;
	ValaDataType* _tmp3_ = NULL;
	ValaDelegate* cb = NULL;
	GIdlNode* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	ValaDataType* _tmp6_ = NULL;
	ValaSourceReference* _tmp7_ = NULL;
	ValaDelegate* _tmp8_ = NULL;
	ValaDelegate* _tmp9_ = NULL;
	ValaDelegate* _tmp10_ = NULL;
	gboolean check_has_target = FALSE;
	gboolean suppress_throws = FALSE;
	gchar* error_types = NULL;
	gchar** attributes = NULL;
	GIdlNode* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gchar** _tmp14_ = NULL;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	guint remaining_params = 0U;
	GIdlNodeFunction* _tmp161_ = NULL;
	GList* _tmp162_ = NULL;
	guint _tmp163_ = 0U;
	GIdlNodeFunction* _tmp164_ = NULL;
	GList* _tmp165_ = NULL;
	gboolean _tmp352_ = FALSE;
	gboolean _tmp353_ = FALSE;
	gboolean _tmp355_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (f_node != NULL, NULL);
	_tmp0_ = f_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = f_node;
	_tmp2_ = _tmp1_->result;
	_tmp3_ = vala_gidl_parser_parse_param (self, _tmp2_, NULL);
	return_type = _tmp3_;
	_tmp4_ = node;
	_tmp5_ = _tmp4_->name;
	_tmp6_ = return_type;
	_tmp7_ = self->priv->current_source_reference;
	_tmp8_ = vala_delegate_new (_tmp5_, _tmp6_, _tmp7_, NULL);
	cb = _tmp8_;
	_tmp9_ = cb;
	vala_symbol_set_access ((ValaSymbol*) _tmp9_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	_tmp10_ = cb;
	vala_delegate_set_has_target (_tmp10_, FALSE);
	check_has_target = TRUE;
	suppress_throws = FALSE;
	error_types = NULL;
	_tmp11_ = node;
	_tmp12_ = _tmp11_->name;
	_tmp14_ = vala_gidl_parser_get_attributes (self, _tmp12_, &_tmp13_);
	attributes = _tmp14_;
	attributes_length1 = _tmp13_;
	_attributes_size_ = attributes_length1;
	_tmp15_ = attributes;
	_tmp15__length1 = attributes_length1;
	if (_tmp15_ != NULL) {
		gchar** _tmp16_ = NULL;
		gint _tmp16__length1 = 0;
		_tmp16_ = attributes;
		_tmp16__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp16_;
			attr_collection_length1 = _tmp16__length1;
			for (attr_it = 0; attr_it < _tmp16__length1; attr_it = attr_it + 1) {
				gchar* _tmp17_ = NULL;
				gchar* attr = NULL;
				_tmp17_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp17_;
				{
					gchar** nv = NULL;
					const gchar* _tmp18_ = NULL;
					gchar** _tmp19_ = NULL;
					gchar** _tmp20_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp21_ = NULL;
					gint _tmp21__length1 = 0;
					const gchar* _tmp22_ = NULL;
					_tmp18_ = attr;
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "=", 2);
					nv = _tmp20_;
					nv_length1 = _vala_array_length (_tmp19_);
					_nv_size_ = nv_length1;
					_tmp21_ = nv;
					_tmp21__length1 = nv_length1;
					_tmp22_ = _tmp21_[0];
					if (g_strcmp0 (_tmp22_, "hidden") == 0) {
						gchar** _tmp23_ = NULL;
						gint _tmp23__length1 = 0;
						const gchar* _tmp24_ = NULL;
						gchar* _tmp25_ = NULL;
						gchar* _tmp26_ = NULL;
						gboolean _tmp27_ = FALSE;
						_tmp23_ = nv;
						_tmp23__length1 = nv_length1;
						_tmp24_ = _tmp23_[1];
						_tmp25_ = vala_gidl_parser_eval (self, _tmp24_);
						_tmp26_ = _tmp25_;
						_tmp27_ = g_strcmp0 (_tmp26_, "1") == 0;
						_g_free0 (_tmp26_);
						if (_tmp27_) {
							result = NULL;
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
							attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (error_types);
							_vala_code_node_unref0 (cb);
							_vala_code_node_unref0 (return_type);
							return result;
						}
					} else {
						gchar** _tmp28_ = NULL;
						gint _tmp28__length1 = 0;
						const gchar* _tmp29_ = NULL;
						_tmp28_ = nv;
						_tmp28__length1 = nv_length1;
						_tmp29_ = _tmp28_[0];
						if (g_strcmp0 (_tmp29_, "cheader_filename") == 0) {
							ValaDelegate* _tmp30_ = NULL;
							gchar** _tmp31_ = NULL;
							gint _tmp31__length1 = 0;
							const gchar* _tmp32_ = NULL;
							gchar* _tmp33_ = NULL;
							gchar* _tmp34_ = NULL;
							_tmp30_ = cb;
							_tmp31_ = nv;
							_tmp31__length1 = nv_length1;
							_tmp32_ = _tmp31_[1];
							_tmp33_ = vala_gidl_parser_eval (self, _tmp32_);
							_tmp34_ = _tmp33_;
							vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp30_, "CCode", "cheader_filename", _tmp34_, NULL);
							_g_free0 (_tmp34_);
						} else {
							gchar** _tmp35_ = NULL;
							gint _tmp35__length1 = 0;
							const gchar* _tmp36_ = NULL;
							_tmp35_ = nv;
							_tmp35__length1 = nv_length1;
							_tmp36_ = _tmp35_[0];
							if (g_strcmp0 (_tmp36_, "has_target") == 0) {
								gchar** _tmp37_ = NULL;
								gint _tmp37__length1 = 0;
								const gchar* _tmp38_ = NULL;
								gchar* _tmp39_ = NULL;
								gchar* _tmp40_ = NULL;
								gboolean _tmp41_ = FALSE;
								_tmp37_ = nv;
								_tmp37__length1 = nv_length1;
								_tmp38_ = _tmp37_[1];
								_tmp39_ = vala_gidl_parser_eval (self, _tmp38_);
								_tmp40_ = _tmp39_;
								_tmp41_ = g_strcmp0 (_tmp40_, "0") == 0;
								_g_free0 (_tmp40_);
								if (_tmp41_) {
									check_has_target = FALSE;
								} else {
									gchar** _tmp42_ = NULL;
									gint _tmp42__length1 = 0;
									const gchar* _tmp43_ = NULL;
									gchar* _tmp44_ = NULL;
									gchar* _tmp45_ = NULL;
									gboolean _tmp46_ = FALSE;
									_tmp42_ = nv;
									_tmp42__length1 = nv_length1;
									_tmp43_ = _tmp42_[1];
									_tmp44_ = vala_gidl_parser_eval (self, _tmp43_);
									_tmp45_ = _tmp44_;
									_tmp46_ = g_strcmp0 (_tmp45_, "1") == 0;
									_g_free0 (_tmp45_);
									if (_tmp46_) {
										ValaDelegate* _tmp47_ = NULL;
										_tmp47_ = cb;
										vala_delegate_set_has_target (_tmp47_, TRUE);
									}
								}
							} else {
								gchar** _tmp48_ = NULL;
								gint _tmp48__length1 = 0;
								const gchar* _tmp49_ = NULL;
								_tmp48_ = nv;
								_tmp48__length1 = nv_length1;
								_tmp49_ = _tmp48_[0];
								if (g_strcmp0 (_tmp49_, "transfer_ownership") == 0) {
									gchar** _tmp50_ = NULL;
									gint _tmp50__length1 = 0;
									const gchar* _tmp51_ = NULL;
									gchar* _tmp52_ = NULL;
									gchar* _tmp53_ = NULL;
									gboolean _tmp54_ = FALSE;
									_tmp50_ = nv;
									_tmp50__length1 = nv_length1;
									_tmp51_ = _tmp50_[1];
									_tmp52_ = vala_gidl_parser_eval (self, _tmp51_);
									_tmp53_ = _tmp52_;
									_tmp54_ = g_strcmp0 (_tmp53_, "1") == 0;
									_g_free0 (_tmp53_);
									if (_tmp54_) {
										ValaDataType* _tmp55_ = NULL;
										_tmp55_ = return_type;
										vala_data_type_set_value_owned (_tmp55_, TRUE);
									}
								} else {
									gchar** _tmp56_ = NULL;
									gint _tmp56__length1 = 0;
									const gchar* _tmp57_ = NULL;
									_tmp56_ = nv;
									_tmp56__length1 = nv_length1;
									_tmp57_ = _tmp56_[0];
									if (g_strcmp0 (_tmp57_, "is_array") == 0) {
										gchar** _tmp58_ = NULL;
										gint _tmp58__length1 = 0;
										const gchar* _tmp59_ = NULL;
										gchar* _tmp60_ = NULL;
										gchar* _tmp61_ = NULL;
										gboolean _tmp62_ = FALSE;
										_tmp58_ = nv;
										_tmp58__length1 = nv_length1;
										_tmp59_ = _tmp58_[1];
										_tmp60_ = vala_gidl_parser_eval (self, _tmp59_);
										_tmp61_ = _tmp60_;
										_tmp62_ = g_strcmp0 (_tmp61_, "1") == 0;
										_g_free0 (_tmp61_);
										if (_tmp62_) {
											ValaDataType* _tmp63_ = NULL;
											ValaDataType* _tmp64_ = NULL;
											ValaSourceReference* _tmp65_ = NULL;
											ValaSourceReference* _tmp66_ = NULL;
											ValaArrayType* _tmp67_ = NULL;
											ValaDelegate* _tmp68_ = NULL;
											ValaDataType* _tmp69_ = NULL;
											_tmp63_ = return_type;
											_tmp64_ = return_type;
											_tmp65_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp64_);
											_tmp66_ = _tmp65_;
											_tmp67_ = vala_array_type_new (_tmp63_, 1, _tmp66_);
											_vala_code_node_unref0 (return_type);
											return_type = (ValaDataType*) _tmp67_;
											_tmp68_ = cb;
											_tmp69_ = return_type;
											vala_delegate_set_return_type (_tmp68_, _tmp69_);
										}
									} else {
										gchar** _tmp70_ = NULL;
										gint _tmp70__length1 = 0;
										const gchar* _tmp71_ = NULL;
										_tmp70_ = nv;
										_tmp70__length1 = nv_length1;
										_tmp71_ = _tmp70_[0];
										if (g_strcmp0 (_tmp71_, "throws") == 0) {
											gchar** _tmp72_ = NULL;
											gint _tmp72__length1 = 0;
											const gchar* _tmp73_ = NULL;
											gchar* _tmp74_ = NULL;
											gchar* _tmp75_ = NULL;
											gboolean _tmp76_ = FALSE;
											_tmp72_ = nv;
											_tmp72__length1 = nv_length1;
											_tmp73_ = _tmp72_[1];
											_tmp74_ = vala_gidl_parser_eval (self, _tmp73_);
											_tmp75_ = _tmp74_;
											_tmp76_ = g_strcmp0 (_tmp75_, "0") == 0;
											_g_free0 (_tmp75_);
											if (_tmp76_) {
												suppress_throws = TRUE;
											}
										} else {
											gchar** _tmp77_ = NULL;
											gint _tmp77__length1 = 0;
											const gchar* _tmp78_ = NULL;
											_tmp77_ = nv;
											_tmp77__length1 = nv_length1;
											_tmp78_ = _tmp77_[0];
											if (g_strcmp0 (_tmp78_, "error_types") == 0) {
												gchar** _tmp79_ = NULL;
												gint _tmp79__length1 = 0;
												const gchar* _tmp80_ = NULL;
												gchar* _tmp81_ = NULL;
												_tmp79_ = nv;
												_tmp79__length1 = nv_length1;
												_tmp80_ = _tmp79_[1];
												_tmp81_ = vala_gidl_parser_eval (self, _tmp80_);
												_g_free0 (error_types);
												error_types = _tmp81_;
											} else {
												gchar** _tmp82_ = NULL;
												gint _tmp82__length1 = 0;
												const gchar* _tmp83_ = NULL;
												_tmp82_ = nv;
												_tmp82__length1 = nv_length1;
												_tmp83_ = _tmp82_[0];
												if (g_strcmp0 (_tmp83_, "array_length_type") == 0) {
													ValaDelegate* _tmp84_ = NULL;
													gchar** _tmp85_ = NULL;
													gint _tmp85__length1 = 0;
													const gchar* _tmp86_ = NULL;
													gchar* _tmp87_ = NULL;
													gchar* _tmp88_ = NULL;
													_tmp84_ = cb;
													_tmp85_ = nv;
													_tmp85__length1 = nv_length1;
													_tmp86_ = _tmp85_[1];
													_tmp87_ = vala_gidl_parser_eval (self, _tmp86_);
													_tmp88_ = _tmp87_;
													vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp84_, "CCode", "array_length_type", _tmp88_, NULL);
													_g_free0 (_tmp88_);
												} else {
													gchar** _tmp89_ = NULL;
													gint _tmp89__length1 = 0;
													const gchar* _tmp90_ = NULL;
													_tmp89_ = nv;
													_tmp89__length1 = nv_length1;
													_tmp90_ = _tmp89_[0];
													if (g_strcmp0 (_tmp90_, "type_name") == 0) {
														ValaDelegate* _tmp91_ = NULL;
														gchar** _tmp92_ = NULL;
														gint _tmp92__length1 = 0;
														const gchar* _tmp93_ = NULL;
														gchar* _tmp94_ = NULL;
														gchar* _tmp95_ = NULL;
														ValaDataType* _tmp96_ = NULL;
														gboolean _tmp97_ = FALSE;
														gboolean _tmp98_ = FALSE;
														ValaDataType* _tmp99_ = NULL;
														ValaDataType* _tmp100_ = NULL;
														_tmp91_ = cb;
														_tmp92_ = nv;
														_tmp92__length1 = nv_length1;
														_tmp93_ = _tmp92_[1];
														_tmp94_ = vala_gidl_parser_eval (self, _tmp93_);
														_tmp95_ = _tmp94_;
														_tmp96_ = return_type;
														_tmp97_ = vala_data_type_get_value_owned (_tmp96_);
														_tmp98_ = _tmp97_;
														_tmp99_ = vala_gidl_parser_parse_type_from_string (self, _tmp95_, _tmp98_, NULL);
														_vala_code_node_unref0 (return_type);
														return_type = _tmp99_;
														_tmp100_ = return_type;
														vala_delegate_set_return_type (_tmp91_, _tmp100_);
														_g_free0 (_tmp95_);
													} else {
														gchar** _tmp101_ = NULL;
														gint _tmp101__length1 = 0;
														const gchar* _tmp102_ = NULL;
														_tmp101_ = nv;
														_tmp101__length1 = nv_length1;
														_tmp102_ = _tmp101_[0];
														if (g_strcmp0 (_tmp102_, "deprecated") == 0) {
															gchar** _tmp103_ = NULL;
															gint _tmp103__length1 = 0;
															const gchar* _tmp104_ = NULL;
															gchar* _tmp105_ = NULL;
															gchar* _tmp106_ = NULL;
															gboolean _tmp107_ = FALSE;
															_tmp103_ = nv;
															_tmp103__length1 = nv_length1;
															_tmp104_ = _tmp103_[1];
															_tmp105_ = vala_gidl_parser_eval (self, _tmp104_);
															_tmp106_ = _tmp105_;
															_tmp107_ = g_strcmp0 (_tmp106_, "1") == 0;
															_g_free0 (_tmp106_);
															if (_tmp107_) {
																ValaDelegate* _tmp108_ = NULL;
																_tmp108_ = cb;
																vala_code_node_set_attribute ((ValaCodeNode*) _tmp108_, "Deprecated", TRUE, NULL);
															}
														} else {
															gchar** _tmp109_ = NULL;
															gint _tmp109__length1 = 0;
															const gchar* _tmp110_ = NULL;
															_tmp109_ = nv;
															_tmp109__length1 = nv_length1;
															_tmp110_ = _tmp109_[0];
															if (g_strcmp0 (_tmp110_, "replacement") == 0) {
																ValaDelegate* _tmp111_ = NULL;
																gchar** _tmp112_ = NULL;
																gint _tmp112__length1 = 0;
																const gchar* _tmp113_ = NULL;
																gchar* _tmp114_ = NULL;
																gchar* _tmp115_ = NULL;
																_tmp111_ = cb;
																_tmp112_ = nv;
																_tmp112__length1 = nv_length1;
																_tmp113_ = _tmp112_[1];
																_tmp114_ = vala_gidl_parser_eval (self, _tmp113_);
																_tmp115_ = _tmp114_;
																vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp111_, "Deprecated", "replacement", _tmp115_, NULL);
																_g_free0 (_tmp115_);
															} else {
																gchar** _tmp116_ = NULL;
																gint _tmp116__length1 = 0;
																const gchar* _tmp117_ = NULL;
																_tmp116_ = nv;
																_tmp116__length1 = nv_length1;
																_tmp117_ = _tmp116_[0];
																if (g_strcmp0 (_tmp117_, "deprecated_since") == 0) {
																	ValaDelegate* _tmp118_ = NULL;
																	gchar** _tmp119_ = NULL;
																	gint _tmp119__length1 = 0;
																	const gchar* _tmp120_ = NULL;
																	gchar* _tmp121_ = NULL;
																	gchar* _tmp122_ = NULL;
																	_tmp118_ = cb;
																	_tmp119_ = nv;
																	_tmp119__length1 = nv_length1;
																	_tmp120_ = _tmp119_[1];
																	_tmp121_ = vala_gidl_parser_eval (self, _tmp120_);
																	_tmp122_ = _tmp121_;
																	vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp118_, "Deprecated", "since", _tmp122_, NULL);
																	_g_free0 (_tmp122_);
																} else {
																	gchar** _tmp123_ = NULL;
																	gint _tmp123__length1 = 0;
																	const gchar* _tmp124_ = NULL;
																	_tmp123_ = nv;
																	_tmp123__length1 = nv_length1;
																	_tmp124_ = _tmp123_[0];
																	if (g_strcmp0 (_tmp124_, "type_arguments") == 0) {
																		ValaDataType* _tmp125_ = NULL;
																		gchar** _tmp126_ = NULL;
																		gint _tmp126__length1 = 0;
																		const gchar* _tmp127_ = NULL;
																		gchar* _tmp128_ = NULL;
																		gchar* _tmp129_ = NULL;
																		_tmp125_ = return_type;
																		_tmp126_ = nv;
																		_tmp126__length1 = nv_length1;
																		_tmp127_ = _tmp126_[1];
																		_tmp128_ = vala_gidl_parser_eval (self, _tmp127_);
																		_tmp129_ = _tmp128_;
																		vala_gidl_parser_parse_type_arguments_from_string (self, _tmp125_, _tmp129_, NULL);
																		_g_free0 (_tmp129_);
																	} else {
																		gchar** _tmp130_ = NULL;
																		gint _tmp130__length1 = 0;
																		const gchar* _tmp131_ = NULL;
																		_tmp130_ = nv;
																		_tmp130__length1 = nv_length1;
																		_tmp131_ = _tmp130_[0];
																		if (g_strcmp0 (_tmp131_, "instance_pos") == 0) {
																			ValaDelegate* _tmp132_ = NULL;
																			gchar** _tmp133_ = NULL;
																			gint _tmp133__length1 = 0;
																			const gchar* _tmp134_ = NULL;
																			gchar* _tmp135_ = NULL;
																			gchar* _tmp136_ = NULL;
																			gdouble _tmp137_ = 0.0;
																			_tmp132_ = cb;
																			_tmp133_ = nv;
																			_tmp133__length1 = nv_length1;
																			_tmp134_ = _tmp133_[1];
																			_tmp135_ = vala_gidl_parser_eval (self, _tmp134_);
																			_tmp136_ = _tmp135_;
																			_tmp137_ = double_parse (_tmp136_);
																			vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp132_, "CCode", "instance_pos", _tmp137_, NULL);
																			_g_free0 (_tmp136_);
																		} else {
																			gchar** _tmp138_ = NULL;
																			gint _tmp138__length1 = 0;
																			const gchar* _tmp139_ = NULL;
																			_tmp138_ = nv;
																			_tmp138__length1 = nv_length1;
																			_tmp139_ = _tmp138_[0];
																			if (g_strcmp0 (_tmp139_, "type_parameters") == 0) {
																				gchar** _tmp140_ = NULL;
																				gint _tmp140__length1 = 0;
																				const gchar* _tmp141_ = NULL;
																				gchar* _tmp142_ = NULL;
																				gchar* _tmp143_ = NULL;
																				gchar** _tmp144_ = NULL;
																				gchar** _tmp145_ = NULL;
																				gchar** _tmp146_ = NULL;
																				gint _tmp146__length1 = 0;
																				_tmp140_ = nv;
																				_tmp140__length1 = nv_length1;
																				_tmp141_ = _tmp140_[1];
																				_tmp142_ = vala_gidl_parser_eval (self, _tmp141_);
																				_tmp143_ = _tmp142_;
																				_tmp145_ = _tmp144_ = g_strsplit (_tmp143_, ",", 0);
																				_tmp146_ = _tmp145_;
																				_tmp146__length1 = _vala_array_length (_tmp144_);
																				_g_free0 (_tmp143_);
																				{
																					gchar** type_param_name_collection = NULL;
																					gint type_param_name_collection_length1 = 0;
																					gint _type_param_name_collection_size_ = 0;
																					gint type_param_name_it = 0;
																					type_param_name_collection = _tmp146_;
																					type_param_name_collection_length1 = _tmp146__length1;
																					for (type_param_name_it = 0; type_param_name_it < _tmp146__length1; type_param_name_it = type_param_name_it + 1) {
																						gchar* _tmp147_ = NULL;
																						gchar* type_param_name = NULL;
																						_tmp147_ = g_strdup (type_param_name_collection[type_param_name_it]);
																						type_param_name = _tmp147_;
																						{
																							ValaDelegate* _tmp148_ = NULL;
																							const gchar* _tmp149_ = NULL;
																							ValaSourceReference* _tmp150_ = NULL;
																							ValaTypeParameter* _tmp151_ = NULL;
																							ValaTypeParameter* _tmp152_ = NULL;
																							_tmp148_ = cb;
																							_tmp149_ = type_param_name;
																							_tmp150_ = self->priv->current_source_reference;
																							_tmp151_ = vala_typeparameter_new (_tmp149_, _tmp150_);
																							_tmp152_ = _tmp151_;
																							vala_delegate_add_type_parameter (_tmp148_, _tmp152_);
																							_vala_code_node_unref0 (_tmp152_);
																							_g_free0 (type_param_name);
																						}
																					}
																					type_param_name_collection = (_vala_array_free (type_param_name_collection, type_param_name_collection_length1, (GDestroyNotify) g_free), NULL);
																				}
																			} else {
																				gchar** _tmp153_ = NULL;
																				gint _tmp153__length1 = 0;
																				const gchar* _tmp154_ = NULL;
																				_tmp153_ = nv;
																				_tmp153__length1 = nv_length1;
																				_tmp154_ = _tmp153_[0];
																				if (g_strcmp0 (_tmp154_, "experimental") == 0) {
																					gchar** _tmp155_ = NULL;
																					gint _tmp155__length1 = 0;
																					const gchar* _tmp156_ = NULL;
																					gchar* _tmp157_ = NULL;
																					gchar* _tmp158_ = NULL;
																					gboolean _tmp159_ = FALSE;
																					_tmp155_ = nv;
																					_tmp155__length1 = nv_length1;
																					_tmp156_ = _tmp155_[1];
																					_tmp157_ = vala_gidl_parser_eval (self, _tmp156_);
																					_tmp158_ = _tmp157_;
																					_tmp159_ = g_strcmp0 (_tmp158_, "1") == 0;
																					_g_free0 (_tmp158_);
																					if (_tmp159_) {
																						ValaDelegate* _tmp160_ = NULL;
																						_tmp160_ = cb;
																						vala_code_node_set_attribute ((ValaCodeNode*) _tmp160_, "Experimental", TRUE, NULL);
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp161_ = f_node;
	_tmp162_ = _tmp161_->parameters;
	_tmp163_ = g_list_length (_tmp162_);
	remaining_params = _tmp163_;
	_tmp164_ = f_node;
	_tmp165_ = _tmp164_->parameters;
	{
		GList* param_collection = NULL;
		GList* param_it = NULL;
		param_collection = _tmp165_;
		for (param_it = param_collection; param_it != NULL; param_it = param_it->next) {
			GIdlNodeParam* param = NULL;
			param = (GIdlNodeParam*) param_it->data;
			{
				GIdlNode* param_node = NULL;
				GIdlNodeParam* _tmp166_ = NULL;
				gboolean _tmp167_ = FALSE;
				gboolean _tmp168_ = FALSE;
				gboolean _tmp169_ = FALSE;
				gboolean _tmp171_ = FALSE;
				gboolean _tmp178_ = FALSE;
				guint _tmp351_ = 0U;
				_tmp166_ = param;
				param_node = (GIdlNode*) _tmp166_;
				_tmp169_ = check_has_target;
				if (_tmp169_) {
					guint _tmp170_ = 0U;
					_tmp170_ = remaining_params;
					_tmp168_ = _tmp170_ == ((guint) 1);
				} else {
					_tmp168_ = FALSE;
				}
				_tmp171_ = _tmp168_;
				if (_tmp171_) {
					gboolean _tmp172_ = FALSE;
					GIdlNode* _tmp173_ = NULL;
					const gchar* _tmp174_ = NULL;
					gboolean _tmp177_ = FALSE;
					_tmp173_ = param_node;
					_tmp174_ = _tmp173_->name;
					if (g_strcmp0 (_tmp174_, "user_data") == 0) {
						_tmp172_ = TRUE;
					} else {
						GIdlNode* _tmp175_ = NULL;
						const gchar* _tmp176_ = NULL;
						_tmp175_ = param_node;
						_tmp176_ = _tmp175_->name;
						_tmp172_ = g_strcmp0 (_tmp176_, "data") == 0;
					}
					_tmp177_ = _tmp172_;
					_tmp167_ = _tmp177_;
				} else {
					_tmp167_ = FALSE;
				}
				_tmp178_ = _tmp167_;
				if (_tmp178_) {
					ValaDelegate* _tmp179_ = NULL;
					_tmp179_ = cb;
					vala_delegate_set_has_target (_tmp179_, TRUE);
				} else {
					gboolean _tmp180_ = FALSE;
					gboolean _tmp181_ = FALSE;
					gboolean _tmp184_ = FALSE;
					gchar* param_name = NULL;
					GIdlNode* _tmp192_ = NULL;
					const gchar* _tmp193_ = NULL;
					gchar* _tmp194_ = NULL;
					const gchar* _tmp195_ = NULL;
					ValaParameterDirection direction = 0;
					ValaDataType* param_type = NULL;
					GIdlNodeParam* _tmp199_ = NULL;
					ValaParameterDirection _tmp200_ = 0;
					ValaDataType* _tmp201_ = NULL;
					ValaParameter* p = NULL;
					const gchar* _tmp202_ = NULL;
					ValaDataType* _tmp203_ = NULL;
					ValaParameter* _tmp204_ = NULL;
					ValaParameter* _tmp205_ = NULL;
					ValaParameterDirection _tmp206_ = 0;
					gboolean hide_param = FALSE;
					gboolean show_param = FALSE;
					gboolean array_requested = FALSE;
					gboolean out_requested = FALSE;
					GIdlNode* _tmp207_ = NULL;
					const gchar* _tmp208_ = NULL;
					GIdlNode* _tmp209_ = NULL;
					const gchar* _tmp210_ = NULL;
					gchar* _tmp211_ = NULL;
					gchar* _tmp212_ = NULL;
					gint _tmp213_ = 0;
					gchar** _tmp214_ = NULL;
					gchar** _tmp215_ = NULL;
					gint _tmp215__length1 = 0;
					gboolean _tmp345_ = FALSE;
					gboolean _tmp346_ = FALSE;
					gboolean _tmp348_ = FALSE;
					_tmp181_ = suppress_throws;
					if (_tmp181_ == FALSE) {
						GIdlNodeParam* _tmp182_ = NULL;
						gboolean _tmp183_ = FALSE;
						_tmp182_ = param;
						_tmp183_ = vala_gidl_parser_param_is_exception (self, _tmp182_);
						_tmp180_ = _tmp183_;
					} else {
						_tmp180_ = FALSE;
					}
					_tmp184_ = _tmp180_;
					if (_tmp184_) {
						const gchar* _tmp185_ = NULL;
						guint _tmp191_ = 0U;
						_tmp185_ = error_types;
						if (_tmp185_ == NULL) {
							ValaDelegate* _tmp186_ = NULL;
							GIdlNodeParam* _tmp187_ = NULL;
							GIdlNodeType* _tmp188_ = NULL;
							ValaDataType* _tmp189_ = NULL;
							ValaDataType* _tmp190_ = NULL;
							_tmp186_ = cb;
							_tmp187_ = param;
							_tmp188_ = _tmp187_->type;
							_tmp189_ = vala_gidl_parser_parse_type (self, _tmp188_, NULL);
							_tmp190_ = _tmp189_;
							vala_code_node_add_error_type ((ValaCodeNode*) _tmp186_, _tmp190_);
							_vala_code_node_unref0 (_tmp190_);
						}
						_tmp191_ = remaining_params;
						remaining_params = _tmp191_ - 1;
						continue;
					}
					_tmp192_ = param_node;
					_tmp193_ = _tmp192_->name;
					_tmp194_ = g_strdup (_tmp193_);
					param_name = _tmp194_;
					_tmp195_ = param_name;
					if (g_strcmp0 (_tmp195_, "string") == 0) {
						gchar* _tmp196_ = NULL;
						_tmp196_ = g_strdup ("str");
						_g_free0 (param_name);
						param_name = _tmp196_;
					} else {
						const gchar* _tmp197_ = NULL;
						_tmp197_ = param_name;
						if (g_strcmp0 (_tmp197_, "self") == 0) {
							gchar* _tmp198_ = NULL;
							_tmp198_ = g_strdup ("_self");
							_g_free0 (param_name);
							param_name = _tmp198_;
						}
					}
					_tmp199_ = param;
					_tmp201_ = vala_gidl_parser_parse_param (self, _tmp199_, &_tmp200_);
					direction = _tmp200_;
					param_type = _tmp201_;
					_tmp202_ = param_name;
					_tmp203_ = param_type;
					_tmp204_ = vala_parameter_new (_tmp202_, _tmp203_, NULL);
					p = _tmp204_;
					_tmp205_ = p;
					_tmp206_ = direction;
					vala_parameter_set_direction (_tmp205_, _tmp206_);
					hide_param = FALSE;
					show_param = FALSE;
					array_requested = FALSE;
					out_requested = FALSE;
					_tmp207_ = node;
					_tmp208_ = _tmp207_->name;
					_tmp209_ = param_node;
					_tmp210_ = _tmp209_->name;
					_tmp211_ = g_strdup_printf ("%s.%s", _tmp208_, _tmp210_);
					_tmp212_ = _tmp211_;
					_tmp214_ = vala_gidl_parser_get_attributes (self, _tmp212_, &_tmp213_);
					attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
					attributes = _tmp214_;
					attributes_length1 = _tmp213_;
					_attributes_size_ = attributes_length1;
					_g_free0 (_tmp212_);
					_tmp215_ = attributes;
					_tmp215__length1 = attributes_length1;
					if (_tmp215_ != NULL) {
						gchar** _tmp216_ = NULL;
						gint _tmp216__length1 = 0;
						_tmp216_ = attributes;
						_tmp216__length1 = attributes_length1;
						{
							gchar** attr_collection = NULL;
							gint attr_collection_length1 = 0;
							gint _attr_collection_size_ = 0;
							gint attr_it = 0;
							attr_collection = _tmp216_;
							attr_collection_length1 = _tmp216__length1;
							for (attr_it = 0; attr_it < _tmp216__length1; attr_it = attr_it + 1) {
								gchar* _tmp217_ = NULL;
								gchar* attr = NULL;
								_tmp217_ = g_strdup (attr_collection[attr_it]);
								attr = _tmp217_;
								{
									gchar** nv = NULL;
									const gchar* _tmp218_ = NULL;
									gchar** _tmp219_ = NULL;
									gchar** _tmp220_ = NULL;
									gint nv_length1 = 0;
									gint _nv_size_ = 0;
									gchar** _tmp221_ = NULL;
									gint _tmp221__length1 = 0;
									const gchar* _tmp222_ = NULL;
									_tmp218_ = attr;
									_tmp220_ = _tmp219_ = g_strsplit (_tmp218_, "=", 2);
									nv = _tmp220_;
									nv_length1 = _vala_array_length (_tmp219_);
									_nv_size_ = nv_length1;
									_tmp221_ = nv;
									_tmp221__length1 = nv_length1;
									_tmp222_ = _tmp221_[0];
									if (g_strcmp0 (_tmp222_, "hidden") == 0) {
										gchar** _tmp223_ = NULL;
										gint _tmp223__length1 = 0;
										const gchar* _tmp224_ = NULL;
										gchar* _tmp225_ = NULL;
										gchar* _tmp226_ = NULL;
										gboolean _tmp227_ = FALSE;
										_tmp223_ = nv;
										_tmp223__length1 = nv_length1;
										_tmp224_ = _tmp223_[1];
										_tmp225_ = vala_gidl_parser_eval (self, _tmp224_);
										_tmp226_ = _tmp225_;
										_tmp227_ = g_strcmp0 (_tmp226_, "1") == 0;
										_g_free0 (_tmp226_);
										if (_tmp227_) {
											hide_param = TRUE;
										} else {
											gchar** _tmp228_ = NULL;
											gint _tmp228__length1 = 0;
											const gchar* _tmp229_ = NULL;
											gchar* _tmp230_ = NULL;
											gchar* _tmp231_ = NULL;
											gboolean _tmp232_ = FALSE;
											_tmp228_ = nv;
											_tmp228__length1 = nv_length1;
											_tmp229_ = _tmp228_[1];
											_tmp230_ = vala_gidl_parser_eval (self, _tmp229_);
											_tmp231_ = _tmp230_;
											_tmp232_ = g_strcmp0 (_tmp231_, "0") == 0;
											_g_free0 (_tmp231_);
											if (_tmp232_) {
												show_param = TRUE;
											}
										}
									} else {
										gchar** _tmp233_ = NULL;
										gint _tmp233__length1 = 0;
										const gchar* _tmp234_ = NULL;
										_tmp233_ = nv;
										_tmp233__length1 = nv_length1;
										_tmp234_ = _tmp233_[0];
										if (g_strcmp0 (_tmp234_, "is_array") == 0) {
											gchar** _tmp235_ = NULL;
											gint _tmp235__length1 = 0;
											const gchar* _tmp236_ = NULL;
											gchar* _tmp237_ = NULL;
											gchar* _tmp238_ = NULL;
											gboolean _tmp239_ = FALSE;
											_tmp235_ = nv;
											_tmp235__length1 = nv_length1;
											_tmp236_ = _tmp235_[1];
											_tmp237_ = vala_gidl_parser_eval (self, _tmp236_);
											_tmp238_ = _tmp237_;
											_tmp239_ = g_strcmp0 (_tmp238_, "1") == 0;
											_g_free0 (_tmp238_);
											if (_tmp239_) {
												ValaDataType* _tmp240_ = NULL;
												ValaDataType* _tmp241_ = NULL;
												ValaSourceReference* _tmp242_ = NULL;
												ValaSourceReference* _tmp243_ = NULL;
												ValaArrayType* _tmp244_ = NULL;
												ValaParameter* _tmp245_ = NULL;
												ValaDataType* _tmp246_ = NULL;
												gboolean _tmp247_ = FALSE;
												_tmp240_ = param_type;
												_tmp241_ = param_type;
												_tmp242_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp241_);
												_tmp243_ = _tmp242_;
												_tmp244_ = vala_array_type_new (_tmp240_, 1, _tmp243_);
												_vala_code_node_unref0 (param_type);
												param_type = (ValaDataType*) _tmp244_;
												_tmp245_ = p;
												_tmp246_ = param_type;
												vala_variable_set_variable_type ((ValaVariable*) _tmp245_, _tmp246_);
												_tmp247_ = out_requested;
												if (!_tmp247_) {
													ValaParameter* _tmp248_ = NULL;
													_tmp248_ = p;
													vala_parameter_set_direction (_tmp248_, VALA_PARAMETER_DIRECTION_IN);
												}
												array_requested = TRUE;
											}
										} else {
											gchar** _tmp249_ = NULL;
											gint _tmp249__length1 = 0;
											const gchar* _tmp250_ = NULL;
											_tmp249_ = nv;
											_tmp249__length1 = nv_length1;
											_tmp250_ = _tmp249_[0];
											if (g_strcmp0 (_tmp250_, "is_out") == 0) {
												gchar** _tmp251_ = NULL;
												gint _tmp251__length1 = 0;
												const gchar* _tmp252_ = NULL;
												gchar* _tmp253_ = NULL;
												gchar* _tmp254_ = NULL;
												gboolean _tmp255_ = FALSE;
												_tmp251_ = nv;
												_tmp251__length1 = nv_length1;
												_tmp252_ = _tmp251_[1];
												_tmp253_ = vala_gidl_parser_eval (self, _tmp252_);
												_tmp254_ = _tmp253_;
												_tmp255_ = g_strcmp0 (_tmp254_, "1") == 0;
												_g_free0 (_tmp254_);
												if (_tmp255_) {
													ValaParameter* _tmp256_ = NULL;
													gboolean _tmp257_ = FALSE;
													gboolean _tmp258_ = FALSE;
													gboolean _tmp260_ = FALSE;
													_tmp256_ = p;
													vala_parameter_set_direction (_tmp256_, VALA_PARAMETER_DIRECTION_OUT);
													out_requested = TRUE;
													_tmp258_ = array_requested;
													if (!_tmp258_) {
														ValaDataType* _tmp259_ = NULL;
														_tmp259_ = param_type;
														_tmp257_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp259_, VALA_TYPE_ARRAY_TYPE);
													} else {
														_tmp257_ = FALSE;
													}
													_tmp260_ = _tmp257_;
													if (_tmp260_) {
														ValaArrayType* array_type = NULL;
														ValaDataType* _tmp261_ = NULL;
														ValaArrayType* _tmp262_ = NULL;
														ValaArrayType* _tmp263_ = NULL;
														ValaDataType* _tmp264_ = NULL;
														ValaDataType* _tmp265_ = NULL;
														ValaDataType* _tmp266_ = NULL;
														ValaParameter* _tmp267_ = NULL;
														ValaDataType* _tmp268_ = NULL;
														_tmp261_ = param_type;
														_tmp262_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp261_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
														array_type = _tmp262_;
														_tmp263_ = array_type;
														_tmp264_ = vala_array_type_get_element_type (_tmp263_);
														_tmp265_ = _tmp264_;
														_tmp266_ = _vala_code_node_ref0 (_tmp265_);
														_vala_code_node_unref0 (param_type);
														param_type = _tmp266_;
														_tmp267_ = p;
														_tmp268_ = param_type;
														vala_variable_set_variable_type ((ValaVariable*) _tmp267_, _tmp268_);
														_vala_code_node_unref0 (array_type);
													}
												}
											} else {
												gchar** _tmp269_ = NULL;
												gint _tmp269__length1 = 0;
												const gchar* _tmp270_ = NULL;
												_tmp269_ = nv;
												_tmp269__length1 = nv_length1;
												_tmp270_ = _tmp269_[0];
												if (g_strcmp0 (_tmp270_, "is_ref") == 0) {
													gchar** _tmp271_ = NULL;
													gint _tmp271__length1 = 0;
													const gchar* _tmp272_ = NULL;
													gchar* _tmp273_ = NULL;
													gchar* _tmp274_ = NULL;
													gboolean _tmp275_ = FALSE;
													_tmp271_ = nv;
													_tmp271__length1 = nv_length1;
													_tmp272_ = _tmp271_[1];
													_tmp273_ = vala_gidl_parser_eval (self, _tmp272_);
													_tmp274_ = _tmp273_;
													_tmp275_ = g_strcmp0 (_tmp274_, "1") == 0;
													_g_free0 (_tmp274_);
													if (_tmp275_) {
														ValaParameter* _tmp276_ = NULL;
														gboolean _tmp277_ = FALSE;
														gboolean _tmp278_ = FALSE;
														gboolean _tmp280_ = FALSE;
														_tmp276_ = p;
														vala_parameter_set_direction (_tmp276_, VALA_PARAMETER_DIRECTION_REF);
														_tmp278_ = array_requested;
														if (!_tmp278_) {
															ValaDataType* _tmp279_ = NULL;
															_tmp279_ = param_type;
															_tmp277_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp279_, VALA_TYPE_ARRAY_TYPE);
														} else {
															_tmp277_ = FALSE;
														}
														_tmp280_ = _tmp277_;
														if (_tmp280_) {
															ValaArrayType* array_type = NULL;
															ValaDataType* _tmp281_ = NULL;
															ValaArrayType* _tmp282_ = NULL;
															ValaArrayType* _tmp283_ = NULL;
															ValaDataType* _tmp284_ = NULL;
															ValaDataType* _tmp285_ = NULL;
															ValaDataType* _tmp286_ = NULL;
															ValaParameter* _tmp287_ = NULL;
															ValaDataType* _tmp288_ = NULL;
															_tmp281_ = param_type;
															_tmp282_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp281_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
															array_type = _tmp282_;
															_tmp283_ = array_type;
															_tmp284_ = vala_array_type_get_element_type (_tmp283_);
															_tmp285_ = _tmp284_;
															_tmp286_ = _vala_code_node_ref0 (_tmp285_);
															_vala_code_node_unref0 (param_type);
															param_type = _tmp286_;
															_tmp287_ = p;
															_tmp288_ = param_type;
															vala_variable_set_variable_type ((ValaVariable*) _tmp287_, _tmp288_);
															_vala_code_node_unref0 (array_type);
														}
													}
												} else {
													gchar** _tmp289_ = NULL;
													gint _tmp289__length1 = 0;
													const gchar* _tmp290_ = NULL;
													_tmp289_ = nv;
													_tmp289__length1 = nv_length1;
													_tmp290_ = _tmp289_[0];
													if (g_strcmp0 (_tmp290_, "takes_ownership") == 0) {
														gchar** _tmp291_ = NULL;
														gint _tmp291__length1 = 0;
														const gchar* _tmp292_ = NULL;
														gchar* _tmp293_ = NULL;
														gchar* _tmp294_ = NULL;
														gboolean _tmp295_ = FALSE;
														_tmp291_ = nv;
														_tmp291__length1 = nv_length1;
														_tmp292_ = _tmp291_[1];
														_tmp293_ = vala_gidl_parser_eval (self, _tmp292_);
														_tmp294_ = _tmp293_;
														_tmp295_ = g_strcmp0 (_tmp294_, "1") == 0;
														_g_free0 (_tmp294_);
														if (_tmp295_) {
															ValaDataType* _tmp296_ = NULL;
															_tmp296_ = param_type;
															vala_data_type_set_value_owned (_tmp296_, TRUE);
														}
													} else {
														gchar** _tmp297_ = NULL;
														gint _tmp297__length1 = 0;
														const gchar* _tmp298_ = NULL;
														_tmp297_ = nv;
														_tmp297__length1 = nv_length1;
														_tmp298_ = _tmp297_[0];
														if (g_strcmp0 (_tmp298_, "nullable") == 0) {
															gchar** _tmp299_ = NULL;
															gint _tmp299__length1 = 0;
															const gchar* _tmp300_ = NULL;
															gchar* _tmp301_ = NULL;
															gchar* _tmp302_ = NULL;
															gboolean _tmp303_ = FALSE;
															_tmp299_ = nv;
															_tmp299__length1 = nv_length1;
															_tmp300_ = _tmp299_[1];
															_tmp301_ = vala_gidl_parser_eval (self, _tmp300_);
															_tmp302_ = _tmp301_;
															_tmp303_ = g_strcmp0 (_tmp302_, "1") == 0;
															_g_free0 (_tmp302_);
															if (_tmp303_) {
																ValaDataType* _tmp304_ = NULL;
																_tmp304_ = param_type;
																vala_data_type_set_nullable (_tmp304_, TRUE);
															}
														} else {
															gchar** _tmp305_ = NULL;
															gint _tmp305__length1 = 0;
															const gchar* _tmp306_ = NULL;
															_tmp305_ = nv;
															_tmp305__length1 = nv_length1;
															_tmp306_ = _tmp305_[0];
															if (g_strcmp0 (_tmp306_, "type_arguments") == 0) {
																ValaDataType* _tmp307_ = NULL;
																gchar** _tmp308_ = NULL;
																gint _tmp308__length1 = 0;
																const gchar* _tmp309_ = NULL;
																gchar* _tmp310_ = NULL;
																gchar* _tmp311_ = NULL;
																_tmp307_ = param_type;
																_tmp308_ = nv;
																_tmp308__length1 = nv_length1;
																_tmp309_ = _tmp308_[1];
																_tmp310_ = vala_gidl_parser_eval (self, _tmp309_);
																_tmp311_ = _tmp310_;
																vala_gidl_parser_parse_type_arguments_from_string (self, _tmp307_, _tmp311_, NULL);
																_g_free0 (_tmp311_);
															} else {
																gchar** _tmp312_ = NULL;
																gint _tmp312__length1 = 0;
																const gchar* _tmp313_ = NULL;
																_tmp312_ = nv;
																_tmp312__length1 = nv_length1;
																_tmp313_ = _tmp312_[0];
																if (g_strcmp0 (_tmp313_, "no_array_length") == 0) {
																	gchar** _tmp314_ = NULL;
																	gint _tmp314__length1 = 0;
																	const gchar* _tmp315_ = NULL;
																	gchar* _tmp316_ = NULL;
																	gchar* _tmp317_ = NULL;
																	gboolean _tmp318_ = FALSE;
																	_tmp314_ = nv;
																	_tmp314__length1 = nv_length1;
																	_tmp315_ = _tmp314_[1];
																	_tmp316_ = vala_gidl_parser_eval (self, _tmp315_);
																	_tmp317_ = _tmp316_;
																	_tmp318_ = g_strcmp0 (_tmp317_, "1") == 0;
																	_g_free0 (_tmp317_);
																	if (_tmp318_) {
																		ValaParameter* _tmp319_ = NULL;
																		_tmp319_ = p;
																		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp319_, "CCode", "array_length", FALSE, NULL);
																	}
																} else {
																	gchar** _tmp320_ = NULL;
																	gint _tmp320__length1 = 0;
																	const gchar* _tmp321_ = NULL;
																	_tmp320_ = nv;
																	_tmp320__length1 = nv_length1;
																	_tmp321_ = _tmp320_[0];
																	if (g_strcmp0 (_tmp321_, "array_length_type") == 0) {
																		ValaParameter* _tmp322_ = NULL;
																		gchar** _tmp323_ = NULL;
																		gint _tmp323__length1 = 0;
																		const gchar* _tmp324_ = NULL;
																		gchar* _tmp325_ = NULL;
																		gchar* _tmp326_ = NULL;
																		_tmp322_ = p;
																		_tmp323_ = nv;
																		_tmp323__length1 = nv_length1;
																		_tmp324_ = _tmp323_[1];
																		_tmp325_ = vala_gidl_parser_eval (self, _tmp324_);
																		_tmp326_ = _tmp325_;
																		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp322_, "CCode", "array_length_type", _tmp326_, NULL);
																		_g_free0 (_tmp326_);
																	} else {
																		gchar** _tmp327_ = NULL;
																		gint _tmp327__length1 = 0;
																		const gchar* _tmp328_ = NULL;
																		_tmp327_ = nv;
																		_tmp327__length1 = nv_length1;
																		_tmp328_ = _tmp327_[0];
																		if (g_strcmp0 (_tmp328_, "array_null_terminated") == 0) {
																			gchar** _tmp329_ = NULL;
																			gint _tmp329__length1 = 0;
																			const gchar* _tmp330_ = NULL;
																			gchar* _tmp331_ = NULL;
																			gchar* _tmp332_ = NULL;
																			gboolean _tmp333_ = FALSE;
																			_tmp329_ = nv;
																			_tmp329__length1 = nv_length1;
																			_tmp330_ = _tmp329_[1];
																			_tmp331_ = vala_gidl_parser_eval (self, _tmp330_);
																			_tmp332_ = _tmp331_;
																			_tmp333_ = g_strcmp0 (_tmp332_, "1") == 0;
																			_g_free0 (_tmp332_);
																			if (_tmp333_) {
																				ValaParameter* _tmp334_ = NULL;
																				ValaParameter* _tmp335_ = NULL;
																				_tmp334_ = p;
																				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp334_, "CCode", "array_length", FALSE, NULL);
																				_tmp335_ = p;
																				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp335_, "CCode", "array_null_terminated", TRUE, NULL);
																			}
																		} else {
																			gchar** _tmp336_ = NULL;
																			gint _tmp336__length1 = 0;
																			const gchar* _tmp337_ = NULL;
																			_tmp336_ = nv;
																			_tmp336__length1 = nv_length1;
																			_tmp337_ = _tmp336_[0];
																			if (g_strcmp0 (_tmp337_, "type_name") == 0) {
																				ValaParameter* _tmp338_ = NULL;
																				gchar** _tmp339_ = NULL;
																				gint _tmp339__length1 = 0;
																				const gchar* _tmp340_ = NULL;
																				gchar* _tmp341_ = NULL;
																				gchar* _tmp342_ = NULL;
																				ValaDataType* _tmp343_ = NULL;
																				ValaDataType* _tmp344_ = NULL;
																				_tmp338_ = p;
																				_tmp339_ = nv;
																				_tmp339__length1 = nv_length1;
																				_tmp340_ = _tmp339_[1];
																				_tmp341_ = vala_gidl_parser_eval (self, _tmp340_);
																				_tmp342_ = _tmp341_;
																				_tmp343_ = vala_gidl_parser_parse_type_from_string (self, _tmp342_, FALSE, NULL);
																				_vala_code_node_unref0 (param_type);
																				param_type = _tmp343_;
																				_tmp344_ = param_type;
																				vala_variable_set_variable_type ((ValaVariable*) _tmp338_, _tmp344_);
																				_g_free0 (_tmp342_);
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
									nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (attr);
								}
							}
						}
					}
					_tmp346_ = show_param;
					if (_tmp346_) {
						_tmp345_ = TRUE;
					} else {
						gboolean _tmp347_ = FALSE;
						_tmp347_ = hide_param;
						_tmp345_ = !_tmp347_;
					}
					_tmp348_ = _tmp345_;
					if (_tmp348_) {
						ValaDelegate* _tmp349_ = NULL;
						ValaParameter* _tmp350_ = NULL;
						_tmp349_ = cb;
						_tmp350_ = p;
						vala_delegate_add_parameter (_tmp349_, _tmp350_);
					}
					_vala_code_node_unref0 (p);
					_vala_code_node_unref0 (param_type);
					_g_free0 (param_name);
				}
				_tmp351_ = remaining_params;
				remaining_params = _tmp351_ - 1;
			}
		}
	}
	_tmp353_ = suppress_throws;
	if (_tmp353_ == FALSE) {
		const gchar* _tmp354_ = NULL;
		_tmp354_ = error_types;
		_tmp352_ = _tmp354_ != NULL;
	} else {
		_tmp352_ = FALSE;
	}
	_tmp355_ = _tmp352_;
	if (_tmp355_) {
		gchar** type_args = NULL;
		const gchar* _tmp356_ = NULL;
		gchar* _tmp357_ = NULL;
		gchar* _tmp358_ = NULL;
		gchar** _tmp359_ = NULL;
		gchar** _tmp360_ = NULL;
		gchar** _tmp361_ = NULL;
		gint _tmp361__length1 = 0;
		gint type_args_length1 = 0;
		gint _type_args_size_ = 0;
		gchar** _tmp362_ = NULL;
		gint _tmp362__length1 = 0;
		_tmp356_ = error_types;
		_tmp357_ = vala_gidl_parser_eval (self, _tmp356_);
		_tmp358_ = _tmp357_;
		_tmp360_ = _tmp359_ = g_strsplit (_tmp358_, ",", 0);
		_tmp361_ = _tmp360_;
		_tmp361__length1 = _vala_array_length (_tmp359_);
		_g_free0 (_tmp358_);
		type_args = _tmp361_;
		type_args_length1 = _tmp361__length1;
		_type_args_size_ = type_args_length1;
		_tmp362_ = type_args;
		_tmp362__length1 = type_args_length1;
		{
			gchar** type_arg_collection = NULL;
			gint type_arg_collection_length1 = 0;
			gint _type_arg_collection_size_ = 0;
			gint type_arg_it = 0;
			type_arg_collection = _tmp362_;
			type_arg_collection_length1 = _tmp362__length1;
			for (type_arg_it = 0; type_arg_it < _tmp362__length1; type_arg_it = type_arg_it + 1) {
				gchar* _tmp363_ = NULL;
				gchar* type_arg = NULL;
				_tmp363_ = g_strdup (type_arg_collection[type_arg_it]);
				type_arg = _tmp363_;
				{
					ValaDelegate* _tmp364_ = NULL;
					const gchar* _tmp365_ = NULL;
					ValaDataType* _tmp366_ = NULL;
					ValaDataType* _tmp367_ = NULL;
					_tmp364_ = cb;
					_tmp365_ = type_arg;
					_tmp366_ = vala_gidl_parser_parse_type_from_string (self, _tmp365_, TRUE, NULL);
					_tmp367_ = _tmp366_;
					vala_code_node_add_error_type ((ValaCodeNode*) _tmp364_, _tmp367_);
					_vala_code_node_unref0 (_tmp367_);
					_g_free0 (type_arg);
				}
			}
		}
		type_args = (_vala_array_free (type_args, type_args_length1, (GDestroyNotify) g_free), NULL);
	}
	result = cb;
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (error_types);
	_vala_code_node_unref0 (return_type);
	return result;
}


static gboolean vala_gidl_parser_is_reference_type (ValaGIdlParser* self, const gchar* cname) {
	gboolean result = FALSE;
	gchar** st_attributes = NULL;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gchar** _tmp2_ = NULL;
	gint st_attributes_length1 = 0;
	gint _st_attributes_size_ = 0;
	gchar** _tmp3_ = NULL;
	gint _tmp3__length1 = 0;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (cname != NULL, FALSE);
	_tmp0_ = cname;
	_tmp2_ = vala_gidl_parser_get_attributes (self, _tmp0_, &_tmp1_);
	st_attributes = _tmp2_;
	st_attributes_length1 = _tmp1_;
	_st_attributes_size_ = st_attributes_length1;
	_tmp3_ = st_attributes;
	_tmp3__length1 = st_attributes_length1;
	if (_tmp3_ != NULL) {
		gchar** _tmp4_ = NULL;
		gint _tmp4__length1 = 0;
		_tmp4_ = st_attributes;
		_tmp4__length1 = st_attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp4_;
			attr_collection_length1 = _tmp4__length1;
			for (attr_it = 0; attr_it < _tmp4__length1; attr_it = attr_it + 1) {
				gchar* _tmp5_ = NULL;
				gchar* attr = NULL;
				_tmp5_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp5_;
				{
					gchar** nv = NULL;
					const gchar* _tmp6_ = NULL;
					gchar** _tmp7_ = NULL;
					gchar** _tmp8_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gboolean _tmp9_ = FALSE;
					gchar** _tmp10_ = NULL;
					gint _tmp10__length1 = 0;
					const gchar* _tmp11_ = NULL;
					gboolean _tmp16_ = FALSE;
					_tmp6_ = attr;
					_tmp8_ = _tmp7_ = g_strsplit (_tmp6_, "=", 2);
					nv = _tmp8_;
					nv_length1 = _vala_array_length (_tmp7_);
					_nv_size_ = nv_length1;
					_tmp10_ = nv;
					_tmp10__length1 = nv_length1;
					_tmp11_ = _tmp10_[0];
					if (g_strcmp0 (_tmp11_, "is_value_type") == 0) {
						gchar** _tmp12_ = NULL;
						gint _tmp12__length1 = 0;
						const gchar* _tmp13_ = NULL;
						gchar* _tmp14_ = NULL;
						gchar* _tmp15_ = NULL;
						_tmp12_ = nv;
						_tmp12__length1 = nv_length1;
						_tmp13_ = _tmp12_[1];
						_tmp14_ = vala_gidl_parser_eval (self, _tmp13_);
						_tmp15_ = _tmp14_;
						_tmp9_ = g_strcmp0 (_tmp15_, "1") == 0;
						_g_free0 (_tmp15_);
					} else {
						_tmp9_ = FALSE;
					}
					_tmp16_ = _tmp9_;
					if (_tmp16_) {
						result = FALSE;
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
						st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
						return result;
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	result = TRUE;
	st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static void vala_gidl_parser_parse_struct (ValaGIdlParser* self, GIdlNodeStruct* st_node, ValaSymbol* container, GIdlModule* module) {
	GIdlNode* node = NULL;
	GIdlNodeStruct* _tmp0_ = NULL;
	GIdlNodeStruct* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* name = NULL;
	GIdlNode* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	ValaSymbol* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GIdlNode* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (st_node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = st_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = st_node;
	_tmp2_ = _tmp1_->deprecated;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = node;
	_tmp4_ = _tmp3_->name;
	_tmp5_ = container;
	_tmp6_ = vala_gidl_parser_fix_type_name (self, _tmp4_, _tmp5_);
	name = _tmp6_;
	_tmp7_ = node;
	_tmp8_ = _tmp7_->name;
	_tmp9_ = vala_gidl_parser_is_reference_type (self, _tmp8_);
	if (!_tmp9_) {
		ValaStruct* st = NULL;
		ValaSymbol* _tmp10_ = NULL;
		ValaScope* _tmp11_ = NULL;
		ValaScope* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		ValaSymbol* _tmp14_ = NULL;
		ValaStruct* _tmp15_ = NULL;
		ValaStruct* _tmp16_ = NULL;
		ValaStruct* _tmp143_ = NULL;
		ValaTypeSymbol* _tmp144_ = NULL;
		GIdlNodeStruct* _tmp145_ = NULL;
		GList* _tmp146_ = NULL;
		_tmp10_ = container;
		_tmp11_ = vala_symbol_get_scope (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = name;
		_tmp14_ = vala_scope_lookup (_tmp12_, _tmp13_);
		_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp14_) : NULL;
		if (_tmp15_ == NULL) {
			_vala_code_node_unref0 (_tmp14_);
		}
		st = _tmp15_;
		_tmp16_ = st;
		if (_tmp16_ == NULL) {
			const gchar* _tmp17_ = NULL;
			ValaSourceReference* _tmp18_ = NULL;
			ValaStruct* _tmp19_ = NULL;
			ValaStruct* _tmp20_ = NULL;
			gchar** st_attributes = NULL;
			GIdlNode* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			gint _tmp23_ = 0;
			gchar** _tmp24_ = NULL;
			gint st_attributes_length1 = 0;
			gint _st_attributes_size_ = 0;
			gchar** _tmp25_ = NULL;
			gint _tmp25__length1 = 0;
			ValaSymbol* _tmp139_ = NULL;
			ValaStruct* _tmp140_ = NULL;
			ValaSourceFile* _tmp141_ = NULL;
			ValaStruct* _tmp142_ = NULL;
			_tmp17_ = name;
			_tmp18_ = self->priv->current_source_reference;
			_tmp19_ = vala_struct_new (_tmp17_, _tmp18_, NULL);
			_vala_code_node_unref0 (st);
			st = _tmp19_;
			_tmp20_ = st;
			vala_symbol_set_access ((ValaSymbol*) _tmp20_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp21_ = node;
			_tmp22_ = _tmp21_->name;
			_tmp24_ = vala_gidl_parser_get_attributes (self, _tmp22_, &_tmp23_);
			st_attributes = _tmp24_;
			st_attributes_length1 = _tmp23_;
			_st_attributes_size_ = st_attributes_length1;
			_tmp25_ = st_attributes;
			_tmp25__length1 = st_attributes_length1;
			if (_tmp25_ != NULL) {
				gchar** _tmp26_ = NULL;
				gint _tmp26__length1 = 0;
				_tmp26_ = st_attributes;
				_tmp26__length1 = st_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp26_;
					attr_collection_length1 = _tmp26__length1;
					for (attr_it = 0; attr_it < _tmp26__length1; attr_it = attr_it + 1) {
						gchar* _tmp27_ = NULL;
						gchar* attr = NULL;
						_tmp27_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp27_;
						{
							gchar** nv = NULL;
							const gchar* _tmp28_ = NULL;
							gchar** _tmp29_ = NULL;
							gchar** _tmp30_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp31_ = NULL;
							gint _tmp31__length1 = 0;
							const gchar* _tmp32_ = NULL;
							_tmp28_ = attr;
							_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, "=", 2);
							nv = _tmp30_;
							nv_length1 = _vala_array_length (_tmp29_);
							_nv_size_ = nv_length1;
							_tmp31_ = nv;
							_tmp31__length1 = nv_length1;
							_tmp32_ = _tmp31_[0];
							if (g_strcmp0 (_tmp32_, "cheader_filename") == 0) {
								ValaStruct* _tmp33_ = NULL;
								gchar** _tmp34_ = NULL;
								gint _tmp34__length1 = 0;
								const gchar* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
								_tmp33_ = st;
								_tmp34_ = nv;
								_tmp34__length1 = nv_length1;
								_tmp35_ = _tmp34_[1];
								_tmp36_ = vala_gidl_parser_eval (self, _tmp35_);
								_tmp37_ = _tmp36_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp33_, "CCode", "cheader_filename", _tmp37_, NULL);
								_g_free0 (_tmp37_);
							} else {
								gchar** _tmp38_ = NULL;
								gint _tmp38__length1 = 0;
								const gchar* _tmp39_ = NULL;
								_tmp38_ = nv;
								_tmp38__length1 = nv_length1;
								_tmp39_ = _tmp38_[0];
								if (g_strcmp0 (_tmp39_, "hidden") == 0) {
									gchar** _tmp40_ = NULL;
									gint _tmp40__length1 = 0;
									const gchar* _tmp41_ = NULL;
									gchar* _tmp42_ = NULL;
									gchar* _tmp43_ = NULL;
									gboolean _tmp44_ = FALSE;
									_tmp40_ = nv;
									_tmp40__length1 = nv_length1;
									_tmp41_ = _tmp40_[1];
									_tmp42_ = vala_gidl_parser_eval (self, _tmp41_);
									_tmp43_ = _tmp42_;
									_tmp44_ = g_strcmp0 (_tmp43_, "1") == 0;
									_g_free0 (_tmp43_);
									if (_tmp44_) {
										nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
										_g_free0 (attr);
										st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
										_vala_code_node_unref0 (st);
										_g_free0 (name);
										return;
									}
								} else {
									gchar** _tmp45_ = NULL;
									gint _tmp45__length1 = 0;
									const gchar* _tmp46_ = NULL;
									_tmp45_ = nv;
									_tmp45__length1 = nv_length1;
									_tmp46_ = _tmp45_[0];
									if (g_strcmp0 (_tmp46_, "base_type") == 0) {
										ValaStruct* _tmp47_ = NULL;
										gchar** _tmp48_ = NULL;
										gint _tmp48__length1 = 0;
										const gchar* _tmp49_ = NULL;
										gchar* _tmp50_ = NULL;
										gchar* _tmp51_ = NULL;
										ValaDataType* _tmp52_ = NULL;
										ValaDataType* _tmp53_ = NULL;
										_tmp47_ = st;
										_tmp48_ = nv;
										_tmp48__length1 = nv_length1;
										_tmp49_ = _tmp48_[1];
										_tmp50_ = vala_gidl_parser_eval (self, _tmp49_);
										_tmp51_ = _tmp50_;
										_tmp52_ = vala_gidl_parser_parse_type_string (self, _tmp51_);
										_tmp53_ = _tmp52_;
										vala_struct_set_base_type (_tmp47_, _tmp53_);
										_vala_code_node_unref0 (_tmp53_);
										_g_free0 (_tmp51_);
									} else {
										gchar** _tmp54_ = NULL;
										gint _tmp54__length1 = 0;
										const gchar* _tmp55_ = NULL;
										_tmp54_ = nv;
										_tmp54__length1 = nv_length1;
										_tmp55_ = _tmp54_[0];
										if (g_strcmp0 (_tmp55_, "rank") == 0) {
											ValaStruct* _tmp56_ = NULL;
											gchar** _tmp57_ = NULL;
											gint _tmp57__length1 = 0;
											const gchar* _tmp58_ = NULL;
											gchar* _tmp59_ = NULL;
											gchar* _tmp60_ = NULL;
											gint _tmp61_ = 0;
											_tmp56_ = st;
											_tmp57_ = nv;
											_tmp57__length1 = nv_length1;
											_tmp58_ = _tmp57_[1];
											_tmp59_ = vala_gidl_parser_eval (self, _tmp58_);
											_tmp60_ = _tmp59_;
											_tmp61_ = atoi (_tmp60_);
											vala_struct_set_rank (_tmp56_, _tmp61_);
											_g_free0 (_tmp60_);
										} else {
											gchar** _tmp62_ = NULL;
											gint _tmp62__length1 = 0;
											const gchar* _tmp63_ = NULL;
											_tmp62_ = nv;
											_tmp62__length1 = nv_length1;
											_tmp63_ = _tmp62_[0];
											if (g_strcmp0 (_tmp63_, "simple_type") == 0) {
												gchar** _tmp64_ = NULL;
												gint _tmp64__length1 = 0;
												const gchar* _tmp65_ = NULL;
												gchar* _tmp66_ = NULL;
												gchar* _tmp67_ = NULL;
												gboolean _tmp68_ = FALSE;
												_tmp64_ = nv;
												_tmp64__length1 = nv_length1;
												_tmp65_ = _tmp64_[1];
												_tmp66_ = vala_gidl_parser_eval (self, _tmp65_);
												_tmp67_ = _tmp66_;
												_tmp68_ = g_strcmp0 (_tmp67_, "1") == 0;
												_g_free0 (_tmp67_);
												if (_tmp68_) {
													ValaStruct* _tmp69_ = NULL;
													_tmp69_ = st;
													vala_struct_set_simple_type (_tmp69_, TRUE);
												}
											} else {
												gchar** _tmp70_ = NULL;
												gint _tmp70__length1 = 0;
												const gchar* _tmp71_ = NULL;
												_tmp70_ = nv;
												_tmp70__length1 = nv_length1;
												_tmp71_ = _tmp70_[0];
												if (g_strcmp0 (_tmp71_, "immutable") == 0) {
													gchar** _tmp72_ = NULL;
													gint _tmp72__length1 = 0;
													const gchar* _tmp73_ = NULL;
													gchar* _tmp74_ = NULL;
													gchar* _tmp75_ = NULL;
													gboolean _tmp76_ = FALSE;
													_tmp72_ = nv;
													_tmp72__length1 = nv_length1;
													_tmp73_ = _tmp72_[1];
													_tmp74_ = vala_gidl_parser_eval (self, _tmp73_);
													_tmp75_ = _tmp74_;
													_tmp76_ = g_strcmp0 (_tmp75_, "1") == 0;
													_g_free0 (_tmp75_);
													if (_tmp76_) {
														ValaStruct* _tmp77_ = NULL;
														_tmp77_ = st;
														vala_code_node_set_attribute ((ValaCodeNode*) _tmp77_, "Immutable", TRUE, NULL);
													}
												} else {
													gchar** _tmp78_ = NULL;
													gint _tmp78__length1 = 0;
													const gchar* _tmp79_ = NULL;
													_tmp78_ = nv;
													_tmp78__length1 = nv_length1;
													_tmp79_ = _tmp78_[0];
													if (g_strcmp0 (_tmp79_, "has_type_id") == 0) {
														gchar** _tmp80_ = NULL;
														gint _tmp80__length1 = 0;
														const gchar* _tmp81_ = NULL;
														gchar* _tmp82_ = NULL;
														gchar* _tmp83_ = NULL;
														gboolean _tmp84_ = FALSE;
														_tmp80_ = nv;
														_tmp80__length1 = nv_length1;
														_tmp81_ = _tmp80_[1];
														_tmp82_ = vala_gidl_parser_eval (self, _tmp81_);
														_tmp83_ = _tmp82_;
														_tmp84_ = g_strcmp0 (_tmp83_, "0") == 0;
														_g_free0 (_tmp83_);
														if (_tmp84_) {
															ValaStruct* _tmp85_ = NULL;
															_tmp85_ = st;
															vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp85_, "CCode", "has_type_id", FALSE, NULL);
														}
													} else {
														gchar** _tmp86_ = NULL;
														gint _tmp86__length1 = 0;
														const gchar* _tmp87_ = NULL;
														_tmp86_ = nv;
														_tmp86__length1 = nv_length1;
														_tmp87_ = _tmp86_[0];
														if (g_strcmp0 (_tmp87_, "type_id") == 0) {
															ValaStruct* _tmp88_ = NULL;
															gchar** _tmp89_ = NULL;
															gint _tmp89__length1 = 0;
															const gchar* _tmp90_ = NULL;
															gchar* _tmp91_ = NULL;
															gchar* _tmp92_ = NULL;
															_tmp88_ = st;
															_tmp89_ = nv;
															_tmp89__length1 = nv_length1;
															_tmp90_ = _tmp89_[1];
															_tmp91_ = vala_gidl_parser_eval (self, _tmp90_);
															_tmp92_ = _tmp91_;
															vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp88_, "CCode", "type_id", _tmp92_, NULL);
															_g_free0 (_tmp92_);
														} else {
															gchar** _tmp93_ = NULL;
															gint _tmp93__length1 = 0;
															const gchar* _tmp94_ = NULL;
															_tmp93_ = nv;
															_tmp93__length1 = nv_length1;
															_tmp94_ = _tmp93_[0];
															if (g_strcmp0 (_tmp94_, "has_copy_function") == 0) {
																gchar** _tmp95_ = NULL;
																gint _tmp95__length1 = 0;
																const gchar* _tmp96_ = NULL;
																gchar* _tmp97_ = NULL;
																gchar* _tmp98_ = NULL;
																gboolean _tmp99_ = FALSE;
																_tmp95_ = nv;
																_tmp95__length1 = nv_length1;
																_tmp96_ = _tmp95_[1];
																_tmp97_ = vala_gidl_parser_eval (self, _tmp96_);
																_tmp98_ = _tmp97_;
																_tmp99_ = g_strcmp0 (_tmp98_, "0") == 0;
																_g_free0 (_tmp98_);
																if (_tmp99_) {
																	ValaStruct* _tmp100_ = NULL;
																	_tmp100_ = st;
																	vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp100_, "CCode", "has_copy_function", FALSE, NULL);
																}
															} else {
																gchar** _tmp101_ = NULL;
																gint _tmp101__length1 = 0;
																const gchar* _tmp102_ = NULL;
																_tmp101_ = nv;
																_tmp101__length1 = nv_length1;
																_tmp102_ = _tmp101_[0];
																if (g_strcmp0 (_tmp102_, "deprecated") == 0) {
																	gchar** _tmp103_ = NULL;
																	gint _tmp103__length1 = 0;
																	const gchar* _tmp104_ = NULL;
																	gchar* _tmp105_ = NULL;
																	gchar* _tmp106_ = NULL;
																	gboolean _tmp107_ = FALSE;
																	_tmp103_ = nv;
																	_tmp103__length1 = nv_length1;
																	_tmp104_ = _tmp103_[1];
																	_tmp105_ = vala_gidl_parser_eval (self, _tmp104_);
																	_tmp106_ = _tmp105_;
																	_tmp107_ = g_strcmp0 (_tmp106_, "1") == 0;
																	_g_free0 (_tmp106_);
																	if (_tmp107_) {
																		ValaStruct* _tmp108_ = NULL;
																		_tmp108_ = st;
																		vala_code_node_set_attribute ((ValaCodeNode*) _tmp108_, "Deprecated", TRUE, NULL);
																	}
																} else {
																	gchar** _tmp109_ = NULL;
																	gint _tmp109__length1 = 0;
																	const gchar* _tmp110_ = NULL;
																	_tmp109_ = nv;
																	_tmp109__length1 = nv_length1;
																	_tmp110_ = _tmp109_[0];
																	if (g_strcmp0 (_tmp110_, "replacement") == 0) {
																		ValaStruct* _tmp111_ = NULL;
																		gchar** _tmp112_ = NULL;
																		gint _tmp112__length1 = 0;
																		const gchar* _tmp113_ = NULL;
																		gchar* _tmp114_ = NULL;
																		gchar* _tmp115_ = NULL;
																		_tmp111_ = st;
																		_tmp112_ = nv;
																		_tmp112__length1 = nv_length1;
																		_tmp113_ = _tmp112_[1];
																		_tmp114_ = vala_gidl_parser_eval (self, _tmp113_);
																		_tmp115_ = _tmp114_;
																		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp111_, "Deprecated", "replacement", _tmp115_, NULL);
																		_g_free0 (_tmp115_);
																	} else {
																		gchar** _tmp116_ = NULL;
																		gint _tmp116__length1 = 0;
																		const gchar* _tmp117_ = NULL;
																		_tmp116_ = nv;
																		_tmp116__length1 = nv_length1;
																		_tmp117_ = _tmp116_[0];
																		if (g_strcmp0 (_tmp117_, "deprecated_since") == 0) {
																			ValaStruct* _tmp118_ = NULL;
																			gchar** _tmp119_ = NULL;
																			gint _tmp119__length1 = 0;
																			const gchar* _tmp120_ = NULL;
																			gchar* _tmp121_ = NULL;
																			gchar* _tmp122_ = NULL;
																			_tmp118_ = st;
																			_tmp119_ = nv;
																			_tmp119__length1 = nv_length1;
																			_tmp120_ = _tmp119_[1];
																			_tmp121_ = vala_gidl_parser_eval (self, _tmp120_);
																			_tmp122_ = _tmp121_;
																			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp118_, "Deprecated", "since", _tmp122_, NULL);
																			_g_free0 (_tmp122_);
																		} else {
																			gchar** _tmp123_ = NULL;
																			gint _tmp123__length1 = 0;
																			const gchar* _tmp124_ = NULL;
																			_tmp123_ = nv;
																			_tmp123__length1 = nv_length1;
																			_tmp124_ = _tmp123_[0];
																			if (g_strcmp0 (_tmp124_, "has_destroy_function") == 0) {
																				gchar** _tmp125_ = NULL;
																				gint _tmp125__length1 = 0;
																				const gchar* _tmp126_ = NULL;
																				gchar* _tmp127_ = NULL;
																				gchar* _tmp128_ = NULL;
																				gboolean _tmp129_ = FALSE;
																				_tmp125_ = nv;
																				_tmp125__length1 = nv_length1;
																				_tmp126_ = _tmp125_[1];
																				_tmp127_ = vala_gidl_parser_eval (self, _tmp126_);
																				_tmp128_ = _tmp127_;
																				_tmp129_ = g_strcmp0 (_tmp128_, "0") == 0;
																				_g_free0 (_tmp128_);
																				if (_tmp129_) {
																					ValaStruct* _tmp130_ = NULL;
																					_tmp130_ = st;
																					vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp130_, "CCode", "has_destroy_function", FALSE, NULL);
																				}
																			} else {
																				gchar** _tmp131_ = NULL;
																				gint _tmp131__length1 = 0;
																				const gchar* _tmp132_ = NULL;
																				_tmp131_ = nv;
																				_tmp131__length1 = nv_length1;
																				_tmp132_ = _tmp131_[0];
																				if (g_strcmp0 (_tmp132_, "experimental") == 0) {
																					gchar** _tmp133_ = NULL;
																					gint _tmp133__length1 = 0;
																					const gchar* _tmp134_ = NULL;
																					gchar* _tmp135_ = NULL;
																					gchar* _tmp136_ = NULL;
																					gboolean _tmp137_ = FALSE;
																					_tmp133_ = nv;
																					_tmp133__length1 = nv_length1;
																					_tmp134_ = _tmp133_[1];
																					_tmp135_ = vala_gidl_parser_eval (self, _tmp134_);
																					_tmp136_ = _tmp135_;
																					_tmp137_ = g_strcmp0 (_tmp136_, "1") == 0;
																					_g_free0 (_tmp136_);
																					if (_tmp137_) {
																						ValaStruct* _tmp138_ = NULL;
																						_tmp138_ = st;
																						vala_code_node_set_attribute ((ValaCodeNode*) _tmp138_, "Experimental", TRUE, NULL);
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp139_ = container;
			_tmp140_ = st;
			vala_gidl_parser_add_symbol_to_container (self, _tmp139_, (ValaSymbol*) _tmp140_);
			_tmp141_ = self->priv->current_source_file;
			_tmp142_ = st;
			vala_source_file_add_node (_tmp141_, (ValaCodeNode*) _tmp142_);
			st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp143_ = st;
		_tmp144_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp143_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp144_;
		_tmp145_ = st_node;
		_tmp146_ = _tmp145_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp146_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp147_ = NULL;
					GIdlNodeTypeId _tmp148_ = 0;
					_tmp147_ = member;
					_tmp148_ = _tmp147_->type;
					if (_tmp148_ == G_IDL_NODE_FUNCTION) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp149_ = NULL;
						ValaMethod* _tmp150_ = NULL;
						ValaMethod* _tmp151_ = NULL;
						_tmp149_ = member;
						_tmp150_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp149_, FALSE);
						m = _tmp150_;
						_tmp151_ = m;
						if (_tmp151_ != NULL) {
							ValaStruct* _tmp152_ = NULL;
							ValaMethod* _tmp153_ = NULL;
							_tmp152_ = st;
							_tmp153_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp152_, _tmp153_);
						}
						_vala_code_node_unref0 (m);
					} else {
						GIdlNode* _tmp154_ = NULL;
						GIdlNodeTypeId _tmp155_ = 0;
						_tmp154_ = member;
						_tmp155_ = _tmp154_->type;
						if (_tmp155_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp156_ = NULL;
							ValaField* _tmp157_ = NULL;
							ValaField* _tmp158_ = NULL;
							_tmp156_ = member;
							_tmp157_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp156_);
							f = _tmp157_;
							_tmp158_ = f;
							if (_tmp158_ != NULL) {
								ValaStruct* _tmp159_ = NULL;
								ValaField* _tmp160_ = NULL;
								_tmp159_ = st;
								_tmp160_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp159_, _tmp160_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_vala_code_node_unref0 (st);
	} else {
		gboolean ref_function_void = FALSE;
		gchar* ref_function = NULL;
		gchar* unref_function = NULL;
		gchar* copy_function = NULL;
		gchar* free_function = NULL;
		ValaClass* cl = NULL;
		ValaSymbol* _tmp161_ = NULL;
		ValaScope* _tmp162_ = NULL;
		ValaScope* _tmp163_ = NULL;
		const gchar* _tmp164_ = NULL;
		ValaSymbol* _tmp165_ = NULL;
		ValaClass* _tmp166_ = NULL;
		ValaClass* _tmp167_ = NULL;
		ValaClass* _tmp320_ = NULL;
		ValaTypeSymbol* _tmp321_ = NULL;
		GIdlNodeStruct* _tmp322_ = NULL;
		GList* _tmp323_ = NULL;
		const gchar* _tmp379_ = NULL;
		const gchar* _tmp388_ = NULL;
		ref_function_void = FALSE;
		ref_function = NULL;
		unref_function = NULL;
		copy_function = NULL;
		free_function = NULL;
		_tmp161_ = container;
		_tmp162_ = vala_symbol_get_scope (_tmp161_);
		_tmp163_ = _tmp162_;
		_tmp164_ = name;
		_tmp165_ = vala_scope_lookup (_tmp163_, _tmp164_);
		_tmp166_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp165_, VALA_TYPE_CLASS) ? ((ValaClass*) _tmp165_) : NULL;
		if (_tmp166_ == NULL) {
			_vala_code_node_unref0 (_tmp165_);
		}
		cl = _tmp166_;
		_tmp167_ = cl;
		if (_tmp167_ == NULL) {
			gchar* base_class = NULL;
			gboolean is_fundamental = FALSE;
			const gchar* _tmp168_ = NULL;
			ValaSourceReference* _tmp169_ = NULL;
			ValaClass* _tmp170_ = NULL;
			ValaClass* _tmp171_ = NULL;
			gchar** cl_attributes = NULL;
			GIdlNode* _tmp172_ = NULL;
			const gchar* _tmp173_ = NULL;
			gint _tmp174_ = 0;
			gchar** _tmp175_ = NULL;
			gint cl_attributes_length1 = 0;
			gint _cl_attributes_size_ = 0;
			gchar** _tmp176_ = NULL;
			gint _tmp176__length1 = 0;
			ValaSymbol* _tmp306_ = NULL;
			ValaClass* _tmp307_ = NULL;
			ValaSourceFile* _tmp308_ = NULL;
			ValaClass* _tmp309_ = NULL;
			const gchar* _tmp310_ = NULL;
			gboolean _tmp315_ = FALSE;
			const gchar* _tmp316_ = NULL;
			gboolean _tmp318_ = FALSE;
			base_class = NULL;
			is_fundamental = FALSE;
			_tmp168_ = name;
			_tmp169_ = self->priv->current_source_reference;
			_tmp170_ = vala_class_new (_tmp168_, _tmp169_, NULL);
			_vala_code_node_unref0 (cl);
			cl = _tmp170_;
			_tmp171_ = cl;
			vala_symbol_set_access ((ValaSymbol*) _tmp171_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp172_ = node;
			_tmp173_ = _tmp172_->name;
			_tmp175_ = vala_gidl_parser_get_attributes (self, _tmp173_, &_tmp174_);
			cl_attributes = _tmp175_;
			cl_attributes_length1 = _tmp174_;
			_cl_attributes_size_ = cl_attributes_length1;
			_tmp176_ = cl_attributes;
			_tmp176__length1 = cl_attributes_length1;
			if (_tmp176_ != NULL) {
				gchar** _tmp177_ = NULL;
				gint _tmp177__length1 = 0;
				_tmp177_ = cl_attributes;
				_tmp177__length1 = cl_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp177_;
					attr_collection_length1 = _tmp177__length1;
					for (attr_it = 0; attr_it < _tmp177__length1; attr_it = attr_it + 1) {
						gchar* _tmp178_ = NULL;
						gchar* attr = NULL;
						_tmp178_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp178_;
						{
							gchar** nv = NULL;
							const gchar* _tmp179_ = NULL;
							gchar** _tmp180_ = NULL;
							gchar** _tmp181_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp182_ = NULL;
							gint _tmp182__length1 = 0;
							const gchar* _tmp183_ = NULL;
							_tmp179_ = attr;
							_tmp181_ = _tmp180_ = g_strsplit (_tmp179_, "=", 2);
							nv = _tmp181_;
							nv_length1 = _vala_array_length (_tmp180_);
							_nv_size_ = nv_length1;
							_tmp182_ = nv;
							_tmp182__length1 = nv_length1;
							_tmp183_ = _tmp182_[0];
							if (g_strcmp0 (_tmp183_, "cheader_filename") == 0) {
								ValaClass* _tmp184_ = NULL;
								gchar** _tmp185_ = NULL;
								gint _tmp185__length1 = 0;
								const gchar* _tmp186_ = NULL;
								gchar* _tmp187_ = NULL;
								gchar* _tmp188_ = NULL;
								_tmp184_ = cl;
								_tmp185_ = nv;
								_tmp185__length1 = nv_length1;
								_tmp186_ = _tmp185_[1];
								_tmp187_ = vala_gidl_parser_eval (self, _tmp186_);
								_tmp188_ = _tmp187_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp184_, "CCode", "cheader_filename", _tmp188_, NULL);
								_g_free0 (_tmp188_);
							} else {
								gchar** _tmp189_ = NULL;
								gint _tmp189__length1 = 0;
								const gchar* _tmp190_ = NULL;
								_tmp189_ = nv;
								_tmp189__length1 = nv_length1;
								_tmp190_ = _tmp189_[0];
								if (g_strcmp0 (_tmp190_, "base_class") == 0) {
									gchar** _tmp191_ = NULL;
									gint _tmp191__length1 = 0;
									const gchar* _tmp192_ = NULL;
									gchar* _tmp193_ = NULL;
									_tmp191_ = nv;
									_tmp191__length1 = nv_length1;
									_tmp192_ = _tmp191_[1];
									_tmp193_ = vala_gidl_parser_eval (self, _tmp192_);
									_g_free0 (base_class);
									base_class = _tmp193_;
								} else {
									gchar** _tmp194_ = NULL;
									gint _tmp194__length1 = 0;
									const gchar* _tmp195_ = NULL;
									_tmp194_ = nv;
									_tmp194__length1 = nv_length1;
									_tmp195_ = _tmp194_[0];
									if (g_strcmp0 (_tmp195_, "hidden") == 0) {
										gchar** _tmp196_ = NULL;
										gint _tmp196__length1 = 0;
										const gchar* _tmp197_ = NULL;
										gchar* _tmp198_ = NULL;
										gchar* _tmp199_ = NULL;
										gboolean _tmp200_ = FALSE;
										_tmp196_ = nv;
										_tmp196__length1 = nv_length1;
										_tmp197_ = _tmp196_[1];
										_tmp198_ = vala_gidl_parser_eval (self, _tmp197_);
										_tmp199_ = _tmp198_;
										_tmp200_ = g_strcmp0 (_tmp199_, "1") == 0;
										_g_free0 (_tmp199_);
										if (_tmp200_) {
											nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
											_g_free0 (attr);
											cl_attributes = (_vala_array_free (cl_attributes, cl_attributes_length1, (GDestroyNotify) g_free), NULL);
											_g_free0 (base_class);
											_vala_code_node_unref0 (cl);
											_g_free0 (free_function);
											_g_free0 (copy_function);
											_g_free0 (unref_function);
											_g_free0 (ref_function);
											_g_free0 (name);
											return;
										}
									} else {
										gchar** _tmp201_ = NULL;
										gint _tmp201__length1 = 0;
										const gchar* _tmp202_ = NULL;
										_tmp201_ = nv;
										_tmp201__length1 = nv_length1;
										_tmp202_ = _tmp201_[0];
										if (g_strcmp0 (_tmp202_, "is_immutable") == 0) {
											gchar** _tmp203_ = NULL;
											gint _tmp203__length1 = 0;
											const gchar* _tmp204_ = NULL;
											gchar* _tmp205_ = NULL;
											gchar* _tmp206_ = NULL;
											gboolean _tmp207_ = FALSE;
											_tmp203_ = nv;
											_tmp203__length1 = nv_length1;
											_tmp204_ = _tmp203_[1];
											_tmp205_ = vala_gidl_parser_eval (self, _tmp204_);
											_tmp206_ = _tmp205_;
											_tmp207_ = g_strcmp0 (_tmp206_, "1") == 0;
											_g_free0 (_tmp206_);
											if (_tmp207_) {
												ValaClass* _tmp208_ = NULL;
												_tmp208_ = cl;
												vala_class_set_is_immutable (_tmp208_, TRUE);
											}
										} else {
											gchar** _tmp209_ = NULL;
											gint _tmp209__length1 = 0;
											const gchar* _tmp210_ = NULL;
											_tmp209_ = nv;
											_tmp209__length1 = nv_length1;
											_tmp210_ = _tmp209_[0];
											if (g_strcmp0 (_tmp210_, "const_cname") == 0) {
												ValaClass* _tmp211_ = NULL;
												gchar** _tmp212_ = NULL;
												gint _tmp212__length1 = 0;
												const gchar* _tmp213_ = NULL;
												gchar* _tmp214_ = NULL;
												gchar* _tmp215_ = NULL;
												_tmp211_ = cl;
												_tmp212_ = nv;
												_tmp212__length1 = nv_length1;
												_tmp213_ = _tmp212_[1];
												_tmp214_ = vala_gidl_parser_eval (self, _tmp213_);
												_tmp215_ = _tmp214_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp211_, "CCode", "const_cname", _tmp215_, NULL);
												_g_free0 (_tmp215_);
											} else {
												gchar** _tmp216_ = NULL;
												gint _tmp216__length1 = 0;
												const gchar* _tmp217_ = NULL;
												_tmp216_ = nv;
												_tmp216__length1 = nv_length1;
												_tmp217_ = _tmp216_[0];
												if (g_strcmp0 (_tmp217_, "is_fundamental") == 0) {
													gchar** _tmp218_ = NULL;
													gint _tmp218__length1 = 0;
													const gchar* _tmp219_ = NULL;
													gchar* _tmp220_ = NULL;
													gchar* _tmp221_ = NULL;
													gboolean _tmp222_ = FALSE;
													_tmp218_ = nv;
													_tmp218__length1 = nv_length1;
													_tmp219_ = _tmp218_[1];
													_tmp220_ = vala_gidl_parser_eval (self, _tmp219_);
													_tmp221_ = _tmp220_;
													_tmp222_ = g_strcmp0 (_tmp221_, "1") == 0;
													_g_free0 (_tmp221_);
													if (_tmp222_) {
														is_fundamental = TRUE;
													}
												} else {
													gboolean _tmp223_ = FALSE;
													gchar** _tmp224_ = NULL;
													gint _tmp224__length1 = 0;
													const gchar* _tmp225_ = NULL;
													gboolean _tmp227_ = FALSE;
													_tmp224_ = nv;
													_tmp224__length1 = nv_length1;
													_tmp225_ = _tmp224_[0];
													if (g_strcmp0 (_tmp225_, "abstract") == 0) {
														const gchar* _tmp226_ = NULL;
														_tmp226_ = base_class;
														_tmp223_ = _tmp226_ != NULL;
													} else {
														_tmp223_ = FALSE;
													}
													_tmp227_ = _tmp223_;
													if (_tmp227_) {
														gchar** _tmp228_ = NULL;
														gint _tmp228__length1 = 0;
														const gchar* _tmp229_ = NULL;
														gchar* _tmp230_ = NULL;
														gchar* _tmp231_ = NULL;
														gboolean _tmp232_ = FALSE;
														_tmp228_ = nv;
														_tmp228__length1 = nv_length1;
														_tmp229_ = _tmp228_[1];
														_tmp230_ = vala_gidl_parser_eval (self, _tmp229_);
														_tmp231_ = _tmp230_;
														_tmp232_ = g_strcmp0 (_tmp231_, "1") == 0;
														_g_free0 (_tmp231_);
														if (_tmp232_) {
															ValaClass* _tmp233_ = NULL;
															_tmp233_ = cl;
															vala_class_set_is_abstract (_tmp233_, TRUE);
														}
													} else {
														gchar** _tmp234_ = NULL;
														gint _tmp234__length1 = 0;
														const gchar* _tmp235_ = NULL;
														_tmp234_ = nv;
														_tmp234__length1 = nv_length1;
														_tmp235_ = _tmp234_[0];
														if (g_strcmp0 (_tmp235_, "free_function") == 0) {
															gchar** _tmp236_ = NULL;
															gint _tmp236__length1 = 0;
															const gchar* _tmp237_ = NULL;
															gchar* _tmp238_ = NULL;
															_tmp236_ = nv;
															_tmp236__length1 = nv_length1;
															_tmp237_ = _tmp236_[1];
															_tmp238_ = vala_gidl_parser_eval (self, _tmp237_);
															_g_free0 (free_function);
															free_function = _tmp238_;
														} else {
															gchar** _tmp239_ = NULL;
															gint _tmp239__length1 = 0;
															const gchar* _tmp240_ = NULL;
															_tmp239_ = nv;
															_tmp239__length1 = nv_length1;
															_tmp240_ = _tmp239_[0];
															if (g_strcmp0 (_tmp240_, "ref_function") == 0) {
																gchar** _tmp241_ = NULL;
																gint _tmp241__length1 = 0;
																const gchar* _tmp242_ = NULL;
																gchar* _tmp243_ = NULL;
																_tmp241_ = nv;
																_tmp241__length1 = nv_length1;
																_tmp242_ = _tmp241_[1];
																_tmp243_ = vala_gidl_parser_eval (self, _tmp242_);
																_g_free0 (ref_function);
																ref_function = _tmp243_;
															} else {
																gchar** _tmp244_ = NULL;
																gint _tmp244__length1 = 0;
																const gchar* _tmp245_ = NULL;
																_tmp244_ = nv;
																_tmp244__length1 = nv_length1;
																_tmp245_ = _tmp244_[0];
																if (g_strcmp0 (_tmp245_, "unref_function") == 0) {
																	gchar** _tmp246_ = NULL;
																	gint _tmp246__length1 = 0;
																	const gchar* _tmp247_ = NULL;
																	gchar* _tmp248_ = NULL;
																	_tmp246_ = nv;
																	_tmp246__length1 = nv_length1;
																	_tmp247_ = _tmp246_[1];
																	_tmp248_ = vala_gidl_parser_eval (self, _tmp247_);
																	_g_free0 (unref_function);
																	unref_function = _tmp248_;
																} else {
																	gchar** _tmp249_ = NULL;
																	gint _tmp249__length1 = 0;
																	const gchar* _tmp250_ = NULL;
																	_tmp249_ = nv;
																	_tmp249__length1 = nv_length1;
																	_tmp250_ = _tmp249_[0];
																	if (g_strcmp0 (_tmp250_, "copy_function") == 0) {
																		gchar** _tmp251_ = NULL;
																		gint _tmp251__length1 = 0;
																		const gchar* _tmp252_ = NULL;
																		gchar* _tmp253_ = NULL;
																		_tmp251_ = nv;
																		_tmp251__length1 = nv_length1;
																		_tmp252_ = _tmp251_[1];
																		_tmp253_ = vala_gidl_parser_eval (self, _tmp252_);
																		_g_free0 (copy_function);
																		copy_function = _tmp253_;
																	} else {
																		gchar** _tmp254_ = NULL;
																		gint _tmp254__length1 = 0;
																		const gchar* _tmp255_ = NULL;
																		_tmp254_ = nv;
																		_tmp254__length1 = nv_length1;
																		_tmp255_ = _tmp254_[0];
																		if (g_strcmp0 (_tmp255_, "ref_function_void") == 0) {
																			gchar** _tmp256_ = NULL;
																			gint _tmp256__length1 = 0;
																			const gchar* _tmp257_ = NULL;
																			gchar* _tmp258_ = NULL;
																			gchar* _tmp259_ = NULL;
																			gboolean _tmp260_ = FALSE;
																			_tmp256_ = nv;
																			_tmp256__length1 = nv_length1;
																			_tmp257_ = _tmp256_[1];
																			_tmp258_ = vala_gidl_parser_eval (self, _tmp257_);
																			_tmp259_ = _tmp258_;
																			_tmp260_ = g_strcmp0 (_tmp259_, "1") == 0;
																			_g_free0 (_tmp259_);
																			if (_tmp260_) {
																				ref_function_void = TRUE;
																			}
																		} else {
																			gchar** _tmp261_ = NULL;
																			gint _tmp261__length1 = 0;
																			const gchar* _tmp262_ = NULL;
																			_tmp261_ = nv;
																			_tmp261__length1 = nv_length1;
																			_tmp262_ = _tmp261_[0];
																			if (g_strcmp0 (_tmp262_, "deprecated") == 0) {
																				gchar** _tmp263_ = NULL;
																				gint _tmp263__length1 = 0;
																				const gchar* _tmp264_ = NULL;
																				gchar* _tmp265_ = NULL;
																				gchar* _tmp266_ = NULL;
																				gboolean _tmp267_ = FALSE;
																				_tmp263_ = nv;
																				_tmp263__length1 = nv_length1;
																				_tmp264_ = _tmp263_[1];
																				_tmp265_ = vala_gidl_parser_eval (self, _tmp264_);
																				_tmp266_ = _tmp265_;
																				_tmp267_ = g_strcmp0 (_tmp266_, "1") == 0;
																				_g_free0 (_tmp266_);
																				if (_tmp267_) {
																					ValaClass* _tmp268_ = NULL;
																					_tmp268_ = cl;
																					vala_code_node_set_attribute ((ValaCodeNode*) _tmp268_, "Deprecated", TRUE, NULL);
																				}
																			} else {
																				gchar** _tmp269_ = NULL;
																				gint _tmp269__length1 = 0;
																				const gchar* _tmp270_ = NULL;
																				_tmp269_ = nv;
																				_tmp269__length1 = nv_length1;
																				_tmp270_ = _tmp269_[0];
																				if (g_strcmp0 (_tmp270_, "replacement") == 0) {
																					ValaClass* _tmp271_ = NULL;
																					gchar** _tmp272_ = NULL;
																					gint _tmp272__length1 = 0;
																					const gchar* _tmp273_ = NULL;
																					gchar* _tmp274_ = NULL;
																					gchar* _tmp275_ = NULL;
																					_tmp271_ = cl;
																					_tmp272_ = nv;
																					_tmp272__length1 = nv_length1;
																					_tmp273_ = _tmp272_[1];
																					_tmp274_ = vala_gidl_parser_eval (self, _tmp273_);
																					_tmp275_ = _tmp274_;
																					vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp271_, "Deprecated", "replacement", _tmp275_, NULL);
																					_g_free0 (_tmp275_);
																				} else {
																					gchar** _tmp276_ = NULL;
																					gint _tmp276__length1 = 0;
																					const gchar* _tmp277_ = NULL;
																					_tmp276_ = nv;
																					_tmp276__length1 = nv_length1;
																					_tmp277_ = _tmp276_[0];
																					if (g_strcmp0 (_tmp277_, "deprecated_since") == 0) {
																						ValaClass* _tmp278_ = NULL;
																						gchar** _tmp279_ = NULL;
																						gint _tmp279__length1 = 0;
																						const gchar* _tmp280_ = NULL;
																						gchar* _tmp281_ = NULL;
																						gchar* _tmp282_ = NULL;
																						_tmp278_ = cl;
																						_tmp279_ = nv;
																						_tmp279__length1 = nv_length1;
																						_tmp280_ = _tmp279_[1];
																						_tmp281_ = vala_gidl_parser_eval (self, _tmp280_);
																						_tmp282_ = _tmp281_;
																						vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp278_, "Deprecated", "since", _tmp282_, NULL);
																						_g_free0 (_tmp282_);
																					} else {
																						gchar** _tmp283_ = NULL;
																						gint _tmp283__length1 = 0;
																						const gchar* _tmp284_ = NULL;
																						_tmp283_ = nv;
																						_tmp283__length1 = nv_length1;
																						_tmp284_ = _tmp283_[0];
																						if (g_strcmp0 (_tmp284_, "type_parameters") == 0) {
																							gchar** _tmp285_ = NULL;
																							gint _tmp285__length1 = 0;
																							const gchar* _tmp286_ = NULL;
																							gchar* _tmp287_ = NULL;
																							gchar* _tmp288_ = NULL;
																							gchar** _tmp289_ = NULL;
																							gchar** _tmp290_ = NULL;
																							gchar** _tmp291_ = NULL;
																							gint _tmp291__length1 = 0;
																							_tmp285_ = nv;
																							_tmp285__length1 = nv_length1;
																							_tmp286_ = _tmp285_[1];
																							_tmp287_ = vala_gidl_parser_eval (self, _tmp286_);
																							_tmp288_ = _tmp287_;
																							_tmp290_ = _tmp289_ = g_strsplit (_tmp288_, ",", 0);
																							_tmp291_ = _tmp290_;
																							_tmp291__length1 = _vala_array_length (_tmp289_);
																							_g_free0 (_tmp288_);
																							{
																								gchar** type_param_name_collection = NULL;
																								gint type_param_name_collection_length1 = 0;
																								gint _type_param_name_collection_size_ = 0;
																								gint type_param_name_it = 0;
																								type_param_name_collection = _tmp291_;
																								type_param_name_collection_length1 = _tmp291__length1;
																								for (type_param_name_it = 0; type_param_name_it < _tmp291__length1; type_param_name_it = type_param_name_it + 1) {
																									gchar* _tmp292_ = NULL;
																									gchar* type_param_name = NULL;
																									_tmp292_ = g_strdup (type_param_name_collection[type_param_name_it]);
																									type_param_name = _tmp292_;
																									{
																										ValaClass* _tmp293_ = NULL;
																										const gchar* _tmp294_ = NULL;
																										ValaSourceReference* _tmp295_ = NULL;
																										ValaTypeParameter* _tmp296_ = NULL;
																										ValaTypeParameter* _tmp297_ = NULL;
																										_tmp293_ = cl;
																										_tmp294_ = type_param_name;
																										_tmp295_ = self->priv->current_source_reference;
																										_tmp296_ = vala_typeparameter_new (_tmp294_, _tmp295_);
																										_tmp297_ = _tmp296_;
																										vala_object_type_symbol_add_type_parameter ((ValaObjectTypeSymbol*) _tmp293_, _tmp297_);
																										_vala_code_node_unref0 (_tmp297_);
																										_g_free0 (type_param_name);
																									}
																								}
																								type_param_name_collection = (_vala_array_free (type_param_name_collection, type_param_name_collection_length1, (GDestroyNotify) g_free), NULL);
																							}
																						} else {
																							gchar** _tmp298_ = NULL;
																							gint _tmp298__length1 = 0;
																							const gchar* _tmp299_ = NULL;
																							_tmp298_ = nv;
																							_tmp298__length1 = nv_length1;
																							_tmp299_ = _tmp298_[0];
																							if (g_strcmp0 (_tmp299_, "experimental") == 0) {
																								gchar** _tmp300_ = NULL;
																								gint _tmp300__length1 = 0;
																								const gchar* _tmp301_ = NULL;
																								gchar* _tmp302_ = NULL;
																								gchar* _tmp303_ = NULL;
																								gboolean _tmp304_ = FALSE;
																								_tmp300_ = nv;
																								_tmp300__length1 = nv_length1;
																								_tmp301_ = _tmp300_[1];
																								_tmp302_ = vala_gidl_parser_eval (self, _tmp301_);
																								_tmp303_ = _tmp302_;
																								_tmp304_ = g_strcmp0 (_tmp303_, "1") == 0;
																								_g_free0 (_tmp303_);
																								if (_tmp304_) {
																									ValaClass* _tmp305_ = NULL;
																									_tmp305_ = cl;
																									vala_code_node_set_attribute ((ValaCodeNode*) _tmp305_, "Experimental", TRUE, NULL);
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp306_ = container;
			_tmp307_ = cl;
			vala_gidl_parser_add_symbol_to_container (self, _tmp306_, (ValaSymbol*) _tmp307_);
			_tmp308_ = self->priv->current_source_file;
			_tmp309_ = cl;
			vala_source_file_add_node (_tmp308_, (ValaCodeNode*) _tmp309_);
			_tmp310_ = base_class;
			if (_tmp310_ != NULL) {
				ValaDataType* parent = NULL;
				const gchar* _tmp311_ = NULL;
				ValaDataType* _tmp312_ = NULL;
				ValaClass* _tmp313_ = NULL;
				ValaDataType* _tmp314_ = NULL;
				_tmp311_ = base_class;
				_tmp312_ = vala_gidl_parser_parse_type_string (self, _tmp311_);
				parent = _tmp312_;
				_tmp313_ = cl;
				_tmp314_ = parent;
				vala_class_add_base_type (_tmp313_, _tmp314_);
				_vala_code_node_unref0 (parent);
			}
			_tmp316_ = base_class;
			if (_tmp316_ == NULL) {
				gboolean _tmp317_ = FALSE;
				_tmp317_ = is_fundamental;
				_tmp315_ = !_tmp317_;
			} else {
				_tmp315_ = FALSE;
			}
			_tmp318_ = _tmp315_;
			if (_tmp318_) {
				ValaClass* _tmp319_ = NULL;
				_tmp319_ = cl;
				vala_class_set_is_compact (_tmp319_, TRUE);
			}
			cl_attributes = (_vala_array_free (cl_attributes, cl_attributes_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (base_class);
		}
		_tmp320_ = cl;
		_tmp321_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp320_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp321_;
		_tmp322_ = st_node;
		_tmp323_ = _tmp322_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp323_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp324_ = NULL;
					GIdlNodeTypeId _tmp325_ = 0;
					_tmp324_ = member;
					_tmp325_ = _tmp324_->type;
					if (_tmp325_ == G_IDL_NODE_FUNCTION) {
						gboolean _tmp326_ = FALSE;
						const gchar* _tmp327_ = NULL;
						gboolean _tmp330_ = FALSE;
						_tmp327_ = ref_function;
						if (_tmp327_ == NULL) {
							GIdlNode* _tmp328_ = NULL;
							const gchar* _tmp329_ = NULL;
							_tmp328_ = member;
							_tmp329_ = _tmp328_->name;
							_tmp326_ = g_strcmp0 (_tmp329_, "ref") == 0;
						} else {
							_tmp326_ = FALSE;
						}
						_tmp330_ = _tmp326_;
						if (_tmp330_) {
							GIdlNode* _tmp331_ = NULL;
							const gchar* _tmp332_ = NULL;
							gchar* _tmp333_ = NULL;
							GIdlNode* _tmp334_ = NULL;
							GIdlNodeParam* _tmp335_ = NULL;
							GIdlNodeType* _tmp336_ = NULL;
							ValaDataType* _tmp337_ = NULL;
							ValaDataType* _tmp338_ = NULL;
							_tmp331_ = member;
							_tmp332_ = ((GIdlNodeFunction*) _tmp331_)->symbol;
							_tmp333_ = g_strdup (_tmp332_);
							_g_free0 (ref_function);
							ref_function = _tmp333_;
							_tmp334_ = member;
							_tmp335_ = ((GIdlNodeFunction*) _tmp334_)->result;
							_tmp336_ = _tmp335_->type;
							_tmp337_ = vala_gidl_parser_parse_type (self, _tmp336_, NULL);
							_tmp338_ = _tmp337_;
							ref_function_void = G_TYPE_CHECK_INSTANCE_TYPE (_tmp338_, VALA_TYPE_VOID_TYPE);
							_vala_code_node_unref0 (_tmp338_);
						} else {
							gboolean _tmp339_ = FALSE;
							const gchar* _tmp340_ = NULL;
							gboolean _tmp343_ = FALSE;
							_tmp340_ = unref_function;
							if (_tmp340_ == NULL) {
								GIdlNode* _tmp341_ = NULL;
								const gchar* _tmp342_ = NULL;
								_tmp341_ = member;
								_tmp342_ = _tmp341_->name;
								_tmp339_ = g_strcmp0 (_tmp342_, "unref") == 0;
							} else {
								_tmp339_ = FALSE;
							}
							_tmp343_ = _tmp339_;
							if (_tmp343_) {
								GIdlNode* _tmp344_ = NULL;
								const gchar* _tmp345_ = NULL;
								gchar* _tmp346_ = NULL;
								_tmp344_ = member;
								_tmp345_ = ((GIdlNodeFunction*) _tmp344_)->symbol;
								_tmp346_ = g_strdup (_tmp345_);
								_g_free0 (unref_function);
								unref_function = _tmp346_;
							} else {
								gboolean _tmp347_ = FALSE;
								const gchar* _tmp348_ = NULL;
								gboolean _tmp355_ = FALSE;
								_tmp348_ = free_function;
								if (_tmp348_ == NULL) {
									gboolean _tmp349_ = FALSE;
									GIdlNode* _tmp350_ = NULL;
									const gchar* _tmp351_ = NULL;
									gboolean _tmp354_ = FALSE;
									_tmp350_ = member;
									_tmp351_ = _tmp350_->name;
									if (g_strcmp0 (_tmp351_, "free") == 0) {
										_tmp349_ = TRUE;
									} else {
										GIdlNode* _tmp352_ = NULL;
										const gchar* _tmp353_ = NULL;
										_tmp352_ = member;
										_tmp353_ = _tmp352_->name;
										_tmp349_ = g_strcmp0 (_tmp353_, "destroy") == 0;
									}
									_tmp354_ = _tmp349_;
									_tmp347_ = _tmp354_;
								} else {
									_tmp347_ = FALSE;
								}
								_tmp355_ = _tmp347_;
								if (_tmp355_) {
									GIdlNode* _tmp356_ = NULL;
									const gchar* _tmp357_ = NULL;
									gchar* _tmp358_ = NULL;
									_tmp356_ = member;
									_tmp357_ = ((GIdlNodeFunction*) _tmp356_)->symbol;
									_tmp358_ = g_strdup (_tmp357_);
									_g_free0 (free_function);
									free_function = _tmp358_;
								} else {
									gboolean _tmp359_ = FALSE;
									const gchar* _tmp360_ = NULL;
									gboolean _tmp363_ = FALSE;
									ValaMethod* m = NULL;
									GIdlNode* _tmp367_ = NULL;
									ValaMethod* _tmp368_ = NULL;
									ValaMethod* _tmp369_ = NULL;
									_tmp360_ = copy_function;
									if (_tmp360_ == NULL) {
										GIdlNode* _tmp361_ = NULL;
										const gchar* _tmp362_ = NULL;
										_tmp361_ = member;
										_tmp362_ = _tmp361_->name;
										_tmp359_ = g_strcmp0 (_tmp362_, "copy") == 0;
									} else {
										_tmp359_ = FALSE;
									}
									_tmp363_ = _tmp359_;
									if (_tmp363_) {
										GIdlNode* _tmp364_ = NULL;
										const gchar* _tmp365_ = NULL;
										gchar* _tmp366_ = NULL;
										_tmp364_ = member;
										_tmp365_ = ((GIdlNodeFunction*) _tmp364_)->symbol;
										_tmp366_ = g_strdup (_tmp365_);
										_g_free0 (copy_function);
										copy_function = _tmp366_;
									}
									_tmp367_ = member;
									_tmp368_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp367_, FALSE);
									m = _tmp368_;
									_tmp369_ = m;
									if (_tmp369_ != NULL) {
										ValaClass* _tmp370_ = NULL;
										ValaMethod* _tmp371_ = NULL;
										_tmp370_ = cl;
										_tmp371_ = m;
										vala_symbol_add_method ((ValaSymbol*) _tmp370_, _tmp371_);
									}
									_vala_code_node_unref0 (m);
								}
							}
						}
					} else {
						GIdlNode* _tmp372_ = NULL;
						GIdlNodeTypeId _tmp373_ = 0;
						_tmp372_ = member;
						_tmp373_ = _tmp372_->type;
						if (_tmp373_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp374_ = NULL;
							ValaField* _tmp375_ = NULL;
							ValaField* _tmp376_ = NULL;
							_tmp374_ = member;
							_tmp375_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp374_);
							f = _tmp375_;
							_tmp376_ = f;
							if (_tmp376_ != NULL) {
								ValaClass* _tmp377_ = NULL;
								ValaField* _tmp378_ = NULL;
								_tmp377_ = cl;
								_tmp378_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp377_, _tmp378_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_tmp379_ = ref_function;
		if (_tmp379_ != NULL) {
			ValaClass* _tmp380_ = NULL;
			const gchar* _tmp381_ = NULL;
			gboolean _tmp382_ = FALSE;
			_tmp380_ = cl;
			_tmp381_ = ref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp380_, "CCode", "ref_function", _tmp381_, NULL);
			_tmp382_ = ref_function_void;
			if (_tmp382_) {
				ValaClass* _tmp383_ = NULL;
				gboolean _tmp384_ = FALSE;
				_tmp383_ = cl;
				_tmp384_ = ref_function_void;
				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp383_, "CCode", "ref_function_void", _tmp384_, NULL);
			}
		} else {
			const gchar* _tmp385_ = NULL;
			_tmp385_ = copy_function;
			if (_tmp385_ != NULL) {
				ValaClass* _tmp386_ = NULL;
				const gchar* _tmp387_ = NULL;
				_tmp386_ = cl;
				_tmp387_ = copy_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp386_, "CCode", "copy_function", _tmp387_, NULL);
			}
		}
		_tmp388_ = unref_function;
		if (_tmp388_ != NULL) {
			ValaClass* _tmp389_ = NULL;
			const gchar* _tmp390_ = NULL;
			_tmp389_ = cl;
			_tmp390_ = unref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp389_, "CCode", "unref_function", _tmp390_, NULL);
		} else {
			gboolean _tmp391_ = FALSE;
			const gchar* _tmp392_ = NULL;
			gboolean _tmp399_ = FALSE;
			_tmp392_ = free_function;
			if (_tmp392_ != NULL) {
				const gchar* _tmp393_ = NULL;
				ValaClass* _tmp394_ = NULL;
				gchar* _tmp395_ = NULL;
				gchar* _tmp396_ = NULL;
				gchar* _tmp397_ = NULL;
				gchar* _tmp398_ = NULL;
				_tmp393_ = free_function;
				_tmp394_ = cl;
				_tmp395_ = vala_gidl_parser_get_lower_case_cprefix (self, (ValaSymbol*) _tmp394_);
				_tmp396_ = _tmp395_;
				_tmp397_ = g_strdup_printf ("%sfree", _tmp396_);
				_tmp398_ = _tmp397_;
				_tmp391_ = g_strcmp0 (_tmp393_, _tmp398_) != 0;
				_g_free0 (_tmp398_);
				_g_free0 (_tmp396_);
			} else {
				_tmp391_ = FALSE;
			}
			_tmp399_ = _tmp391_;
			if (_tmp399_) {
				ValaClass* _tmp400_ = NULL;
				const gchar* _tmp401_ = NULL;
				_tmp400_ = cl;
				_tmp401_ = free_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp400_, "CCode", "free_function", _tmp401_, NULL);
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_vala_code_node_unref0 (cl);
		_g_free0 (free_function);
		_g_free0 (copy_function);
		_g_free0 (unref_function);
		_g_free0 (ref_function);
	}
	_g_free0 (name);
}


static void vala_gidl_parser_parse_union (ValaGIdlParser* self, GIdlNodeUnion* un_node, ValaSymbol* container, GIdlModule* module) {
	GIdlNode* node = NULL;
	GIdlNodeUnion* _tmp0_ = NULL;
	GIdlNodeUnion* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* name = NULL;
	GIdlNode* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	ValaSymbol* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	GIdlNode* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (un_node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = un_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = un_node;
	_tmp2_ = _tmp1_->deprecated;
	if (_tmp2_) {
		return;
	}
	_tmp3_ = node;
	_tmp4_ = _tmp3_->name;
	_tmp5_ = container;
	_tmp6_ = vala_gidl_parser_fix_type_name (self, _tmp4_, _tmp5_);
	name = _tmp6_;
	_tmp7_ = node;
	_tmp8_ = _tmp7_->name;
	_tmp9_ = vala_gidl_parser_is_reference_type (self, _tmp8_);
	if (!_tmp9_) {
		ValaStruct* st = NULL;
		ValaSymbol* _tmp10_ = NULL;
		ValaScope* _tmp11_ = NULL;
		ValaScope* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		ValaSymbol* _tmp14_ = NULL;
		ValaStruct* _tmp15_ = NULL;
		ValaStruct* _tmp16_ = NULL;
		ValaStruct* _tmp79_ = NULL;
		ValaTypeSymbol* _tmp80_ = NULL;
		GIdlNodeUnion* _tmp81_ = NULL;
		GList* _tmp82_ = NULL;
		_tmp10_ = container;
		_tmp11_ = vala_symbol_get_scope (_tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = name;
		_tmp14_ = vala_scope_lookup (_tmp12_, _tmp13_);
		_tmp15_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp14_) : NULL;
		if (_tmp15_ == NULL) {
			_vala_code_node_unref0 (_tmp14_);
		}
		st = _tmp15_;
		_tmp16_ = st;
		if (_tmp16_ == NULL) {
			const gchar* _tmp17_ = NULL;
			ValaSourceReference* _tmp18_ = NULL;
			ValaStruct* _tmp19_ = NULL;
			ValaStruct* _tmp20_ = NULL;
			gchar** st_attributes = NULL;
			GIdlNode* _tmp21_ = NULL;
			const gchar* _tmp22_ = NULL;
			gint _tmp23_ = 0;
			gchar** _tmp24_ = NULL;
			gint st_attributes_length1 = 0;
			gint _st_attributes_size_ = 0;
			gchar** _tmp25_ = NULL;
			gint _tmp25__length1 = 0;
			ValaSymbol* _tmp75_ = NULL;
			ValaStruct* _tmp76_ = NULL;
			ValaSourceFile* _tmp77_ = NULL;
			ValaStruct* _tmp78_ = NULL;
			_tmp17_ = name;
			_tmp18_ = self->priv->current_source_reference;
			_tmp19_ = vala_struct_new (_tmp17_, _tmp18_, NULL);
			_vala_code_node_unref0 (st);
			st = _tmp19_;
			_tmp20_ = st;
			vala_symbol_set_access ((ValaSymbol*) _tmp20_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp21_ = node;
			_tmp22_ = _tmp21_->name;
			_tmp24_ = vala_gidl_parser_get_attributes (self, _tmp22_, &_tmp23_);
			st_attributes = _tmp24_;
			st_attributes_length1 = _tmp23_;
			_st_attributes_size_ = st_attributes_length1;
			_tmp25_ = st_attributes;
			_tmp25__length1 = st_attributes_length1;
			if (_tmp25_ != NULL) {
				gchar** _tmp26_ = NULL;
				gint _tmp26__length1 = 0;
				_tmp26_ = st_attributes;
				_tmp26__length1 = st_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp26_;
					attr_collection_length1 = _tmp26__length1;
					for (attr_it = 0; attr_it < _tmp26__length1; attr_it = attr_it + 1) {
						gchar* _tmp27_ = NULL;
						gchar* attr = NULL;
						_tmp27_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp27_;
						{
							gchar** nv = NULL;
							const gchar* _tmp28_ = NULL;
							gchar** _tmp29_ = NULL;
							gchar** _tmp30_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp31_ = NULL;
							gint _tmp31__length1 = 0;
							const gchar* _tmp32_ = NULL;
							_tmp28_ = attr;
							_tmp30_ = _tmp29_ = g_strsplit (_tmp28_, "=", 2);
							nv = _tmp30_;
							nv_length1 = _vala_array_length (_tmp29_);
							_nv_size_ = nv_length1;
							_tmp31_ = nv;
							_tmp31__length1 = nv_length1;
							_tmp32_ = _tmp31_[0];
							if (g_strcmp0 (_tmp32_, "cheader_filename") == 0) {
								ValaStruct* _tmp33_ = NULL;
								gchar** _tmp34_ = NULL;
								gint _tmp34__length1 = 0;
								const gchar* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
								_tmp33_ = st;
								_tmp34_ = nv;
								_tmp34__length1 = nv_length1;
								_tmp35_ = _tmp34_[1];
								_tmp36_ = vala_gidl_parser_eval (self, _tmp35_);
								_tmp37_ = _tmp36_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp33_, "CCode", "cheader_filename", _tmp37_, NULL);
								_g_free0 (_tmp37_);
							} else {
								gchar** _tmp38_ = NULL;
								gint _tmp38__length1 = 0;
								const gchar* _tmp39_ = NULL;
								_tmp38_ = nv;
								_tmp38__length1 = nv_length1;
								_tmp39_ = _tmp38_[0];
								if (g_strcmp0 (_tmp39_, "deprecated") == 0) {
									gchar** _tmp40_ = NULL;
									gint _tmp40__length1 = 0;
									const gchar* _tmp41_ = NULL;
									gchar* _tmp42_ = NULL;
									gchar* _tmp43_ = NULL;
									gboolean _tmp44_ = FALSE;
									_tmp40_ = nv;
									_tmp40__length1 = nv_length1;
									_tmp41_ = _tmp40_[1];
									_tmp42_ = vala_gidl_parser_eval (self, _tmp41_);
									_tmp43_ = _tmp42_;
									_tmp44_ = g_strcmp0 (_tmp43_, "1") == 0;
									_g_free0 (_tmp43_);
									if (_tmp44_) {
										ValaStruct* _tmp45_ = NULL;
										_tmp45_ = st;
										vala_code_node_set_attribute ((ValaCodeNode*) _tmp45_, "Deprecated", TRUE, NULL);
									}
								} else {
									gchar** _tmp46_ = NULL;
									gint _tmp46__length1 = 0;
									const gchar* _tmp47_ = NULL;
									_tmp46_ = nv;
									_tmp46__length1 = nv_length1;
									_tmp47_ = _tmp46_[0];
									if (g_strcmp0 (_tmp47_, "replacement") == 0) {
										ValaStruct* _tmp48_ = NULL;
										gchar** _tmp49_ = NULL;
										gint _tmp49__length1 = 0;
										const gchar* _tmp50_ = NULL;
										gchar* _tmp51_ = NULL;
										gchar* _tmp52_ = NULL;
										_tmp48_ = st;
										_tmp49_ = nv;
										_tmp49__length1 = nv_length1;
										_tmp50_ = _tmp49_[1];
										_tmp51_ = vala_gidl_parser_eval (self, _tmp50_);
										_tmp52_ = _tmp51_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp48_, "Deprecated", "replacement", _tmp52_, NULL);
										_g_free0 (_tmp52_);
									} else {
										gchar** _tmp53_ = NULL;
										gint _tmp53__length1 = 0;
										const gchar* _tmp54_ = NULL;
										_tmp53_ = nv;
										_tmp53__length1 = nv_length1;
										_tmp54_ = _tmp53_[0];
										if (g_strcmp0 (_tmp54_, "deprecated_since") == 0) {
											ValaStruct* _tmp55_ = NULL;
											gchar** _tmp56_ = NULL;
											gint _tmp56__length1 = 0;
											const gchar* _tmp57_ = NULL;
											gchar* _tmp58_ = NULL;
											gchar* _tmp59_ = NULL;
											_tmp55_ = st;
											_tmp56_ = nv;
											_tmp56__length1 = nv_length1;
											_tmp57_ = _tmp56_[1];
											_tmp58_ = vala_gidl_parser_eval (self, _tmp57_);
											_tmp59_ = _tmp58_;
											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp55_, "Deprecated", "since", _tmp59_, NULL);
											_g_free0 (_tmp59_);
										} else {
											gchar** _tmp60_ = NULL;
											gint _tmp60__length1 = 0;
											const gchar* _tmp61_ = NULL;
											_tmp60_ = nv;
											_tmp60__length1 = nv_length1;
											_tmp61_ = _tmp60_[0];
											if (g_strcmp0 (_tmp61_, "hidden") == 0) {
												gchar** _tmp62_ = NULL;
												gint _tmp62__length1 = 0;
												const gchar* _tmp63_ = NULL;
												gchar* _tmp64_ = NULL;
												gchar* _tmp65_ = NULL;
												gboolean _tmp66_ = FALSE;
												_tmp62_ = nv;
												_tmp62__length1 = nv_length1;
												_tmp63_ = _tmp62_[1];
												_tmp64_ = vala_gidl_parser_eval (self, _tmp63_);
												_tmp65_ = _tmp64_;
												_tmp66_ = g_strcmp0 (_tmp65_, "1") == 0;
												_g_free0 (_tmp65_);
												if (_tmp66_) {
													nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
													_g_free0 (attr);
													st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
													_vala_code_node_unref0 (st);
													_g_free0 (name);
													return;
												}
											} else {
												gchar** _tmp67_ = NULL;
												gint _tmp67__length1 = 0;
												const gchar* _tmp68_ = NULL;
												_tmp67_ = nv;
												_tmp67__length1 = nv_length1;
												_tmp68_ = _tmp67_[0];
												if (g_strcmp0 (_tmp68_, "experimental") == 0) {
													gchar** _tmp69_ = NULL;
													gint _tmp69__length1 = 0;
													const gchar* _tmp70_ = NULL;
													gchar* _tmp71_ = NULL;
													gchar* _tmp72_ = NULL;
													gboolean _tmp73_ = FALSE;
													_tmp69_ = nv;
													_tmp69__length1 = nv_length1;
													_tmp70_ = _tmp69_[1];
													_tmp71_ = vala_gidl_parser_eval (self, _tmp70_);
													_tmp72_ = _tmp71_;
													_tmp73_ = g_strcmp0 (_tmp72_, "1") == 0;
													_g_free0 (_tmp72_);
													if (_tmp73_) {
														ValaStruct* _tmp74_ = NULL;
														_tmp74_ = st;
														vala_code_node_set_attribute ((ValaCodeNode*) _tmp74_, "Experimental", TRUE, NULL);
													}
												}
											}
										}
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp75_ = container;
			_tmp76_ = st;
			vala_gidl_parser_add_symbol_to_container (self, _tmp75_, (ValaSymbol*) _tmp76_);
			_tmp77_ = self->priv->current_source_file;
			_tmp78_ = st;
			vala_source_file_add_node (_tmp77_, (ValaCodeNode*) _tmp78_);
			st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp79_ = st;
		_tmp80_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp79_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp80_;
		_tmp81_ = un_node;
		_tmp82_ = _tmp81_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp82_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp83_ = NULL;
					GIdlNodeTypeId _tmp84_ = 0;
					_tmp83_ = member;
					_tmp84_ = _tmp83_->type;
					if (_tmp84_ == G_IDL_NODE_FUNCTION) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp85_ = NULL;
						ValaMethod* _tmp86_ = NULL;
						ValaMethod* _tmp87_ = NULL;
						_tmp85_ = member;
						_tmp86_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp85_, FALSE);
						m = _tmp86_;
						_tmp87_ = m;
						if (_tmp87_ != NULL) {
							ValaStruct* _tmp88_ = NULL;
							ValaMethod* _tmp89_ = NULL;
							_tmp88_ = st;
							_tmp89_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp88_, _tmp89_);
						}
						_vala_code_node_unref0 (m);
					} else {
						GIdlNode* _tmp90_ = NULL;
						GIdlNodeTypeId _tmp91_ = 0;
						_tmp90_ = member;
						_tmp91_ = _tmp90_->type;
						if (_tmp91_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp92_ = NULL;
							ValaField* _tmp93_ = NULL;
							ValaField* _tmp94_ = NULL;
							_tmp92_ = member;
							_tmp93_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp92_);
							f = _tmp93_;
							_tmp94_ = f;
							if (_tmp94_ != NULL) {
								ValaStruct* _tmp95_ = NULL;
								ValaField* _tmp96_ = NULL;
								_tmp95_ = st;
								_tmp96_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp95_, _tmp96_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_vala_code_node_unref0 (st);
	} else {
		ValaClass* cl = NULL;
		ValaSymbol* _tmp97_ = NULL;
		ValaScope* _tmp98_ = NULL;
		ValaScope* _tmp99_ = NULL;
		const gchar* _tmp100_ = NULL;
		ValaSymbol* _tmp101_ = NULL;
		ValaClass* _tmp102_ = NULL;
		ValaClass* _tmp103_ = NULL;
		ValaClass* _tmp137_ = NULL;
		ValaTypeSymbol* _tmp138_ = NULL;
		gboolean ref_function_void = FALSE;
		gchar* ref_function = NULL;
		gchar* unref_function = NULL;
		gchar* copy_function = NULL;
		gchar* free_function = NULL;
		GIdlNodeUnion* _tmp139_ = NULL;
		GList* _tmp140_ = NULL;
		const gchar* _tmp184_ = NULL;
		const gchar* _tmp193_ = NULL;
		_tmp97_ = container;
		_tmp98_ = vala_symbol_get_scope (_tmp97_);
		_tmp99_ = _tmp98_;
		_tmp100_ = name;
		_tmp101_ = vala_scope_lookup (_tmp99_, _tmp100_);
		_tmp102_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp101_, VALA_TYPE_CLASS) ? ((ValaClass*) _tmp101_) : NULL;
		if (_tmp102_ == NULL) {
			_vala_code_node_unref0 (_tmp101_);
		}
		cl = _tmp102_;
		_tmp103_ = cl;
		if (_tmp103_ == NULL) {
			const gchar* _tmp104_ = NULL;
			ValaSourceReference* _tmp105_ = NULL;
			ValaClass* _tmp106_ = NULL;
			ValaClass* _tmp107_ = NULL;
			ValaClass* _tmp108_ = NULL;
			gchar** cl_attributes = NULL;
			GIdlNode* _tmp109_ = NULL;
			const gchar* _tmp110_ = NULL;
			gint _tmp111_ = 0;
			gchar** _tmp112_ = NULL;
			gint cl_attributes_length1 = 0;
			gint _cl_attributes_size_ = 0;
			gchar** _tmp113_ = NULL;
			gint _tmp113__length1 = 0;
			ValaSymbol* _tmp133_ = NULL;
			ValaClass* _tmp134_ = NULL;
			ValaSourceFile* _tmp135_ = NULL;
			ValaClass* _tmp136_ = NULL;
			_tmp104_ = name;
			_tmp105_ = self->priv->current_source_reference;
			_tmp106_ = vala_class_new (_tmp104_, _tmp105_, NULL);
			_vala_code_node_unref0 (cl);
			cl = _tmp106_;
			_tmp107_ = cl;
			vala_symbol_set_access ((ValaSymbol*) _tmp107_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp108_ = cl;
			vala_class_set_is_compact (_tmp108_, TRUE);
			_tmp109_ = node;
			_tmp110_ = _tmp109_->name;
			_tmp112_ = vala_gidl_parser_get_attributes (self, _tmp110_, &_tmp111_);
			cl_attributes = _tmp112_;
			cl_attributes_length1 = _tmp111_;
			_cl_attributes_size_ = cl_attributes_length1;
			_tmp113_ = cl_attributes;
			_tmp113__length1 = cl_attributes_length1;
			if (_tmp113_ != NULL) {
				gchar** _tmp114_ = NULL;
				gint _tmp114__length1 = 0;
				_tmp114_ = cl_attributes;
				_tmp114__length1 = cl_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp114_;
					attr_collection_length1 = _tmp114__length1;
					for (attr_it = 0; attr_it < _tmp114__length1; attr_it = attr_it + 1) {
						gchar* _tmp115_ = NULL;
						gchar* attr = NULL;
						_tmp115_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp115_;
						{
							gchar** nv = NULL;
							const gchar* _tmp116_ = NULL;
							gchar** _tmp117_ = NULL;
							gchar** _tmp118_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp119_ = NULL;
							gint _tmp119__length1 = 0;
							const gchar* _tmp120_ = NULL;
							_tmp116_ = attr;
							_tmp118_ = _tmp117_ = g_strsplit (_tmp116_, "=", 2);
							nv = _tmp118_;
							nv_length1 = _vala_array_length (_tmp117_);
							_nv_size_ = nv_length1;
							_tmp119_ = nv;
							_tmp119__length1 = nv_length1;
							_tmp120_ = _tmp119_[0];
							if (g_strcmp0 (_tmp120_, "cheader_filename") == 0) {
								ValaClass* _tmp121_ = NULL;
								gchar** _tmp122_ = NULL;
								gint _tmp122__length1 = 0;
								const gchar* _tmp123_ = NULL;
								gchar* _tmp124_ = NULL;
								gchar* _tmp125_ = NULL;
								_tmp121_ = cl;
								_tmp122_ = nv;
								_tmp122__length1 = nv_length1;
								_tmp123_ = _tmp122_[1];
								_tmp124_ = vala_gidl_parser_eval (self, _tmp123_);
								_tmp125_ = _tmp124_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp121_, "CCode", "cheader_filename", _tmp125_, NULL);
								_g_free0 (_tmp125_);
							} else {
								gchar** _tmp126_ = NULL;
								gint _tmp126__length1 = 0;
								const gchar* _tmp127_ = NULL;
								_tmp126_ = nv;
								_tmp126__length1 = nv_length1;
								_tmp127_ = _tmp126_[0];
								if (g_strcmp0 (_tmp127_, "hidden") == 0) {
									gchar** _tmp128_ = NULL;
									gint _tmp128__length1 = 0;
									const gchar* _tmp129_ = NULL;
									gchar* _tmp130_ = NULL;
									gchar* _tmp131_ = NULL;
									gboolean _tmp132_ = FALSE;
									_tmp128_ = nv;
									_tmp128__length1 = nv_length1;
									_tmp129_ = _tmp128_[1];
									_tmp130_ = vala_gidl_parser_eval (self, _tmp129_);
									_tmp131_ = _tmp130_;
									_tmp132_ = g_strcmp0 (_tmp131_, "1") == 0;
									_g_free0 (_tmp131_);
									if (_tmp132_) {
										nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
										_g_free0 (attr);
										cl_attributes = (_vala_array_free (cl_attributes, cl_attributes_length1, (GDestroyNotify) g_free), NULL);
										_vala_code_node_unref0 (cl);
										_g_free0 (name);
										return;
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp133_ = container;
			_tmp134_ = cl;
			vala_gidl_parser_add_symbol_to_container (self, _tmp133_, (ValaSymbol*) _tmp134_);
			_tmp135_ = self->priv->current_source_file;
			_tmp136_ = cl;
			vala_source_file_add_node (_tmp135_, (ValaCodeNode*) _tmp136_);
			cl_attributes = (_vala_array_free (cl_attributes, cl_attributes_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp137_ = cl;
		_tmp138_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp137_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp138_;
		ref_function_void = FALSE;
		ref_function = NULL;
		unref_function = NULL;
		copy_function = NULL;
		free_function = NULL;
		_tmp139_ = un_node;
		_tmp140_ = _tmp139_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp140_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp141_ = NULL;
					GIdlNodeTypeId _tmp142_ = 0;
					_tmp141_ = member;
					_tmp142_ = _tmp141_->type;
					if (_tmp142_ == G_IDL_NODE_FUNCTION) {
						GIdlNode* _tmp143_ = NULL;
						const gchar* _tmp144_ = NULL;
						_tmp143_ = member;
						_tmp144_ = _tmp143_->name;
						if (g_strcmp0 (_tmp144_, "ref") == 0) {
							GIdlNode* _tmp145_ = NULL;
							const gchar* _tmp146_ = NULL;
							gchar* _tmp147_ = NULL;
							GIdlNode* _tmp148_ = NULL;
							GIdlNodeParam* _tmp149_ = NULL;
							GIdlNodeType* _tmp150_ = NULL;
							ValaDataType* _tmp151_ = NULL;
							ValaDataType* _tmp152_ = NULL;
							_tmp145_ = member;
							_tmp146_ = ((GIdlNodeFunction*) _tmp145_)->symbol;
							_tmp147_ = g_strdup (_tmp146_);
							_g_free0 (ref_function);
							ref_function = _tmp147_;
							_tmp148_ = member;
							_tmp149_ = ((GIdlNodeFunction*) _tmp148_)->result;
							_tmp150_ = _tmp149_->type;
							_tmp151_ = vala_gidl_parser_parse_type (self, _tmp150_, NULL);
							_tmp152_ = _tmp151_;
							ref_function_void = G_TYPE_CHECK_INSTANCE_TYPE (_tmp152_, VALA_TYPE_VOID_TYPE);
							_vala_code_node_unref0 (_tmp152_);
						} else {
							GIdlNode* _tmp153_ = NULL;
							const gchar* _tmp154_ = NULL;
							_tmp153_ = member;
							_tmp154_ = _tmp153_->name;
							if (g_strcmp0 (_tmp154_, "unref") == 0) {
								GIdlNode* _tmp155_ = NULL;
								const gchar* _tmp156_ = NULL;
								gchar* _tmp157_ = NULL;
								_tmp155_ = member;
								_tmp156_ = ((GIdlNodeFunction*) _tmp155_)->symbol;
								_tmp157_ = g_strdup (_tmp156_);
								_g_free0 (unref_function);
								unref_function = _tmp157_;
							} else {
								gboolean _tmp158_ = FALSE;
								GIdlNode* _tmp159_ = NULL;
								const gchar* _tmp160_ = NULL;
								gboolean _tmp163_ = FALSE;
								_tmp159_ = member;
								_tmp160_ = _tmp159_->name;
								if (g_strcmp0 (_tmp160_, "free") == 0) {
									_tmp158_ = TRUE;
								} else {
									GIdlNode* _tmp161_ = NULL;
									const gchar* _tmp162_ = NULL;
									_tmp161_ = member;
									_tmp162_ = _tmp161_->name;
									_tmp158_ = g_strcmp0 (_tmp162_, "destroy") == 0;
								}
								_tmp163_ = _tmp158_;
								if (_tmp163_) {
									GIdlNode* _tmp164_ = NULL;
									const gchar* _tmp165_ = NULL;
									gchar* _tmp166_ = NULL;
									_tmp164_ = member;
									_tmp165_ = ((GIdlNodeFunction*) _tmp164_)->symbol;
									_tmp166_ = g_strdup (_tmp165_);
									_g_free0 (free_function);
									free_function = _tmp166_;
								} else {
									GIdlNode* _tmp167_ = NULL;
									const gchar* _tmp168_ = NULL;
									ValaMethod* m = NULL;
									GIdlNode* _tmp172_ = NULL;
									ValaMethod* _tmp173_ = NULL;
									ValaMethod* _tmp174_ = NULL;
									_tmp167_ = member;
									_tmp168_ = _tmp167_->name;
									if (g_strcmp0 (_tmp168_, "copy") == 0) {
										GIdlNode* _tmp169_ = NULL;
										const gchar* _tmp170_ = NULL;
										gchar* _tmp171_ = NULL;
										_tmp169_ = member;
										_tmp170_ = ((GIdlNodeFunction*) _tmp169_)->symbol;
										_tmp171_ = g_strdup (_tmp170_);
										_g_free0 (copy_function);
										copy_function = _tmp171_;
									}
									_tmp172_ = member;
									_tmp173_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp172_, FALSE);
									m = _tmp173_;
									_tmp174_ = m;
									if (_tmp174_ != NULL) {
										ValaClass* _tmp175_ = NULL;
										ValaMethod* _tmp176_ = NULL;
										_tmp175_ = cl;
										_tmp176_ = m;
										vala_symbol_add_method ((ValaSymbol*) _tmp175_, _tmp176_);
									}
									_vala_code_node_unref0 (m);
								}
							}
						}
					} else {
						GIdlNode* _tmp177_ = NULL;
						GIdlNodeTypeId _tmp178_ = 0;
						_tmp177_ = member;
						_tmp178_ = _tmp177_->type;
						if (_tmp178_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp179_ = NULL;
							ValaField* _tmp180_ = NULL;
							ValaField* _tmp181_ = NULL;
							_tmp179_ = member;
							_tmp180_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp179_);
							f = _tmp180_;
							_tmp181_ = f;
							if (_tmp181_ != NULL) {
								ValaClass* _tmp182_ = NULL;
								ValaField* _tmp183_ = NULL;
								_tmp182_ = cl;
								_tmp183_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp182_, _tmp183_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_tmp184_ = ref_function;
		if (_tmp184_ != NULL) {
			ValaClass* _tmp185_ = NULL;
			const gchar* _tmp186_ = NULL;
			gboolean _tmp187_ = FALSE;
			_tmp185_ = cl;
			_tmp186_ = ref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp185_, "CCode", "ref_function", _tmp186_, NULL);
			_tmp187_ = ref_function_void;
			if (_tmp187_) {
				ValaClass* _tmp188_ = NULL;
				gboolean _tmp189_ = FALSE;
				_tmp188_ = cl;
				_tmp189_ = ref_function_void;
				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp188_, "CCode", "ref_function_void", _tmp189_, NULL);
			}
		} else {
			const gchar* _tmp190_ = NULL;
			_tmp190_ = copy_function;
			if (_tmp190_ != NULL) {
				ValaClass* _tmp191_ = NULL;
				const gchar* _tmp192_ = NULL;
				_tmp191_ = cl;
				_tmp192_ = copy_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp191_, "CCode", "copy_function", _tmp192_, NULL);
			}
		}
		_tmp193_ = unref_function;
		if (_tmp193_ != NULL) {
			ValaClass* _tmp194_ = NULL;
			const gchar* _tmp195_ = NULL;
			_tmp194_ = cl;
			_tmp195_ = unref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp194_, "CCode", "unref_function", _tmp195_, NULL);
		} else {
			gboolean _tmp196_ = FALSE;
			const gchar* _tmp197_ = NULL;
			gboolean _tmp204_ = FALSE;
			_tmp197_ = free_function;
			if (_tmp197_ != NULL) {
				const gchar* _tmp198_ = NULL;
				ValaClass* _tmp199_ = NULL;
				gchar* _tmp200_ = NULL;
				gchar* _tmp201_ = NULL;
				gchar* _tmp202_ = NULL;
				gchar* _tmp203_ = NULL;
				_tmp198_ = free_function;
				_tmp199_ = cl;
				_tmp200_ = vala_gidl_parser_get_lower_case_cprefix (self, (ValaSymbol*) _tmp199_);
				_tmp201_ = _tmp200_;
				_tmp202_ = g_strdup_printf ("%sfree", _tmp201_);
				_tmp203_ = _tmp202_;
				_tmp196_ = g_strcmp0 (_tmp198_, _tmp203_) != 0;
				_g_free0 (_tmp203_);
				_g_free0 (_tmp201_);
			} else {
				_tmp196_ = FALSE;
			}
			_tmp204_ = _tmp196_;
			if (_tmp204_) {
				ValaClass* _tmp205_ = NULL;
				const gchar* _tmp206_ = NULL;
				_tmp205_ = cl;
				_tmp206_ = free_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp205_, "CCode", "free_function", _tmp206_, NULL);
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_g_free0 (free_function);
		_g_free0 (copy_function);
		_g_free0 (unref_function);
		_g_free0 (ref_function);
		_vala_code_node_unref0 (cl);
	}
	_g_free0 (name);
}


static void vala_gidl_parser_parse_boxed (ValaGIdlParser* self, GIdlNodeBoxed* boxed_node, ValaSymbol* container, GIdlModule* module) {
	GIdlNode* node = NULL;
	GIdlNodeBoxed* _tmp0_ = NULL;
	gchar* name = NULL;
	GIdlNode* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	ValaSymbol* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gchar** node_attributes = NULL;
	GIdlNode* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	gint _tmp7_ = 0;
	gchar** _tmp8_ = NULL;
	gint node_attributes_length1 = 0;
	gint _node_attributes_size_ = 0;
	gchar** _tmp9_ = NULL;
	gint _tmp9__length1 = 0;
	GIdlNode* _tmp17_ = NULL;
	const gchar* _tmp18_ = NULL;
	gboolean _tmp19_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (boxed_node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = boxed_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = node;
	_tmp2_ = _tmp1_->name;
	_tmp3_ = container;
	_tmp4_ = vala_gidl_parser_fix_type_name (self, _tmp2_, _tmp3_);
	name = _tmp4_;
	_tmp5_ = node;
	_tmp6_ = _tmp5_->name;
	_tmp8_ = vala_gidl_parser_get_attributes (self, _tmp6_, &_tmp7_);
	node_attributes = _tmp8_;
	node_attributes_length1 = _tmp7_;
	_node_attributes_size_ = node_attributes_length1;
	_tmp9_ = node_attributes;
	_tmp9__length1 = node_attributes_length1;
	if (_tmp9_ != NULL) {
		gchar** _tmp10_ = NULL;
		gint _tmp10__length1 = 0;
		_tmp10_ = node_attributes;
		_tmp10__length1 = node_attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp10_;
			attr_collection_length1 = _tmp10__length1;
			for (attr_it = 0; attr_it < _tmp10__length1; attr_it = attr_it + 1) {
				gchar* _tmp11_ = NULL;
				gchar* attr = NULL;
				_tmp11_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp11_;
				{
					gchar** nv = NULL;
					const gchar* _tmp12_ = NULL;
					gchar** _tmp13_ = NULL;
					gchar** _tmp14_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp15_ = NULL;
					gint _tmp15__length1 = 0;
					const gchar* _tmp16_ = NULL;
					_tmp12_ = attr;
					_tmp14_ = _tmp13_ = g_strsplit (_tmp12_, "=", 2);
					nv = _tmp14_;
					nv_length1 = _vala_array_length (_tmp13_);
					_nv_size_ = nv_length1;
					_tmp15_ = nv;
					_tmp15__length1 = nv_length1;
					_tmp16_ = _tmp15_[0];
					if (g_strcmp0 (_tmp16_, "hidden") == 0) {
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
						node_attributes = (_vala_array_free (node_attributes, node_attributes_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (name);
						return;
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp17_ = node;
	_tmp18_ = _tmp17_->name;
	_tmp19_ = vala_gidl_parser_is_reference_type (self, _tmp18_);
	if (!_tmp19_) {
		ValaStruct* st = NULL;
		ValaSymbol* _tmp20_ = NULL;
		ValaScope* _tmp21_ = NULL;
		ValaScope* _tmp22_ = NULL;
		const gchar* _tmp23_ = NULL;
		ValaSymbol* _tmp24_ = NULL;
		ValaStruct* _tmp25_ = NULL;
		ValaStruct* _tmp26_ = NULL;
		ValaStruct* _tmp106_ = NULL;
		ValaTypeSymbol* _tmp107_ = NULL;
		GIdlNodeBoxed* _tmp108_ = NULL;
		GList* _tmp109_ = NULL;
		_tmp20_ = container;
		_tmp21_ = vala_symbol_get_scope (_tmp20_);
		_tmp22_ = _tmp21_;
		_tmp23_ = name;
		_tmp24_ = vala_scope_lookup (_tmp22_, _tmp23_);
		_tmp25_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp24_) : NULL;
		if (_tmp25_ == NULL) {
			_vala_code_node_unref0 (_tmp24_);
		}
		st = _tmp25_;
		_tmp26_ = st;
		if (_tmp26_ == NULL) {
			const gchar* _tmp27_ = NULL;
			ValaSourceReference* _tmp28_ = NULL;
			ValaStruct* _tmp29_ = NULL;
			ValaStruct* _tmp30_ = NULL;
			gchar** st_attributes = NULL;
			GIdlNode* _tmp31_ = NULL;
			const gchar* _tmp32_ = NULL;
			gint _tmp33_ = 0;
			gchar** _tmp34_ = NULL;
			gint st_attributes_length1 = 0;
			gint _st_attributes_size_ = 0;
			gchar** _tmp35_ = NULL;
			gint _tmp35__length1 = 0;
			ValaSymbol* _tmp102_ = NULL;
			ValaStruct* _tmp103_ = NULL;
			ValaSourceFile* _tmp104_ = NULL;
			ValaStruct* _tmp105_ = NULL;
			_tmp27_ = name;
			_tmp28_ = self->priv->current_source_reference;
			_tmp29_ = vala_struct_new (_tmp27_, _tmp28_, NULL);
			_vala_code_node_unref0 (st);
			st = _tmp29_;
			_tmp30_ = st;
			vala_symbol_set_access ((ValaSymbol*) _tmp30_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp31_ = node;
			_tmp32_ = _tmp31_->name;
			_tmp34_ = vala_gidl_parser_get_attributes (self, _tmp32_, &_tmp33_);
			st_attributes = _tmp34_;
			st_attributes_length1 = _tmp33_;
			_st_attributes_size_ = st_attributes_length1;
			_tmp35_ = st_attributes;
			_tmp35__length1 = st_attributes_length1;
			if (_tmp35_ != NULL) {
				gchar** _tmp36_ = NULL;
				gint _tmp36__length1 = 0;
				_tmp36_ = st_attributes;
				_tmp36__length1 = st_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp36_;
					attr_collection_length1 = _tmp36__length1;
					for (attr_it = 0; attr_it < _tmp36__length1; attr_it = attr_it + 1) {
						gchar* _tmp37_ = NULL;
						gchar* attr = NULL;
						_tmp37_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp37_;
						{
							gchar** nv = NULL;
							const gchar* _tmp38_ = NULL;
							gchar** _tmp39_ = NULL;
							gchar** _tmp40_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp41_ = NULL;
							gint _tmp41__length1 = 0;
							const gchar* _tmp42_ = NULL;
							_tmp38_ = attr;
							_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, "=", 2);
							nv = _tmp40_;
							nv_length1 = _vala_array_length (_tmp39_);
							_nv_size_ = nv_length1;
							_tmp41_ = nv;
							_tmp41__length1 = nv_length1;
							_tmp42_ = _tmp41_[0];
							if (g_strcmp0 (_tmp42_, "cheader_filename") == 0) {
								ValaStruct* _tmp43_ = NULL;
								gchar** _tmp44_ = NULL;
								gint _tmp44__length1 = 0;
								const gchar* _tmp45_ = NULL;
								gchar* _tmp46_ = NULL;
								gchar* _tmp47_ = NULL;
								_tmp43_ = st;
								_tmp44_ = nv;
								_tmp44__length1 = nv_length1;
								_tmp45_ = _tmp44_[1];
								_tmp46_ = vala_gidl_parser_eval (self, _tmp45_);
								_tmp47_ = _tmp46_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp43_, "CCode", "cheader_filename", _tmp47_, NULL);
								_g_free0 (_tmp47_);
							} else {
								gchar** _tmp48_ = NULL;
								gint _tmp48__length1 = 0;
								const gchar* _tmp49_ = NULL;
								_tmp48_ = nv;
								_tmp48__length1 = nv_length1;
								_tmp49_ = _tmp48_[0];
								if (g_strcmp0 (_tmp49_, "deprecated") == 0) {
									gchar** _tmp50_ = NULL;
									gint _tmp50__length1 = 0;
									const gchar* _tmp51_ = NULL;
									gchar* _tmp52_ = NULL;
									gchar* _tmp53_ = NULL;
									gboolean _tmp54_ = FALSE;
									_tmp50_ = nv;
									_tmp50__length1 = nv_length1;
									_tmp51_ = _tmp50_[1];
									_tmp52_ = vala_gidl_parser_eval (self, _tmp51_);
									_tmp53_ = _tmp52_;
									_tmp54_ = g_strcmp0 (_tmp53_, "1") == 0;
									_g_free0 (_tmp53_);
									if (_tmp54_) {
										ValaStruct* _tmp55_ = NULL;
										_tmp55_ = st;
										vala_code_node_set_attribute ((ValaCodeNode*) _tmp55_, "Deprecated", TRUE, NULL);
									}
								} else {
									gchar** _tmp56_ = NULL;
									gint _tmp56__length1 = 0;
									const gchar* _tmp57_ = NULL;
									_tmp56_ = nv;
									_tmp56__length1 = nv_length1;
									_tmp57_ = _tmp56_[0];
									if (g_strcmp0 (_tmp57_, "replacement") == 0) {
										ValaStruct* _tmp58_ = NULL;
										gchar** _tmp59_ = NULL;
										gint _tmp59__length1 = 0;
										const gchar* _tmp60_ = NULL;
										gchar* _tmp61_ = NULL;
										gchar* _tmp62_ = NULL;
										_tmp58_ = st;
										_tmp59_ = nv;
										_tmp59__length1 = nv_length1;
										_tmp60_ = _tmp59_[1];
										_tmp61_ = vala_gidl_parser_eval (self, _tmp60_);
										_tmp62_ = _tmp61_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp58_, "Deprecated", "replacement", _tmp62_, NULL);
										_g_free0 (_tmp62_);
									} else {
										gchar** _tmp63_ = NULL;
										gint _tmp63__length1 = 0;
										const gchar* _tmp64_ = NULL;
										_tmp63_ = nv;
										_tmp63__length1 = nv_length1;
										_tmp64_ = _tmp63_[0];
										if (g_strcmp0 (_tmp64_, "deprecated_since") == 0) {
											ValaStruct* _tmp65_ = NULL;
											gchar** _tmp66_ = NULL;
											gint _tmp66__length1 = 0;
											const gchar* _tmp67_ = NULL;
											gchar* _tmp68_ = NULL;
											gchar* _tmp69_ = NULL;
											_tmp65_ = st;
											_tmp66_ = nv;
											_tmp66__length1 = nv_length1;
											_tmp67_ = _tmp66_[1];
											_tmp68_ = vala_gidl_parser_eval (self, _tmp67_);
											_tmp69_ = _tmp68_;
											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp65_, "Deprecated", "since", _tmp69_, NULL);
											_g_free0 (_tmp69_);
										} else {
											gchar** _tmp70_ = NULL;
											gint _tmp70__length1 = 0;
											const gchar* _tmp71_ = NULL;
											_tmp70_ = nv;
											_tmp70__length1 = nv_length1;
											_tmp71_ = _tmp70_[0];
											if (g_strcmp0 (_tmp71_, "immutable") == 0) {
												gchar** _tmp72_ = NULL;
												gint _tmp72__length1 = 0;
												const gchar* _tmp73_ = NULL;
												gchar* _tmp74_ = NULL;
												gchar* _tmp75_ = NULL;
												gboolean _tmp76_ = FALSE;
												_tmp72_ = nv;
												_tmp72__length1 = nv_length1;
												_tmp73_ = _tmp72_[1];
												_tmp74_ = vala_gidl_parser_eval (self, _tmp73_);
												_tmp75_ = _tmp74_;
												_tmp76_ = g_strcmp0 (_tmp75_, "1") == 0;
												_g_free0 (_tmp75_);
												if (_tmp76_) {
													ValaStruct* _tmp77_ = NULL;
													_tmp77_ = st;
													vala_code_node_set_attribute ((ValaCodeNode*) _tmp77_, "Immutable", TRUE, NULL);
												}
											} else {
												gchar** _tmp78_ = NULL;
												gint _tmp78__length1 = 0;
												const gchar* _tmp79_ = NULL;
												_tmp78_ = nv;
												_tmp78__length1 = nv_length1;
												_tmp79_ = _tmp78_[0];
												if (g_strcmp0 (_tmp79_, "has_copy_function") == 0) {
													gchar** _tmp80_ = NULL;
													gint _tmp80__length1 = 0;
													const gchar* _tmp81_ = NULL;
													gchar* _tmp82_ = NULL;
													gchar* _tmp83_ = NULL;
													gboolean _tmp84_ = FALSE;
													_tmp80_ = nv;
													_tmp80__length1 = nv_length1;
													_tmp81_ = _tmp80_[1];
													_tmp82_ = vala_gidl_parser_eval (self, _tmp81_);
													_tmp83_ = _tmp82_;
													_tmp84_ = g_strcmp0 (_tmp83_, "0") == 0;
													_g_free0 (_tmp83_);
													if (_tmp84_) {
														ValaStruct* _tmp85_ = NULL;
														_tmp85_ = st;
														vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp85_, "CCode", "has_copy_function", FALSE, NULL);
													}
												} else {
													gchar** _tmp86_ = NULL;
													gint _tmp86__length1 = 0;
													const gchar* _tmp87_ = NULL;
													_tmp86_ = nv;
													_tmp86__length1 = nv_length1;
													_tmp87_ = _tmp86_[0];
													if (g_strcmp0 (_tmp87_, "has_destroy_function") == 0) {
														gchar** _tmp88_ = NULL;
														gint _tmp88__length1 = 0;
														const gchar* _tmp89_ = NULL;
														gchar* _tmp90_ = NULL;
														gchar* _tmp91_ = NULL;
														gboolean _tmp92_ = FALSE;
														_tmp88_ = nv;
														_tmp88__length1 = nv_length1;
														_tmp89_ = _tmp88_[1];
														_tmp90_ = vala_gidl_parser_eval (self, _tmp89_);
														_tmp91_ = _tmp90_;
														_tmp92_ = g_strcmp0 (_tmp91_, "0") == 0;
														_g_free0 (_tmp91_);
														if (_tmp92_) {
															ValaStruct* _tmp93_ = NULL;
															_tmp93_ = st;
															vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp93_, "CCode", "has_destroy_function", FALSE, NULL);
														}
													} else {
														gchar** _tmp94_ = NULL;
														gint _tmp94__length1 = 0;
														const gchar* _tmp95_ = NULL;
														_tmp94_ = nv;
														_tmp94__length1 = nv_length1;
														_tmp95_ = _tmp94_[0];
														if (g_strcmp0 (_tmp95_, "experimental") == 0) {
															gchar** _tmp96_ = NULL;
															gint _tmp96__length1 = 0;
															const gchar* _tmp97_ = NULL;
															gchar* _tmp98_ = NULL;
															gchar* _tmp99_ = NULL;
															gboolean _tmp100_ = FALSE;
															_tmp96_ = nv;
															_tmp96__length1 = nv_length1;
															_tmp97_ = _tmp96_[1];
															_tmp98_ = vala_gidl_parser_eval (self, _tmp97_);
															_tmp99_ = _tmp98_;
															_tmp100_ = g_strcmp0 (_tmp99_, "1") == 0;
															_g_free0 (_tmp99_);
															if (_tmp100_) {
																ValaStruct* _tmp101_ = NULL;
																_tmp101_ = st;
																vala_code_node_set_attribute ((ValaCodeNode*) _tmp101_, "Experimental", TRUE, NULL);
															}
														}
													}
												}
											}
										}
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp102_ = container;
			_tmp103_ = st;
			vala_gidl_parser_add_symbol_to_container (self, _tmp102_, (ValaSymbol*) _tmp103_);
			_tmp104_ = self->priv->current_source_file;
			_tmp105_ = st;
			vala_source_file_add_node (_tmp104_, (ValaCodeNode*) _tmp105_);
			st_attributes = (_vala_array_free (st_attributes, st_attributes_length1, (GDestroyNotify) g_free), NULL);
		}
		_tmp106_ = st;
		_tmp107_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp106_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp107_;
		_tmp108_ = boxed_node;
		_tmp109_ = _tmp108_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp109_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp110_ = NULL;
					GIdlNodeTypeId _tmp111_ = 0;
					_tmp110_ = member;
					_tmp111_ = _tmp110_->type;
					if (_tmp111_ == G_IDL_NODE_FUNCTION) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp112_ = NULL;
						ValaMethod* _tmp113_ = NULL;
						ValaMethod* _tmp114_ = NULL;
						_tmp112_ = member;
						_tmp113_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp112_, FALSE);
						m = _tmp113_;
						_tmp114_ = m;
						if (_tmp114_ != NULL) {
							ValaStruct* _tmp115_ = NULL;
							ValaMethod* _tmp116_ = NULL;
							_tmp115_ = st;
							_tmp116_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp115_, _tmp116_);
						}
						_vala_code_node_unref0 (m);
					} else {
						GIdlNode* _tmp117_ = NULL;
						GIdlNodeTypeId _tmp118_ = 0;
						_tmp117_ = member;
						_tmp118_ = _tmp117_->type;
						if (_tmp118_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp119_ = NULL;
							ValaField* _tmp120_ = NULL;
							ValaField* _tmp121_ = NULL;
							_tmp119_ = member;
							_tmp120_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp119_);
							f = _tmp120_;
							_tmp121_ = f;
							if (_tmp121_ != NULL) {
								ValaStruct* _tmp122_ = NULL;
								ValaField* _tmp123_ = NULL;
								_tmp122_ = st;
								_tmp123_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp122_, _tmp123_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_vala_code_node_unref0 (st);
	} else {
		gboolean ref_function_void = FALSE;
		gchar* ref_function = NULL;
		gchar* unref_function = NULL;
		gchar* copy_function = NULL;
		gchar* free_function = NULL;
		ValaClass* cl = NULL;
		ValaSymbol* _tmp124_ = NULL;
		ValaScope* _tmp125_ = NULL;
		ValaScope* _tmp126_ = NULL;
		const gchar* _tmp127_ = NULL;
		ValaSymbol* _tmp128_ = NULL;
		ValaClass* _tmp129_ = NULL;
		ValaClass* _tmp130_ = NULL;
		ValaClass* _tmp246_ = NULL;
		ValaTypeSymbol* _tmp247_ = NULL;
		GIdlNodeBoxed* _tmp248_ = NULL;
		GList* _tmp249_ = NULL;
		const gchar* _tmp293_ = NULL;
		const gchar* _tmp302_ = NULL;
		ref_function_void = FALSE;
		ref_function = NULL;
		unref_function = NULL;
		copy_function = NULL;
		free_function = NULL;
		_tmp124_ = container;
		_tmp125_ = vala_symbol_get_scope (_tmp124_);
		_tmp126_ = _tmp125_;
		_tmp127_ = name;
		_tmp128_ = vala_scope_lookup (_tmp126_, _tmp127_);
		_tmp129_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp128_, VALA_TYPE_CLASS) ? ((ValaClass*) _tmp128_) : NULL;
		if (_tmp129_ == NULL) {
			_vala_code_node_unref0 (_tmp128_);
		}
		cl = _tmp129_;
		_tmp130_ = cl;
		if (_tmp130_ == NULL) {
			gchar* base_class = NULL;
			const gchar* _tmp131_ = NULL;
			ValaSourceReference* _tmp132_ = NULL;
			ValaClass* _tmp133_ = NULL;
			ValaClass* _tmp134_ = NULL;
			ValaClass* _tmp135_ = NULL;
			GIdlNodeBoxed* _tmp136_ = NULL;
			const gchar* _tmp137_ = NULL;
			gchar** cl_attributes = NULL;
			GIdlNode* _tmp143_ = NULL;
			const gchar* _tmp144_ = NULL;
			gint _tmp145_ = 0;
			gchar** _tmp146_ = NULL;
			gint cl_attributes_length1 = 0;
			gint _cl_attributes_size_ = 0;
			gchar** _tmp147_ = NULL;
			gint _tmp147__length1 = 0;
			ValaSymbol* _tmp237_ = NULL;
			ValaClass* _tmp238_ = NULL;
			ValaSourceFile* _tmp239_ = NULL;
			ValaClass* _tmp240_ = NULL;
			const gchar* _tmp241_ = NULL;
			base_class = NULL;
			_tmp131_ = name;
			_tmp132_ = self->priv->current_source_reference;
			_tmp133_ = vala_class_new (_tmp131_, _tmp132_, NULL);
			_vala_code_node_unref0 (cl);
			cl = _tmp133_;
			_tmp134_ = cl;
			vala_symbol_set_access ((ValaSymbol*) _tmp134_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
			_tmp135_ = cl;
			vala_class_set_is_compact (_tmp135_, TRUE);
			_tmp136_ = boxed_node;
			_tmp137_ = _tmp136_->gtype_init;
			if (_tmp137_ != NULL) {
				ValaClass* _tmp138_ = NULL;
				GIdlNodeBoxed* _tmp139_ = NULL;
				const gchar* _tmp140_ = NULL;
				gchar* _tmp141_ = NULL;
				gchar* _tmp142_ = NULL;
				_tmp138_ = cl;
				_tmp139_ = boxed_node;
				_tmp140_ = _tmp139_->gtype_init;
				_tmp141_ = g_strdup_printf ("%s ()", _tmp140_);
				_tmp142_ = _tmp141_;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp138_, "CCode", "type_id", _tmp142_, NULL);
				_g_free0 (_tmp142_);
			}
			_tmp143_ = node;
			_tmp144_ = _tmp143_->name;
			_tmp146_ = vala_gidl_parser_get_attributes (self, _tmp144_, &_tmp145_);
			cl_attributes = _tmp146_;
			cl_attributes_length1 = _tmp145_;
			_cl_attributes_size_ = cl_attributes_length1;
			_tmp147_ = cl_attributes;
			_tmp147__length1 = cl_attributes_length1;
			if (_tmp147_ != NULL) {
				gchar** _tmp148_ = NULL;
				gint _tmp148__length1 = 0;
				_tmp148_ = cl_attributes;
				_tmp148__length1 = cl_attributes_length1;
				{
					gchar** attr_collection = NULL;
					gint attr_collection_length1 = 0;
					gint _attr_collection_size_ = 0;
					gint attr_it = 0;
					attr_collection = _tmp148_;
					attr_collection_length1 = _tmp148__length1;
					for (attr_it = 0; attr_it < _tmp148__length1; attr_it = attr_it + 1) {
						gchar* _tmp149_ = NULL;
						gchar* attr = NULL;
						_tmp149_ = g_strdup (attr_collection[attr_it]);
						attr = _tmp149_;
						{
							gchar** nv = NULL;
							const gchar* _tmp150_ = NULL;
							gchar** _tmp151_ = NULL;
							gchar** _tmp152_ = NULL;
							gint nv_length1 = 0;
							gint _nv_size_ = 0;
							gchar** _tmp153_ = NULL;
							gint _tmp153__length1 = 0;
							const gchar* _tmp154_ = NULL;
							_tmp150_ = attr;
							_tmp152_ = _tmp151_ = g_strsplit (_tmp150_, "=", 2);
							nv = _tmp152_;
							nv_length1 = _vala_array_length (_tmp151_);
							_nv_size_ = nv_length1;
							_tmp153_ = nv;
							_tmp153__length1 = nv_length1;
							_tmp154_ = _tmp153_[0];
							if (g_strcmp0 (_tmp154_, "cheader_filename") == 0) {
								ValaClass* _tmp155_ = NULL;
								gchar** _tmp156_ = NULL;
								gint _tmp156__length1 = 0;
								const gchar* _tmp157_ = NULL;
								gchar* _tmp158_ = NULL;
								gchar* _tmp159_ = NULL;
								_tmp155_ = cl;
								_tmp156_ = nv;
								_tmp156__length1 = nv_length1;
								_tmp157_ = _tmp156_[1];
								_tmp158_ = vala_gidl_parser_eval (self, _tmp157_);
								_tmp159_ = _tmp158_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp155_, "CCode", "cheader_filename", _tmp159_, NULL);
								_g_free0 (_tmp159_);
							} else {
								gchar** _tmp160_ = NULL;
								gint _tmp160__length1 = 0;
								const gchar* _tmp161_ = NULL;
								_tmp160_ = nv;
								_tmp160__length1 = nv_length1;
								_tmp161_ = _tmp160_[0];
								if (g_strcmp0 (_tmp161_, "base_class") == 0) {
									gchar** _tmp162_ = NULL;
									gint _tmp162__length1 = 0;
									const gchar* _tmp163_ = NULL;
									gchar* _tmp164_ = NULL;
									_tmp162_ = nv;
									_tmp162__length1 = nv_length1;
									_tmp163_ = _tmp162_[1];
									_tmp164_ = vala_gidl_parser_eval (self, _tmp163_);
									_g_free0 (base_class);
									base_class = _tmp164_;
								} else {
									gchar** _tmp165_ = NULL;
									gint _tmp165__length1 = 0;
									const gchar* _tmp166_ = NULL;
									_tmp165_ = nv;
									_tmp165__length1 = nv_length1;
									_tmp166_ = _tmp165_[0];
									if (g_strcmp0 (_tmp166_, "is_immutable") == 0) {
										gchar** _tmp167_ = NULL;
										gint _tmp167__length1 = 0;
										const gchar* _tmp168_ = NULL;
										gchar* _tmp169_ = NULL;
										gchar* _tmp170_ = NULL;
										gboolean _tmp171_ = FALSE;
										_tmp167_ = nv;
										_tmp167__length1 = nv_length1;
										_tmp168_ = _tmp167_[1];
										_tmp169_ = vala_gidl_parser_eval (self, _tmp168_);
										_tmp170_ = _tmp169_;
										_tmp171_ = g_strcmp0 (_tmp170_, "1") == 0;
										_g_free0 (_tmp170_);
										if (_tmp171_) {
											ValaClass* _tmp172_ = NULL;
											_tmp172_ = cl;
											vala_class_set_is_immutable (_tmp172_, TRUE);
										}
									} else {
										gchar** _tmp173_ = NULL;
										gint _tmp173__length1 = 0;
										const gchar* _tmp174_ = NULL;
										_tmp173_ = nv;
										_tmp173__length1 = nv_length1;
										_tmp174_ = _tmp173_[0];
										if (g_strcmp0 (_tmp174_, "deprecated") == 0) {
											gchar** _tmp175_ = NULL;
											gint _tmp175__length1 = 0;
											const gchar* _tmp176_ = NULL;
											gchar* _tmp177_ = NULL;
											gchar* _tmp178_ = NULL;
											gboolean _tmp179_ = FALSE;
											_tmp175_ = nv;
											_tmp175__length1 = nv_length1;
											_tmp176_ = _tmp175_[1];
											_tmp177_ = vala_gidl_parser_eval (self, _tmp176_);
											_tmp178_ = _tmp177_;
											_tmp179_ = g_strcmp0 (_tmp178_, "1") == 0;
											_g_free0 (_tmp178_);
											if (_tmp179_) {
												ValaClass* _tmp180_ = NULL;
												_tmp180_ = cl;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp180_, "Deprecated", TRUE, NULL);
											}
										} else {
											gchar** _tmp181_ = NULL;
											gint _tmp181__length1 = 0;
											const gchar* _tmp182_ = NULL;
											_tmp181_ = nv;
											_tmp181__length1 = nv_length1;
											_tmp182_ = _tmp181_[0];
											if (g_strcmp0 (_tmp182_, "replacement") == 0) {
												ValaClass* _tmp183_ = NULL;
												gchar** _tmp184_ = NULL;
												gint _tmp184__length1 = 0;
												const gchar* _tmp185_ = NULL;
												gchar* _tmp186_ = NULL;
												gchar* _tmp187_ = NULL;
												_tmp183_ = cl;
												_tmp184_ = nv;
												_tmp184__length1 = nv_length1;
												_tmp185_ = _tmp184_[1];
												_tmp186_ = vala_gidl_parser_eval (self, _tmp185_);
												_tmp187_ = _tmp186_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp183_, "Deprecated", "replacement", _tmp187_, NULL);
												_g_free0 (_tmp187_);
											} else {
												gchar** _tmp188_ = NULL;
												gint _tmp188__length1 = 0;
												const gchar* _tmp189_ = NULL;
												_tmp188_ = nv;
												_tmp188__length1 = nv_length1;
												_tmp189_ = _tmp188_[0];
												if (g_strcmp0 (_tmp189_, "deprecated_since") == 0) {
													ValaClass* _tmp190_ = NULL;
													gchar** _tmp191_ = NULL;
													gint _tmp191__length1 = 0;
													const gchar* _tmp192_ = NULL;
													gchar* _tmp193_ = NULL;
													gchar* _tmp194_ = NULL;
													_tmp190_ = cl;
													_tmp191_ = nv;
													_tmp191__length1 = nv_length1;
													_tmp192_ = _tmp191_[1];
													_tmp193_ = vala_gidl_parser_eval (self, _tmp192_);
													_tmp194_ = _tmp193_;
													vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp190_, "Deprecated", "since", _tmp194_, NULL);
													_g_free0 (_tmp194_);
												} else {
													gchar** _tmp195_ = NULL;
													gint _tmp195__length1 = 0;
													const gchar* _tmp196_ = NULL;
													_tmp195_ = nv;
													_tmp195__length1 = nv_length1;
													_tmp196_ = _tmp195_[0];
													if (g_strcmp0 (_tmp196_, "const_cname") == 0) {
														ValaClass* _tmp197_ = NULL;
														gchar** _tmp198_ = NULL;
														gint _tmp198__length1 = 0;
														const gchar* _tmp199_ = NULL;
														gchar* _tmp200_ = NULL;
														gchar* _tmp201_ = NULL;
														_tmp197_ = cl;
														_tmp198_ = nv;
														_tmp198__length1 = nv_length1;
														_tmp199_ = _tmp198_[1];
														_tmp200_ = vala_gidl_parser_eval (self, _tmp199_);
														_tmp201_ = _tmp200_;
														vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp197_, "CCode", "const_cname", _tmp201_, NULL);
														_g_free0 (_tmp201_);
													} else {
														gchar** _tmp202_ = NULL;
														gint _tmp202__length1 = 0;
														const gchar* _tmp203_ = NULL;
														_tmp202_ = nv;
														_tmp202__length1 = nv_length1;
														_tmp203_ = _tmp202_[0];
														if (g_strcmp0 (_tmp203_, "free_function") == 0) {
															gchar** _tmp204_ = NULL;
															gint _tmp204__length1 = 0;
															const gchar* _tmp205_ = NULL;
															gchar* _tmp206_ = NULL;
															_tmp204_ = nv;
															_tmp204__length1 = nv_length1;
															_tmp205_ = _tmp204_[1];
															_tmp206_ = vala_gidl_parser_eval (self, _tmp205_);
															_g_free0 (free_function);
															free_function = _tmp206_;
														} else {
															gchar** _tmp207_ = NULL;
															gint _tmp207__length1 = 0;
															const gchar* _tmp208_ = NULL;
															_tmp207_ = nv;
															_tmp207__length1 = nv_length1;
															_tmp208_ = _tmp207_[0];
															if (g_strcmp0 (_tmp208_, "ref_function") == 0) {
																gchar** _tmp209_ = NULL;
																gint _tmp209__length1 = 0;
																const gchar* _tmp210_ = NULL;
																gchar* _tmp211_ = NULL;
																_tmp209_ = nv;
																_tmp209__length1 = nv_length1;
																_tmp210_ = _tmp209_[1];
																_tmp211_ = vala_gidl_parser_eval (self, _tmp210_);
																_g_free0 (ref_function);
																ref_function = _tmp211_;
															} else {
																gchar** _tmp212_ = NULL;
																gint _tmp212__length1 = 0;
																const gchar* _tmp213_ = NULL;
																_tmp212_ = nv;
																_tmp212__length1 = nv_length1;
																_tmp213_ = _tmp212_[0];
																if (g_strcmp0 (_tmp213_, "unref_function") == 0) {
																	gchar** _tmp214_ = NULL;
																	gint _tmp214__length1 = 0;
																	const gchar* _tmp215_ = NULL;
																	gchar* _tmp216_ = NULL;
																	_tmp214_ = nv;
																	_tmp214__length1 = nv_length1;
																	_tmp215_ = _tmp214_[1];
																	_tmp216_ = vala_gidl_parser_eval (self, _tmp215_);
																	_g_free0 (unref_function);
																	unref_function = _tmp216_;
																} else {
																	gchar** _tmp217_ = NULL;
																	gint _tmp217__length1 = 0;
																	const gchar* _tmp218_ = NULL;
																	_tmp217_ = nv;
																	_tmp217__length1 = nv_length1;
																	_tmp218_ = _tmp217_[0];
																	if (g_strcmp0 (_tmp218_, "copy_function") == 0) {
																		gchar** _tmp219_ = NULL;
																		gint _tmp219__length1 = 0;
																		const gchar* _tmp220_ = NULL;
																		gchar* _tmp221_ = NULL;
																		_tmp219_ = nv;
																		_tmp219__length1 = nv_length1;
																		_tmp220_ = _tmp219_[1];
																		_tmp221_ = vala_gidl_parser_eval (self, _tmp220_);
																		_g_free0 (copy_function);
																		copy_function = _tmp221_;
																	} else {
																		gchar** _tmp222_ = NULL;
																		gint _tmp222__length1 = 0;
																		const gchar* _tmp223_ = NULL;
																		_tmp222_ = nv;
																		_tmp222__length1 = nv_length1;
																		_tmp223_ = _tmp222_[0];
																		if (g_strcmp0 (_tmp223_, "ref_function_void") == 0) {
																			gchar** _tmp224_ = NULL;
																			gint _tmp224__length1 = 0;
																			const gchar* _tmp225_ = NULL;
																			gchar* _tmp226_ = NULL;
																			gchar* _tmp227_ = NULL;
																			gboolean _tmp228_ = FALSE;
																			_tmp224_ = nv;
																			_tmp224__length1 = nv_length1;
																			_tmp225_ = _tmp224_[1];
																			_tmp226_ = vala_gidl_parser_eval (self, _tmp225_);
																			_tmp227_ = _tmp226_;
																			_tmp228_ = g_strcmp0 (_tmp227_, "1") == 0;
																			_g_free0 (_tmp227_);
																			if (_tmp228_) {
																				ref_function_void = TRUE;
																			}
																		} else {
																			gchar** _tmp229_ = NULL;
																			gint _tmp229__length1 = 0;
																			const gchar* _tmp230_ = NULL;
																			_tmp229_ = nv;
																			_tmp229__length1 = nv_length1;
																			_tmp230_ = _tmp229_[0];
																			if (g_strcmp0 (_tmp230_, "experimental") == 0) {
																				gchar** _tmp231_ = NULL;
																				gint _tmp231__length1 = 0;
																				const gchar* _tmp232_ = NULL;
																				gchar* _tmp233_ = NULL;
																				gchar* _tmp234_ = NULL;
																				gboolean _tmp235_ = FALSE;
																				_tmp231_ = nv;
																				_tmp231__length1 = nv_length1;
																				_tmp232_ = _tmp231_[1];
																				_tmp233_ = vala_gidl_parser_eval (self, _tmp232_);
																				_tmp234_ = _tmp233_;
																				_tmp235_ = g_strcmp0 (_tmp234_, "1") == 0;
																				_g_free0 (_tmp234_);
																				if (_tmp235_) {
																					ValaClass* _tmp236_ = NULL;
																					_tmp236_ = cl;
																					vala_code_node_set_attribute ((ValaCodeNode*) _tmp236_, "Experimental", TRUE, NULL);
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
						}
					}
				}
			}
			_tmp237_ = container;
			_tmp238_ = cl;
			vala_gidl_parser_add_symbol_to_container (self, _tmp237_, (ValaSymbol*) _tmp238_);
			_tmp239_ = self->priv->current_source_file;
			_tmp240_ = cl;
			vala_source_file_add_node (_tmp239_, (ValaCodeNode*) _tmp240_);
			_tmp241_ = base_class;
			if (_tmp241_ != NULL) {
				ValaDataType* parent = NULL;
				const gchar* _tmp242_ = NULL;
				ValaDataType* _tmp243_ = NULL;
				ValaClass* _tmp244_ = NULL;
				ValaDataType* _tmp245_ = NULL;
				_tmp242_ = base_class;
				_tmp243_ = vala_gidl_parser_parse_type_string (self, _tmp242_);
				parent = _tmp243_;
				_tmp244_ = cl;
				_tmp245_ = parent;
				vala_class_add_base_type (_tmp244_, _tmp245_);
				_vala_code_node_unref0 (parent);
			}
			cl_attributes = (_vala_array_free (cl_attributes, cl_attributes_length1, (GDestroyNotify) g_free), NULL);
			_g_free0 (base_class);
		}
		_tmp246_ = cl;
		_tmp247_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp246_);
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = _tmp247_;
		_tmp248_ = boxed_node;
		_tmp249_ = _tmp248_->members;
		{
			GList* member_collection = NULL;
			GList* member_it = NULL;
			member_collection = _tmp249_;
			for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
				GIdlNode* member = NULL;
				member = (GIdlNode*) member_it->data;
				{
					GIdlNode* _tmp250_ = NULL;
					GIdlNodeTypeId _tmp251_ = 0;
					_tmp250_ = member;
					_tmp251_ = _tmp250_->type;
					if (_tmp251_ == G_IDL_NODE_FUNCTION) {
						GIdlNode* _tmp252_ = NULL;
						const gchar* _tmp253_ = NULL;
						_tmp252_ = member;
						_tmp253_ = _tmp252_->name;
						if (g_strcmp0 (_tmp253_, "ref") == 0) {
							GIdlNode* _tmp254_ = NULL;
							const gchar* _tmp255_ = NULL;
							gchar* _tmp256_ = NULL;
							GIdlNode* _tmp257_ = NULL;
							GIdlNodeParam* _tmp258_ = NULL;
							GIdlNodeType* _tmp259_ = NULL;
							ValaDataType* _tmp260_ = NULL;
							ValaDataType* _tmp261_ = NULL;
							_tmp254_ = member;
							_tmp255_ = ((GIdlNodeFunction*) _tmp254_)->symbol;
							_tmp256_ = g_strdup (_tmp255_);
							_g_free0 (ref_function);
							ref_function = _tmp256_;
							_tmp257_ = member;
							_tmp258_ = ((GIdlNodeFunction*) _tmp257_)->result;
							_tmp259_ = _tmp258_->type;
							_tmp260_ = vala_gidl_parser_parse_type (self, _tmp259_, NULL);
							_tmp261_ = _tmp260_;
							ref_function_void = G_TYPE_CHECK_INSTANCE_TYPE (_tmp261_, VALA_TYPE_VOID_TYPE);
							_vala_code_node_unref0 (_tmp261_);
						} else {
							GIdlNode* _tmp262_ = NULL;
							const gchar* _tmp263_ = NULL;
							_tmp262_ = member;
							_tmp263_ = _tmp262_->name;
							if (g_strcmp0 (_tmp263_, "unref") == 0) {
								GIdlNode* _tmp264_ = NULL;
								const gchar* _tmp265_ = NULL;
								gchar* _tmp266_ = NULL;
								_tmp264_ = member;
								_tmp265_ = ((GIdlNodeFunction*) _tmp264_)->symbol;
								_tmp266_ = g_strdup (_tmp265_);
								_g_free0 (unref_function);
								unref_function = _tmp266_;
							} else {
								gboolean _tmp267_ = FALSE;
								GIdlNode* _tmp268_ = NULL;
								const gchar* _tmp269_ = NULL;
								gboolean _tmp272_ = FALSE;
								_tmp268_ = member;
								_tmp269_ = _tmp268_->name;
								if (g_strcmp0 (_tmp269_, "free") == 0) {
									_tmp267_ = TRUE;
								} else {
									GIdlNode* _tmp270_ = NULL;
									const gchar* _tmp271_ = NULL;
									_tmp270_ = member;
									_tmp271_ = _tmp270_->name;
									_tmp267_ = g_strcmp0 (_tmp271_, "destroy") == 0;
								}
								_tmp272_ = _tmp267_;
								if (_tmp272_) {
									GIdlNode* _tmp273_ = NULL;
									const gchar* _tmp274_ = NULL;
									gchar* _tmp275_ = NULL;
									_tmp273_ = member;
									_tmp274_ = ((GIdlNodeFunction*) _tmp273_)->symbol;
									_tmp275_ = g_strdup (_tmp274_);
									_g_free0 (free_function);
									free_function = _tmp275_;
								} else {
									GIdlNode* _tmp276_ = NULL;
									const gchar* _tmp277_ = NULL;
									ValaMethod* m = NULL;
									GIdlNode* _tmp281_ = NULL;
									ValaMethod* _tmp282_ = NULL;
									ValaMethod* _tmp283_ = NULL;
									_tmp276_ = member;
									_tmp277_ = _tmp276_->name;
									if (g_strcmp0 (_tmp277_, "copy") == 0) {
										GIdlNode* _tmp278_ = NULL;
										const gchar* _tmp279_ = NULL;
										gchar* _tmp280_ = NULL;
										_tmp278_ = member;
										_tmp279_ = ((GIdlNodeFunction*) _tmp278_)->symbol;
										_tmp280_ = g_strdup (_tmp279_);
										_g_free0 (copy_function);
										copy_function = _tmp280_;
									}
									_tmp281_ = member;
									_tmp282_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp281_, FALSE);
									m = _tmp282_;
									_tmp283_ = m;
									if (_tmp283_ != NULL) {
										ValaClass* _tmp284_ = NULL;
										ValaMethod* _tmp285_ = NULL;
										_tmp284_ = cl;
										_tmp285_ = m;
										vala_symbol_add_method ((ValaSymbol*) _tmp284_, _tmp285_);
									}
									_vala_code_node_unref0 (m);
								}
							}
						}
					} else {
						GIdlNode* _tmp286_ = NULL;
						GIdlNodeTypeId _tmp287_ = 0;
						_tmp286_ = member;
						_tmp287_ = _tmp286_->type;
						if (_tmp287_ == G_IDL_NODE_FIELD) {
							ValaField* f = NULL;
							GIdlNode* _tmp288_ = NULL;
							ValaField* _tmp289_ = NULL;
							ValaField* _tmp290_ = NULL;
							_tmp288_ = member;
							_tmp289_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp288_);
							f = _tmp289_;
							_tmp290_ = f;
							if (_tmp290_ != NULL) {
								ValaClass* _tmp291_ = NULL;
								ValaField* _tmp292_ = NULL;
								_tmp291_ = cl;
								_tmp292_ = f;
								vala_symbol_add_field ((ValaSymbol*) _tmp291_, _tmp292_);
							}
							_vala_code_node_unref0 (f);
						}
					}
				}
			}
		}
		_tmp293_ = ref_function;
		if (_tmp293_ != NULL) {
			ValaClass* _tmp294_ = NULL;
			const gchar* _tmp295_ = NULL;
			gboolean _tmp296_ = FALSE;
			_tmp294_ = cl;
			_tmp295_ = ref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp294_, "CCode", "ref_function", _tmp295_, NULL);
			_tmp296_ = ref_function_void;
			if (_tmp296_) {
				ValaClass* _tmp297_ = NULL;
				gboolean _tmp298_ = FALSE;
				_tmp297_ = cl;
				_tmp298_ = ref_function_void;
				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp297_, "CCode", "ref_function_void", _tmp298_, NULL);
			}
		} else {
			const gchar* _tmp299_ = NULL;
			_tmp299_ = copy_function;
			if (_tmp299_ != NULL) {
				ValaClass* _tmp300_ = NULL;
				const gchar* _tmp301_ = NULL;
				_tmp300_ = cl;
				_tmp301_ = copy_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp300_, "CCode", "copy_function", _tmp301_, NULL);
			}
		}
		_tmp302_ = unref_function;
		if (_tmp302_ != NULL) {
			ValaClass* _tmp303_ = NULL;
			const gchar* _tmp304_ = NULL;
			_tmp303_ = cl;
			_tmp304_ = unref_function;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp303_, "CCode", "unref_function", _tmp304_, NULL);
		} else {
			gboolean _tmp305_ = FALSE;
			const gchar* _tmp306_ = NULL;
			gboolean _tmp313_ = FALSE;
			_tmp306_ = free_function;
			if (_tmp306_ != NULL) {
				const gchar* _tmp307_ = NULL;
				ValaClass* _tmp308_ = NULL;
				gchar* _tmp309_ = NULL;
				gchar* _tmp310_ = NULL;
				gchar* _tmp311_ = NULL;
				gchar* _tmp312_ = NULL;
				_tmp307_ = free_function;
				_tmp308_ = cl;
				_tmp309_ = vala_gidl_parser_get_lower_case_cprefix (self, (ValaSymbol*) _tmp308_);
				_tmp310_ = _tmp309_;
				_tmp311_ = g_strdup_printf ("%sfree", _tmp310_);
				_tmp312_ = _tmp311_;
				_tmp305_ = g_strcmp0 (_tmp307_, _tmp312_) != 0;
				_g_free0 (_tmp312_);
				_g_free0 (_tmp310_);
			} else {
				_tmp305_ = FALSE;
			}
			_tmp313_ = _tmp305_;
			if (_tmp313_) {
				ValaClass* _tmp314_ = NULL;
				const gchar* _tmp315_ = NULL;
				_tmp314_ = cl;
				_tmp315_ = free_function;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp314_, "CCode", "free_function", _tmp315_, NULL);
			}
		}
		_vala_code_node_unref0 (self->priv->current_data_type);
		self->priv->current_data_type = NULL;
		_vala_code_node_unref0 (cl);
		_g_free0 (free_function);
		_g_free0 (copy_function);
		_g_free0 (unref_function);
		_g_free0 (ref_function);
	}
	node_attributes = (_vala_array_free (node_attributes, node_attributes_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (name);
}


static gunichar string_get_char (const gchar* self, glong index) {
	gunichar result = 0U;
	glong _tmp0_ = 0L;
	gunichar _tmp1_ = 0U;
	g_return_val_if_fail (self != NULL, 0U);
	_tmp0_ = index;
	_tmp1_ = g_utf8_get_char (((gchar*) self) + _tmp0_);
	result = _tmp1_;
	return result;
}


static void vala_gidl_parser_parse_enum (ValaGIdlParser* self, GIdlNodeEnum* en_node, ValaSymbol* container, GIdlModule* module, gboolean is_flags) {
	GIdlNode* node = NULL;
	GIdlNodeEnum* _tmp0_ = NULL;
	gchar* name = NULL;
	GIdlNode* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	ValaSymbol* _tmp3_ = NULL;
	gchar* _tmp4_ = NULL;
	gboolean existing = FALSE;
	ValaEnum* en = NULL;
	ValaSymbol* _tmp5_ = NULL;
	ValaScope* _tmp6_ = NULL;
	ValaScope* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	ValaSymbol* _tmp9_ = NULL;
	ValaEnum* _tmp10_ = NULL;
	ValaEnum* _tmp11_ = NULL;
	gboolean _tmp28_ = FALSE;
	GIdlNodeEnum* _tmp29_ = NULL;
	const gchar* _tmp30_ = NULL;
	gboolean _tmp33_ = FALSE;
	gchar* common_prefix = NULL;
	GIdlNodeEnum* _tmp35_ = NULL;
	GList* _tmp36_ = NULL;
	gboolean is_errordomain = FALSE;
	gchar* cheader_filename = NULL;
	gchar** en_attributes = NULL;
	GIdlNode* _tmp111_ = NULL;
	const gchar* _tmp112_ = NULL;
	gint _tmp113_ = 0;
	gchar** _tmp114_ = NULL;
	gint en_attributes_length1 = 0;
	gint _en_attributes_size_ = 0;
	gchar** _tmp115_ = NULL;
	gint _tmp115__length1 = 0;
	ValaEnum* _tmp209_ = NULL;
	const gchar* _tmp210_ = NULL;
	GIdlNodeEnum* _tmp211_ = NULL;
	GList* _tmp212_ = NULL;
	gboolean _tmp265_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (en_node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = en_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = node;
	_tmp2_ = _tmp1_->name;
	_tmp3_ = container;
	_tmp4_ = vala_gidl_parser_fix_type_name (self, _tmp2_, _tmp3_);
	name = _tmp4_;
	existing = TRUE;
	_tmp5_ = container;
	_tmp6_ = vala_symbol_get_scope (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = name;
	_tmp9_ = vala_scope_lookup (_tmp7_, _tmp8_);
	_tmp10_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, VALA_TYPE_ENUM) ? ((ValaEnum*) _tmp9_) : NULL;
	if (_tmp10_ == NULL) {
		_vala_code_node_unref0 (_tmp9_);
	}
	en = _tmp10_;
	_tmp11_ = en;
	if (_tmp11_ == NULL) {
		const gchar* _tmp12_ = NULL;
		ValaSourceReference* _tmp13_ = NULL;
		ValaEnum* _tmp14_ = NULL;
		ValaEnum* _tmp15_ = NULL;
		_tmp12_ = name;
		_tmp13_ = self->priv->current_source_reference;
		_tmp14_ = vala_enum_new (_tmp12_, _tmp13_, NULL);
		_vala_code_node_unref0 (en);
		en = _tmp14_;
		_tmp15_ = en;
		vala_symbol_set_access ((ValaSymbol*) _tmp15_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		existing = FALSE;
	} else {
		ValaEnumValue* dummy = NULL;
		ValaEnum* _tmp16_ = NULL;
		ValaScope* _tmp17_ = NULL;
		ValaScope* _tmp18_ = NULL;
		ValaSymbol* _tmp19_ = NULL;
		ValaEnumValue* _tmp20_ = NULL;
		_tmp16_ = en;
		_tmp17_ = vala_symbol_get_scope ((ValaSymbol*) _tmp16_);
		_tmp18_ = _tmp17_;
		_tmp19_ = vala_scope_lookup (_tmp18_, "__DUMMY__");
		dummy = G_TYPE_CHECK_INSTANCE_CAST (_tmp19_, VALA_TYPE_ENUM_VALUE, ValaEnumValue);
		_tmp20_ = dummy;
		if (_tmp20_ != NULL) {
			ValaEnum* _tmp21_ = NULL;
			ValaList* _tmp22_ = NULL;
			ValaList* _tmp23_ = NULL;
			ValaEnumValue* _tmp24_ = NULL;
			ValaEnum* _tmp25_ = NULL;
			ValaScope* _tmp26_ = NULL;
			ValaScope* _tmp27_ = NULL;
			_tmp21_ = en;
			_tmp22_ = vala_enum_get_values (_tmp21_);
			_tmp23_ = _tmp22_;
			_tmp24_ = dummy;
			vala_collection_remove ((ValaCollection*) _tmp23_, _tmp24_);
			_vala_iterable_unref0 (_tmp23_);
			_tmp25_ = en;
			_tmp26_ = vala_symbol_get_scope ((ValaSymbol*) _tmp25_);
			_tmp27_ = _tmp26_;
			vala_scope_remove (_tmp27_, "__DUMMY__");
		}
		_vala_code_node_unref0 (dummy);
	}
	_tmp29_ = en_node;
	_tmp30_ = _tmp29_->gtype_name;
	if (_tmp30_ == NULL) {
		_tmp28_ = TRUE;
	} else {
		GIdlNodeEnum* _tmp31_ = NULL;
		const gchar* _tmp32_ = NULL;
		_tmp31_ = en_node;
		_tmp32_ = _tmp31_->gtype_name;
		_tmp28_ = g_strcmp0 (_tmp32_, "") == 0;
	}
	_tmp33_ = _tmp28_;
	if (_tmp33_) {
		ValaEnum* _tmp34_ = NULL;
		_tmp34_ = en;
		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp34_, "CCode", "has_type_id", FALSE, NULL);
	}
	common_prefix = NULL;
	_tmp35_ = en_node;
	_tmp36_ = _tmp35_->values;
	{
		GList* value_collection = NULL;
		GList* value_it = NULL;
		value_collection = _tmp36_;
		for (value_it = value_collection; value_it != NULL; value_it = value_it->next) {
			GIdlNode* value = NULL;
			value = (GIdlNode*) value_it->data;
			{
				gchar** val_attributes = NULL;
				GIdlNode* _tmp37_ = NULL;
				const gchar* _tmp38_ = NULL;
				gint _tmp39_ = 0;
				gchar** _tmp40_ = NULL;
				gint val_attributes_length1 = 0;
				gint _val_attributes_size_ = 0;
				gboolean is_hidden = FALSE;
				gchar** _tmp41_ = NULL;
				gint _tmp41__length1 = 0;
				gboolean _tmp55_ = FALSE;
				const gchar* _tmp56_ = NULL;
				_tmp37_ = value;
				_tmp38_ = _tmp37_->name;
				_tmp40_ = vala_gidl_parser_get_attributes (self, _tmp38_, &_tmp39_);
				val_attributes = _tmp40_;
				val_attributes_length1 = _tmp39_;
				_val_attributes_size_ = val_attributes_length1;
				is_hidden = FALSE;
				_tmp41_ = val_attributes;
				_tmp41__length1 = val_attributes_length1;
				if (_tmp41_ != NULL) {
					gchar** _tmp42_ = NULL;
					gint _tmp42__length1 = 0;
					_tmp42_ = val_attributes;
					_tmp42__length1 = val_attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp42_;
						attr_collection_length1 = _tmp42__length1;
						for (attr_it = 0; attr_it < _tmp42__length1; attr_it = attr_it + 1) {
							gchar* _tmp43_ = NULL;
							gchar* attr = NULL;
							_tmp43_ = g_strdup (attr_collection[attr_it]);
							attr = _tmp43_;
							{
								gchar** nv = NULL;
								const gchar* _tmp44_ = NULL;
								gchar** _tmp45_ = NULL;
								gchar** _tmp46_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gboolean _tmp47_ = FALSE;
								gchar** _tmp48_ = NULL;
								gint _tmp48__length1 = 0;
								const gchar* _tmp49_ = NULL;
								gboolean _tmp54_ = FALSE;
								_tmp44_ = attr;
								_tmp46_ = _tmp45_ = g_strsplit (_tmp44_, "=", 2);
								nv = _tmp46_;
								nv_length1 = _vala_array_length (_tmp45_);
								_nv_size_ = nv_length1;
								_tmp48_ = nv;
								_tmp48__length1 = nv_length1;
								_tmp49_ = _tmp48_[0];
								if (g_strcmp0 (_tmp49_, "hidden") == 0) {
									gchar** _tmp50_ = NULL;
									gint _tmp50__length1 = 0;
									const gchar* _tmp51_ = NULL;
									gchar* _tmp52_ = NULL;
									gchar* _tmp53_ = NULL;
									_tmp50_ = nv;
									_tmp50__length1 = nv_length1;
									_tmp51_ = _tmp50_[1];
									_tmp52_ = vala_gidl_parser_eval (self, _tmp51_);
									_tmp53_ = _tmp52_;
									_tmp47_ = g_strcmp0 (_tmp53_, "1") == 0;
									_g_free0 (_tmp53_);
								} else {
									_tmp47_ = FALSE;
								}
								_tmp54_ = _tmp47_;
								if (_tmp54_) {
									is_hidden = TRUE;
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
							}
						}
					}
				}
				_tmp55_ = is_hidden;
				if (_tmp55_) {
					val_attributes = (_vala_array_free (val_attributes, val_attributes_length1, (GDestroyNotify) g_free), NULL);
					continue;
				}
				_tmp56_ = common_prefix;
				if (_tmp56_ == NULL) {
					GIdlNode* _tmp57_ = NULL;
					const gchar* _tmp58_ = NULL;
					gchar* _tmp59_ = NULL;
					_tmp57_ = value;
					_tmp58_ = _tmp57_->name;
					_tmp59_ = g_strdup (_tmp58_);
					_g_free0 (common_prefix);
					common_prefix = _tmp59_;
					while (TRUE) {
						gboolean _tmp60_ = FALSE;
						const gchar* _tmp61_ = NULL;
						gint _tmp62_ = 0;
						gint _tmp63_ = 0;
						gboolean _tmp66_ = FALSE;
						const gchar* _tmp67_ = NULL;
						const gchar* _tmp68_ = NULL;
						gint _tmp69_ = 0;
						gint _tmp70_ = 0;
						gchar* _tmp71_ = NULL;
						_tmp61_ = common_prefix;
						_tmp62_ = strlen (_tmp61_);
						_tmp63_ = _tmp62_;
						if (_tmp63_ > 0) {
							const gchar* _tmp64_ = NULL;
							gboolean _tmp65_ = FALSE;
							_tmp64_ = common_prefix;
							_tmp65_ = g_str_has_suffix (_tmp64_, "_");
							_tmp60_ = !_tmp65_;
						} else {
							_tmp60_ = FALSE;
						}
						_tmp66_ = _tmp60_;
						if (!_tmp66_) {
							break;
						}
						_tmp67_ = common_prefix;
						_tmp68_ = common_prefix;
						_tmp69_ = strlen (_tmp68_);
						_tmp70_ = _tmp69_;
						_tmp71_ = string_substring (_tmp67_, (glong) 0, (glong) (_tmp70_ - 1));
						_g_free0 (common_prefix);
						common_prefix = _tmp71_;
					}
				} else {
					while (TRUE) {
						GIdlNode* _tmp72_ = NULL;
						const gchar* _tmp73_ = NULL;
						const gchar* _tmp74_ = NULL;
						gboolean _tmp75_ = FALSE;
						const gchar* _tmp76_ = NULL;
						const gchar* _tmp77_ = NULL;
						gint _tmp78_ = 0;
						gint _tmp79_ = 0;
						gchar* _tmp80_ = NULL;
						_tmp72_ = value;
						_tmp73_ = _tmp72_->name;
						_tmp74_ = common_prefix;
						_tmp75_ = g_str_has_prefix (_tmp73_, _tmp74_);
						if (!(!_tmp75_)) {
							break;
						}
						_tmp76_ = common_prefix;
						_tmp77_ = common_prefix;
						_tmp78_ = strlen (_tmp77_);
						_tmp79_ = _tmp78_;
						_tmp80_ = string_substring (_tmp76_, (glong) 0, (glong) (_tmp79_ - 1));
						_g_free0 (common_prefix);
						common_prefix = _tmp80_;
					}
				}
				while (TRUE) {
					gboolean _tmp81_ = FALSE;
					const gchar* _tmp82_ = NULL;
					gint _tmp83_ = 0;
					gint _tmp84_ = 0;
					gboolean _tmp105_ = FALSE;
					const gchar* _tmp106_ = NULL;
					const gchar* _tmp107_ = NULL;
					gint _tmp108_ = 0;
					gint _tmp109_ = 0;
					gchar* _tmp110_ = NULL;
					_tmp82_ = common_prefix;
					_tmp83_ = strlen (_tmp82_);
					_tmp84_ = _tmp83_;
					if (_tmp84_ > 0) {
						gboolean _tmp85_ = FALSE;
						const gchar* _tmp86_ = NULL;
						gboolean _tmp87_ = FALSE;
						gboolean _tmp104_ = FALSE;
						_tmp86_ = common_prefix;
						_tmp87_ = g_str_has_suffix (_tmp86_, "_");
						if (!_tmp87_) {
							_tmp85_ = TRUE;
						} else {
							gboolean _tmp88_ = FALSE;
							GIdlNode* _tmp89_ = NULL;
							const gchar* _tmp90_ = NULL;
							const gchar* _tmp91_ = NULL;
							gint _tmp92_ = 0;
							gint _tmp93_ = 0;
							gunichar _tmp94_ = 0U;
							gboolean _tmp95_ = FALSE;
							gboolean _tmp103_ = FALSE;
							_tmp89_ = value;
							_tmp90_ = _tmp89_->name;
							_tmp91_ = common_prefix;
							_tmp92_ = strlen (_tmp91_);
							_tmp93_ = _tmp92_;
							_tmp94_ = string_get_char (_tmp90_, (glong) _tmp93_);
							_tmp95_ = g_unichar_isdigit (_tmp94_);
							if (_tmp95_) {
								GIdlNode* _tmp96_ = NULL;
								const gchar* _tmp97_ = NULL;
								gint _tmp98_ = 0;
								gint _tmp99_ = 0;
								const gchar* _tmp100_ = NULL;
								gint _tmp101_ = 0;
								gint _tmp102_ = 0;
								_tmp96_ = value;
								_tmp97_ = _tmp96_->name;
								_tmp98_ = strlen (_tmp97_);
								_tmp99_ = _tmp98_;
								_tmp100_ = common_prefix;
								_tmp101_ = strlen (_tmp100_);
								_tmp102_ = _tmp101_;
								_tmp88_ = (_tmp99_ - _tmp102_) <= 1;
							} else {
								_tmp88_ = FALSE;
							}
							_tmp103_ = _tmp88_;
							_tmp85_ = _tmp103_;
						}
						_tmp104_ = _tmp85_;
						_tmp81_ = _tmp104_;
					} else {
						_tmp81_ = FALSE;
					}
					_tmp105_ = _tmp81_;
					if (!_tmp105_) {
						break;
					}
					_tmp106_ = common_prefix;
					_tmp107_ = common_prefix;
					_tmp108_ = strlen (_tmp107_);
					_tmp109_ = _tmp108_;
					_tmp110_ = string_substring (_tmp106_, (glong) 0, (glong) (_tmp109_ - 1));
					_g_free0 (common_prefix);
					common_prefix = _tmp110_;
				}
				val_attributes = (_vala_array_free (val_attributes, val_attributes_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	is_errordomain = FALSE;
	cheader_filename = NULL;
	_tmp111_ = node;
	_tmp112_ = _tmp111_->name;
	_tmp114_ = vala_gidl_parser_get_attributes (self, _tmp112_, &_tmp113_);
	en_attributes = _tmp114_;
	en_attributes_length1 = _tmp113_;
	_en_attributes_size_ = en_attributes_length1;
	_tmp115_ = en_attributes;
	_tmp115__length1 = en_attributes_length1;
	if (_tmp115_ != NULL) {
		gchar** _tmp116_ = NULL;
		gint _tmp116__length1 = 0;
		_tmp116_ = en_attributes;
		_tmp116__length1 = en_attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp116_;
			attr_collection_length1 = _tmp116__length1;
			for (attr_it = 0; attr_it < _tmp116__length1; attr_it = attr_it + 1) {
				gchar* _tmp117_ = NULL;
				gchar* attr = NULL;
				_tmp117_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp117_;
				{
					gchar** nv = NULL;
					const gchar* _tmp118_ = NULL;
					gchar** _tmp119_ = NULL;
					gchar** _tmp120_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp121_ = NULL;
					gint _tmp121__length1 = 0;
					const gchar* _tmp122_ = NULL;
					_tmp118_ = attr;
					_tmp120_ = _tmp119_ = g_strsplit (_tmp118_, "=", 2);
					nv = _tmp120_;
					nv_length1 = _vala_array_length (_tmp119_);
					_nv_size_ = nv_length1;
					_tmp121_ = nv;
					_tmp121__length1 = nv_length1;
					_tmp122_ = _tmp121_[0];
					if (g_strcmp0 (_tmp122_, "common_prefix") == 0) {
						gchar** _tmp123_ = NULL;
						gint _tmp123__length1 = 0;
						const gchar* _tmp124_ = NULL;
						gchar* _tmp125_ = NULL;
						_tmp123_ = nv;
						_tmp123__length1 = nv_length1;
						_tmp124_ = _tmp123_[1];
						_tmp125_ = vala_gidl_parser_eval (self, _tmp124_);
						_g_free0 (common_prefix);
						common_prefix = _tmp125_;
					} else {
						gchar** _tmp126_ = NULL;
						gint _tmp126__length1 = 0;
						const gchar* _tmp127_ = NULL;
						_tmp126_ = nv;
						_tmp126__length1 = nv_length1;
						_tmp127_ = _tmp126_[0];
						if (g_strcmp0 (_tmp127_, "cheader_filename") == 0) {
							gchar** _tmp128_ = NULL;
							gint _tmp128__length1 = 0;
							const gchar* _tmp129_ = NULL;
							gchar* _tmp130_ = NULL;
							ValaEnum* _tmp131_ = NULL;
							const gchar* _tmp132_ = NULL;
							_tmp128_ = nv;
							_tmp128__length1 = nv_length1;
							_tmp129_ = _tmp128_[1];
							_tmp130_ = vala_gidl_parser_eval (self, _tmp129_);
							_g_free0 (cheader_filename);
							cheader_filename = _tmp130_;
							_tmp131_ = en;
							_tmp132_ = cheader_filename;
							vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp131_, "CCode", "cheader_filename", _tmp132_, NULL);
						} else {
							gchar** _tmp133_ = NULL;
							gint _tmp133__length1 = 0;
							const gchar* _tmp134_ = NULL;
							_tmp133_ = nv;
							_tmp133__length1 = nv_length1;
							_tmp134_ = _tmp133_[0];
							if (g_strcmp0 (_tmp134_, "hidden") == 0) {
								gchar** _tmp135_ = NULL;
								gint _tmp135__length1 = 0;
								const gchar* _tmp136_ = NULL;
								gchar* _tmp137_ = NULL;
								gchar* _tmp138_ = NULL;
								gboolean _tmp139_ = FALSE;
								_tmp135_ = nv;
								_tmp135__length1 = nv_length1;
								_tmp136_ = _tmp135_[1];
								_tmp137_ = vala_gidl_parser_eval (self, _tmp136_);
								_tmp138_ = _tmp137_;
								_tmp139_ = g_strcmp0 (_tmp138_, "1") == 0;
								_g_free0 (_tmp138_);
								if (_tmp139_) {
									nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (attr);
									en_attributes = (_vala_array_free (en_attributes, en_attributes_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (cheader_filename);
									_g_free0 (common_prefix);
									_vala_code_node_unref0 (en);
									_g_free0 (name);
									return;
								}
							} else {
								gchar** _tmp140_ = NULL;
								gint _tmp140__length1 = 0;
								const gchar* _tmp141_ = NULL;
								_tmp140_ = nv;
								_tmp140__length1 = nv_length1;
								_tmp141_ = _tmp140_[0];
								if (g_strcmp0 (_tmp141_, "deprecated") == 0) {
									gchar** _tmp142_ = NULL;
									gint _tmp142__length1 = 0;
									const gchar* _tmp143_ = NULL;
									gchar* _tmp144_ = NULL;
									gchar* _tmp145_ = NULL;
									gboolean _tmp146_ = FALSE;
									_tmp142_ = nv;
									_tmp142__length1 = nv_length1;
									_tmp143_ = _tmp142_[1];
									_tmp144_ = vala_gidl_parser_eval (self, _tmp143_);
									_tmp145_ = _tmp144_;
									_tmp146_ = g_strcmp0 (_tmp145_, "1") == 0;
									_g_free0 (_tmp145_);
									if (_tmp146_) {
										ValaEnum* _tmp147_ = NULL;
										_tmp147_ = en;
										vala_code_node_set_attribute ((ValaCodeNode*) _tmp147_, "Deprecated", TRUE, NULL);
									}
								} else {
									gchar** _tmp148_ = NULL;
									gint _tmp148__length1 = 0;
									const gchar* _tmp149_ = NULL;
									_tmp148_ = nv;
									_tmp148__length1 = nv_length1;
									_tmp149_ = _tmp148_[0];
									if (g_strcmp0 (_tmp149_, "default_value") == 0) {
										ValaEnum* _tmp150_ = NULL;
										gchar** _tmp151_ = NULL;
										gint _tmp151__length1 = 0;
										const gchar* _tmp152_ = NULL;
										gchar* _tmp153_ = NULL;
										gchar* _tmp154_ = NULL;
										_tmp150_ = en;
										_tmp151_ = nv;
										_tmp151__length1 = nv_length1;
										_tmp152_ = _tmp151_[1];
										_tmp153_ = vala_gidl_parser_eval (self, _tmp152_);
										_tmp154_ = _tmp153_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp150_, "CCode", "default_value", _tmp154_, NULL);
										_g_free0 (_tmp154_);
									} else {
										gchar** _tmp155_ = NULL;
										gint _tmp155__length1 = 0;
										const gchar* _tmp156_ = NULL;
										_tmp155_ = nv;
										_tmp155__length1 = nv_length1;
										_tmp156_ = _tmp155_[0];
										if (g_strcmp0 (_tmp156_, "replacement") == 0) {
											ValaEnum* _tmp157_ = NULL;
											gchar** _tmp158_ = NULL;
											gint _tmp158__length1 = 0;
											const gchar* _tmp159_ = NULL;
											gchar* _tmp160_ = NULL;
											gchar* _tmp161_ = NULL;
											_tmp157_ = en;
											_tmp158_ = nv;
											_tmp158__length1 = nv_length1;
											_tmp159_ = _tmp158_[1];
											_tmp160_ = vala_gidl_parser_eval (self, _tmp159_);
											_tmp161_ = _tmp160_;
											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp157_, "Deprecated", "replacement", _tmp161_, NULL);
											_g_free0 (_tmp161_);
										} else {
											gchar** _tmp162_ = NULL;
											gint _tmp162__length1 = 0;
											const gchar* _tmp163_ = NULL;
											_tmp162_ = nv;
											_tmp162__length1 = nv_length1;
											_tmp163_ = _tmp162_[0];
											if (g_strcmp0 (_tmp163_, "deprecated_since") == 0) {
												ValaEnum* _tmp164_ = NULL;
												gchar** _tmp165_ = NULL;
												gint _tmp165__length1 = 0;
												const gchar* _tmp166_ = NULL;
												gchar* _tmp167_ = NULL;
												gchar* _tmp168_ = NULL;
												_tmp164_ = en;
												_tmp165_ = nv;
												_tmp165__length1 = nv_length1;
												_tmp166_ = _tmp165_[1];
												_tmp167_ = vala_gidl_parser_eval (self, _tmp166_);
												_tmp168_ = _tmp167_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp164_, "Deprecated", "since", _tmp168_, NULL);
												_g_free0 (_tmp168_);
											} else {
												gchar** _tmp169_ = NULL;
												gint _tmp169__length1 = 0;
												const gchar* _tmp170_ = NULL;
												_tmp169_ = nv;
												_tmp169__length1 = nv_length1;
												_tmp170_ = _tmp169_[0];
												if (g_strcmp0 (_tmp170_, "rename_to") == 0) {
													ValaEnum* _tmp171_ = NULL;
													gchar** _tmp172_ = NULL;
													gint _tmp172__length1 = 0;
													const gchar* _tmp173_ = NULL;
													gchar* _tmp174_ = NULL;
													gchar* _tmp175_ = NULL;
													_tmp171_ = en;
													_tmp172_ = nv;
													_tmp172__length1 = nv_length1;
													_tmp173_ = _tmp172_[1];
													_tmp174_ = vala_gidl_parser_eval (self, _tmp173_);
													_tmp175_ = _tmp174_;
													vala_symbol_set_name ((ValaSymbol*) _tmp171_, _tmp175_);
													_g_free0 (_tmp175_);
												} else {
													gchar** _tmp176_ = NULL;
													gint _tmp176__length1 = 0;
													const gchar* _tmp177_ = NULL;
													_tmp176_ = nv;
													_tmp176__length1 = nv_length1;
													_tmp177_ = _tmp176_[0];
													if (g_strcmp0 (_tmp177_, "errordomain") == 0) {
														gchar** _tmp178_ = NULL;
														gint _tmp178__length1 = 0;
														const gchar* _tmp179_ = NULL;
														gchar* _tmp180_ = NULL;
														gchar* _tmp181_ = NULL;
														gboolean _tmp182_ = FALSE;
														_tmp178_ = nv;
														_tmp178__length1 = nv_length1;
														_tmp179_ = _tmp178_[1];
														_tmp180_ = vala_gidl_parser_eval (self, _tmp179_);
														_tmp181_ = _tmp180_;
														_tmp182_ = g_strcmp0 (_tmp181_, "1") == 0;
														_g_free0 (_tmp181_);
														if (_tmp182_) {
															is_errordomain = TRUE;
														}
													} else {
														gchar** _tmp183_ = NULL;
														gint _tmp183__length1 = 0;
														const gchar* _tmp184_ = NULL;
														_tmp183_ = nv;
														_tmp183__length1 = nv_length1;
														_tmp184_ = _tmp183_[0];
														if (g_strcmp0 (_tmp184_, "to_string") == 0) {
															ValaUnresolvedType* return_type = NULL;
															ValaUnresolvedType* _tmp185_ = NULL;
															ValaUnresolvedType* _tmp186_ = NULL;
															ValaUnresolvedSymbol* _tmp187_ = NULL;
															ValaUnresolvedSymbol* _tmp188_ = NULL;
															ValaUnresolvedType* _tmp189_ = NULL;
															ValaMethod* m = NULL;
															ValaUnresolvedType* _tmp190_ = NULL;
															ValaSourceReference* _tmp191_ = NULL;
															ValaMethod* _tmp192_ = NULL;
															ValaMethod* _tmp193_ = NULL;
															ValaMethod* _tmp194_ = NULL;
															gchar** _tmp195_ = NULL;
															gint _tmp195__length1 = 0;
															const gchar* _tmp196_ = NULL;
															gchar* _tmp197_ = NULL;
															gchar* _tmp198_ = NULL;
															ValaEnum* _tmp199_ = NULL;
															ValaMethod* _tmp200_ = NULL;
															_tmp185_ = vala_unresolved_type_new ();
															return_type = _tmp185_;
															_tmp186_ = return_type;
															_tmp187_ = vala_unresolved_symbol_new (NULL, "string", NULL);
															_tmp188_ = _tmp187_;
															vala_unresolved_type_set_unresolved_symbol (_tmp186_, _tmp188_);
															_vala_code_node_unref0 (_tmp188_);
															_tmp189_ = return_type;
															vala_data_type_set_value_owned ((ValaDataType*) _tmp189_, FALSE);
															_tmp190_ = return_type;
															_tmp191_ = self->priv->current_source_reference;
															_tmp192_ = vala_method_new ("to_string", (ValaDataType*) _tmp190_, _tmp191_, NULL);
															m = _tmp192_;
															_tmp193_ = m;
															vala_symbol_set_access ((ValaSymbol*) _tmp193_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
															_tmp194_ = m;
															_tmp195_ = nv;
															_tmp195__length1 = nv_length1;
															_tmp196_ = _tmp195_[1];
															_tmp197_ = vala_gidl_parser_eval (self, _tmp196_);
															_tmp198_ = _tmp197_;
															vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp194_, "CCode", "cname", _tmp198_, NULL);
															_g_free0 (_tmp198_);
															_tmp199_ = en;
															_tmp200_ = m;
															vala_symbol_add_method ((ValaSymbol*) _tmp199_, _tmp200_);
															_vala_code_node_unref0 (m);
															_vala_code_node_unref0 (return_type);
														} else {
															gchar** _tmp201_ = NULL;
															gint _tmp201__length1 = 0;
															const gchar* _tmp202_ = NULL;
															_tmp201_ = nv;
															_tmp201__length1 = nv_length1;
															_tmp202_ = _tmp201_[0];
															if (g_strcmp0 (_tmp202_, "experimental") == 0) {
																gchar** _tmp203_ = NULL;
																gint _tmp203__length1 = 0;
																const gchar* _tmp204_ = NULL;
																gchar* _tmp205_ = NULL;
																gchar* _tmp206_ = NULL;
																gboolean _tmp207_ = FALSE;
																_tmp203_ = nv;
																_tmp203__length1 = nv_length1;
																_tmp204_ = _tmp203_[1];
																_tmp205_ = vala_gidl_parser_eval (self, _tmp204_);
																_tmp206_ = _tmp205_;
																_tmp207_ = g_strcmp0 (_tmp206_, "1") == 0;
																_g_free0 (_tmp206_);
																if (_tmp207_) {
																	ValaEnum* _tmp208_ = NULL;
																	_tmp208_ = en;
																	vala_code_node_set_attribute ((ValaCodeNode*) _tmp208_, "Experimental", TRUE, NULL);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp209_ = en;
	_tmp210_ = common_prefix;
	vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp209_, "CCode", "cprefix", _tmp210_, NULL);
	_tmp211_ = en_node;
	_tmp212_ = _tmp211_->values;
	{
		GList* value2_collection = NULL;
		GList* value2_it = NULL;
		value2_collection = _tmp212_;
		for (value2_it = value2_collection; value2_it != NULL; value2_it = value2_it->next) {
			GIdlNode* value2 = NULL;
			value2 = (GIdlNode*) value2_it->data;
			{
				ValaEnumValue* ev = NULL;
				GIdlNode* _tmp213_ = NULL;
				const gchar* _tmp214_ = NULL;
				const gchar* _tmp215_ = NULL;
				gint _tmp216_ = 0;
				gint _tmp217_ = 0;
				gchar* _tmp218_ = NULL;
				gchar* _tmp219_ = NULL;
				ValaEnumValue* _tmp220_ = NULL;
				ValaEnumValue* _tmp221_ = NULL;
				gchar** val_attributes = NULL;
				GIdlNode* _tmp222_ = NULL;
				const gchar* _tmp223_ = NULL;
				gint _tmp224_ = 0;
				gchar** _tmp225_ = NULL;
				gint val_attributes_length1 = 0;
				gint _val_attributes_size_ = 0;
				gboolean is_hidden = FALSE;
				gchar** _tmp226_ = NULL;
				gint _tmp226__length1 = 0;
				gboolean _tmp262_ = FALSE;
				_tmp213_ = value2;
				_tmp214_ = _tmp213_->name;
				_tmp215_ = common_prefix;
				_tmp216_ = strlen (_tmp215_);
				_tmp217_ = _tmp216_;
				_tmp218_ = string_substring (_tmp214_, (glong) _tmp217_, (glong) (-1));
				_tmp219_ = _tmp218_;
				_tmp220_ = vala_enum_value_new (_tmp219_, NULL, NULL, NULL);
				_tmp221_ = _tmp220_;
				_g_free0 (_tmp219_);
				ev = _tmp221_;
				_tmp222_ = value2;
				_tmp223_ = _tmp222_->name;
				_tmp225_ = vala_gidl_parser_get_attributes (self, _tmp223_, &_tmp224_);
				val_attributes = _tmp225_;
				val_attributes_length1 = _tmp224_;
				_val_attributes_size_ = val_attributes_length1;
				is_hidden = FALSE;
				_tmp226_ = val_attributes;
				_tmp226__length1 = val_attributes_length1;
				if (_tmp226_ != NULL) {
					gchar** _tmp227_ = NULL;
					gint _tmp227__length1 = 0;
					_tmp227_ = val_attributes;
					_tmp227__length1 = val_attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp227_;
						attr_collection_length1 = _tmp227__length1;
						for (attr_it = 0; attr_it < _tmp227__length1; attr_it = attr_it + 1) {
							gchar* _tmp228_ = NULL;
							gchar* attr = NULL;
							_tmp228_ = g_strdup (attr_collection[attr_it]);
							attr = _tmp228_;
							{
								gchar** nv = NULL;
								const gchar* _tmp229_ = NULL;
								gchar** _tmp230_ = NULL;
								gchar** _tmp231_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gboolean _tmp232_ = FALSE;
								gchar** _tmp233_ = NULL;
								gint _tmp233__length1 = 0;
								const gchar* _tmp234_ = NULL;
								gboolean _tmp239_ = FALSE;
								_tmp229_ = attr;
								_tmp231_ = _tmp230_ = g_strsplit (_tmp229_, "=", 2);
								nv = _tmp231_;
								nv_length1 = _vala_array_length (_tmp230_);
								_nv_size_ = nv_length1;
								_tmp233_ = nv;
								_tmp233__length1 = nv_length1;
								_tmp234_ = _tmp233_[0];
								if (g_strcmp0 (_tmp234_, "hidden") == 0) {
									gchar** _tmp235_ = NULL;
									gint _tmp235__length1 = 0;
									const gchar* _tmp236_ = NULL;
									gchar* _tmp237_ = NULL;
									gchar* _tmp238_ = NULL;
									_tmp235_ = nv;
									_tmp235__length1 = nv_length1;
									_tmp236_ = _tmp235_[1];
									_tmp237_ = vala_gidl_parser_eval (self, _tmp236_);
									_tmp238_ = _tmp237_;
									_tmp232_ = g_strcmp0 (_tmp238_, "1") == 0;
									_g_free0 (_tmp238_);
								} else {
									_tmp232_ = FALSE;
								}
								_tmp239_ = _tmp232_;
								if (_tmp239_) {
									is_hidden = TRUE;
								} else {
									gchar** _tmp240_ = NULL;
									gint _tmp240__length1 = 0;
									const gchar* _tmp241_ = NULL;
									_tmp240_ = nv;
									_tmp240__length1 = nv_length1;
									_tmp241_ = _tmp240_[0];
									if (g_strcmp0 (_tmp241_, "deprecated") == 0) {
										gchar** _tmp242_ = NULL;
										gint _tmp242__length1 = 0;
										const gchar* _tmp243_ = NULL;
										gchar* _tmp244_ = NULL;
										gchar* _tmp245_ = NULL;
										gboolean _tmp246_ = FALSE;
										_tmp242_ = nv;
										_tmp242__length1 = nv_length1;
										_tmp243_ = _tmp242_[1];
										_tmp244_ = vala_gidl_parser_eval (self, _tmp243_);
										_tmp245_ = _tmp244_;
										_tmp246_ = g_strcmp0 (_tmp245_, "1") == 0;
										_g_free0 (_tmp245_);
										if (_tmp246_) {
											ValaEnumValue* _tmp247_ = NULL;
											_tmp247_ = ev;
											vala_code_node_set_attribute ((ValaCodeNode*) _tmp247_, "Deprecated", TRUE, NULL);
										}
									} else {
										gchar** _tmp248_ = NULL;
										gint _tmp248__length1 = 0;
										const gchar* _tmp249_ = NULL;
										_tmp248_ = nv;
										_tmp248__length1 = nv_length1;
										_tmp249_ = _tmp248_[0];
										if (g_strcmp0 (_tmp249_, "replacement") == 0) {
											ValaEnumValue* _tmp250_ = NULL;
											gchar** _tmp251_ = NULL;
											gint _tmp251__length1 = 0;
											const gchar* _tmp252_ = NULL;
											gchar* _tmp253_ = NULL;
											gchar* _tmp254_ = NULL;
											_tmp250_ = ev;
											_tmp251_ = nv;
											_tmp251__length1 = nv_length1;
											_tmp252_ = _tmp251_[1];
											_tmp253_ = vala_gidl_parser_eval (self, _tmp252_);
											_tmp254_ = _tmp253_;
											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp250_, "Deprecated", "replacement", _tmp254_, NULL);
											_g_free0 (_tmp254_);
										} else {
											gchar** _tmp255_ = NULL;
											gint _tmp255__length1 = 0;
											const gchar* _tmp256_ = NULL;
											_tmp255_ = nv;
											_tmp255__length1 = nv_length1;
											_tmp256_ = _tmp255_[0];
											if (g_strcmp0 (_tmp256_, "deprecated_since") == 0) {
												ValaEnumValue* _tmp257_ = NULL;
												gchar** _tmp258_ = NULL;
												gint _tmp258__length1 = 0;
												const gchar* _tmp259_ = NULL;
												gchar* _tmp260_ = NULL;
												gchar* _tmp261_ = NULL;
												_tmp257_ = ev;
												_tmp258_ = nv;
												_tmp258__length1 = nv_length1;
												_tmp259_ = _tmp258_[1];
												_tmp260_ = vala_gidl_parser_eval (self, _tmp259_);
												_tmp261_ = _tmp260_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp257_, "Deprecated", "since", _tmp261_, NULL);
												_g_free0 (_tmp261_);
											}
										}
									}
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
							}
						}
					}
				}
				_tmp262_ = is_hidden;
				if (!_tmp262_) {
					ValaEnum* _tmp263_ = NULL;
					ValaEnumValue* _tmp264_ = NULL;
					_tmp263_ = en;
					_tmp264_ = ev;
					vala_enum_add_value (_tmp263_, _tmp264_);
				}
				val_attributes = (_vala_array_free (val_attributes, val_attributes_length1, (GDestroyNotify) g_free), NULL);
				_vala_code_node_unref0 (ev);
			}
		}
	}
	_tmp265_ = is_errordomain;
	if (_tmp265_) {
		ValaErrorDomain* ed = NULL;
		ValaEnum* _tmp266_ = NULL;
		const gchar* _tmp267_ = NULL;
		const gchar* _tmp268_ = NULL;
		ValaSourceReference* _tmp269_ = NULL;
		ValaErrorDomain* _tmp270_ = NULL;
		ValaErrorDomain* _tmp271_ = NULL;
		ValaErrorDomain* _tmp272_ = NULL;
		const gchar* _tmp273_ = NULL;
		const gchar* _tmp274_ = NULL;
		ValaSourceFile* _tmp294_ = NULL;
		ValaErrorDomain* _tmp295_ = NULL;
		gboolean _tmp296_ = FALSE;
		_tmp266_ = en;
		_tmp267_ = vala_symbol_get_name ((ValaSymbol*) _tmp266_);
		_tmp268_ = _tmp267_;
		_tmp269_ = self->priv->current_source_reference;
		_tmp270_ = vala_error_domain_new (_tmp268_, _tmp269_, NULL);
		ed = _tmp270_;
		_tmp271_ = ed;
		vala_symbol_set_access ((ValaSymbol*) _tmp271_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		_tmp272_ = ed;
		_tmp273_ = common_prefix;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp272_, "CCode", "cprefix", _tmp273_, NULL);
		_tmp274_ = cheader_filename;
		if (_tmp274_ != NULL) {
			ValaErrorDomain* _tmp275_ = NULL;
			const gchar* _tmp276_ = NULL;
			_tmp275_ = ed;
			_tmp276_ = cheader_filename;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp275_, "CCode", "cheader_filename", _tmp276_, NULL);
		}
		{
			ValaList* _ev_list = NULL;
			ValaEnum* _tmp277_ = NULL;
			ValaList* _tmp278_ = NULL;
			gint _ev_size = 0;
			ValaList* _tmp279_ = NULL;
			gint _tmp280_ = 0;
			gint _tmp281_ = 0;
			gint _ev_index = 0;
			_tmp277_ = en;
			_tmp278_ = vala_enum_get_values (_tmp277_);
			_ev_list = _tmp278_;
			_tmp279_ = _ev_list;
			_tmp280_ = vala_collection_get_size ((ValaCollection*) _tmp279_);
			_tmp281_ = _tmp280_;
			_ev_size = _tmp281_;
			_ev_index = -1;
			while (TRUE) {
				gint _tmp282_ = 0;
				gint _tmp283_ = 0;
				gint _tmp284_ = 0;
				ValaEnumValue* ev = NULL;
				ValaList* _tmp285_ = NULL;
				gint _tmp286_ = 0;
				gpointer _tmp287_ = NULL;
				ValaErrorDomain* _tmp288_ = NULL;
				ValaEnumValue* _tmp289_ = NULL;
				const gchar* _tmp290_ = NULL;
				const gchar* _tmp291_ = NULL;
				ValaErrorCode* _tmp292_ = NULL;
				ValaErrorCode* _tmp293_ = NULL;
				_tmp282_ = _ev_index;
				_ev_index = _tmp282_ + 1;
				_tmp283_ = _ev_index;
				_tmp284_ = _ev_size;
				if (!(_tmp283_ < _tmp284_)) {
					break;
				}
				_tmp285_ = _ev_list;
				_tmp286_ = _ev_index;
				_tmp287_ = vala_list_get (_tmp285_, _tmp286_);
				ev = (ValaEnumValue*) _tmp287_;
				_tmp288_ = ed;
				_tmp289_ = ev;
				_tmp290_ = vala_symbol_get_name ((ValaSymbol*) _tmp289_);
				_tmp291_ = _tmp290_;
				_tmp292_ = vala_error_code_new (_tmp291_, NULL, NULL);
				_tmp293_ = _tmp292_;
				vala_error_domain_add_code (_tmp288_, _tmp293_);
				_vala_code_node_unref0 (_tmp293_);
				_vala_code_node_unref0 (ev);
			}
			_vala_iterable_unref0 (_ev_list);
		}
		_tmp294_ = self->priv->current_source_file;
		_tmp295_ = ed;
		vala_source_file_add_node (_tmp294_, (ValaCodeNode*) _tmp295_);
		_tmp296_ = existing;
		if (!_tmp296_) {
			ValaSymbol* _tmp297_ = NULL;
			ValaErrorDomain* _tmp298_ = NULL;
			_tmp297_ = container;
			_tmp298_ = ed;
			vala_gidl_parser_add_symbol_to_container (self, _tmp297_, (ValaSymbol*) _tmp298_);
		}
		_vala_code_node_unref0 (ed);
	} else {
		ValaEnum* _tmp299_ = NULL;
		gboolean _tmp300_ = FALSE;
		ValaSourceFile* _tmp301_ = NULL;
		ValaEnum* _tmp302_ = NULL;
		gboolean _tmp303_ = FALSE;
		_tmp299_ = en;
		_tmp300_ = is_flags;
		vala_code_node_set_attribute ((ValaCodeNode*) _tmp299_, "Flags", _tmp300_, NULL);
		_tmp301_ = self->priv->current_source_file;
		_tmp302_ = en;
		vala_source_file_add_node (_tmp301_, (ValaCodeNode*) _tmp302_);
		_tmp303_ = existing;
		if (!_tmp303_) {
			ValaSymbol* _tmp304_ = NULL;
			ValaEnum* _tmp305_ = NULL;
			_tmp304_ = container;
			_tmp305_ = en;
			vala_gidl_parser_add_symbol_to_container (self, _tmp304_, (ValaSymbol*) _tmp305_);
		}
	}
	en_attributes = (_vala_array_free (en_attributes, en_attributes_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (cheader_filename);
	_g_free0 (common_prefix);
	_vala_code_node_unref0 (en);
	_g_free0 (name);
}


static void vala_gidl_parser_parse_object (ValaGIdlParser* self, GIdlNodeInterface* node, ValaSymbol* container, GIdlModule* module) {
	gchar* name = NULL;
	GIdlNodeInterface* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	ValaSymbol* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	gchar* base_class = NULL;
	ValaClass* cl = NULL;
	ValaSymbol* _tmp4_ = NULL;
	ValaScope* _tmp5_ = NULL;
	ValaScope* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	ValaSymbol* _tmp8_ = NULL;
	ValaClass* _tmp9_ = NULL;
	ValaClass* _tmp10_ = NULL;
	const gchar* _tmp136_ = NULL;
	GIdlNodeInterface* _tmp159_ = NULL;
	GList* _tmp160_ = NULL;
	ValaClass* _tmp183_ = NULL;
	ValaTypeSymbol* _tmp184_ = NULL;
	GHashFunc _tmp185_ = NULL;
	GEqualFunc _tmp186_ = NULL;
	ValaHashSet* _tmp187_ = NULL;
	ValaHashMap* current_type_func_map = NULL;
	GHashFunc _tmp188_ = NULL;
	GEqualFunc _tmp189_ = NULL;
	GEqualFunc _tmp190_ = NULL;
	ValaHashMap* _tmp191_ = NULL;
	ValaHashMap* current_type_vfunc_map = NULL;
	GHashFunc _tmp192_ = NULL;
	GEqualFunc _tmp193_ = NULL;
	GEqualFunc _tmp194_ = NULL;
	ValaHashMap* _tmp195_ = NULL;
	GIdlNodeInterface* _tmp196_ = NULL;
	GList* _tmp197_ = NULL;
	GIdlNodeInterface* _tmp209_ = NULL;
	GList* _tmp210_ = NULL;
	GIdlNodeInterface* _tmp247_ = NULL;
	GList* _tmp248_ = NULL;
	ValaClass* _tmp318_ = NULL;
	ValaClass* _tmp319_ = NULL;
	ValaCreationMethod* _tmp320_ = NULL;
	ValaCreationMethod* _tmp321_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = node;
	_tmp1_ = ((GIdlNode*) _tmp0_)->name;
	_tmp2_ = container;
	_tmp3_ = vala_gidl_parser_fix_type_name (self, _tmp1_, _tmp2_);
	name = _tmp3_;
	base_class = NULL;
	_tmp4_ = container;
	_tmp5_ = vala_symbol_get_scope (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = name;
	_tmp8_ = vala_scope_lookup (_tmp6_, _tmp7_);
	_tmp9_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, VALA_TYPE_CLASS) ? ((ValaClass*) _tmp8_) : NULL;
	if (_tmp9_ == NULL) {
		_vala_code_node_unref0 (_tmp8_);
	}
	cl = _tmp9_;
	_tmp10_ = cl;
	if (_tmp10_ == NULL) {
		const gchar* _tmp11_ = NULL;
		ValaSourceReference* _tmp12_ = NULL;
		ValaClass* _tmp13_ = NULL;
		ValaClass* _tmp14_ = NULL;
		gchar** attributes = NULL;
		GIdlNodeInterface* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		gchar** _tmp18_ = NULL;
		gint attributes_length1 = 0;
		gint _attributes_size_ = 0;
		gchar** _tmp19_ = NULL;
		gint _tmp19__length1 = 0;
		ValaSymbol* _tmp132_ = NULL;
		ValaClass* _tmp133_ = NULL;
		ValaSourceFile* _tmp134_ = NULL;
		ValaClass* _tmp135_ = NULL;
		_tmp11_ = name;
		_tmp12_ = self->priv->current_source_reference;
		_tmp13_ = vala_class_new (_tmp11_, _tmp12_, NULL);
		_vala_code_node_unref0 (cl);
		cl = _tmp13_;
		_tmp14_ = cl;
		vala_symbol_set_access ((ValaSymbol*) _tmp14_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		_tmp15_ = node;
		_tmp16_ = _tmp15_->gtype_name;
		_tmp18_ = vala_gidl_parser_get_attributes (self, _tmp16_, &_tmp17_);
		attributes = _tmp18_;
		attributes_length1 = _tmp17_;
		_attributes_size_ = attributes_length1;
		_tmp19_ = attributes;
		_tmp19__length1 = attributes_length1;
		if (_tmp19_ != NULL) {
			gchar** _tmp20_ = NULL;
			gint _tmp20__length1 = 0;
			_tmp20_ = attributes;
			_tmp20__length1 = attributes_length1;
			{
				gchar** attr_collection = NULL;
				gint attr_collection_length1 = 0;
				gint _attr_collection_size_ = 0;
				gint attr_it = 0;
				attr_collection = _tmp20_;
				attr_collection_length1 = _tmp20__length1;
				for (attr_it = 0; attr_it < _tmp20__length1; attr_it = attr_it + 1) {
					gchar* _tmp21_ = NULL;
					gchar* attr = NULL;
					_tmp21_ = g_strdup (attr_collection[attr_it]);
					attr = _tmp21_;
					{
						gchar** nv = NULL;
						const gchar* _tmp22_ = NULL;
						gchar** _tmp23_ = NULL;
						gchar** _tmp24_ = NULL;
						gint nv_length1 = 0;
						gint _nv_size_ = 0;
						gchar** _tmp25_ = NULL;
						gint _tmp25__length1 = 0;
						const gchar* _tmp26_ = NULL;
						_tmp22_ = attr;
						_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, "=", 2);
						nv = _tmp24_;
						nv_length1 = _vala_array_length (_tmp23_);
						_nv_size_ = nv_length1;
						_tmp25_ = nv;
						_tmp25__length1 = nv_length1;
						_tmp26_ = _tmp25_[0];
						if (g_strcmp0 (_tmp26_, "cheader_filename") == 0) {
							ValaClass* _tmp27_ = NULL;
							gchar** _tmp28_ = NULL;
							gint _tmp28__length1 = 0;
							const gchar* _tmp29_ = NULL;
							gchar* _tmp30_ = NULL;
							gchar* _tmp31_ = NULL;
							_tmp27_ = cl;
							_tmp28_ = nv;
							_tmp28__length1 = nv_length1;
							_tmp29_ = _tmp28_[1];
							_tmp30_ = vala_gidl_parser_eval (self, _tmp29_);
							_tmp31_ = _tmp30_;
							vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp27_, "CCode", "cheader_filename", _tmp31_, NULL);
							_g_free0 (_tmp31_);
						} else {
							gchar** _tmp32_ = NULL;
							gint _tmp32__length1 = 0;
							const gchar* _tmp33_ = NULL;
							_tmp32_ = nv;
							_tmp32__length1 = nv_length1;
							_tmp33_ = _tmp32_[0];
							if (g_strcmp0 (_tmp33_, "base_class") == 0) {
								gchar** _tmp34_ = NULL;
								gint _tmp34__length1 = 0;
								const gchar* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								_tmp34_ = nv;
								_tmp34__length1 = nv_length1;
								_tmp35_ = _tmp34_[1];
								_tmp36_ = vala_gidl_parser_eval (self, _tmp35_);
								_g_free0 (base_class);
								base_class = _tmp36_;
							} else {
								gchar** _tmp37_ = NULL;
								gint _tmp37__length1 = 0;
								const gchar* _tmp38_ = NULL;
								_tmp37_ = nv;
								_tmp37__length1 = nv_length1;
								_tmp38_ = _tmp37_[0];
								if (g_strcmp0 (_tmp38_, "hidden") == 0) {
									gchar** _tmp39_ = NULL;
									gint _tmp39__length1 = 0;
									const gchar* _tmp40_ = NULL;
									gchar* _tmp41_ = NULL;
									gchar* _tmp42_ = NULL;
									gboolean _tmp43_ = FALSE;
									_tmp39_ = nv;
									_tmp39__length1 = nv_length1;
									_tmp40_ = _tmp39_[1];
									_tmp41_ = vala_gidl_parser_eval (self, _tmp40_);
									_tmp42_ = _tmp41_;
									_tmp43_ = g_strcmp0 (_tmp42_, "1") == 0;
									_g_free0 (_tmp42_);
									if (_tmp43_) {
										nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
										_g_free0 (attr);
										attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
										_vala_code_node_unref0 (cl);
										_g_free0 (base_class);
										_g_free0 (name);
										return;
									}
								} else {
									gchar** _tmp44_ = NULL;
									gint _tmp44__length1 = 0;
									const gchar* _tmp45_ = NULL;
									_tmp44_ = nv;
									_tmp44__length1 = nv_length1;
									_tmp45_ = _tmp44_[0];
									if (g_strcmp0 (_tmp45_, "type_check_function") == 0) {
										ValaClass* _tmp46_ = NULL;
										gchar** _tmp47_ = NULL;
										gint _tmp47__length1 = 0;
										const gchar* _tmp48_ = NULL;
										gchar* _tmp49_ = NULL;
										gchar* _tmp50_ = NULL;
										_tmp46_ = cl;
										_tmp47_ = nv;
										_tmp47__length1 = nv_length1;
										_tmp48_ = _tmp47_[1];
										_tmp49_ = vala_gidl_parser_eval (self, _tmp48_);
										_tmp50_ = _tmp49_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp46_, "CCode", "type_check_function", _tmp50_, NULL);
										_g_free0 (_tmp50_);
									} else {
										gchar** _tmp51_ = NULL;
										gint _tmp51__length1 = 0;
										const gchar* _tmp52_ = NULL;
										_tmp51_ = nv;
										_tmp51__length1 = nv_length1;
										_tmp52_ = _tmp51_[0];
										if (g_strcmp0 (_tmp52_, "deprecated") == 0) {
											gchar** _tmp53_ = NULL;
											gint _tmp53__length1 = 0;
											const gchar* _tmp54_ = NULL;
											gchar* _tmp55_ = NULL;
											gchar* _tmp56_ = NULL;
											gboolean _tmp57_ = FALSE;
											_tmp53_ = nv;
											_tmp53__length1 = nv_length1;
											_tmp54_ = _tmp53_[1];
											_tmp55_ = vala_gidl_parser_eval (self, _tmp54_);
											_tmp56_ = _tmp55_;
											_tmp57_ = g_strcmp0 (_tmp56_, "1") == 0;
											_g_free0 (_tmp56_);
											if (_tmp57_) {
												ValaClass* _tmp58_ = NULL;
												_tmp58_ = cl;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp58_, "Deprecated", TRUE, NULL);
											}
										} else {
											gchar** _tmp59_ = NULL;
											gint _tmp59__length1 = 0;
											const gchar* _tmp60_ = NULL;
											_tmp59_ = nv;
											_tmp59__length1 = nv_length1;
											_tmp60_ = _tmp59_[0];
											if (g_strcmp0 (_tmp60_, "replacement") == 0) {
												ValaClass* _tmp61_ = NULL;
												gchar** _tmp62_ = NULL;
												gint _tmp62__length1 = 0;
												const gchar* _tmp63_ = NULL;
												gchar* _tmp64_ = NULL;
												gchar* _tmp65_ = NULL;
												_tmp61_ = cl;
												_tmp62_ = nv;
												_tmp62__length1 = nv_length1;
												_tmp63_ = _tmp62_[1];
												_tmp64_ = vala_gidl_parser_eval (self, _tmp63_);
												_tmp65_ = _tmp64_;
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp61_, "Deprecated", "replacement", _tmp65_, NULL);
												_g_free0 (_tmp65_);
											} else {
												gchar** _tmp66_ = NULL;
												gint _tmp66__length1 = 0;
												const gchar* _tmp67_ = NULL;
												_tmp66_ = nv;
												_tmp66__length1 = nv_length1;
												_tmp67_ = _tmp66_[0];
												if (g_strcmp0 (_tmp67_, "deprecated_since") == 0) {
													ValaClass* _tmp68_ = NULL;
													gchar** _tmp69_ = NULL;
													gint _tmp69__length1 = 0;
													const gchar* _tmp70_ = NULL;
													gchar* _tmp71_ = NULL;
													gchar* _tmp72_ = NULL;
													_tmp68_ = cl;
													_tmp69_ = nv;
													_tmp69__length1 = nv_length1;
													_tmp70_ = _tmp69_[1];
													_tmp71_ = vala_gidl_parser_eval (self, _tmp70_);
													_tmp72_ = _tmp71_;
													vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp68_, "Deprecated", "since", _tmp72_, NULL);
													_g_free0 (_tmp72_);
												} else {
													gchar** _tmp73_ = NULL;
													gint _tmp73__length1 = 0;
													const gchar* _tmp74_ = NULL;
													_tmp73_ = nv;
													_tmp73__length1 = nv_length1;
													_tmp74_ = _tmp73_[0];
													if (g_strcmp0 (_tmp74_, "type_id") == 0) {
														ValaClass* _tmp75_ = NULL;
														gchar** _tmp76_ = NULL;
														gint _tmp76__length1 = 0;
														const gchar* _tmp77_ = NULL;
														gchar* _tmp78_ = NULL;
														gchar* _tmp79_ = NULL;
														_tmp75_ = cl;
														_tmp76_ = nv;
														_tmp76__length1 = nv_length1;
														_tmp77_ = _tmp76_[1];
														_tmp78_ = vala_gidl_parser_eval (self, _tmp77_);
														_tmp79_ = _tmp78_;
														vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp75_, "CCode", "type_id", _tmp79_, NULL);
														_g_free0 (_tmp79_);
													} else {
														gchar** _tmp80_ = NULL;
														gint _tmp80__length1 = 0;
														const gchar* _tmp81_ = NULL;
														_tmp80_ = nv;
														_tmp80__length1 = nv_length1;
														_tmp81_ = _tmp80_[0];
														if (g_strcmp0 (_tmp81_, "abstract") == 0) {
															gchar** _tmp82_ = NULL;
															gint _tmp82__length1 = 0;
															const gchar* _tmp83_ = NULL;
															gchar* _tmp84_ = NULL;
															gchar* _tmp85_ = NULL;
															gboolean _tmp86_ = FALSE;
															_tmp82_ = nv;
															_tmp82__length1 = nv_length1;
															_tmp83_ = _tmp82_[1];
															_tmp84_ = vala_gidl_parser_eval (self, _tmp83_);
															_tmp85_ = _tmp84_;
															_tmp86_ = g_strcmp0 (_tmp85_, "1") == 0;
															_g_free0 (_tmp85_);
															if (_tmp86_) {
																ValaClass* _tmp87_ = NULL;
																_tmp87_ = cl;
																vala_class_set_is_abstract (_tmp87_, TRUE);
															}
														} else {
															gchar** _tmp88_ = NULL;
															gint _tmp88__length1 = 0;
															const gchar* _tmp89_ = NULL;
															_tmp88_ = nv;
															_tmp88__length1 = nv_length1;
															_tmp89_ = _tmp88_[0];
															if (g_strcmp0 (_tmp89_, "experimental") == 0) {
																gchar** _tmp90_ = NULL;
																gint _tmp90__length1 = 0;
																const gchar* _tmp91_ = NULL;
																gchar* _tmp92_ = NULL;
																gchar* _tmp93_ = NULL;
																gboolean _tmp94_ = FALSE;
																_tmp90_ = nv;
																_tmp90__length1 = nv_length1;
																_tmp91_ = _tmp90_[1];
																_tmp92_ = vala_gidl_parser_eval (self, _tmp91_);
																_tmp93_ = _tmp92_;
																_tmp94_ = g_strcmp0 (_tmp93_, "1") == 0;
																_g_free0 (_tmp93_);
																if (_tmp94_) {
																	ValaClass* _tmp95_ = NULL;
																	_tmp95_ = cl;
																	vala_code_node_set_attribute ((ValaCodeNode*) _tmp95_, "Experimental", TRUE, NULL);
																}
															} else {
																gchar** _tmp96_ = NULL;
																gint _tmp96__length1 = 0;
																const gchar* _tmp97_ = NULL;
																_tmp96_ = nv;
																_tmp96__length1 = nv_length1;
																_tmp97_ = _tmp96_[0];
																if (g_strcmp0 (_tmp97_, "compact") == 0) {
																	gchar** _tmp98_ = NULL;
																	gint _tmp98__length1 = 0;
																	const gchar* _tmp99_ = NULL;
																	gchar* _tmp100_ = NULL;
																	gchar* _tmp101_ = NULL;
																	gboolean _tmp102_ = FALSE;
																	_tmp98_ = nv;
																	_tmp98__length1 = nv_length1;
																	_tmp99_ = _tmp98_[1];
																	_tmp100_ = vala_gidl_parser_eval (self, _tmp99_);
																	_tmp101_ = _tmp100_;
																	_tmp102_ = g_strcmp0 (_tmp101_, "1") == 0;
																	_g_free0 (_tmp101_);
																	if (_tmp102_) {
																		ValaClass* _tmp103_ = NULL;
																		_tmp103_ = cl;
																		vala_class_set_is_compact (_tmp103_, TRUE);
																	}
																} else {
																	gchar** _tmp104_ = NULL;
																	gint _tmp104__length1 = 0;
																	const gchar* _tmp105_ = NULL;
																	_tmp104_ = nv;
																	_tmp104__length1 = nv_length1;
																	_tmp105_ = _tmp104_[0];
																	if (g_strcmp0 (_tmp105_, "ref_function") == 0) {
																		ValaClass* _tmp106_ = NULL;
																		gchar** _tmp107_ = NULL;
																		gint _tmp107__length1 = 0;
																		const gchar* _tmp108_ = NULL;
																		gchar* _tmp109_ = NULL;
																		gchar* _tmp110_ = NULL;
																		_tmp106_ = cl;
																		_tmp107_ = nv;
																		_tmp107__length1 = nv_length1;
																		_tmp108_ = _tmp107_[1];
																		_tmp109_ = vala_gidl_parser_eval (self, _tmp108_);
																		_tmp110_ = _tmp109_;
																		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp106_, "CCode", "ref_function", _tmp110_, NULL);
																		_g_free0 (_tmp110_);
																	} else {
																		gchar** _tmp111_ = NULL;
																		gint _tmp111__length1 = 0;
																		const gchar* _tmp112_ = NULL;
																		_tmp111_ = nv;
																		_tmp111__length1 = nv_length1;
																		_tmp112_ = _tmp111_[0];
																		if (g_strcmp0 (_tmp112_, "unref_function") == 0) {
																			ValaClass* _tmp113_ = NULL;
																			gchar** _tmp114_ = NULL;
																			gint _tmp114__length1 = 0;
																			const gchar* _tmp115_ = NULL;
																			gchar* _tmp116_ = NULL;
																			gchar* _tmp117_ = NULL;
																			_tmp113_ = cl;
																			_tmp114_ = nv;
																			_tmp114__length1 = nv_length1;
																			_tmp115_ = _tmp114_[1];
																			_tmp116_ = vala_gidl_parser_eval (self, _tmp115_);
																			_tmp117_ = _tmp116_;
																			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp113_, "CCode", "unref_function", _tmp117_, NULL);
																			_g_free0 (_tmp117_);
																		} else {
																			gchar** _tmp118_ = NULL;
																			gint _tmp118__length1 = 0;
																			const gchar* _tmp119_ = NULL;
																			_tmp118_ = nv;
																			_tmp118__length1 = nv_length1;
																			_tmp119_ = _tmp118_[0];
																			if (g_strcmp0 (_tmp119_, "copy_function") == 0) {
																				ValaClass* _tmp120_ = NULL;
																				gchar** _tmp121_ = NULL;
																				gint _tmp121__length1 = 0;
																				const gchar* _tmp122_ = NULL;
																				gchar* _tmp123_ = NULL;
																				gchar* _tmp124_ = NULL;
																				_tmp120_ = cl;
																				_tmp121_ = nv;
																				_tmp121__length1 = nv_length1;
																				_tmp122_ = _tmp121_[1];
																				_tmp123_ = vala_gidl_parser_eval (self, _tmp122_);
																				_tmp124_ = _tmp123_;
																				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp120_, "CCode", "copy_function", _tmp124_, NULL);
																				_g_free0 (_tmp124_);
																			} else {
																				gchar** _tmp125_ = NULL;
																				gint _tmp125__length1 = 0;
																				const gchar* _tmp126_ = NULL;
																				_tmp125_ = nv;
																				_tmp125__length1 = nv_length1;
																				_tmp126_ = _tmp125_[0];
																				if (g_strcmp0 (_tmp126_, "free_function") == 0) {
																					ValaClass* _tmp127_ = NULL;
																					gchar** _tmp128_ = NULL;
																					gint _tmp128__length1 = 0;
																					const gchar* _tmp129_ = NULL;
																					gchar* _tmp130_ = NULL;
																					gchar* _tmp131_ = NULL;
																					_tmp127_ = cl;
																					_tmp128_ = nv;
																					_tmp128__length1 = nv_length1;
																					_tmp129_ = _tmp128_[1];
																					_tmp130_ = vala_gidl_parser_eval (self, _tmp129_);
																					_tmp131_ = _tmp130_;
																					vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp127_, "CCode", "free_function", _tmp131_, NULL);
																					_g_free0 (_tmp131_);
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
					}
				}
			}
		}
		_tmp132_ = container;
		_tmp133_ = cl;
		vala_gidl_parser_add_symbol_to_container (self, _tmp132_, (ValaSymbol*) _tmp133_);
		_tmp134_ = self->priv->current_source_file;
		_tmp135_ = cl;
		vala_source_file_add_node (_tmp134_, (ValaCodeNode*) _tmp135_);
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp136_ = base_class;
	if (_tmp136_ != NULL) {
		ValaDataType* parent = NULL;
		const gchar* _tmp137_ = NULL;
		ValaDataType* _tmp138_ = NULL;
		ValaClass* _tmp139_ = NULL;
		ValaDataType* _tmp140_ = NULL;
		_tmp137_ = base_class;
		_tmp138_ = vala_gidl_parser_parse_type_string (self, _tmp137_);
		parent = _tmp138_;
		_tmp139_ = cl;
		_tmp140_ = parent;
		vala_class_add_base_type (_tmp139_, _tmp140_);
		_vala_code_node_unref0 (parent);
	} else {
		GIdlNodeInterface* _tmp141_ = NULL;
		const gchar* _tmp142_ = NULL;
		_tmp141_ = node;
		_tmp142_ = _tmp141_->parent;
		if (_tmp142_ != NULL) {
			ValaClass* _tmp143_ = NULL;
			gboolean _tmp144_ = FALSE;
			gboolean _tmp145_ = FALSE;
			_tmp143_ = cl;
			_tmp144_ = vala_class_get_is_compact (_tmp143_);
			_tmp145_ = _tmp144_;
			if (!_tmp145_) {
				ValaDataType* parent = NULL;
				GIdlNodeInterface* _tmp146_ = NULL;
				const gchar* _tmp147_ = NULL;
				ValaDataType* _tmp148_ = NULL;
				ValaClass* _tmp149_ = NULL;
				ValaDataType* _tmp150_ = NULL;
				_tmp146_ = node;
				_tmp147_ = _tmp146_->parent;
				_tmp148_ = vala_gidl_parser_parse_type_string (self, _tmp147_);
				parent = _tmp148_;
				_tmp149_ = cl;
				_tmp150_ = parent;
				vala_class_add_base_type (_tmp149_, _tmp150_);
				_vala_code_node_unref0 (parent);
			}
		} else {
			ValaUnresolvedSymbol* gobject_symbol = NULL;
			ValaUnresolvedSymbol* _tmp151_ = NULL;
			ValaUnresolvedSymbol* _tmp152_ = NULL;
			ValaUnresolvedSymbol* _tmp153_ = NULL;
			ValaUnresolvedSymbol* _tmp154_ = NULL;
			ValaClass* _tmp155_ = NULL;
			ValaUnresolvedSymbol* _tmp156_ = NULL;
			ValaUnresolvedType* _tmp157_ = NULL;
			ValaUnresolvedType* _tmp158_ = NULL;
			_tmp151_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
			_tmp152_ = _tmp151_;
			_tmp153_ = vala_unresolved_symbol_new (_tmp152_, "Object", NULL);
			_tmp154_ = _tmp153_;
			_vala_code_node_unref0 (_tmp152_);
			gobject_symbol = _tmp154_;
			_tmp155_ = cl;
			_tmp156_ = gobject_symbol;
			_tmp157_ = vala_unresolved_type_new_from_symbol (_tmp156_, NULL);
			_tmp158_ = _tmp157_;
			vala_class_add_base_type (_tmp155_, (ValaDataType*) _tmp158_);
			_vala_code_node_unref0 (_tmp158_);
			_vala_code_node_unref0 (gobject_symbol);
		}
	}
	_tmp159_ = node;
	_tmp160_ = _tmp159_->interfaces;
	{
		GList* iface_name_collection = NULL;
		GList* iface_name_it = NULL;
		iface_name_collection = _tmp160_;
		for (iface_name_it = iface_name_collection; iface_name_it != NULL; iface_name_it = iface_name_it->next) {
			gchar* _tmp161_ = NULL;
			gchar* iface_name = NULL;
			_tmp161_ = g_strdup ((const gchar*) iface_name_it->data);
			iface_name = _tmp161_;
			{
				gboolean skip_iface = FALSE;
				gchar** attributes = NULL;
				const gchar* _tmp162_ = NULL;
				gint _tmp163_ = 0;
				gchar** _tmp164_ = NULL;
				gint attributes_length1 = 0;
				gint _attributes_size_ = 0;
				gchar** _tmp165_ = NULL;
				gint _tmp165__length1 = 0;
				gboolean _tmp178_ = FALSE;
				ValaDataType* iface = NULL;
				const gchar* _tmp179_ = NULL;
				ValaDataType* _tmp180_ = NULL;
				ValaClass* _tmp181_ = NULL;
				ValaDataType* _tmp182_ = NULL;
				skip_iface = FALSE;
				_tmp162_ = iface_name;
				_tmp164_ = vala_gidl_parser_get_attributes (self, _tmp162_, &_tmp163_);
				attributes = _tmp164_;
				attributes_length1 = _tmp163_;
				_attributes_size_ = attributes_length1;
				_tmp165_ = attributes;
				_tmp165__length1 = attributes_length1;
				if (_tmp165_ != NULL) {
					gchar** _tmp166_ = NULL;
					gint _tmp166__length1 = 0;
					_tmp166_ = attributes;
					_tmp166__length1 = attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp166_;
						attr_collection_length1 = _tmp166__length1;
						for (attr_it = 0; attr_it < _tmp166__length1; attr_it = attr_it + 1) {
							gchar* _tmp167_ = NULL;
							gchar* attr = NULL;
							_tmp167_ = g_strdup (attr_collection[attr_it]);
							attr = _tmp167_;
							{
								gchar** nv = NULL;
								const gchar* _tmp168_ = NULL;
								gchar** _tmp169_ = NULL;
								gchar** _tmp170_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gchar** _tmp171_ = NULL;
								gint _tmp171__length1 = 0;
								const gchar* _tmp172_ = NULL;
								_tmp168_ = attr;
								_tmp170_ = _tmp169_ = g_strsplit (_tmp168_, "=", 2);
								nv = _tmp170_;
								nv_length1 = _vala_array_length (_tmp169_);
								_nv_size_ = nv_length1;
								_tmp171_ = nv;
								_tmp171__length1 = nv_length1;
								_tmp172_ = _tmp171_[0];
								if (g_strcmp0 (_tmp172_, "hidden") == 0) {
									gchar** _tmp173_ = NULL;
									gint _tmp173__length1 = 0;
									const gchar* _tmp174_ = NULL;
									gchar* _tmp175_ = NULL;
									gchar* _tmp176_ = NULL;
									gboolean _tmp177_ = FALSE;
									_tmp173_ = nv;
									_tmp173__length1 = nv_length1;
									_tmp174_ = _tmp173_[1];
									_tmp175_ = vala_gidl_parser_eval (self, _tmp174_);
									_tmp176_ = _tmp175_;
									_tmp177_ = g_strcmp0 (_tmp176_, "1") == 0;
									_g_free0 (_tmp176_);
									if (_tmp177_) {
										skip_iface = TRUE;
									}
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
							}
						}
					}
				}
				_tmp178_ = skip_iface;
				if (_tmp178_) {
					attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (iface_name);
					continue;
				}
				_tmp179_ = iface_name;
				_tmp180_ = vala_gidl_parser_parse_type_string (self, _tmp179_);
				iface = _tmp180_;
				_tmp181_ = cl;
				_tmp182_ = iface;
				vala_class_add_base_type (_tmp181_, _tmp182_);
				_vala_code_node_unref0 (iface);
				attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
				_g_free0 (iface_name);
			}
		}
	}
	_tmp183_ = cl;
	_tmp184_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp183_);
	_vala_code_node_unref0 (self->priv->current_data_type);
	self->priv->current_data_type = _tmp184_;
	_tmp185_ = g_str_hash;
	_tmp186_ = g_str_equal;
	_tmp187_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp185_, _tmp186_);
	_vala_iterable_unref0 (self->priv->current_type_symbol_set);
	self->priv->current_type_symbol_set = (ValaSet*) _tmp187_;
	_tmp188_ = g_str_hash;
	_tmp189_ = g_str_equal;
	_tmp190_ = g_direct_equal;
	_tmp191_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_POINTER, NULL, NULL, _tmp188_, _tmp189_, _tmp190_);
	current_type_func_map = _tmp191_;
	_tmp192_ = g_str_hash;
	_tmp193_ = g_str_equal;
	_tmp194_ = g_direct_equal;
	_tmp195_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp192_, _tmp193_, _tmp194_);
	current_type_vfunc_map = _tmp195_;
	_tmp196_ = node;
	_tmp197_ = _tmp196_->members;
	{
		GList* member_collection = NULL;
		GList* member_it = NULL;
		member_collection = _tmp197_;
		for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
			GIdlNode* member = NULL;
			member = (GIdlNode*) member_it->data;
			{
				GIdlNode* _tmp198_ = NULL;
				GIdlNodeTypeId _tmp199_ = 0;
				GIdlNode* _tmp204_ = NULL;
				GIdlNodeTypeId _tmp205_ = 0;
				_tmp198_ = member;
				_tmp199_ = _tmp198_->type;
				if (_tmp199_ == G_IDL_NODE_FUNCTION) {
					ValaHashMap* _tmp200_ = NULL;
					GIdlNode* _tmp201_ = NULL;
					const gchar* _tmp202_ = NULL;
					GIdlNode* _tmp203_ = NULL;
					_tmp200_ = current_type_func_map;
					_tmp201_ = member;
					_tmp202_ = _tmp201_->name;
					_tmp203_ = member;
					vala_map_set ((ValaMap*) _tmp200_, _tmp202_, (GIdlNodeFunction*) _tmp203_);
				}
				_tmp204_ = member;
				_tmp205_ = _tmp204_->type;
				if (_tmp205_ == G_IDL_NODE_VFUNC) {
					ValaHashMap* _tmp206_ = NULL;
					GIdlNode* _tmp207_ = NULL;
					const gchar* _tmp208_ = NULL;
					_tmp206_ = current_type_vfunc_map;
					_tmp207_ = member;
					_tmp208_ = _tmp207_->name;
					vala_map_set ((ValaMap*) _tmp206_, _tmp208_, "1");
				}
			}
		}
	}
	_tmp209_ = node;
	_tmp210_ = _tmp209_->members;
	{
		GList* member_collection = NULL;
		GList* member_it = NULL;
		member_collection = _tmp210_;
		for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
			GIdlNode* member = NULL;
			member = (GIdlNode*) member_it->data;
			{
				GIdlNode* _tmp211_ = NULL;
				GIdlNodeTypeId _tmp212_ = 0;
				_tmp211_ = member;
				_tmp212_ = _tmp211_->type;
				if (_tmp212_ == G_IDL_NODE_FUNCTION) {
					ValaHashMap* _tmp213_ = NULL;
					GIdlNode* _tmp214_ = NULL;
					const gchar* _tmp215_ = NULL;
					gboolean _tmp216_ = FALSE;
					_tmp213_ = current_type_vfunc_map;
					_tmp214_ = member;
					_tmp215_ = _tmp214_->name;
					_tmp216_ = vala_map_contains ((ValaMap*) _tmp213_, _tmp215_);
					if (!_tmp216_) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp217_ = NULL;
						ValaMethod* _tmp218_ = NULL;
						ValaMethod* _tmp219_ = NULL;
						_tmp217_ = member;
						_tmp218_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp217_, FALSE);
						m = _tmp218_;
						_tmp219_ = m;
						if (_tmp219_ != NULL) {
							ValaClass* _tmp220_ = NULL;
							ValaMethod* _tmp221_ = NULL;
							_tmp220_ = cl;
							_tmp221_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp220_, _tmp221_);
						}
						_vala_code_node_unref0 (m);
					}
				} else {
					GIdlNode* _tmp222_ = NULL;
					GIdlNodeTypeId _tmp223_ = 0;
					_tmp222_ = member;
					_tmp223_ = _tmp222_->type;
					if (_tmp223_ == G_IDL_NODE_VFUNC) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp224_ = NULL;
						ValaHashMap* _tmp225_ = NULL;
						GIdlNode* _tmp226_ = NULL;
						const gchar* _tmp227_ = NULL;
						gpointer _tmp228_ = NULL;
						ValaMethod* _tmp229_ = NULL;
						ValaMethod* _tmp230_ = NULL;
						_tmp224_ = member;
						_tmp225_ = current_type_func_map;
						_tmp226_ = member;
						_tmp227_ = _tmp226_->name;
						_tmp228_ = vala_map_get ((ValaMap*) _tmp225_, _tmp227_);
						_tmp229_ = vala_gidl_parser_parse_virtual (self, (GIdlNodeVFunc*) _tmp224_, (GIdlNodeFunction*) _tmp228_, FALSE);
						m = _tmp229_;
						_tmp230_ = m;
						if (_tmp230_ != NULL) {
							ValaClass* _tmp231_ = NULL;
							ValaMethod* _tmp232_ = NULL;
							_tmp231_ = cl;
							_tmp232_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp231_, _tmp232_);
						}
						_vala_code_node_unref0 (m);
					} else {
						GIdlNode* _tmp233_ = NULL;
						GIdlNodeTypeId _tmp234_ = 0;
						_tmp233_ = member;
						_tmp234_ = _tmp233_->type;
						if (_tmp234_ == G_IDL_NODE_PROPERTY) {
							ValaProperty* prop = NULL;
							GIdlNode* _tmp235_ = NULL;
							ValaProperty* _tmp236_ = NULL;
							ValaProperty* _tmp237_ = NULL;
							_tmp235_ = member;
							_tmp236_ = vala_gidl_parser_parse_property (self, (GIdlNodeProperty*) _tmp235_);
							prop = _tmp236_;
							_tmp237_ = prop;
							if (_tmp237_ != NULL) {
								ValaClass* _tmp238_ = NULL;
								ValaProperty* _tmp239_ = NULL;
								_tmp238_ = cl;
								_tmp239_ = prop;
								vala_symbol_add_property ((ValaSymbol*) _tmp238_, _tmp239_);
							}
							_vala_code_node_unref0 (prop);
						} else {
							GIdlNode* _tmp240_ = NULL;
							GIdlNodeTypeId _tmp241_ = 0;
							_tmp240_ = member;
							_tmp241_ = _tmp240_->type;
							if (_tmp241_ == G_IDL_NODE_SIGNAL) {
								ValaSignal* sig = NULL;
								GIdlNode* _tmp242_ = NULL;
								ValaSignal* _tmp243_ = NULL;
								ValaSignal* _tmp244_ = NULL;
								_tmp242_ = member;
								_tmp243_ = vala_gidl_parser_parse_signal (self, (GIdlNodeSignal*) _tmp242_);
								sig = _tmp243_;
								_tmp244_ = sig;
								if (_tmp244_ != NULL) {
									ValaClass* _tmp245_ = NULL;
									ValaSignal* _tmp246_ = NULL;
									_tmp245_ = cl;
									_tmp246_ = sig;
									vala_symbol_add_signal ((ValaSymbol*) _tmp245_, _tmp246_);
								}
								_vala_code_node_unref0 (sig);
							}
						}
					}
				}
			}
		}
	}
	_tmp247_ = node;
	_tmp248_ = _tmp247_->members;
	{
		GList* member_collection = NULL;
		GList* member_it = NULL;
		member_collection = _tmp248_;
		for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
			GIdlNode* member = NULL;
			member = (GIdlNode*) member_it->data;
			{
				GIdlNode* _tmp249_ = NULL;
				GIdlNodeTypeId _tmp250_ = 0;
				_tmp249_ = member;
				_tmp250_ = _tmp249_->type;
				if (_tmp250_ == G_IDL_NODE_FIELD) {
					ValaSet* _tmp251_ = NULL;
					GIdlNode* _tmp252_ = NULL;
					const gchar* _tmp253_ = NULL;
					gboolean _tmp254_ = FALSE;
					_tmp251_ = self->priv->current_type_symbol_set;
					_tmp252_ = member;
					_tmp253_ = _tmp252_->name;
					_tmp254_ = vala_collection_contains ((ValaCollection*) _tmp251_, _tmp253_);
					if (!_tmp254_) {
						ValaField* f = NULL;
						GIdlNode* _tmp255_ = NULL;
						ValaField* _tmp256_ = NULL;
						ValaField* _tmp257_ = NULL;
						_tmp255_ = member;
						_tmp256_ = vala_gidl_parser_parse_field (self, (GIdlNodeField*) _tmp255_);
						f = _tmp256_;
						_tmp257_ = f;
						if (_tmp257_ != NULL) {
							ValaClass* _tmp258_ = NULL;
							ValaField* _tmp259_ = NULL;
							_tmp258_ = cl;
							_tmp259_ = f;
							vala_symbol_add_field ((ValaSymbol*) _tmp258_, _tmp259_);
						}
						_vala_code_node_unref0 (f);
					}
				}
			}
		}
	}
	{
		ValaList* _prop_list = NULL;
		ValaClass* _tmp260_ = NULL;
		ValaList* _tmp261_ = NULL;
		gint _prop_size = 0;
		ValaList* _tmp262_ = NULL;
		gint _tmp263_ = 0;
		gint _tmp264_ = 0;
		gint _prop_index = 0;
		_tmp260_ = cl;
		_tmp261_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) _tmp260_);
		_prop_list = _tmp261_;
		_tmp262_ = _prop_list;
		_tmp263_ = vala_collection_get_size ((ValaCollection*) _tmp262_);
		_tmp264_ = _tmp263_;
		_prop_size = _tmp264_;
		_prop_index = -1;
		while (TRUE) {
			gint _tmp265_ = 0;
			gint _tmp266_ = 0;
			gint _tmp267_ = 0;
			ValaProperty* prop = NULL;
			ValaList* _tmp268_ = NULL;
			gint _tmp269_ = 0;
			gpointer _tmp270_ = NULL;
			gchar* getter = NULL;
			ValaProperty* _tmp271_ = NULL;
			const gchar* _tmp272_ = NULL;
			const gchar* _tmp273_ = NULL;
			gchar* _tmp274_ = NULL;
			gboolean _tmp275_ = FALSE;
			ValaProperty* _tmp276_ = NULL;
			ValaPropertyAccessor* _tmp277_ = NULL;
			ValaPropertyAccessor* _tmp278_ = NULL;
			gboolean _tmp282_ = FALSE;
			gchar* setter = NULL;
			ValaProperty* _tmp284_ = NULL;
			const gchar* _tmp285_ = NULL;
			const gchar* _tmp286_ = NULL;
			gchar* _tmp287_ = NULL;
			gboolean _tmp288_ = FALSE;
			gboolean _tmp289_ = FALSE;
			ValaProperty* _tmp290_ = NULL;
			ValaPropertyAccessor* _tmp291_ = NULL;
			ValaPropertyAccessor* _tmp292_ = NULL;
			gboolean _tmp298_ = FALSE;
			gboolean _tmp302_ = FALSE;
			gboolean _tmp304_ = FALSE;
			ValaProperty* _tmp305_ = NULL;
			ValaAttribute* _tmp306_ = NULL;
			ValaAttribute* _tmp307_ = NULL;
			gboolean _tmp308_ = FALSE;
			gboolean _tmp312_ = FALSE;
			_tmp265_ = _prop_index;
			_prop_index = _tmp265_ + 1;
			_tmp266_ = _prop_index;
			_tmp267_ = _prop_size;
			if (!(_tmp266_ < _tmp267_)) {
				break;
			}
			_tmp268_ = _prop_list;
			_tmp269_ = _prop_index;
			_tmp270_ = vala_list_get (_tmp268_, _tmp269_);
			prop = (ValaProperty*) _tmp270_;
			_tmp271_ = prop;
			_tmp272_ = vala_symbol_get_name ((ValaSymbol*) _tmp271_);
			_tmp273_ = _tmp272_;
			_tmp274_ = g_strdup_printf ("get_%s", _tmp273_);
			getter = _tmp274_;
			_tmp276_ = prop;
			_tmp277_ = vala_property_get_get_accessor (_tmp276_);
			_tmp278_ = _tmp277_;
			if (_tmp278_ != NULL) {
				ValaSet* _tmp279_ = NULL;
				const gchar* _tmp280_ = NULL;
				gboolean _tmp281_ = FALSE;
				_tmp279_ = self->priv->current_type_symbol_set;
				_tmp280_ = getter;
				_tmp281_ = vala_collection_contains ((ValaCollection*) _tmp279_, _tmp280_);
				_tmp275_ = !_tmp281_;
			} else {
				_tmp275_ = FALSE;
			}
			_tmp282_ = _tmp275_;
			if (_tmp282_) {
				ValaProperty* _tmp283_ = NULL;
				_tmp283_ = prop;
				vala_code_node_set_attribute ((ValaCodeNode*) _tmp283_, "NoAccessorMethod", TRUE, NULL);
			}
			_tmp284_ = prop;
			_tmp285_ = vala_symbol_get_name ((ValaSymbol*) _tmp284_);
			_tmp286_ = _tmp285_;
			_tmp287_ = g_strdup_printf ("set_%s", _tmp286_);
			setter = _tmp287_;
			_tmp290_ = prop;
			_tmp291_ = vala_property_get_set_accessor (_tmp290_);
			_tmp292_ = _tmp291_;
			if (_tmp292_ != NULL) {
				ValaProperty* _tmp293_ = NULL;
				ValaPropertyAccessor* _tmp294_ = NULL;
				ValaPropertyAccessor* _tmp295_ = NULL;
				gboolean _tmp296_ = FALSE;
				gboolean _tmp297_ = FALSE;
				_tmp293_ = prop;
				_tmp294_ = vala_property_get_set_accessor (_tmp293_);
				_tmp295_ = _tmp294_;
				_tmp296_ = vala_property_accessor_get_writable (_tmp295_);
				_tmp297_ = _tmp296_;
				_tmp289_ = _tmp297_;
			} else {
				_tmp289_ = FALSE;
			}
			_tmp298_ = _tmp289_;
			if (_tmp298_) {
				ValaSet* _tmp299_ = NULL;
				const gchar* _tmp300_ = NULL;
				gboolean _tmp301_ = FALSE;
				_tmp299_ = self->priv->current_type_symbol_set;
				_tmp300_ = setter;
				_tmp301_ = vala_collection_contains ((ValaCollection*) _tmp299_, _tmp300_);
				_tmp288_ = !_tmp301_;
			} else {
				_tmp288_ = FALSE;
			}
			_tmp302_ = _tmp288_;
			if (_tmp302_) {
				ValaProperty* _tmp303_ = NULL;
				_tmp303_ = prop;
				vala_code_node_set_attribute ((ValaCodeNode*) _tmp303_, "NoAccessorMethod", TRUE, NULL);
			}
			_tmp305_ = prop;
			_tmp306_ = vala_code_node_get_attribute ((ValaCodeNode*) _tmp305_, "NoAccessorMethod");
			_tmp307_ = _tmp306_;
			_tmp308_ = _tmp307_ != NULL;
			_vala_code_node_unref0 (_tmp307_);
			if (_tmp308_) {
				ValaProperty* _tmp309_ = NULL;
				ValaPropertyAccessor* _tmp310_ = NULL;
				ValaPropertyAccessor* _tmp311_ = NULL;
				_tmp309_ = prop;
				_tmp310_ = vala_property_get_get_accessor (_tmp309_);
				_tmp311_ = _tmp310_;
				_tmp304_ = _tmp311_ != NULL;
			} else {
				_tmp304_ = FALSE;
			}
			_tmp312_ = _tmp304_;
			if (_tmp312_) {
				ValaProperty* _tmp313_ = NULL;
				ValaPropertyAccessor* _tmp314_ = NULL;
				ValaPropertyAccessor* _tmp315_ = NULL;
				ValaDataType* _tmp316_ = NULL;
				ValaDataType* _tmp317_ = NULL;
				_tmp313_ = prop;
				_tmp314_ = vala_property_get_get_accessor (_tmp313_);
				_tmp315_ = _tmp314_;
				_tmp316_ = vala_property_accessor_get_value_type (_tmp315_);
				_tmp317_ = _tmp316_;
				vala_data_type_set_value_owned (_tmp317_, TRUE);
			}
			_g_free0 (setter);
			_g_free0 (getter);
			_vala_code_node_unref0 (prop);
		}
		_vala_iterable_unref0 (_prop_list);
	}
	_tmp318_ = cl;
	vala_gidl_parser_handle_async_methods (self, (ValaObjectTypeSymbol*) _tmp318_);
	_tmp319_ = cl;
	_tmp320_ = vala_class_get_default_construction_method (_tmp319_);
	_tmp321_ = _tmp320_;
	if (_tmp321_ == NULL) {
		ValaCreationMethod* cm = NULL;
		ValaClass* _tmp322_ = NULL;
		ValaSourceReference* _tmp323_ = NULL;
		ValaSourceReference* _tmp324_ = NULL;
		ValaCreationMethod* _tmp325_ = NULL;
		ValaCreationMethod* _tmp326_ = NULL;
		ValaCreationMethod* _tmp327_ = NULL;
		ValaClass* _tmp328_ = NULL;
		ValaCreationMethod* _tmp329_ = NULL;
		_tmp322_ = cl;
		_tmp323_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp322_);
		_tmp324_ = _tmp323_;
		_tmp325_ = vala_creation_method_new (NULL, NULL, _tmp324_, NULL);
		cm = _tmp325_;
		_tmp326_ = cm;
		vala_method_set_has_construct_function ((ValaMethod*) _tmp326_, FALSE);
		_tmp327_ = cm;
		vala_symbol_set_access ((ValaSymbol*) _tmp327_, VALA_SYMBOL_ACCESSIBILITY_PROTECTED);
		_tmp328_ = cl;
		_tmp329_ = cm;
		vala_symbol_add_method ((ValaSymbol*) _tmp328_, (ValaMethod*) _tmp329_);
		_vala_code_node_unref0 (cm);
	}
	_vala_code_node_unref0 (self->priv->current_data_type);
	self->priv->current_data_type = NULL;
	_vala_iterable_unref0 (self->priv->current_type_symbol_set);
	self->priv->current_type_symbol_set = NULL;
	_vala_map_unref0 (current_type_vfunc_map);
	_vala_map_unref0 (current_type_func_map);
	_vala_code_node_unref0 (cl);
	_g_free0 (base_class);
	_g_free0 (name);
}


static void vala_gidl_parser_parse_interface (ValaGIdlParser* self, GIdlNodeInterface* node, ValaSymbol* container, GIdlModule* module) {
	gchar* name = NULL;
	GIdlNodeInterface* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	ValaSymbol* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	ValaInterface* iface = NULL;
	ValaSymbol* _tmp4_ = NULL;
	ValaScope* _tmp5_ = NULL;
	ValaScope* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	ValaSymbol* _tmp8_ = NULL;
	ValaInterface* _tmp9_ = NULL;
	ValaInterface* _tmp10_ = NULL;
	ValaInterface* _tmp64_ = NULL;
	ValaTypeSymbol* _tmp65_ = NULL;
	GHashFunc _tmp66_ = NULL;
	GEqualFunc _tmp67_ = NULL;
	ValaHashSet* _tmp68_ = NULL;
	ValaHashMap* current_type_func_map = NULL;
	GHashFunc _tmp69_ = NULL;
	GEqualFunc _tmp70_ = NULL;
	GEqualFunc _tmp71_ = NULL;
	ValaHashMap* _tmp72_ = NULL;
	ValaHashMap* current_type_vfunc_map = NULL;
	GHashFunc _tmp73_ = NULL;
	GEqualFunc _tmp74_ = NULL;
	GEqualFunc _tmp75_ = NULL;
	ValaHashMap* _tmp76_ = NULL;
	GIdlNodeInterface* _tmp77_ = NULL;
	GList* _tmp78_ = NULL;
	GIdlNodeInterface* _tmp90_ = NULL;
	GList* _tmp91_ = NULL;
	ValaInterface* _tmp187_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (node != NULL);
	g_return_if_fail (container != NULL);
	g_return_if_fail (module != NULL);
	_tmp0_ = node;
	_tmp1_ = _tmp0_->gtype_name;
	_tmp2_ = container;
	_tmp3_ = vala_gidl_parser_fix_type_name (self, _tmp1_, _tmp2_);
	name = _tmp3_;
	_tmp4_ = container;
	_tmp5_ = vala_symbol_get_scope (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = name;
	_tmp8_ = vala_scope_lookup (_tmp6_, _tmp7_);
	_tmp9_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp8_, VALA_TYPE_INTERFACE) ? ((ValaInterface*) _tmp8_) : NULL;
	if (_tmp9_ == NULL) {
		_vala_code_node_unref0 (_tmp8_);
	}
	iface = _tmp9_;
	_tmp10_ = iface;
	if (_tmp10_ == NULL) {
		const gchar* _tmp11_ = NULL;
		ValaSourceReference* _tmp12_ = NULL;
		ValaInterface* _tmp13_ = NULL;
		ValaInterface* _tmp14_ = NULL;
		gchar** attributes = NULL;
		GIdlNodeInterface* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		gint _tmp17_ = 0;
		gchar** _tmp18_ = NULL;
		gint attributes_length1 = 0;
		gint _attributes_size_ = 0;
		gchar** _tmp19_ = NULL;
		gint _tmp19__length1 = 0;
		GIdlNodeInterface* _tmp53_ = NULL;
		GList* _tmp54_ = NULL;
		ValaSymbol* _tmp60_ = NULL;
		ValaInterface* _tmp61_ = NULL;
		ValaSourceFile* _tmp62_ = NULL;
		ValaInterface* _tmp63_ = NULL;
		_tmp11_ = name;
		_tmp12_ = self->priv->current_source_reference;
		_tmp13_ = vala_interface_new (_tmp11_, _tmp12_, NULL);
		_vala_code_node_unref0 (iface);
		iface = _tmp13_;
		_tmp14_ = iface;
		vala_symbol_set_access ((ValaSymbol*) _tmp14_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
		_tmp15_ = node;
		_tmp16_ = _tmp15_->gtype_name;
		_tmp18_ = vala_gidl_parser_get_attributes (self, _tmp16_, &_tmp17_);
		attributes = _tmp18_;
		attributes_length1 = _tmp17_;
		_attributes_size_ = attributes_length1;
		_tmp19_ = attributes;
		_tmp19__length1 = attributes_length1;
		if (_tmp19_ != NULL) {
			gchar** _tmp20_ = NULL;
			gint _tmp20__length1 = 0;
			_tmp20_ = attributes;
			_tmp20__length1 = attributes_length1;
			{
				gchar** attr_collection = NULL;
				gint attr_collection_length1 = 0;
				gint _attr_collection_size_ = 0;
				gint attr_it = 0;
				attr_collection = _tmp20_;
				attr_collection_length1 = _tmp20__length1;
				for (attr_it = 0; attr_it < _tmp20__length1; attr_it = attr_it + 1) {
					gchar* _tmp21_ = NULL;
					gchar* attr = NULL;
					_tmp21_ = g_strdup (attr_collection[attr_it]);
					attr = _tmp21_;
					{
						gchar** nv = NULL;
						const gchar* _tmp22_ = NULL;
						gchar** _tmp23_ = NULL;
						gchar** _tmp24_ = NULL;
						gint nv_length1 = 0;
						gint _nv_size_ = 0;
						gchar** _tmp25_ = NULL;
						gint _tmp25__length1 = 0;
						const gchar* _tmp26_ = NULL;
						_tmp22_ = attr;
						_tmp24_ = _tmp23_ = g_strsplit (_tmp22_, "=", 2);
						nv = _tmp24_;
						nv_length1 = _vala_array_length (_tmp23_);
						_nv_size_ = nv_length1;
						_tmp25_ = nv;
						_tmp25__length1 = nv_length1;
						_tmp26_ = _tmp25_[0];
						if (g_strcmp0 (_tmp26_, "cheader_filename") == 0) {
							ValaInterface* _tmp27_ = NULL;
							gchar** _tmp28_ = NULL;
							gint _tmp28__length1 = 0;
							const gchar* _tmp29_ = NULL;
							gchar* _tmp30_ = NULL;
							gchar* _tmp31_ = NULL;
							_tmp27_ = iface;
							_tmp28_ = nv;
							_tmp28__length1 = nv_length1;
							_tmp29_ = _tmp28_[1];
							_tmp30_ = vala_gidl_parser_eval (self, _tmp29_);
							_tmp31_ = _tmp30_;
							vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp27_, "CCode", "cheader_filename", _tmp31_, NULL);
							_g_free0 (_tmp31_);
						} else {
							gchar** _tmp32_ = NULL;
							gint _tmp32__length1 = 0;
							const gchar* _tmp33_ = NULL;
							_tmp32_ = nv;
							_tmp32__length1 = nv_length1;
							_tmp33_ = _tmp32_[0];
							if (g_strcmp0 (_tmp33_, "hidden") == 0) {
								gchar** _tmp34_ = NULL;
								gint _tmp34__length1 = 0;
								const gchar* _tmp35_ = NULL;
								gchar* _tmp36_ = NULL;
								gchar* _tmp37_ = NULL;
								gboolean _tmp38_ = FALSE;
								_tmp34_ = nv;
								_tmp34__length1 = nv_length1;
								_tmp35_ = _tmp34_[1];
								_tmp36_ = vala_gidl_parser_eval (self, _tmp35_);
								_tmp37_ = _tmp36_;
								_tmp38_ = g_strcmp0 (_tmp37_, "1") == 0;
								_g_free0 (_tmp37_);
								if (_tmp38_) {
									nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (attr);
									attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
									_vala_code_node_unref0 (iface);
									_g_free0 (name);
									return;
								}
							} else {
								gchar** _tmp39_ = NULL;
								gint _tmp39__length1 = 0;
								const gchar* _tmp40_ = NULL;
								_tmp39_ = nv;
								_tmp39__length1 = nv_length1;
								_tmp40_ = _tmp39_[0];
								if (g_strcmp0 (_tmp40_, "type_cname") == 0) {
									ValaInterface* _tmp41_ = NULL;
									gchar** _tmp42_ = NULL;
									gint _tmp42__length1 = 0;
									const gchar* _tmp43_ = NULL;
									gchar* _tmp44_ = NULL;
									gchar* _tmp45_ = NULL;
									_tmp41_ = iface;
									_tmp42_ = nv;
									_tmp42__length1 = nv_length1;
									_tmp43_ = _tmp42_[1];
									_tmp44_ = vala_gidl_parser_eval (self, _tmp43_);
									_tmp45_ = _tmp44_;
									vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp41_, "CCode", "type_cname", _tmp45_, NULL);
									_g_free0 (_tmp45_);
								} else {
									gchar** _tmp46_ = NULL;
									gint _tmp46__length1 = 0;
									const gchar* _tmp47_ = NULL;
									_tmp46_ = nv;
									_tmp46__length1 = nv_length1;
									_tmp47_ = _tmp46_[0];
									if (g_strcmp0 (_tmp47_, "lower_case_csuffix") == 0) {
										ValaInterface* _tmp48_ = NULL;
										gchar** _tmp49_ = NULL;
										gint _tmp49__length1 = 0;
										const gchar* _tmp50_ = NULL;
										gchar* _tmp51_ = NULL;
										gchar* _tmp52_ = NULL;
										_tmp48_ = iface;
										_tmp49_ = nv;
										_tmp49__length1 = nv_length1;
										_tmp50_ = _tmp49_[1];
										_tmp51_ = vala_gidl_parser_eval (self, _tmp50_);
										_tmp52_ = _tmp51_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp48_, "CCode", "lower_case_csuffix", _tmp52_, NULL);
										_g_free0 (_tmp52_);
									}
								}
							}
						}
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
					}
				}
			}
		}
		_tmp53_ = node;
		_tmp54_ = _tmp53_->prerequisites;
		{
			GList* prereq_name_collection = NULL;
			GList* prereq_name_it = NULL;
			prereq_name_collection = _tmp54_;
			for (prereq_name_it = prereq_name_collection; prereq_name_it != NULL; prereq_name_it = prereq_name_it->next) {
				gchar* _tmp55_ = NULL;
				gchar* prereq_name = NULL;
				_tmp55_ = g_strdup ((const gchar*) prereq_name_it->data);
				prereq_name = _tmp55_;
				{
					ValaDataType* prereq = NULL;
					const gchar* _tmp56_ = NULL;
					ValaDataType* _tmp57_ = NULL;
					ValaInterface* _tmp58_ = NULL;
					ValaDataType* _tmp59_ = NULL;
					_tmp56_ = prereq_name;
					_tmp57_ = vala_gidl_parser_parse_type_string (self, _tmp56_);
					prereq = _tmp57_;
					_tmp58_ = iface;
					_tmp59_ = prereq;
					vala_interface_add_prerequisite (_tmp58_, _tmp59_);
					_vala_code_node_unref0 (prereq);
					_g_free0 (prereq_name);
				}
			}
		}
		_tmp60_ = container;
		_tmp61_ = iface;
		vala_gidl_parser_add_symbol_to_container (self, _tmp60_, (ValaSymbol*) _tmp61_);
		_tmp62_ = self->priv->current_source_file;
		_tmp63_ = iface;
		vala_source_file_add_node (_tmp62_, (ValaCodeNode*) _tmp63_);
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp64_ = iface;
	_tmp65_ = _vala_code_node_ref0 ((ValaTypeSymbol*) _tmp64_);
	_vala_code_node_unref0 (self->priv->current_data_type);
	self->priv->current_data_type = _tmp65_;
	_tmp66_ = g_str_hash;
	_tmp67_ = g_str_equal;
	_tmp68_ = vala_hash_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp66_, _tmp67_);
	_vala_iterable_unref0 (self->priv->current_type_symbol_set);
	self->priv->current_type_symbol_set = (ValaSet*) _tmp68_;
	_tmp69_ = g_str_hash;
	_tmp70_ = g_str_equal;
	_tmp71_ = g_direct_equal;
	_tmp72_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_POINTER, NULL, NULL, _tmp69_, _tmp70_, _tmp71_);
	current_type_func_map = _tmp72_;
	_tmp73_ = g_str_hash;
	_tmp74_ = g_str_equal;
	_tmp75_ = g_direct_equal;
	_tmp76_ = vala_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, g_free, _tmp73_, _tmp74_, _tmp75_);
	current_type_vfunc_map = _tmp76_;
	_tmp77_ = node;
	_tmp78_ = _tmp77_->members;
	{
		GList* member_collection = NULL;
		GList* member_it = NULL;
		member_collection = _tmp78_;
		for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
			GIdlNode* member = NULL;
			member = (GIdlNode*) member_it->data;
			{
				GIdlNode* _tmp79_ = NULL;
				GIdlNodeTypeId _tmp80_ = 0;
				GIdlNode* _tmp85_ = NULL;
				GIdlNodeTypeId _tmp86_ = 0;
				_tmp79_ = member;
				_tmp80_ = _tmp79_->type;
				if (_tmp80_ == G_IDL_NODE_FUNCTION) {
					ValaHashMap* _tmp81_ = NULL;
					GIdlNode* _tmp82_ = NULL;
					const gchar* _tmp83_ = NULL;
					GIdlNode* _tmp84_ = NULL;
					_tmp81_ = current_type_func_map;
					_tmp82_ = member;
					_tmp83_ = _tmp82_->name;
					_tmp84_ = member;
					vala_map_set ((ValaMap*) _tmp81_, _tmp83_, (GIdlNodeFunction*) _tmp84_);
				}
				_tmp85_ = member;
				_tmp86_ = _tmp85_->type;
				if (_tmp86_ == G_IDL_NODE_VFUNC) {
					ValaHashMap* _tmp87_ = NULL;
					GIdlNode* _tmp88_ = NULL;
					const gchar* _tmp89_ = NULL;
					_tmp87_ = current_type_vfunc_map;
					_tmp88_ = member;
					_tmp89_ = _tmp88_->name;
					vala_map_set ((ValaMap*) _tmp87_, _tmp89_, "1");
				}
			}
		}
	}
	_tmp90_ = node;
	_tmp91_ = _tmp90_->members;
	{
		GList* member_collection = NULL;
		GList* member_it = NULL;
		member_collection = _tmp91_;
		for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
			GIdlNode* member = NULL;
			member = (GIdlNode*) member_it->data;
			{
				GIdlNode* _tmp92_ = NULL;
				GIdlNodeTypeId _tmp93_ = 0;
				_tmp92_ = member;
				_tmp93_ = _tmp92_->type;
				if (_tmp93_ == G_IDL_NODE_FUNCTION) {
					ValaHashMap* _tmp94_ = NULL;
					GIdlNode* _tmp95_ = NULL;
					const gchar* _tmp96_ = NULL;
					gboolean _tmp97_ = FALSE;
					_tmp94_ = current_type_vfunc_map;
					_tmp95_ = member;
					_tmp96_ = _tmp95_->name;
					_tmp97_ = vala_map_contains ((ValaMap*) _tmp94_, _tmp96_);
					if (!_tmp97_) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp98_ = NULL;
						ValaMethod* _tmp99_ = NULL;
						ValaMethod* _tmp100_ = NULL;
						_tmp98_ = member;
						_tmp99_ = vala_gidl_parser_parse_function (self, (GIdlNodeFunction*) _tmp98_, TRUE);
						m = _tmp99_;
						_tmp100_ = m;
						if (_tmp100_ != NULL) {
							ValaInterface* _tmp101_ = NULL;
							ValaMethod* _tmp102_ = NULL;
							_tmp101_ = iface;
							_tmp102_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp101_, _tmp102_);
						}
						_vala_code_node_unref0 (m);
					}
				} else {
					GIdlNode* _tmp103_ = NULL;
					GIdlNodeTypeId _tmp104_ = 0;
					_tmp103_ = member;
					_tmp104_ = _tmp103_->type;
					if (_tmp104_ == G_IDL_NODE_VFUNC) {
						ValaMethod* m = NULL;
						GIdlNode* _tmp105_ = NULL;
						ValaHashMap* _tmp106_ = NULL;
						GIdlNode* _tmp107_ = NULL;
						const gchar* _tmp108_ = NULL;
						gpointer _tmp109_ = NULL;
						ValaMethod* _tmp110_ = NULL;
						ValaMethod* _tmp111_ = NULL;
						_tmp105_ = member;
						_tmp106_ = current_type_func_map;
						_tmp107_ = member;
						_tmp108_ = _tmp107_->name;
						_tmp109_ = vala_map_get ((ValaMap*) _tmp106_, _tmp108_);
						_tmp110_ = vala_gidl_parser_parse_virtual (self, (GIdlNodeVFunc*) _tmp105_, (GIdlNodeFunction*) _tmp109_, TRUE);
						m = _tmp110_;
						_tmp111_ = m;
						if (_tmp111_ != NULL) {
							ValaInterface* _tmp112_ = NULL;
							ValaMethod* _tmp113_ = NULL;
							_tmp112_ = iface;
							_tmp113_ = m;
							vala_symbol_add_method ((ValaSymbol*) _tmp112_, _tmp113_);
						}
						_vala_code_node_unref0 (m);
					} else {
						GIdlNode* _tmp114_ = NULL;
						GIdlNodeTypeId _tmp115_ = 0;
						_tmp114_ = member;
						_tmp115_ = _tmp114_->type;
						if (_tmp115_ == G_IDL_NODE_PROPERTY) {
							ValaProperty* prop = NULL;
							GIdlNode* _tmp116_ = NULL;
							ValaProperty* _tmp117_ = NULL;
							ValaProperty* _tmp118_ = NULL;
							_tmp116_ = member;
							_tmp117_ = vala_gidl_parser_parse_property (self, (GIdlNodeProperty*) _tmp116_);
							prop = _tmp117_;
							_tmp118_ = prop;
							if (_tmp118_ != NULL) {
								ValaInterface* _tmp119_ = NULL;
								ValaProperty* _tmp120_ = NULL;
								_tmp119_ = iface;
								_tmp120_ = prop;
								vala_symbol_add_property ((ValaSymbol*) _tmp119_, _tmp120_);
							}
							_vala_code_node_unref0 (prop);
						} else {
							GIdlNode* _tmp121_ = NULL;
							GIdlNodeTypeId _tmp122_ = 0;
							_tmp121_ = member;
							_tmp122_ = _tmp121_->type;
							if (_tmp122_ == G_IDL_NODE_SIGNAL) {
								ValaSignal* sig = NULL;
								GIdlNode* _tmp123_ = NULL;
								ValaSignal* _tmp124_ = NULL;
								ValaSignal* _tmp125_ = NULL;
								_tmp123_ = member;
								_tmp124_ = vala_gidl_parser_parse_signal (self, (GIdlNodeSignal*) _tmp123_);
								sig = _tmp124_;
								_tmp125_ = sig;
								if (_tmp125_ != NULL) {
									ValaInterface* _tmp126_ = NULL;
									ValaSignal* _tmp127_ = NULL;
									ValaSignal* _tmp128_ = NULL;
									_tmp126_ = iface;
									_tmp127_ = sig;
									vala_symbol_add_signal ((ValaSymbol*) _tmp126_, _tmp127_);
									_tmp128_ = sig;
									vala_signal_set_is_virtual (_tmp128_, FALSE);
								}
								_vala_code_node_unref0 (sig);
							}
						}
					}
				}
			}
		}
	}
	{
		ValaList* _prop_list = NULL;
		ValaInterface* _tmp129_ = NULL;
		ValaList* _tmp130_ = NULL;
		gint _prop_size = 0;
		ValaList* _tmp131_ = NULL;
		gint _tmp132_ = 0;
		gint _tmp133_ = 0;
		gint _prop_index = 0;
		_tmp129_ = iface;
		_tmp130_ = vala_object_type_symbol_get_properties ((ValaObjectTypeSymbol*) _tmp129_);
		_prop_list = _tmp130_;
		_tmp131_ = _prop_list;
		_tmp132_ = vala_collection_get_size ((ValaCollection*) _tmp131_);
		_tmp133_ = _tmp132_;
		_prop_size = _tmp133_;
		_prop_index = -1;
		while (TRUE) {
			gint _tmp134_ = 0;
			gint _tmp135_ = 0;
			gint _tmp136_ = 0;
			ValaProperty* prop = NULL;
			ValaList* _tmp137_ = NULL;
			gint _tmp138_ = 0;
			gpointer _tmp139_ = NULL;
			gchar* getter = NULL;
			ValaProperty* _tmp140_ = NULL;
			const gchar* _tmp141_ = NULL;
			const gchar* _tmp142_ = NULL;
			gchar* _tmp143_ = NULL;
			gboolean _tmp144_ = FALSE;
			ValaProperty* _tmp145_ = NULL;
			ValaPropertyAccessor* _tmp146_ = NULL;
			ValaPropertyAccessor* _tmp147_ = NULL;
			gboolean _tmp151_ = FALSE;
			gchar* setter = NULL;
			ValaProperty* _tmp153_ = NULL;
			const gchar* _tmp154_ = NULL;
			const gchar* _tmp155_ = NULL;
			gchar* _tmp156_ = NULL;
			gboolean _tmp157_ = FALSE;
			gboolean _tmp158_ = FALSE;
			ValaProperty* _tmp159_ = NULL;
			ValaPropertyAccessor* _tmp160_ = NULL;
			ValaPropertyAccessor* _tmp161_ = NULL;
			gboolean _tmp167_ = FALSE;
			gboolean _tmp171_ = FALSE;
			gboolean _tmp173_ = FALSE;
			ValaProperty* _tmp174_ = NULL;
			ValaAttribute* _tmp175_ = NULL;
			ValaAttribute* _tmp176_ = NULL;
			gboolean _tmp177_ = FALSE;
			gboolean _tmp181_ = FALSE;
			_tmp134_ = _prop_index;
			_prop_index = _tmp134_ + 1;
			_tmp135_ = _prop_index;
			_tmp136_ = _prop_size;
			if (!(_tmp135_ < _tmp136_)) {
				break;
			}
			_tmp137_ = _prop_list;
			_tmp138_ = _prop_index;
			_tmp139_ = vala_list_get (_tmp137_, _tmp138_);
			prop = (ValaProperty*) _tmp139_;
			_tmp140_ = prop;
			_tmp141_ = vala_symbol_get_name ((ValaSymbol*) _tmp140_);
			_tmp142_ = _tmp141_;
			_tmp143_ = g_strdup_printf ("get_%s", _tmp142_);
			getter = _tmp143_;
			_tmp145_ = prop;
			_tmp146_ = vala_property_get_get_accessor (_tmp145_);
			_tmp147_ = _tmp146_;
			if (_tmp147_ != NULL) {
				ValaSet* _tmp148_ = NULL;
				const gchar* _tmp149_ = NULL;
				gboolean _tmp150_ = FALSE;
				_tmp148_ = self->priv->current_type_symbol_set;
				_tmp149_ = getter;
				_tmp150_ = vala_collection_contains ((ValaCollection*) _tmp148_, _tmp149_);
				_tmp144_ = !_tmp150_;
			} else {
				_tmp144_ = FALSE;
			}
			_tmp151_ = _tmp144_;
			if (_tmp151_) {
				ValaProperty* _tmp152_ = NULL;
				_tmp152_ = prop;
				vala_code_node_set_attribute ((ValaCodeNode*) _tmp152_, "NoAccessorMethod", TRUE, NULL);
			}
			_tmp153_ = prop;
			_tmp154_ = vala_symbol_get_name ((ValaSymbol*) _tmp153_);
			_tmp155_ = _tmp154_;
			_tmp156_ = g_strdup_printf ("set_%s", _tmp155_);
			setter = _tmp156_;
			_tmp159_ = prop;
			_tmp160_ = vala_property_get_set_accessor (_tmp159_);
			_tmp161_ = _tmp160_;
			if (_tmp161_ != NULL) {
				ValaProperty* _tmp162_ = NULL;
				ValaPropertyAccessor* _tmp163_ = NULL;
				ValaPropertyAccessor* _tmp164_ = NULL;
				gboolean _tmp165_ = FALSE;
				gboolean _tmp166_ = FALSE;
				_tmp162_ = prop;
				_tmp163_ = vala_property_get_set_accessor (_tmp162_);
				_tmp164_ = _tmp163_;
				_tmp165_ = vala_property_accessor_get_writable (_tmp164_);
				_tmp166_ = _tmp165_;
				_tmp158_ = _tmp166_;
			} else {
				_tmp158_ = FALSE;
			}
			_tmp167_ = _tmp158_;
			if (_tmp167_) {
				ValaSet* _tmp168_ = NULL;
				const gchar* _tmp169_ = NULL;
				gboolean _tmp170_ = FALSE;
				_tmp168_ = self->priv->current_type_symbol_set;
				_tmp169_ = setter;
				_tmp170_ = vala_collection_contains ((ValaCollection*) _tmp168_, _tmp169_);
				_tmp157_ = !_tmp170_;
			} else {
				_tmp157_ = FALSE;
			}
			_tmp171_ = _tmp157_;
			if (_tmp171_) {
				ValaProperty* _tmp172_ = NULL;
				_tmp172_ = prop;
				vala_code_node_set_attribute ((ValaCodeNode*) _tmp172_, "NoAccessorMethod", TRUE, NULL);
			}
			_tmp174_ = prop;
			_tmp175_ = vala_code_node_get_attribute ((ValaCodeNode*) _tmp174_, "NoAccessorMethod");
			_tmp176_ = _tmp175_;
			_tmp177_ = _tmp176_ != NULL;
			_vala_code_node_unref0 (_tmp176_);
			if (_tmp177_) {
				ValaProperty* _tmp178_ = NULL;
				ValaPropertyAccessor* _tmp179_ = NULL;
				ValaPropertyAccessor* _tmp180_ = NULL;
				_tmp178_ = prop;
				_tmp179_ = vala_property_get_get_accessor (_tmp178_);
				_tmp180_ = _tmp179_;
				_tmp173_ = _tmp180_ != NULL;
			} else {
				_tmp173_ = FALSE;
			}
			_tmp181_ = _tmp173_;
			if (_tmp181_) {
				ValaProperty* _tmp182_ = NULL;
				ValaPropertyAccessor* _tmp183_ = NULL;
				ValaPropertyAccessor* _tmp184_ = NULL;
				ValaDataType* _tmp185_ = NULL;
				ValaDataType* _tmp186_ = NULL;
				_tmp182_ = prop;
				_tmp183_ = vala_property_get_get_accessor (_tmp182_);
				_tmp184_ = _tmp183_;
				_tmp185_ = vala_property_accessor_get_value_type (_tmp184_);
				_tmp186_ = _tmp185_;
				vala_data_type_set_value_owned (_tmp186_, TRUE);
			}
			_g_free0 (setter);
			_g_free0 (getter);
			_vala_code_node_unref0 (prop);
		}
		_vala_iterable_unref0 (_prop_list);
	}
	_tmp187_ = iface;
	vala_gidl_parser_handle_async_methods (self, (ValaObjectTypeSymbol*) _tmp187_);
	_vala_code_node_unref0 (self->priv->current_data_type);
	self->priv->current_data_type = NULL;
	_vala_map_unref0 (current_type_vfunc_map);
	_vala_map_unref0 (current_type_func_map);
	_vala_code_node_unref0 (iface);
	_g_free0 (name);
}


static void vala_gidl_parser_handle_async_methods (ValaGIdlParser* self, ValaObjectTypeSymbol* type_symbol) {
	ValaSet* finish_methods = NULL;
	GHashFunc _tmp0_ = NULL;
	GEqualFunc _tmp1_ = NULL;
	ValaHashSet* _tmp2_ = NULL;
	ValaList* methods = NULL;
	ValaObjectTypeSymbol* _tmp3_ = NULL;
	ValaList* _tmp4_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (type_symbol != NULL);
	_tmp0_ = g_direct_hash;
	_tmp1_ = g_direct_equal;
	_tmp2_ = vala_hash_set_new (VALA_TYPE_METHOD, (GBoxedCopyFunc) vala_code_node_ref, vala_code_node_unref, _tmp0_, _tmp1_);
	finish_methods = (ValaSet*) _tmp2_;
	_tmp3_ = type_symbol;
	_tmp4_ = vala_object_type_symbol_get_methods (_tmp3_);
	methods = _tmp4_;
	{
		ValaList* _m_list = NULL;
		ValaList* _tmp5_ = NULL;
		ValaList* _tmp6_ = NULL;
		gint _m_size = 0;
		ValaList* _tmp7_ = NULL;
		gint _tmp8_ = 0;
		gint _tmp9_ = 0;
		gint _m_index = 0;
		_tmp5_ = methods;
		_tmp6_ = _vala_iterable_ref0 (_tmp5_);
		_m_list = _tmp6_;
		_tmp7_ = _m_list;
		_tmp8_ = vala_collection_get_size ((ValaCollection*) _tmp7_);
		_tmp9_ = _tmp8_;
		_m_size = _tmp9_;
		_m_index = -1;
		while (TRUE) {
			gint _tmp10_ = 0;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			ValaMethod* m = NULL;
			ValaList* _tmp13_ = NULL;
			gint _tmp14_ = 0;
			gpointer _tmp15_ = NULL;
			ValaMethod* _tmp16_ = NULL;
			gboolean _tmp17_ = FALSE;
			gboolean _tmp18_ = FALSE;
			_tmp10_ = _m_index;
			_m_index = _tmp10_ + 1;
			_tmp11_ = _m_index;
			_tmp12_ = _m_size;
			if (!(_tmp11_ < _tmp12_)) {
				break;
			}
			_tmp13_ = _m_list;
			_tmp14_ = _m_index;
			_tmp15_ = vala_list_get (_tmp13_, _tmp14_);
			m = (ValaMethod*) _tmp15_;
			_tmp16_ = m;
			_tmp17_ = vala_method_get_coroutine (_tmp16_);
			_tmp18_ = _tmp17_;
			if (_tmp18_) {
				gchar* finish_method_base = NULL;
				ValaMethod* _tmp19_ = NULL;
				const gchar* _tmp20_ = NULL;
				const gchar* _tmp21_ = NULL;
				gboolean _tmp22_ = FALSE;
				ValaMethod* finish_method = NULL;
				ValaObjectTypeSymbol* _tmp38_ = NULL;
				ValaScope* _tmp39_ = NULL;
				ValaScope* _tmp40_ = NULL;
				const gchar* _tmp41_ = NULL;
				gchar* _tmp42_ = NULL;
				gchar* _tmp43_ = NULL;
				ValaSymbol* _tmp44_ = NULL;
				ValaMethod* _tmp45_ = NULL;
				ValaMethod* _tmp46_ = NULL;
				ValaMethod* _tmp47_ = NULL;
				ValaMethod* _tmp68_ = NULL;
				_tmp19_ = m;
				_tmp20_ = vala_symbol_get_name ((ValaSymbol*) _tmp19_);
				_tmp21_ = _tmp20_;
				_tmp22_ = g_str_has_suffix (_tmp21_, "_async");
				if (_tmp22_) {
					ValaMethod* _tmp23_ = NULL;
					const gchar* _tmp24_ = NULL;
					const gchar* _tmp25_ = NULL;
					ValaMethod* _tmp26_ = NULL;
					const gchar* _tmp27_ = NULL;
					const gchar* _tmp28_ = NULL;
					gint _tmp29_ = 0;
					gint _tmp30_ = 0;
					gint _tmp31_ = 0;
					gint _tmp32_ = 0;
					gchar* _tmp33_ = NULL;
					_tmp23_ = m;
					_tmp24_ = vala_symbol_get_name ((ValaSymbol*) _tmp23_);
					_tmp25_ = _tmp24_;
					_tmp26_ = m;
					_tmp27_ = vala_symbol_get_name ((ValaSymbol*) _tmp26_);
					_tmp28_ = _tmp27_;
					_tmp29_ = strlen (_tmp28_);
					_tmp30_ = _tmp29_;
					_tmp31_ = strlen ("_async");
					_tmp32_ = _tmp31_;
					_tmp33_ = string_substring (_tmp25_, (glong) 0, (glong) (_tmp30_ - _tmp32_));
					_g_free0 (finish_method_base);
					finish_method_base = _tmp33_;
				} else {
					ValaMethod* _tmp34_ = NULL;
					const gchar* _tmp35_ = NULL;
					const gchar* _tmp36_ = NULL;
					gchar* _tmp37_ = NULL;
					_tmp34_ = m;
					_tmp35_ = vala_symbol_get_name ((ValaSymbol*) _tmp34_);
					_tmp36_ = _tmp35_;
					_tmp37_ = g_strdup (_tmp36_);
					_g_free0 (finish_method_base);
					finish_method_base = _tmp37_;
				}
				_tmp38_ = type_symbol;
				_tmp39_ = vala_symbol_get_scope ((ValaSymbol*) _tmp38_);
				_tmp40_ = _tmp39_;
				_tmp41_ = finish_method_base;
				_tmp42_ = g_strconcat (_tmp41_, "_finish", NULL);
				_tmp43_ = _tmp42_;
				_tmp44_ = vala_scope_lookup (_tmp40_, _tmp43_);
				_tmp45_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp44_, VALA_TYPE_METHOD) ? ((ValaMethod*) _tmp44_) : NULL;
				if (_tmp45_ == NULL) {
					_vala_code_node_unref0 (_tmp44_);
				}
				_tmp46_ = _tmp45_;
				_g_free0 (_tmp43_);
				finish_method = _tmp46_;
				_tmp47_ = finish_method;
				if (_tmp47_ == NULL) {
					gchar* method_cname = NULL;
					ValaMethod* _tmp48_ = NULL;
					gchar* _tmp49_ = NULL;
					_tmp48_ = m;
					_tmp49_ = vala_gidl_parser_get_finish_cname (self, _tmp48_);
					method_cname = _tmp49_;
					{
						ValaList* _method_list = NULL;
						ValaObjectTypeSymbol* _tmp50_ = NULL;
						ValaList* _tmp51_ = NULL;
						gint _method_size = 0;
						ValaList* _tmp52_ = NULL;
						gint _tmp53_ = 0;
						gint _tmp54_ = 0;
						gint _method_index = 0;
						_tmp50_ = type_symbol;
						_tmp51_ = vala_object_type_symbol_get_methods (_tmp50_);
						_method_list = _tmp51_;
						_tmp52_ = _method_list;
						_tmp53_ = vala_collection_get_size ((ValaCollection*) _tmp52_);
						_tmp54_ = _tmp53_;
						_method_size = _tmp54_;
						_method_index = -1;
						while (TRUE) {
							gint _tmp55_ = 0;
							gint _tmp56_ = 0;
							gint _tmp57_ = 0;
							ValaMethod* method = NULL;
							ValaList* _tmp58_ = NULL;
							gint _tmp59_ = 0;
							gpointer _tmp60_ = NULL;
							ValaMethod* _tmp61_ = NULL;
							gchar* _tmp62_ = NULL;
							gchar* _tmp63_ = NULL;
							const gchar* _tmp64_ = NULL;
							gboolean _tmp65_ = FALSE;
							_tmp55_ = _method_index;
							_method_index = _tmp55_ + 1;
							_tmp56_ = _method_index;
							_tmp57_ = _method_size;
							if (!(_tmp56_ < _tmp57_)) {
								break;
							}
							_tmp58_ = _method_list;
							_tmp59_ = _method_index;
							_tmp60_ = vala_list_get (_tmp58_, _tmp59_);
							method = (ValaMethod*) _tmp60_;
							_tmp61_ = method;
							_tmp62_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp61_, NULL);
							_tmp63_ = _tmp62_;
							_tmp64_ = method_cname;
							_tmp65_ = g_strcmp0 (_tmp63_, _tmp64_) == 0;
							_g_free0 (_tmp63_);
							if (_tmp65_) {
								ValaMethod* _tmp66_ = NULL;
								ValaMethod* _tmp67_ = NULL;
								_tmp66_ = method;
								_tmp67_ = _vala_code_node_ref0 (_tmp66_);
								_vala_code_node_unref0 (finish_method);
								finish_method = _tmp67_;
								_vala_code_node_unref0 (method);
								break;
							}
							_vala_code_node_unref0 (method);
						}
						_vala_iterable_unref0 (_method_list);
					}
					_g_free0 (method_cname);
				}
				_tmp68_ = finish_method;
				if (_tmp68_ != NULL) {
					ValaMethod* _tmp69_ = NULL;
					ValaMethod* _tmp70_ = NULL;
					ValaDataType* _tmp71_ = NULL;
					ValaDataType* _tmp72_ = NULL;
					ValaDataType* _tmp73_ = NULL;
					ValaDataType* _tmp74_ = NULL;
					ValaAttribute* a = NULL;
					ValaMethod* _tmp75_ = NULL;
					ValaAttribute* _tmp76_ = NULL;
					gboolean _tmp77_ = FALSE;
					ValaAttribute* _tmp78_ = NULL;
					gboolean _tmp81_ = FALSE;
					gboolean _tmp85_ = FALSE;
					ValaAttribute* _tmp86_ = NULL;
					gboolean _tmp89_ = FALSE;
					ValaSet* _tmp141_ = NULL;
					ValaMethod* _tmp142_ = NULL;
					_tmp69_ = m;
					_tmp70_ = finish_method;
					_tmp71_ = vala_method_get_return_type (_tmp70_);
					_tmp72_ = _tmp71_;
					_tmp73_ = vala_data_type_copy (_tmp72_);
					_tmp74_ = _tmp73_;
					vala_method_set_return_type (_tmp69_, _tmp74_);
					_vala_code_node_unref0 (_tmp74_);
					_tmp75_ = finish_method;
					_tmp76_ = vala_code_node_get_attribute ((ValaCodeNode*) _tmp75_, "CCode");
					a = _tmp76_;
					_tmp78_ = a;
					if (_tmp78_ != NULL) {
						ValaAttribute* _tmp79_ = NULL;
						gboolean _tmp80_ = FALSE;
						_tmp79_ = a;
						_tmp80_ = vala_attribute_has_argument (_tmp79_, "array_length");
						_tmp77_ = _tmp80_;
					} else {
						_tmp77_ = FALSE;
					}
					_tmp81_ = _tmp77_;
					if (_tmp81_) {
						ValaMethod* _tmp82_ = NULL;
						ValaAttribute* _tmp83_ = NULL;
						gboolean _tmp84_ = FALSE;
						_tmp82_ = m;
						_tmp83_ = a;
						_tmp84_ = vala_attribute_get_bool (_tmp83_, "array_length", FALSE);
						vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp82_, "CCode", "array_length", _tmp84_, NULL);
					}
					_tmp86_ = a;
					if (_tmp86_ != NULL) {
						ValaAttribute* _tmp87_ = NULL;
						gboolean _tmp88_ = FALSE;
						_tmp87_ = a;
						_tmp88_ = vala_attribute_has_argument (_tmp87_, "array_null_terminated");
						_tmp85_ = _tmp88_;
					} else {
						_tmp85_ = FALSE;
					}
					_tmp89_ = _tmp85_;
					if (_tmp89_) {
						ValaMethod* _tmp90_ = NULL;
						ValaAttribute* _tmp91_ = NULL;
						gboolean _tmp92_ = FALSE;
						_tmp90_ = m;
						_tmp91_ = a;
						_tmp92_ = vala_attribute_get_bool (_tmp91_, "array_null_terminated", FALSE);
						vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp90_, "CCode", "array_null_terminated", _tmp92_, NULL);
					}
					{
						ValaList* _param_list = NULL;
						ValaMethod* _tmp93_ = NULL;
						ValaList* _tmp94_ = NULL;
						gint _param_size = 0;
						ValaList* _tmp95_ = NULL;
						gint _tmp96_ = 0;
						gint _tmp97_ = 0;
						gint _param_index = 0;
						_tmp93_ = finish_method;
						_tmp94_ = vala_method_get_parameters (_tmp93_);
						_param_list = _tmp94_;
						_tmp95_ = _param_list;
						_tmp96_ = vala_collection_get_size ((ValaCollection*) _tmp95_);
						_tmp97_ = _tmp96_;
						_param_size = _tmp97_;
						_param_index = -1;
						while (TRUE) {
							gint _tmp98_ = 0;
							gint _tmp99_ = 0;
							gint _tmp100_ = 0;
							ValaParameter* param = NULL;
							ValaList* _tmp101_ = NULL;
							gint _tmp102_ = 0;
							gpointer _tmp103_ = NULL;
							ValaParameter* _tmp104_ = NULL;
							ValaParameterDirection _tmp105_ = 0;
							ValaParameterDirection _tmp106_ = 0;
							_tmp98_ = _param_index;
							_param_index = _tmp98_ + 1;
							_tmp99_ = _param_index;
							_tmp100_ = _param_size;
							if (!(_tmp99_ < _tmp100_)) {
								break;
							}
							_tmp101_ = _param_list;
							_tmp102_ = _param_index;
							_tmp103_ = vala_list_get (_tmp101_, _tmp102_);
							param = (ValaParameter*) _tmp103_;
							_tmp104_ = param;
							_tmp105_ = vala_parameter_get_direction (_tmp104_);
							_tmp106_ = _tmp105_;
							if (_tmp106_ == VALA_PARAMETER_DIRECTION_OUT) {
								ValaParameter* async_param = NULL;
								ValaParameter* _tmp107_ = NULL;
								ValaParameter* _tmp108_ = NULL;
								ValaMethod* _tmp109_ = NULL;
								ValaScope* _tmp110_ = NULL;
								ValaScope* _tmp111_ = NULL;
								ValaParameter* _tmp112_ = NULL;
								const gchar* _tmp113_ = NULL;
								const gchar* _tmp114_ = NULL;
								ValaSymbol* _tmp115_ = NULL;
								ValaSymbol* _tmp116_ = NULL;
								gboolean _tmp117_ = FALSE;
								ValaMethod* _tmp124_ = NULL;
								ValaParameter* _tmp125_ = NULL;
								_tmp107_ = param;
								_tmp108_ = vala_parameter_copy (_tmp107_);
								async_param = _tmp108_;
								_tmp109_ = m;
								_tmp110_ = vala_symbol_get_scope ((ValaSymbol*) _tmp109_);
								_tmp111_ = _tmp110_;
								_tmp112_ = param;
								_tmp113_ = vala_symbol_get_name ((ValaSymbol*) _tmp112_);
								_tmp114_ = _tmp113_;
								_tmp115_ = vala_scope_lookup (_tmp111_, _tmp114_);
								_tmp116_ = _tmp115_;
								_tmp117_ = _tmp116_ != NULL;
								_vala_code_node_unref0 (_tmp116_);
								if (_tmp117_) {
									ValaParameter* _tmp118_ = NULL;
									ValaParameter* _tmp119_ = NULL;
									const gchar* _tmp120_ = NULL;
									const gchar* _tmp121_ = NULL;
									gchar* _tmp122_ = NULL;
									gchar* _tmp123_ = NULL;
									_tmp118_ = async_param;
									_tmp119_ = async_param;
									_tmp120_ = vala_symbol_get_name ((ValaSymbol*) _tmp119_);
									_tmp121_ = _tmp120_;
									_tmp122_ = g_strconcat (_tmp121_, "_out", NULL);
									_tmp123_ = _tmp122_;
									vala_symbol_set_name ((ValaSymbol*) _tmp119_, _tmp123_);
									_g_free0 (_tmp123_);
								}
								_tmp124_ = m;
								_tmp125_ = async_param;
								vala_method_add_parameter (_tmp124_, _tmp125_);
								_vala_code_node_unref0 (async_param);
							}
							_vala_code_node_unref0 (param);
						}
						_vala_iterable_unref0 (_param_list);
					}
					{
						ValaList* _error_type_list = NULL;
						ValaMethod* _tmp126_ = NULL;
						ValaList* _tmp127_ = NULL;
						gint _error_type_size = 0;
						ValaList* _tmp128_ = NULL;
						gint _tmp129_ = 0;
						gint _tmp130_ = 0;
						gint _error_type_index = 0;
						_tmp126_ = finish_method;
						_tmp127_ = vala_code_node_get_error_types ((ValaCodeNode*) _tmp126_);
						_error_type_list = _tmp127_;
						_tmp128_ = _error_type_list;
						_tmp129_ = vala_collection_get_size ((ValaCollection*) _tmp128_);
						_tmp130_ = _tmp129_;
						_error_type_size = _tmp130_;
						_error_type_index = -1;
						while (TRUE) {
							gint _tmp131_ = 0;
							gint _tmp132_ = 0;
							gint _tmp133_ = 0;
							ValaDataType* error_type = NULL;
							ValaList* _tmp134_ = NULL;
							gint _tmp135_ = 0;
							gpointer _tmp136_ = NULL;
							ValaMethod* _tmp137_ = NULL;
							ValaDataType* _tmp138_ = NULL;
							ValaDataType* _tmp139_ = NULL;
							ValaDataType* _tmp140_ = NULL;
							_tmp131_ = _error_type_index;
							_error_type_index = _tmp131_ + 1;
							_tmp132_ = _error_type_index;
							_tmp133_ = _error_type_size;
							if (!(_tmp132_ < _tmp133_)) {
								break;
							}
							_tmp134_ = _error_type_list;
							_tmp135_ = _error_type_index;
							_tmp136_ = vala_list_get (_tmp134_, _tmp135_);
							error_type = (ValaDataType*) _tmp136_;
							_tmp137_ = m;
							_tmp138_ = error_type;
							_tmp139_ = vala_data_type_copy (_tmp138_);
							_tmp140_ = _tmp139_;
							vala_code_node_add_error_type ((ValaCodeNode*) _tmp137_, _tmp140_);
							_vala_code_node_unref0 (_tmp140_);
							_vala_code_node_unref0 (error_type);
						}
						_vala_iterable_unref0 (_error_type_list);
					}
					_tmp141_ = finish_methods;
					_tmp142_ = finish_method;
					vala_collection_add ((ValaCollection*) _tmp141_, _tmp142_);
					_vala_code_node_unref0 (a);
				}
				_vala_code_node_unref0 (finish_method);
				_g_free0 (finish_method_base);
			}
			_vala_code_node_unref0 (m);
		}
		_vala_iterable_unref0 (_m_list);
	}
	{
		ValaIterator* _m_it = NULL;
		ValaSet* _tmp143_ = NULL;
		ValaIterator* _tmp144_ = NULL;
		_tmp143_ = finish_methods;
		_tmp144_ = vala_iterable_iterator ((ValaIterable*) _tmp143_);
		_m_it = _tmp144_;
		while (TRUE) {
			ValaIterator* _tmp145_ = NULL;
			gboolean _tmp146_ = FALSE;
			ValaMethod* m = NULL;
			ValaIterator* _tmp147_ = NULL;
			gpointer _tmp148_ = NULL;
			ValaObjectTypeSymbol* _tmp149_ = NULL;
			ValaScope* _tmp150_ = NULL;
			ValaScope* _tmp151_ = NULL;
			ValaMethod* _tmp152_ = NULL;
			const gchar* _tmp153_ = NULL;
			const gchar* _tmp154_ = NULL;
			ValaList* _tmp155_ = NULL;
			ValaMethod* _tmp156_ = NULL;
			_tmp145_ = _m_it;
			_tmp146_ = vala_iterator_next (_tmp145_);
			if (!_tmp146_) {
				break;
			}
			_tmp147_ = _m_it;
			_tmp148_ = vala_iterator_get (_tmp147_);
			m = (ValaMethod*) _tmp148_;
			_tmp149_ = type_symbol;
			_tmp150_ = vala_symbol_get_scope ((ValaSymbol*) _tmp149_);
			_tmp151_ = _tmp150_;
			_tmp152_ = m;
			_tmp153_ = vala_symbol_get_name ((ValaSymbol*) _tmp152_);
			_tmp154_ = _tmp153_;
			vala_scope_remove (_tmp151_, _tmp154_);
			_tmp155_ = methods;
			_tmp156_ = m;
			vala_collection_remove ((ValaCollection*) _tmp155_, _tmp156_);
			_vala_code_node_unref0 (m);
		}
		_vala_iterator_unref0 (_m_it);
	}
	_vala_iterable_unref0 (methods);
	_vala_iterable_unref0 (finish_methods);
}


static ValaDataType* vala_gidl_parser_parse_type (ValaGIdlParser* self, GIdlNodeType* type_node, ValaParameterDirection* direction) {
	ValaParameterDirection _vala_direction = 0;
	ValaDataType* result = NULL;
	ValaUnresolvedType* type = NULL;
	ValaUnresolvedType* _tmp0_ = NULL;
	GIdlNodeType* _tmp1_ = NULL;
	GITypeTag _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (type_node != NULL, NULL);
	_vala_direction = VALA_PARAMETER_DIRECTION_IN;
	_tmp0_ = vala_unresolved_type_new ();
	type = _tmp0_;
	_tmp1_ = type_node;
	_tmp2_ = _tmp1_->tag;
	if (_tmp2_ == TYPE_TAG_VOID) {
		GIdlNodeType* _tmp3_ = NULL;
		gboolean _tmp4_ = FALSE;
		_tmp3_ = type_node;
		_tmp4_ = _tmp3_->is_pointer;
		if (_tmp4_) {
			ValaVoidType* _tmp5_ = NULL;
			ValaVoidType* _tmp6_ = NULL;
			ValaPointerType* _tmp7_ = NULL;
			ValaDataType* _tmp8_ = NULL;
			_tmp5_ = vala_void_type_new (NULL);
			_tmp6_ = _tmp5_;
			_tmp7_ = vala_pointer_type_new ((ValaDataType*) _tmp6_, NULL);
			_tmp8_ = (ValaDataType*) _tmp7_;
			_vala_code_node_unref0 (_tmp6_);
			result = _tmp8_;
			_vala_code_node_unref0 (type);
			if (direction) {
				*direction = _vala_direction;
			}
			return result;
		} else {
			ValaVoidType* _tmp9_ = NULL;
			_tmp9_ = vala_void_type_new (NULL);
			result = (ValaDataType*) _tmp9_;
			_vala_code_node_unref0 (type);
			if (direction) {
				*direction = _vala_direction;
			}
			return result;
		}
	} else {
		GIdlNodeType* _tmp10_ = NULL;
		GITypeTag _tmp11_ = 0;
		_tmp10_ = type_node;
		_tmp11_ = _tmp10_->tag;
		if (_tmp11_ == TYPE_TAG_BOOLEAN) {
			ValaUnresolvedType* _tmp12_ = NULL;
			ValaUnresolvedSymbol* _tmp13_ = NULL;
			ValaUnresolvedSymbol* _tmp14_ = NULL;
			_tmp12_ = type;
			_tmp13_ = vala_unresolved_symbol_new (NULL, "bool", NULL);
			_tmp14_ = _tmp13_;
			vala_unresolved_type_set_unresolved_symbol (_tmp12_, _tmp14_);
			_vala_code_node_unref0 (_tmp14_);
		} else {
			GIdlNodeType* _tmp15_ = NULL;
			GITypeTag _tmp16_ = 0;
			_tmp15_ = type_node;
			_tmp16_ = _tmp15_->tag;
			if (_tmp16_ == TYPE_TAG_INT8) {
				ValaUnresolvedType* _tmp17_ = NULL;
				ValaUnresolvedSymbol* _tmp18_ = NULL;
				ValaUnresolvedSymbol* _tmp19_ = NULL;
				_tmp17_ = type;
				_tmp18_ = vala_unresolved_symbol_new (NULL, "char", NULL);
				_tmp19_ = _tmp18_;
				vala_unresolved_type_set_unresolved_symbol (_tmp17_, _tmp19_);
				_vala_code_node_unref0 (_tmp19_);
			} else {
				GIdlNodeType* _tmp20_ = NULL;
				GITypeTag _tmp21_ = 0;
				_tmp20_ = type_node;
				_tmp21_ = _tmp20_->tag;
				if (_tmp21_ == TYPE_TAG_UINT8) {
					ValaUnresolvedType* _tmp22_ = NULL;
					ValaUnresolvedSymbol* _tmp23_ = NULL;
					ValaUnresolvedSymbol* _tmp24_ = NULL;
					_tmp22_ = type;
					_tmp23_ = vala_unresolved_symbol_new (NULL, "uchar", NULL);
					_tmp24_ = _tmp23_;
					vala_unresolved_type_set_unresolved_symbol (_tmp22_, _tmp24_);
					_vala_code_node_unref0 (_tmp24_);
				} else {
					GIdlNodeType* _tmp25_ = NULL;
					GITypeTag _tmp26_ = 0;
					_tmp25_ = type_node;
					_tmp26_ = _tmp25_->tag;
					if (_tmp26_ == TYPE_TAG_INT16) {
						ValaUnresolvedType* _tmp27_ = NULL;
						ValaUnresolvedSymbol* _tmp28_ = NULL;
						ValaUnresolvedSymbol* _tmp29_ = NULL;
						_tmp27_ = type;
						_tmp28_ = vala_unresolved_symbol_new (NULL, "int16", NULL);
						_tmp29_ = _tmp28_;
						vala_unresolved_type_set_unresolved_symbol (_tmp27_, _tmp29_);
						_vala_code_node_unref0 (_tmp29_);
					} else {
						GIdlNodeType* _tmp30_ = NULL;
						GITypeTag _tmp31_ = 0;
						_tmp30_ = type_node;
						_tmp31_ = _tmp30_->tag;
						if (_tmp31_ == TYPE_TAG_UINT16) {
							ValaUnresolvedType* _tmp32_ = NULL;
							ValaUnresolvedSymbol* _tmp33_ = NULL;
							ValaUnresolvedSymbol* _tmp34_ = NULL;
							_tmp32_ = type;
							_tmp33_ = vala_unresolved_symbol_new (NULL, "uint16", NULL);
							_tmp34_ = _tmp33_;
							vala_unresolved_type_set_unresolved_symbol (_tmp32_, _tmp34_);
							_vala_code_node_unref0 (_tmp34_);
						} else {
							GIdlNodeType* _tmp35_ = NULL;
							GITypeTag _tmp36_ = 0;
							_tmp35_ = type_node;
							_tmp36_ = _tmp35_->tag;
							if (_tmp36_ == TYPE_TAG_INT32) {
								ValaUnresolvedType* _tmp37_ = NULL;
								ValaUnresolvedSymbol* _tmp38_ = NULL;
								ValaUnresolvedSymbol* _tmp39_ = NULL;
								_tmp37_ = type;
								_tmp38_ = vala_unresolved_symbol_new (NULL, "int32", NULL);
								_tmp39_ = _tmp38_;
								vala_unresolved_type_set_unresolved_symbol (_tmp37_, _tmp39_);
								_vala_code_node_unref0 (_tmp39_);
							} else {
								GIdlNodeType* _tmp40_ = NULL;
								GITypeTag _tmp41_ = 0;
								_tmp40_ = type_node;
								_tmp41_ = _tmp40_->tag;
								if (_tmp41_ == TYPE_TAG_UINT32) {
									ValaUnresolvedType* _tmp42_ = NULL;
									ValaUnresolvedSymbol* _tmp43_ = NULL;
									ValaUnresolvedSymbol* _tmp44_ = NULL;
									_tmp42_ = type;
									_tmp43_ = vala_unresolved_symbol_new (NULL, "uint32", NULL);
									_tmp44_ = _tmp43_;
									vala_unresolved_type_set_unresolved_symbol (_tmp42_, _tmp44_);
									_vala_code_node_unref0 (_tmp44_);
								} else {
									GIdlNodeType* _tmp45_ = NULL;
									GITypeTag _tmp46_ = 0;
									_tmp45_ = type_node;
									_tmp46_ = _tmp45_->tag;
									if (_tmp46_ == TYPE_TAG_INT64) {
										ValaUnresolvedType* _tmp47_ = NULL;
										ValaUnresolvedSymbol* _tmp48_ = NULL;
										ValaUnresolvedSymbol* _tmp49_ = NULL;
										_tmp47_ = type;
										_tmp48_ = vala_unresolved_symbol_new (NULL, "int64", NULL);
										_tmp49_ = _tmp48_;
										vala_unresolved_type_set_unresolved_symbol (_tmp47_, _tmp49_);
										_vala_code_node_unref0 (_tmp49_);
									} else {
										GIdlNodeType* _tmp50_ = NULL;
										GITypeTag _tmp51_ = 0;
										_tmp50_ = type_node;
										_tmp51_ = _tmp50_->tag;
										if (_tmp51_ == TYPE_TAG_UINT64) {
											ValaUnresolvedType* _tmp52_ = NULL;
											ValaUnresolvedSymbol* _tmp53_ = NULL;
											ValaUnresolvedSymbol* _tmp54_ = NULL;
											_tmp52_ = type;
											_tmp53_ = vala_unresolved_symbol_new (NULL, "uint64", NULL);
											_tmp54_ = _tmp53_;
											vala_unresolved_type_set_unresolved_symbol (_tmp52_, _tmp54_);
											_vala_code_node_unref0 (_tmp54_);
										} else {
											GIdlNodeType* _tmp55_ = NULL;
											GITypeTag _tmp56_ = 0;
											_tmp55_ = type_node;
											_tmp56_ = _tmp55_->tag;
											if (_tmp56_ == TYPE_TAG_INT) {
												ValaUnresolvedType* _tmp57_ = NULL;
												ValaUnresolvedSymbol* _tmp58_ = NULL;
												ValaUnresolvedSymbol* _tmp59_ = NULL;
												_tmp57_ = type;
												_tmp58_ = vala_unresolved_symbol_new (NULL, "int", NULL);
												_tmp59_ = _tmp58_;
												vala_unresolved_type_set_unresolved_symbol (_tmp57_, _tmp59_);
												_vala_code_node_unref0 (_tmp59_);
											} else {
												GIdlNodeType* _tmp60_ = NULL;
												GITypeTag _tmp61_ = 0;
												_tmp60_ = type_node;
												_tmp61_ = _tmp60_->tag;
												if (_tmp61_ == TYPE_TAG_UINT) {
													ValaUnresolvedType* _tmp62_ = NULL;
													ValaUnresolvedSymbol* _tmp63_ = NULL;
													ValaUnresolvedSymbol* _tmp64_ = NULL;
													_tmp62_ = type;
													_tmp63_ = vala_unresolved_symbol_new (NULL, "uint", NULL);
													_tmp64_ = _tmp63_;
													vala_unresolved_type_set_unresolved_symbol (_tmp62_, _tmp64_);
													_vala_code_node_unref0 (_tmp64_);
												} else {
													GIdlNodeType* _tmp65_ = NULL;
													GITypeTag _tmp66_ = 0;
													_tmp65_ = type_node;
													_tmp66_ = _tmp65_->tag;
													if (_tmp66_ == TYPE_TAG_LONG) {
														ValaUnresolvedType* _tmp67_ = NULL;
														ValaUnresolvedSymbol* _tmp68_ = NULL;
														ValaUnresolvedSymbol* _tmp69_ = NULL;
														_tmp67_ = type;
														_tmp68_ = vala_unresolved_symbol_new (NULL, "long", NULL);
														_tmp69_ = _tmp68_;
														vala_unresolved_type_set_unresolved_symbol (_tmp67_, _tmp69_);
														_vala_code_node_unref0 (_tmp69_);
													} else {
														GIdlNodeType* _tmp70_ = NULL;
														GITypeTag _tmp71_ = 0;
														_tmp70_ = type_node;
														_tmp71_ = _tmp70_->tag;
														if (_tmp71_ == TYPE_TAG_ULONG) {
															ValaUnresolvedType* _tmp72_ = NULL;
															ValaUnresolvedSymbol* _tmp73_ = NULL;
															ValaUnresolvedSymbol* _tmp74_ = NULL;
															_tmp72_ = type;
															_tmp73_ = vala_unresolved_symbol_new (NULL, "ulong", NULL);
															_tmp74_ = _tmp73_;
															vala_unresolved_type_set_unresolved_symbol (_tmp72_, _tmp74_);
															_vala_code_node_unref0 (_tmp74_);
														} else {
															GIdlNodeType* _tmp75_ = NULL;
															GITypeTag _tmp76_ = 0;
															_tmp75_ = type_node;
															_tmp76_ = _tmp75_->tag;
															if (_tmp76_ == TYPE_TAG_SSIZE) {
																ValaUnresolvedType* _tmp77_ = NULL;
																ValaUnresolvedSymbol* _tmp78_ = NULL;
																ValaUnresolvedSymbol* _tmp79_ = NULL;
																_tmp77_ = type;
																_tmp78_ = vala_unresolved_symbol_new (NULL, "ssize_t", NULL);
																_tmp79_ = _tmp78_;
																vala_unresolved_type_set_unresolved_symbol (_tmp77_, _tmp79_);
																_vala_code_node_unref0 (_tmp79_);
															} else {
																GIdlNodeType* _tmp80_ = NULL;
																GITypeTag _tmp81_ = 0;
																_tmp80_ = type_node;
																_tmp81_ = _tmp80_->tag;
																if (_tmp81_ == TYPE_TAG_SIZE) {
																	ValaUnresolvedType* _tmp82_ = NULL;
																	ValaUnresolvedSymbol* _tmp83_ = NULL;
																	ValaUnresolvedSymbol* _tmp84_ = NULL;
																	_tmp82_ = type;
																	_tmp83_ = vala_unresolved_symbol_new (NULL, "size_t", NULL);
																	_tmp84_ = _tmp83_;
																	vala_unresolved_type_set_unresolved_symbol (_tmp82_, _tmp84_);
																	_vala_code_node_unref0 (_tmp84_);
																} else {
																	GIdlNodeType* _tmp85_ = NULL;
																	GITypeTag _tmp86_ = 0;
																	_tmp85_ = type_node;
																	_tmp86_ = _tmp85_->tag;
																	if (_tmp86_ == TYPE_TAG_FLOAT) {
																		ValaUnresolvedType* _tmp87_ = NULL;
																		ValaUnresolvedSymbol* _tmp88_ = NULL;
																		ValaUnresolvedSymbol* _tmp89_ = NULL;
																		_tmp87_ = type;
																		_tmp88_ = vala_unresolved_symbol_new (NULL, "float", NULL);
																		_tmp89_ = _tmp88_;
																		vala_unresolved_type_set_unresolved_symbol (_tmp87_, _tmp89_);
																		_vala_code_node_unref0 (_tmp89_);
																	} else {
																		GIdlNodeType* _tmp90_ = NULL;
																		GITypeTag _tmp91_ = 0;
																		_tmp90_ = type_node;
																		_tmp91_ = _tmp90_->tag;
																		if (_tmp91_ == TYPE_TAG_DOUBLE) {
																			ValaUnresolvedType* _tmp92_ = NULL;
																			ValaUnresolvedSymbol* _tmp93_ = NULL;
																			ValaUnresolvedSymbol* _tmp94_ = NULL;
																			_tmp92_ = type;
																			_tmp93_ = vala_unresolved_symbol_new (NULL, "double", NULL);
																			_tmp94_ = _tmp93_;
																			vala_unresolved_type_set_unresolved_symbol (_tmp92_, _tmp94_);
																			_vala_code_node_unref0 (_tmp94_);
																		} else {
																			GIdlNodeType* _tmp95_ = NULL;
																			GITypeTag _tmp96_ = 0;
																			_tmp95_ = type_node;
																			_tmp96_ = _tmp95_->tag;
																			if (_tmp96_ == TYPE_TAG_UTF8) {
																				ValaUnresolvedType* _tmp97_ = NULL;
																				ValaUnresolvedSymbol* _tmp98_ = NULL;
																				ValaUnresolvedSymbol* _tmp99_ = NULL;
																				_tmp97_ = type;
																				_tmp98_ = vala_unresolved_symbol_new (NULL, "string", NULL);
																				_tmp99_ = _tmp98_;
																				vala_unresolved_type_set_unresolved_symbol (_tmp97_, _tmp99_);
																				_vala_code_node_unref0 (_tmp99_);
																			} else {
																				GIdlNodeType* _tmp100_ = NULL;
																				GITypeTag _tmp101_ = 0;
																				_tmp100_ = type_node;
																				_tmp101_ = _tmp100_->tag;
																				if (_tmp101_ == TYPE_TAG_FILENAME) {
																					ValaUnresolvedType* _tmp102_ = NULL;
																					ValaUnresolvedSymbol* _tmp103_ = NULL;
																					ValaUnresolvedSymbol* _tmp104_ = NULL;
																					_tmp102_ = type;
																					_tmp103_ = vala_unresolved_symbol_new (NULL, "string", NULL);
																					_tmp104_ = _tmp103_;
																					vala_unresolved_type_set_unresolved_symbol (_tmp102_, _tmp104_);
																					_vala_code_node_unref0 (_tmp104_);
																				} else {
																					GIdlNodeType* _tmp105_ = NULL;
																					GITypeTag _tmp106_ = 0;
																					_tmp105_ = type_node;
																					_tmp106_ = _tmp105_->tag;
																					if (_tmp106_ == TYPE_TAG_ARRAY) {
																						ValaDataType* element_type = NULL;
																						GIdlNodeType* _tmp107_ = NULL;
																						GIdlNodeType* _tmp108_ = NULL;
																						ValaDataType* _tmp109_ = NULL;
																						ValaDataType* _tmp110_ = NULL;
																						ValaUnresolvedType* _tmp111_ = NULL;
																						ValaUnresolvedType* _tmp112_ = NULL;
																						ValaDataType* _tmp113_ = NULL;
																						ValaDataType* _tmp114_ = NULL;
																						ValaSourceReference* _tmp115_ = NULL;
																						ValaSourceReference* _tmp116_ = NULL;
																						ValaArrayType* _tmp117_ = NULL;
																						_tmp107_ = type_node;
																						_tmp108_ = _tmp107_->parameter_type1;
																						_tmp109_ = vala_gidl_parser_parse_type (self, _tmp108_, NULL);
																						element_type = _tmp109_;
																						_tmp110_ = element_type;
																						_tmp111_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp110_, VALA_TYPE_UNRESOLVED_TYPE) ? ((ValaUnresolvedType*) _tmp110_) : NULL);
																						_vala_code_node_unref0 (type);
																						type = _tmp111_;
																						_tmp112_ = type;
																						if (_tmp112_ == NULL) {
																							result = element_type;
																							_vala_code_node_unref0 (type);
																							if (direction) {
																								*direction = _vala_direction;
																							}
																							return result;
																						}
																						_tmp113_ = element_type;
																						_tmp114_ = element_type;
																						_tmp115_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp114_);
																						_tmp116_ = _tmp115_;
																						_tmp117_ = vala_array_type_new (_tmp113_, 1, _tmp116_);
																						result = (ValaDataType*) _tmp117_;
																						_vala_code_node_unref0 (element_type);
																						_vala_code_node_unref0 (type);
																						if (direction) {
																							*direction = _vala_direction;
																						}
																						return result;
																					} else {
																						GIdlNodeType* _tmp118_ = NULL;
																						GITypeTag _tmp119_ = 0;
																						_tmp118_ = type_node;
																						_tmp119_ = _tmp118_->tag;
																						if (_tmp119_ == TYPE_TAG_LIST) {
																							ValaUnresolvedType* _tmp120_ = NULL;
																							ValaUnresolvedSymbol* _tmp121_ = NULL;
																							ValaUnresolvedSymbol* _tmp122_ = NULL;
																							ValaUnresolvedSymbol* _tmp123_ = NULL;
																							ValaUnresolvedSymbol* _tmp124_ = NULL;
																							_tmp120_ = type;
																							_tmp121_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																							_tmp122_ = _tmp121_;
																							_tmp123_ = vala_unresolved_symbol_new (_tmp122_, "List", NULL);
																							_tmp124_ = _tmp123_;
																							vala_unresolved_type_set_unresolved_symbol (_tmp120_, _tmp124_);
																							_vala_code_node_unref0 (_tmp124_);
																							_vala_code_node_unref0 (_tmp122_);
																						} else {
																							GIdlNodeType* _tmp125_ = NULL;
																							GITypeTag _tmp126_ = 0;
																							_tmp125_ = type_node;
																							_tmp126_ = _tmp125_->tag;
																							if (_tmp126_ == TYPE_TAG_SLIST) {
																								ValaUnresolvedType* _tmp127_ = NULL;
																								ValaUnresolvedSymbol* _tmp128_ = NULL;
																								ValaUnresolvedSymbol* _tmp129_ = NULL;
																								ValaUnresolvedSymbol* _tmp130_ = NULL;
																								ValaUnresolvedSymbol* _tmp131_ = NULL;
																								_tmp127_ = type;
																								_tmp128_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																								_tmp129_ = _tmp128_;
																								_tmp130_ = vala_unresolved_symbol_new (_tmp129_, "SList", NULL);
																								_tmp131_ = _tmp130_;
																								vala_unresolved_type_set_unresolved_symbol (_tmp127_, _tmp131_);
																								_vala_code_node_unref0 (_tmp131_);
																								_vala_code_node_unref0 (_tmp129_);
																							} else {
																								GIdlNodeType* _tmp132_ = NULL;
																								GITypeTag _tmp133_ = 0;
																								_tmp132_ = type_node;
																								_tmp133_ = _tmp132_->tag;
																								if (_tmp133_ == TYPE_TAG_HASH) {
																									ValaUnresolvedType* _tmp134_ = NULL;
																									ValaUnresolvedSymbol* _tmp135_ = NULL;
																									ValaUnresolvedSymbol* _tmp136_ = NULL;
																									ValaUnresolvedSymbol* _tmp137_ = NULL;
																									ValaUnresolvedSymbol* _tmp138_ = NULL;
																									_tmp134_ = type;
																									_tmp135_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																									_tmp136_ = _tmp135_;
																									_tmp137_ = vala_unresolved_symbol_new (_tmp136_, "HashTable", NULL);
																									_tmp138_ = _tmp137_;
																									vala_unresolved_type_set_unresolved_symbol (_tmp134_, _tmp138_);
																									_vala_code_node_unref0 (_tmp138_);
																									_vala_code_node_unref0 (_tmp136_);
																								} else {
																									GIdlNodeType* _tmp139_ = NULL;
																									GITypeTag _tmp140_ = 0;
																									_tmp139_ = type_node;
																									_tmp140_ = _tmp139_->tag;
																									if (_tmp140_ == TYPE_TAG_ERROR) {
																										ValaUnresolvedType* _tmp141_ = NULL;
																										ValaUnresolvedSymbol* _tmp142_ = NULL;
																										ValaUnresolvedSymbol* _tmp143_ = NULL;
																										ValaUnresolvedSymbol* _tmp144_ = NULL;
																										ValaUnresolvedSymbol* _tmp145_ = NULL;
																										_tmp141_ = type;
																										_tmp142_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																										_tmp143_ = _tmp142_;
																										_tmp144_ = vala_unresolved_symbol_new (_tmp143_, "Error", NULL);
																										_tmp145_ = _tmp144_;
																										vala_unresolved_type_set_unresolved_symbol (_tmp141_, _tmp145_);
																										_vala_code_node_unref0 (_tmp145_);
																										_vala_code_node_unref0 (_tmp143_);
																									} else {
																										GIdlNodeType* _tmp146_ = NULL;
																										gboolean _tmp147_ = FALSE;
																										_tmp146_ = type_node;
																										_tmp147_ = _tmp146_->is_interface;
																										if (_tmp147_) {
																											gchar* n = NULL;
																											GIdlNodeType* _tmp148_ = NULL;
																											const gchar* _tmp149_ = NULL;
																											gchar* _tmp150_ = NULL;
																											const gchar* _tmp151_ = NULL;
																											const gchar* _tmp152_ = NULL;
																											gboolean _tmp153_ = FALSE;
																											gboolean _tmp158_ = FALSE;
																											GIdlNodeType* _tmp159_ = NULL;
																											gboolean _tmp160_ = FALSE;
																											gboolean _tmp165_ = FALSE;
																											_tmp148_ = type_node;
																											_tmp149_ = _tmp148_->interface;
																											_tmp150_ = g_strdup (_tmp149_);
																											n = _tmp150_;
																											_tmp151_ = n;
																											if (g_strcmp0 (_tmp151_, "") == 0) {
																												result = NULL;
																												_g_free0 (n);
																												_vala_code_node_unref0 (type);
																												if (direction) {
																													*direction = _vala_direction;
																												}
																												return result;
																											}
																											_tmp152_ = n;
																											_tmp153_ = g_str_has_prefix (_tmp152_, "const-");
																											if (_tmp153_) {
																												const gchar* _tmp154_ = NULL;
																												gint _tmp155_ = 0;
																												gint _tmp156_ = 0;
																												gchar* _tmp157_ = NULL;
																												_tmp154_ = n;
																												_tmp155_ = strlen ("const-");
																												_tmp156_ = _tmp155_;
																												_tmp157_ = string_substring (_tmp154_, (glong) _tmp156_, (glong) (-1));
																												_g_free0 (n);
																												n = _tmp157_;
																											}
																											_tmp159_ = type_node;
																											_tmp160_ = _tmp159_->is_pointer;
																											if (_tmp160_) {
																												gboolean _tmp161_ = FALSE;
																												const gchar* _tmp162_ = NULL;
																												gboolean _tmp164_ = FALSE;
																												_tmp162_ = n;
																												if (g_strcmp0 (_tmp162_, "gchar") == 0) {
																													_tmp161_ = TRUE;
																												} else {
																													const gchar* _tmp163_ = NULL;
																													_tmp163_ = n;
																													_tmp161_ = g_strcmp0 (_tmp163_, "char") == 0;
																												}
																												_tmp164_ = _tmp161_;
																												_tmp158_ = _tmp164_;
																											} else {
																												_tmp158_ = FALSE;
																											}
																											_tmp165_ = _tmp158_;
																											if (_tmp165_) {
																												ValaUnresolvedType* _tmp166_ = NULL;
																												ValaUnresolvedSymbol* _tmp167_ = NULL;
																												ValaUnresolvedSymbol* _tmp168_ = NULL;
																												GIdlNodeType* _tmp169_ = NULL;
																												const gchar* _tmp170_ = NULL;
																												gboolean _tmp171_ = FALSE;
																												_tmp166_ = type;
																												_tmp167_ = vala_unresolved_symbol_new (NULL, "string", NULL);
																												_tmp168_ = _tmp167_;
																												vala_unresolved_type_set_unresolved_symbol (_tmp166_, _tmp168_);
																												_vala_code_node_unref0 (_tmp168_);
																												_tmp169_ = type_node;
																												_tmp170_ = _tmp169_->unparsed;
																												_tmp171_ = g_str_has_suffix (_tmp170_, "**");
																												if (_tmp171_) {
																													_vala_direction = VALA_PARAMETER_DIRECTION_OUT;
																												}
																											} else {
																												const gchar* _tmp172_ = NULL;
																												_tmp172_ = n;
																												if (g_strcmp0 (_tmp172_, "gunichar") == 0) {
																													ValaUnresolvedType* _tmp173_ = NULL;
																													ValaUnresolvedSymbol* _tmp174_ = NULL;
																													ValaUnresolvedSymbol* _tmp175_ = NULL;
																													_tmp173_ = type;
																													_tmp174_ = vala_unresolved_symbol_new (NULL, "unichar", NULL);
																													_tmp175_ = _tmp174_;
																													vala_unresolved_type_set_unresolved_symbol (_tmp173_, _tmp175_);
																													_vala_code_node_unref0 (_tmp175_);
																												} else {
																													const gchar* _tmp176_ = NULL;
																													_tmp176_ = n;
																													if (g_strcmp0 (_tmp176_, "gchar") == 0) {
																														ValaUnresolvedType* _tmp177_ = NULL;
																														ValaUnresolvedSymbol* _tmp178_ = NULL;
																														ValaUnresolvedSymbol* _tmp179_ = NULL;
																														_tmp177_ = type;
																														_tmp178_ = vala_unresolved_symbol_new (NULL, "char", NULL);
																														_tmp179_ = _tmp178_;
																														vala_unresolved_type_set_unresolved_symbol (_tmp177_, _tmp179_);
																														_vala_code_node_unref0 (_tmp179_);
																													} else {
																														gboolean _tmp180_ = FALSE;
																														const gchar* _tmp181_ = NULL;
																														gboolean _tmp183_ = FALSE;
																														_tmp181_ = n;
																														if (g_strcmp0 (_tmp181_, "guchar") == 0) {
																															_tmp180_ = TRUE;
																														} else {
																															const gchar* _tmp182_ = NULL;
																															_tmp182_ = n;
																															_tmp180_ = g_strcmp0 (_tmp182_, "guint8") == 0;
																														}
																														_tmp183_ = _tmp180_;
																														if (_tmp183_) {
																															ValaUnresolvedType* _tmp184_ = NULL;
																															ValaUnresolvedSymbol* _tmp185_ = NULL;
																															ValaUnresolvedSymbol* _tmp186_ = NULL;
																															GIdlNodeType* _tmp187_ = NULL;
																															gboolean _tmp188_ = FALSE;
																															_tmp184_ = type;
																															_tmp185_ = vala_unresolved_symbol_new (NULL, "uchar", NULL);
																															_tmp186_ = _tmp185_;
																															vala_unresolved_type_set_unresolved_symbol (_tmp184_, _tmp186_);
																															_vala_code_node_unref0 (_tmp186_);
																															_tmp187_ = type_node;
																															_tmp188_ = _tmp187_->is_pointer;
																															if (_tmp188_) {
																																ValaUnresolvedType* _tmp189_ = NULL;
																																ValaUnresolvedType* _tmp190_ = NULL;
																																ValaSourceReference* _tmp191_ = NULL;
																																ValaSourceReference* _tmp192_ = NULL;
																																ValaArrayType* _tmp193_ = NULL;
																																_tmp189_ = type;
																																_tmp190_ = type;
																																_tmp191_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp190_);
																																_tmp192_ = _tmp191_;
																																_tmp193_ = vala_array_type_new ((ValaDataType*) _tmp189_, 1, _tmp192_);
																																result = (ValaDataType*) _tmp193_;
																																_g_free0 (n);
																																_vala_code_node_unref0 (type);
																																if (direction) {
																																	*direction = _vala_direction;
																																}
																																return result;
																															}
																														} else {
																															const gchar* _tmp194_ = NULL;
																															_tmp194_ = n;
																															if (g_strcmp0 (_tmp194_, "gushort") == 0) {
																																ValaUnresolvedType* _tmp195_ = NULL;
																																ValaUnresolvedSymbol* _tmp196_ = NULL;
																																ValaUnresolvedSymbol* _tmp197_ = NULL;
																																_tmp195_ = type;
																																_tmp196_ = vala_unresolved_symbol_new (NULL, "ushort", NULL);
																																_tmp197_ = _tmp196_;
																																vala_unresolved_type_set_unresolved_symbol (_tmp195_, _tmp197_);
																																_vala_code_node_unref0 (_tmp197_);
																															} else {
																																const gchar* _tmp198_ = NULL;
																																_tmp198_ = n;
																																if (g_strcmp0 (_tmp198_, "gshort") == 0) {
																																	ValaUnresolvedType* _tmp199_ = NULL;
																																	ValaUnresolvedSymbol* _tmp200_ = NULL;
																																	ValaUnresolvedSymbol* _tmp201_ = NULL;
																																	_tmp199_ = type;
																																	_tmp200_ = vala_unresolved_symbol_new (NULL, "short", NULL);
																																	_tmp201_ = _tmp200_;
																																	vala_unresolved_type_set_unresolved_symbol (_tmp199_, _tmp201_);
																																	_vala_code_node_unref0 (_tmp201_);
																																} else {
																																	gboolean _tmp202_ = FALSE;
																																	const gchar* _tmp203_ = NULL;
																																	gboolean _tmp205_ = FALSE;
																																	_tmp203_ = n;
																																	if (g_strcmp0 (_tmp203_, "gconstpointer") == 0) {
																																		_tmp202_ = TRUE;
																																	} else {
																																		const gchar* _tmp204_ = NULL;
																																		_tmp204_ = n;
																																		_tmp202_ = g_strcmp0 (_tmp204_, "void") == 0;
																																	}
																																	_tmp205_ = _tmp202_;
																																	if (_tmp205_) {
																																		ValaVoidType* _tmp206_ = NULL;
																																		ValaVoidType* _tmp207_ = NULL;
																																		ValaPointerType* _tmp208_ = NULL;
																																		ValaDataType* _tmp209_ = NULL;
																																		_tmp206_ = vala_void_type_new (NULL);
																																		_tmp207_ = _tmp206_;
																																		_tmp208_ = vala_pointer_type_new ((ValaDataType*) _tmp207_, NULL);
																																		_tmp209_ = (ValaDataType*) _tmp208_;
																																		_vala_code_node_unref0 (_tmp207_);
																																		result = _tmp209_;
																																		_g_free0 (n);
																																		_vala_code_node_unref0 (type);
																																		if (direction) {
																																			*direction = _vala_direction;
																																		}
																																		return result;
																																	} else {
																																		gboolean _tmp210_ = FALSE;
																																		const gchar* _tmp211_ = NULL;
																																		gboolean _tmp213_ = FALSE;
																																		_tmp211_ = n;
																																		if (g_strcmp0 (_tmp211_, "goffset") == 0) {
																																			_tmp210_ = TRUE;
																																		} else {
																																			const gchar* _tmp212_ = NULL;
																																			_tmp212_ = n;
																																			_tmp210_ = g_strcmp0 (_tmp212_, "off_t") == 0;
																																		}
																																		_tmp213_ = _tmp210_;
																																		if (_tmp213_) {
																																			ValaUnresolvedType* _tmp214_ = NULL;
																																			ValaUnresolvedSymbol* _tmp215_ = NULL;
																																			ValaUnresolvedSymbol* _tmp216_ = NULL;
																																			_tmp214_ = type;
																																			_tmp215_ = vala_unresolved_symbol_new (NULL, "int64", NULL);
																																			_tmp216_ = _tmp215_;
																																			vala_unresolved_type_set_unresolved_symbol (_tmp214_, _tmp216_);
																																			_vala_code_node_unref0 (_tmp216_);
																																		} else {
																																			const gchar* _tmp217_ = NULL;
																																			_tmp217_ = n;
																																			if (g_strcmp0 (_tmp217_, "value_array") == 0) {
																																				ValaUnresolvedType* _tmp218_ = NULL;
																																				ValaUnresolvedSymbol* _tmp219_ = NULL;
																																				ValaUnresolvedSymbol* _tmp220_ = NULL;
																																				ValaUnresolvedSymbol* _tmp221_ = NULL;
																																				ValaUnresolvedSymbol* _tmp222_ = NULL;
																																				_tmp218_ = type;
																																				_tmp219_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																																				_tmp220_ = _tmp219_;
																																				_tmp221_ = vala_unresolved_symbol_new (_tmp220_, "ValueArray", NULL);
																																				_tmp222_ = _tmp221_;
																																				vala_unresolved_type_set_unresolved_symbol (_tmp218_, _tmp222_);
																																				_vala_code_node_unref0 (_tmp222_);
																																				_vala_code_node_unref0 (_tmp220_);
																																			} else {
																																				const gchar* _tmp223_ = NULL;
																																				_tmp223_ = n;
																																				if (g_strcmp0 (_tmp223_, "time_t") == 0) {
																																					ValaUnresolvedType* _tmp224_ = NULL;
																																					ValaUnresolvedSymbol* _tmp225_ = NULL;
																																					ValaUnresolvedSymbol* _tmp226_ = NULL;
																																					_tmp224_ = type;
																																					_tmp225_ = vala_unresolved_symbol_new (NULL, "ulong", NULL);
																																					_tmp226_ = _tmp225_;
																																					vala_unresolved_type_set_unresolved_symbol (_tmp224_, _tmp226_);
																																					_vala_code_node_unref0 (_tmp226_);
																																				} else {
																																					const gchar* _tmp227_ = NULL;
																																					_tmp227_ = n;
																																					if (g_strcmp0 (_tmp227_, "socklen_t") == 0) {
																																						ValaUnresolvedType* _tmp228_ = NULL;
																																						ValaUnresolvedSymbol* _tmp229_ = NULL;
																																						ValaUnresolvedSymbol* _tmp230_ = NULL;
																																						_tmp228_ = type;
																																						_tmp229_ = vala_unresolved_symbol_new (NULL, "uint32", NULL);
																																						_tmp230_ = _tmp229_;
																																						vala_unresolved_type_set_unresolved_symbol (_tmp228_, _tmp230_);
																																						_vala_code_node_unref0 (_tmp230_);
																																					} else {
																																						const gchar* _tmp231_ = NULL;
																																						_tmp231_ = n;
																																						if (g_strcmp0 (_tmp231_, "mode_t") == 0) {
																																							ValaUnresolvedType* _tmp232_ = NULL;
																																							ValaUnresolvedSymbol* _tmp233_ = NULL;
																																							ValaUnresolvedSymbol* _tmp234_ = NULL;
																																							_tmp232_ = type;
																																							_tmp233_ = vala_unresolved_symbol_new (NULL, "uint", NULL);
																																							_tmp234_ = _tmp233_;
																																							vala_unresolved_type_set_unresolved_symbol (_tmp232_, _tmp234_);
																																							_vala_code_node_unref0 (_tmp234_);
																																						} else {
																																							gboolean _tmp235_ = FALSE;
																																							const gchar* _tmp236_ = NULL;
																																							gboolean _tmp238_ = FALSE;
																																							_tmp236_ = n;
																																							if (g_strcmp0 (_tmp236_, "gint") == 0) {
																																								_tmp235_ = TRUE;
																																							} else {
																																								const gchar* _tmp237_ = NULL;
																																								_tmp237_ = n;
																																								_tmp235_ = g_strcmp0 (_tmp237_, "pid_t") == 0;
																																							}
																																							_tmp238_ = _tmp235_;
																																							if (_tmp238_) {
																																								ValaUnresolvedType* _tmp239_ = NULL;
																																								ValaUnresolvedSymbol* _tmp240_ = NULL;
																																								ValaUnresolvedSymbol* _tmp241_ = NULL;
																																								_tmp239_ = type;
																																								_tmp240_ = vala_unresolved_symbol_new (NULL, "int", NULL);
																																								_tmp241_ = _tmp240_;
																																								vala_unresolved_type_set_unresolved_symbol (_tmp239_, _tmp241_);
																																								_vala_code_node_unref0 (_tmp241_);
																																							} else {
																																								gboolean _tmp242_ = FALSE;
																																								const gchar* _tmp243_ = NULL;
																																								gboolean _tmp245_ = FALSE;
																																								_tmp243_ = n;
																																								if (g_strcmp0 (_tmp243_, "unsigned") == 0) {
																																									_tmp242_ = TRUE;
																																								} else {
																																									const gchar* _tmp244_ = NULL;
																																									_tmp244_ = n;
																																									_tmp242_ = g_strcmp0 (_tmp244_, "unsigned-int") == 0;
																																								}
																																								_tmp245_ = _tmp242_;
																																								if (_tmp245_) {
																																									ValaUnresolvedType* _tmp246_ = NULL;
																																									ValaUnresolvedSymbol* _tmp247_ = NULL;
																																									ValaUnresolvedSymbol* _tmp248_ = NULL;
																																									_tmp246_ = type;
																																									_tmp247_ = vala_unresolved_symbol_new (NULL, "uint", NULL);
																																									_tmp248_ = _tmp247_;
																																									vala_unresolved_type_set_unresolved_symbol (_tmp246_, _tmp248_);
																																									_vala_code_node_unref0 (_tmp248_);
																																								} else {
																																									const gchar* _tmp249_ = NULL;
																																									_tmp249_ = n;
																																									if (g_strcmp0 (_tmp249_, "FILE") == 0) {
																																										ValaUnresolvedType* _tmp250_ = NULL;
																																										ValaUnresolvedSymbol* _tmp251_ = NULL;
																																										ValaUnresolvedSymbol* _tmp252_ = NULL;
																																										ValaUnresolvedSymbol* _tmp253_ = NULL;
																																										ValaUnresolvedSymbol* _tmp254_ = NULL;
																																										_tmp250_ = type;
																																										_tmp251_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																																										_tmp252_ = _tmp251_;
																																										_tmp253_ = vala_unresolved_symbol_new (_tmp252_, "FileStream", NULL);
																																										_tmp254_ = _tmp253_;
																																										vala_unresolved_type_set_unresolved_symbol (_tmp250_, _tmp254_);
																																										_vala_code_node_unref0 (_tmp254_);
																																										_vala_code_node_unref0 (_tmp252_);
																																									} else {
																																										const gchar* _tmp255_ = NULL;
																																										_tmp255_ = n;
																																										if (g_strcmp0 (_tmp255_, "struct") == 0) {
																																											ValaVoidType* _tmp256_ = NULL;
																																											ValaVoidType* _tmp257_ = NULL;
																																											ValaPointerType* _tmp258_ = NULL;
																																											ValaDataType* _tmp259_ = NULL;
																																											_tmp256_ = vala_void_type_new (NULL);
																																											_tmp257_ = _tmp256_;
																																											_tmp258_ = vala_pointer_type_new ((ValaDataType*) _tmp257_, NULL);
																																											_tmp259_ = (ValaDataType*) _tmp258_;
																																											_vala_code_node_unref0 (_tmp257_);
																																											result = _tmp259_;
																																											_g_free0 (n);
																																											_vala_code_node_unref0 (type);
																																											if (direction) {
																																												*direction = _vala_direction;
																																											}
																																											return result;
																																										} else {
																																											const gchar* _tmp260_ = NULL;
																																											_tmp260_ = n;
																																											if (g_strcmp0 (_tmp260_, "iconv_t") == 0) {
																																												ValaVoidType* _tmp261_ = NULL;
																																												ValaVoidType* _tmp262_ = NULL;
																																												ValaPointerType* _tmp263_ = NULL;
																																												ValaDataType* _tmp264_ = NULL;
																																												_tmp261_ = vala_void_type_new (NULL);
																																												_tmp262_ = _tmp261_;
																																												_tmp263_ = vala_pointer_type_new ((ValaDataType*) _tmp262_, NULL);
																																												_tmp264_ = (ValaDataType*) _tmp263_;
																																												_vala_code_node_unref0 (_tmp262_);
																																												result = _tmp264_;
																																												_g_free0 (n);
																																												_vala_code_node_unref0 (type);
																																												if (direction) {
																																													*direction = _vala_direction;
																																												}
																																												return result;
																																											} else {
																																												const gchar* _tmp265_ = NULL;
																																												_tmp265_ = n;
																																												if (g_strcmp0 (_tmp265_, "GType") == 0) {
																																													ValaUnresolvedType* _tmp266_ = NULL;
																																													ValaUnresolvedSymbol* _tmp267_ = NULL;
																																													ValaUnresolvedSymbol* _tmp268_ = NULL;
																																													ValaUnresolvedSymbol* _tmp269_ = NULL;
																																													ValaUnresolvedSymbol* _tmp270_ = NULL;
																																													GIdlNodeType* _tmp271_ = NULL;
																																													gboolean _tmp272_ = FALSE;
																																													_tmp266_ = type;
																																													_tmp267_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
																																													_tmp268_ = _tmp267_;
																																													_tmp269_ = vala_unresolved_symbol_new (_tmp268_, "Type", NULL);
																																													_tmp270_ = _tmp269_;
																																													vala_unresolved_type_set_unresolved_symbol (_tmp266_, _tmp270_);
																																													_vala_code_node_unref0 (_tmp270_);
																																													_vala_code_node_unref0 (_tmp268_);
																																													_tmp271_ = type_node;
																																													_tmp272_ = _tmp271_->is_pointer;
																																													if (_tmp272_) {
																																														ValaUnresolvedType* _tmp273_ = NULL;
																																														ValaUnresolvedType* _tmp274_ = NULL;
																																														ValaSourceReference* _tmp275_ = NULL;
																																														ValaSourceReference* _tmp276_ = NULL;
																																														ValaArrayType* _tmp277_ = NULL;
																																														_tmp273_ = type;
																																														_tmp274_ = type;
																																														_tmp275_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp274_);
																																														_tmp276_ = _tmp275_;
																																														_tmp277_ = vala_array_type_new ((ValaDataType*) _tmp273_, 1, _tmp276_);
																																														result = (ValaDataType*) _tmp277_;
																																														_g_free0 (n);
																																														_vala_code_node_unref0 (type);
																																														if (direction) {
																																															*direction = _vala_direction;
																																														}
																																														return result;
																																													}
																																												} else {
																																													const gchar* _tmp278_ = NULL;
																																													_tmp278_ = n;
																																													if (g_strcmp0 (_tmp278_, "GStrv") == 0) {
																																														ValaUnresolvedType* _tmp279_ = NULL;
																																														ValaUnresolvedSymbol* _tmp280_ = NULL;
																																														ValaUnresolvedSymbol* _tmp281_ = NULL;
																																														ValaUnresolvedType* _tmp282_ = NULL;
																																														ValaUnresolvedType* _tmp283_ = NULL;
																																														ValaSourceReference* _tmp284_ = NULL;
																																														ValaSourceReference* _tmp285_ = NULL;
																																														ValaArrayType* _tmp286_ = NULL;
																																														_tmp279_ = type;
																																														_tmp280_ = vala_unresolved_symbol_new (NULL, "string", NULL);
																																														_tmp281_ = _tmp280_;
																																														vala_unresolved_type_set_unresolved_symbol (_tmp279_, _tmp281_);
																																														_vala_code_node_unref0 (_tmp281_);
																																														_tmp282_ = type;
																																														_tmp283_ = type;
																																														_tmp284_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp283_);
																																														_tmp285_ = _tmp284_;
																																														_tmp286_ = vala_array_type_new ((ValaDataType*) _tmp282_, 1, _tmp285_);
																																														result = (ValaDataType*) _tmp286_;
																																														_g_free0 (n);
																																														_vala_code_node_unref0 (type);
																																														if (direction) {
																																															*direction = _vala_direction;
																																														}
																																														return result;
																																													} else {
																																														ValaDataType* named_type = NULL;
																																														const gchar* _tmp287_ = NULL;
																																														ValaDataType* _tmp288_ = NULL;
																																														ValaDataType* _tmp289_ = NULL;
																																														ValaUnresolvedType* _tmp290_ = NULL;
																																														ValaUnresolvedType* _tmp291_ = NULL;
																																														const gchar* _tmp292_ = NULL;
																																														gboolean _tmp293_ = FALSE;
																																														_tmp287_ = n;
																																														_tmp288_ = vala_gidl_parser_parse_type_string (self, _tmp287_);
																																														named_type = _tmp288_;
																																														_tmp289_ = named_type;
																																														_tmp290_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp289_, VALA_TYPE_UNRESOLVED_TYPE) ? ((ValaUnresolvedType*) _tmp289_) : NULL);
																																														_vala_code_node_unref0 (type);
																																														type = _tmp290_;
																																														_tmp291_ = type;
																																														if (_tmp291_ == NULL) {
																																															result = named_type;
																																															_g_free0 (n);
																																															_vala_code_node_unref0 (type);
																																															if (direction) {
																																																*direction = _vala_direction;
																																															}
																																															return result;
																																														}
																																														_tmp292_ = n;
																																														_tmp293_ = vala_gidl_parser_is_simple_type (self, _tmp292_);
																																														if (_tmp293_) {
																																															GIdlNodeType* _tmp294_ = NULL;
																																															gboolean _tmp295_ = FALSE;
																																															_tmp294_ = type_node;
																																															_tmp295_ = _tmp294_->is_pointer;
																																															if (_tmp295_) {
																																																_vala_direction = VALA_PARAMETER_DIRECTION_OUT;
																																															}
																																														} else {
																																															GIdlNodeType* _tmp296_ = NULL;
																																															const gchar* _tmp297_ = NULL;
																																															gboolean _tmp298_ = FALSE;
																																															_tmp296_ = type_node;
																																															_tmp297_ = _tmp296_->unparsed;
																																															_tmp298_ = g_str_has_suffix (_tmp297_, "**");
																																															if (_tmp298_) {
																																																_vala_direction = VALA_PARAMETER_DIRECTION_OUT;
																																															}
																																														}
																																														_vala_code_node_unref0 (named_type);
																																													}
																																												}
																																											}
																																										}
																																									}
																																								}
																																							}
																																						}
																																					}
																																				}
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													}
																												}
																											}
																											_g_free0 (n);
																										} else {
																											FILE* _tmp299_ = NULL;
																											GIdlNodeType* _tmp300_ = NULL;
																											GITypeTag _tmp301_ = 0;
																											_tmp299_ = stdout;
																											_tmp300_ = type_node;
																											_tmp301_ = _tmp300_->tag;
																											fprintf (_tmp299_, "%d\n", (gint) _tmp301_);
																										}
																									}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		}
	}
	result = (ValaDataType*) type;
	if (direction) {
		*direction = _vala_direction;
	}
	return result;
}


static gboolean vala_gidl_parser_is_simple_type (ValaGIdlParser* self, const gchar* type_name) {
	gboolean result = FALSE;
	ValaStruct* st = NULL;
	ValaMap* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
	ValaTypeSymbol* _tmp3_ = NULL;
	ValaStruct* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	ValaStruct* _tmp6_ = NULL;
	gboolean _tmp9_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (type_name != NULL, FALSE);
	_tmp0_ = self->priv->cname_type_map;
	_tmp1_ = type_name;
	_tmp2_ = vala_map_get (_tmp0_, _tmp1_);
	_tmp3_ = (ValaTypeSymbol*) _tmp2_;
	_tmp4_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, VALA_TYPE_STRUCT) ? ((ValaStruct*) _tmp3_) : NULL;
	if (_tmp4_ == NULL) {
		_vala_code_node_unref0 (_tmp3_);
	}
	st = _tmp4_;
	_tmp6_ = st;
	if (_tmp6_ != NULL) {
		ValaStruct* _tmp7_ = NULL;
		gboolean _tmp8_ = FALSE;
		_tmp7_ = st;
		_tmp8_ = vala_struct_is_simple_type (_tmp7_);
		_tmp5_ = _tmp8_;
	} else {
		_tmp5_ = FALSE;
	}
	_tmp9_ = _tmp5_;
	if (_tmp9_) {
		result = TRUE;
		_vala_code_node_unref0 (st);
		return result;
	}
	result = FALSE;
	_vala_code_node_unref0 (st);
	return result;
}


static ValaDataType* vala_gidl_parser_parse_type_string (ValaGIdlParser* self, const gchar* n) {
	ValaDataType* result = NULL;
	const gchar* _tmp0_ = NULL;
	ValaUnresolvedType* type = NULL;
	ValaUnresolvedType* _tmp5_ = NULL;
	ValaTypeSymbol* dt = NULL;
	ValaMap* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gpointer _tmp8_ = NULL;
	ValaTypeSymbol* _tmp9_ = NULL;
	gchar** type_attributes = NULL;
	const gchar* _tmp28_ = NULL;
	gint _tmp29_ = 0;
	gchar** _tmp30_ = NULL;
	gint type_attributes_length1 = 0;
	gint _type_attributes_size_ = 0;
	gchar* ns_name = NULL;
	gchar** _tmp31_ = NULL;
	gint _tmp31__length1 = 0;
	ValaUnresolvedType* _tmp74_ = NULL;
	ValaUnresolvedSymbol* _tmp75_ = NULL;
	ValaUnresolvedSymbol* _tmp76_ = NULL;
	const gchar* _tmp93_ = NULL;
	ValaNamespace* _tmp94_ = NULL;
	const gchar* _tmp95_ = NULL;
	const gchar* _tmp96_ = NULL;
	gboolean _tmp97_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (n != NULL, NULL);
	_tmp0_ = n;
	if (g_strcmp0 (_tmp0_, "va_list") == 0) {
		ValaVoidType* _tmp1_ = NULL;
		ValaVoidType* _tmp2_ = NULL;
		ValaPointerType* _tmp3_ = NULL;
		ValaDataType* _tmp4_ = NULL;
		_tmp1_ = vala_void_type_new (NULL);
		_tmp2_ = _tmp1_;
		_tmp3_ = vala_pointer_type_new ((ValaDataType*) _tmp2_, NULL);
		_tmp4_ = (ValaDataType*) _tmp3_;
		_vala_code_node_unref0 (_tmp2_);
		result = _tmp4_;
		return result;
	}
	_tmp5_ = vala_unresolved_type_new ();
	type = _tmp5_;
	_tmp6_ = self->priv->cname_type_map;
	_tmp7_ = n;
	_tmp8_ = vala_map_get (_tmp6_, _tmp7_);
	dt = (ValaTypeSymbol*) _tmp8_;
	_tmp9_ = dt;
	if (_tmp9_ != NULL) {
		ValaUnresolvedSymbol* parent_symbol = NULL;
		ValaTypeSymbol* _tmp10_ = NULL;
		ValaSymbol* _tmp11_ = NULL;
		ValaSymbol* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		const gchar* _tmp14_ = NULL;
		ValaUnresolvedType* _tmp21_ = NULL;
		ValaUnresolvedSymbol* _tmp22_ = NULL;
		ValaTypeSymbol* _tmp23_ = NULL;
		const gchar* _tmp24_ = NULL;
		const gchar* _tmp25_ = NULL;
		ValaUnresolvedSymbol* _tmp26_ = NULL;
		ValaUnresolvedSymbol* _tmp27_ = NULL;
		parent_symbol = NULL;
		_tmp10_ = dt;
		_tmp11_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp10_);
		_tmp12_ = _tmp11_;
		_tmp13_ = vala_symbol_get_name (_tmp12_);
		_tmp14_ = _tmp13_;
		if (_tmp14_ != NULL) {
			ValaTypeSymbol* _tmp15_ = NULL;
			ValaSymbol* _tmp16_ = NULL;
			ValaSymbol* _tmp17_ = NULL;
			const gchar* _tmp18_ = NULL;
			const gchar* _tmp19_ = NULL;
			ValaUnresolvedSymbol* _tmp20_ = NULL;
			_tmp15_ = dt;
			_tmp16_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp15_);
			_tmp17_ = _tmp16_;
			_tmp18_ = vala_symbol_get_name (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp20_ = vala_unresolved_symbol_new (NULL, _tmp19_, NULL);
			_vala_code_node_unref0 (parent_symbol);
			parent_symbol = _tmp20_;
		}
		_tmp21_ = type;
		_tmp22_ = parent_symbol;
		_tmp23_ = dt;
		_tmp24_ = vala_symbol_get_name ((ValaSymbol*) _tmp23_);
		_tmp25_ = _tmp24_;
		_tmp26_ = vala_unresolved_symbol_new (_tmp22_, _tmp25_, NULL);
		_tmp27_ = _tmp26_;
		vala_unresolved_type_set_unresolved_symbol (_tmp21_, _tmp27_);
		_vala_code_node_unref0 (_tmp27_);
		result = (ValaDataType*) type;
		_vala_code_node_unref0 (parent_symbol);
		_vala_code_node_unref0 (dt);
		return result;
	}
	_tmp28_ = n;
	_tmp30_ = vala_gidl_parser_get_attributes (self, _tmp28_, &_tmp29_);
	type_attributes = _tmp30_;
	type_attributes_length1 = _tmp29_;
	_type_attributes_size_ = type_attributes_length1;
	ns_name = NULL;
	_tmp31_ = type_attributes;
	_tmp31__length1 = type_attributes_length1;
	if (NULL != _tmp31_) {
		gchar** _tmp32_ = NULL;
		gint _tmp32__length1 = 0;
		_tmp32_ = type_attributes;
		_tmp32__length1 = type_attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp32_;
			attr_collection_length1 = _tmp32__length1;
			for (attr_it = 0; attr_it < _tmp32__length1; attr_it = attr_it + 1) {
				gchar* _tmp33_ = NULL;
				gchar* attr = NULL;
				_tmp33_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp33_;
				{
					gchar** nv = NULL;
					const gchar* _tmp34_ = NULL;
					gchar** _tmp35_ = NULL;
					gchar** _tmp36_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp37_ = NULL;
					gint _tmp37__length1 = 0;
					const gchar* _tmp38_ = NULL;
					_tmp34_ = attr;
					_tmp36_ = _tmp35_ = g_strsplit (_tmp34_, "=", 2);
					nv = _tmp36_;
					nv_length1 = _vala_array_length (_tmp35_);
					_nv_size_ = nv_length1;
					_tmp37_ = nv;
					_tmp37__length1 = nv_length1;
					_tmp38_ = _tmp37_[0];
					if (g_strcmp0 (_tmp38_, "cprefix") == 0) {
						ValaUnresolvedType* _tmp39_ = NULL;
						const gchar* _tmp40_ = NULL;
						gchar** _tmp41_ = NULL;
						gint _tmp41__length1 = 0;
						const gchar* _tmp42_ = NULL;
						gchar* _tmp43_ = NULL;
						gchar* _tmp44_ = NULL;
						gint _tmp45_ = 0;
						gint _tmp46_ = 0;
						gchar* _tmp47_ = NULL;
						gchar* _tmp48_ = NULL;
						ValaUnresolvedSymbol* _tmp49_ = NULL;
						ValaUnresolvedSymbol* _tmp50_ = NULL;
						_tmp39_ = type;
						_tmp40_ = n;
						_tmp41_ = nv;
						_tmp41__length1 = nv_length1;
						_tmp42_ = _tmp41_[1];
						_tmp43_ = vala_gidl_parser_eval (self, _tmp42_);
						_tmp44_ = _tmp43_;
						_tmp45_ = strlen (_tmp44_);
						_tmp46_ = _tmp45_;
						_tmp47_ = string_substring (_tmp40_, (glong) _tmp46_, (glong) (-1));
						_tmp48_ = _tmp47_;
						_tmp49_ = vala_unresolved_symbol_new (NULL, _tmp48_, NULL);
						_tmp50_ = _tmp49_;
						vala_unresolved_type_set_unresolved_symbol (_tmp39_, _tmp50_);
						_vala_code_node_unref0 (_tmp50_);
						_g_free0 (_tmp48_);
						_g_free0 (_tmp44_);
					} else {
						gchar** _tmp51_ = NULL;
						gint _tmp51__length1 = 0;
						const gchar* _tmp52_ = NULL;
						_tmp51_ = nv;
						_tmp51__length1 = nv_length1;
						_tmp52_ = _tmp51_[0];
						if (g_strcmp0 (_tmp52_, "name") == 0) {
							ValaUnresolvedType* _tmp53_ = NULL;
							gchar** _tmp54_ = NULL;
							gint _tmp54__length1 = 0;
							const gchar* _tmp55_ = NULL;
							gchar* _tmp56_ = NULL;
							gchar* _tmp57_ = NULL;
							ValaUnresolvedSymbol* _tmp58_ = NULL;
							ValaUnresolvedSymbol* _tmp59_ = NULL;
							_tmp53_ = type;
							_tmp54_ = nv;
							_tmp54__length1 = nv_length1;
							_tmp55_ = _tmp54_[1];
							_tmp56_ = vala_gidl_parser_eval (self, _tmp55_);
							_tmp57_ = _tmp56_;
							_tmp58_ = vala_unresolved_symbol_new (NULL, _tmp57_, NULL);
							_tmp59_ = _tmp58_;
							vala_unresolved_type_set_unresolved_symbol (_tmp53_, _tmp59_);
							_vala_code_node_unref0 (_tmp59_);
							_g_free0 (_tmp57_);
						} else {
							gchar** _tmp60_ = NULL;
							gint _tmp60__length1 = 0;
							const gchar* _tmp61_ = NULL;
							_tmp60_ = nv;
							_tmp60__length1 = nv_length1;
							_tmp61_ = _tmp60_[0];
							if (g_strcmp0 (_tmp61_, "namespace") == 0) {
								gchar** _tmp62_ = NULL;
								gint _tmp62__length1 = 0;
								const gchar* _tmp63_ = NULL;
								gchar* _tmp64_ = NULL;
								_tmp62_ = nv;
								_tmp62__length1 = nv_length1;
								_tmp63_ = _tmp62_[1];
								_tmp64_ = vala_gidl_parser_eval (self, _tmp63_);
								_g_free0 (ns_name);
								ns_name = _tmp64_;
							} else {
								gchar** _tmp65_ = NULL;
								gint _tmp65__length1 = 0;
								const gchar* _tmp66_ = NULL;
								_tmp65_ = nv;
								_tmp65__length1 = nv_length1;
								_tmp66_ = _tmp65_[0];
								if (g_strcmp0 (_tmp66_, "rename_to") == 0) {
									ValaUnresolvedType* _tmp67_ = NULL;
									gchar** _tmp68_ = NULL;
									gint _tmp68__length1 = 0;
									const gchar* _tmp69_ = NULL;
									gchar* _tmp70_ = NULL;
									gchar* _tmp71_ = NULL;
									ValaUnresolvedSymbol* _tmp72_ = NULL;
									ValaUnresolvedSymbol* _tmp73_ = NULL;
									_tmp67_ = type;
									_tmp68_ = nv;
									_tmp68__length1 = nv_length1;
									_tmp69_ = _tmp68_[1];
									_tmp70_ = vala_gidl_parser_eval (self, _tmp69_);
									_tmp71_ = _tmp70_;
									_tmp72_ = vala_unresolved_symbol_new (NULL, _tmp71_, NULL);
									_tmp73_ = _tmp72_;
									vala_unresolved_type_set_unresolved_symbol (_tmp67_, _tmp73_);
									_vala_code_node_unref0 (_tmp73_);
									_g_free0 (_tmp71_);
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp74_ = type;
	_tmp75_ = vala_unresolved_type_get_unresolved_symbol (_tmp74_);
	_tmp76_ = _tmp75_;
	if (_tmp76_ != NULL) {
		ValaUnresolvedType* _tmp77_ = NULL;
		ValaUnresolvedSymbol* _tmp78_ = NULL;
		ValaUnresolvedSymbol* _tmp79_ = NULL;
		const gchar* _tmp80_ = NULL;
		const gchar* _tmp81_ = NULL;
		const gchar* _tmp86_ = NULL;
		_tmp77_ = type;
		_tmp78_ = vala_unresolved_type_get_unresolved_symbol (_tmp77_);
		_tmp79_ = _tmp78_;
		_tmp80_ = vala_symbol_get_name ((ValaSymbol*) _tmp79_);
		_tmp81_ = _tmp80_;
		if (g_strcmp0 (_tmp81_, "pointer") == 0) {
			ValaVoidType* _tmp82_ = NULL;
			ValaVoidType* _tmp83_ = NULL;
			ValaPointerType* _tmp84_ = NULL;
			ValaDataType* _tmp85_ = NULL;
			_tmp82_ = vala_void_type_new (NULL);
			_tmp83_ = _tmp82_;
			_tmp84_ = vala_pointer_type_new ((ValaDataType*) _tmp83_, NULL);
			_tmp85_ = (ValaDataType*) _tmp84_;
			_vala_code_node_unref0 (_tmp83_);
			result = _tmp85_;
			_g_free0 (ns_name);
			type_attributes = (_vala_array_free (type_attributes, type_attributes_length1, (GDestroyNotify) g_free), NULL);
			_vala_code_node_unref0 (dt);
			_vala_code_node_unref0 (type);
			return result;
		}
		_tmp86_ = ns_name;
		if (_tmp86_ != NULL) {
			ValaUnresolvedType* _tmp87_ = NULL;
			ValaUnresolvedSymbol* _tmp88_ = NULL;
			ValaUnresolvedSymbol* _tmp89_ = NULL;
			const gchar* _tmp90_ = NULL;
			ValaUnresolvedSymbol* _tmp91_ = NULL;
			ValaUnresolvedSymbol* _tmp92_ = NULL;
			_tmp87_ = type;
			_tmp88_ = vala_unresolved_type_get_unresolved_symbol (_tmp87_);
			_tmp89_ = _tmp88_;
			_tmp90_ = ns_name;
			_tmp91_ = vala_unresolved_symbol_new (NULL, _tmp90_, NULL);
			_tmp92_ = _tmp91_;
			vala_unresolved_symbol_set_inner (_tmp89_, _tmp92_);
			_vala_code_node_unref0 (_tmp92_);
		}
		result = (ValaDataType*) type;
		_g_free0 (ns_name);
		type_attributes = (_vala_array_free (type_attributes, type_attributes_length1, (GDestroyNotify) g_free), NULL);
		_vala_code_node_unref0 (dt);
		return result;
	}
	_tmp93_ = n;
	_tmp94_ = self->priv->current_namespace;
	_tmp95_ = vala_symbol_get_name ((ValaSymbol*) _tmp94_);
	_tmp96_ = _tmp95_;
	_tmp97_ = g_str_has_prefix (_tmp93_, _tmp96_);
	if (_tmp97_) {
		ValaUnresolvedType* _tmp98_ = NULL;
		ValaNamespace* _tmp99_ = NULL;
		const gchar* _tmp100_ = NULL;
		const gchar* _tmp101_ = NULL;
		ValaUnresolvedSymbol* _tmp102_ = NULL;
		ValaUnresolvedSymbol* _tmp103_ = NULL;
		const gchar* _tmp104_ = NULL;
		ValaNamespace* _tmp105_ = NULL;
		const gchar* _tmp106_ = NULL;
		const gchar* _tmp107_ = NULL;
		gint _tmp108_ = 0;
		gint _tmp109_ = 0;
		gchar* _tmp110_ = NULL;
		gchar* _tmp111_ = NULL;
		ValaUnresolvedSymbol* _tmp112_ = NULL;
		ValaUnresolvedSymbol* _tmp113_ = NULL;
		_tmp98_ = type;
		_tmp99_ = self->priv->current_namespace;
		_tmp100_ = vala_symbol_get_name ((ValaSymbol*) _tmp99_);
		_tmp101_ = _tmp100_;
		_tmp102_ = vala_unresolved_symbol_new (NULL, _tmp101_, NULL);
		_tmp103_ = _tmp102_;
		_tmp104_ = n;
		_tmp105_ = self->priv->current_namespace;
		_tmp106_ = vala_symbol_get_name ((ValaSymbol*) _tmp105_);
		_tmp107_ = _tmp106_;
		_tmp108_ = strlen (_tmp107_);
		_tmp109_ = _tmp108_;
		_tmp110_ = string_substring (_tmp104_, (glong) _tmp109_, (glong) (-1));
		_tmp111_ = _tmp110_;
		_tmp112_ = vala_unresolved_symbol_new (_tmp103_, _tmp111_, NULL);
		_tmp113_ = _tmp112_;
		vala_unresolved_type_set_unresolved_symbol (_tmp98_, _tmp113_);
		_vala_code_node_unref0 (_tmp113_);
		_g_free0 (_tmp111_);
		_vala_code_node_unref0 (_tmp103_);
	} else {
		gboolean _tmp114_ = FALSE;
		gboolean _tmp115_ = FALSE;
		ValaNamespace* _tmp116_ = NULL;
		ValaSymbol* _tmp117_ = NULL;
		ValaSymbol* _tmp118_ = NULL;
		gboolean _tmp124_ = FALSE;
		gboolean _tmp132_ = FALSE;
		_tmp116_ = self->priv->current_namespace;
		_tmp117_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp116_);
		_tmp118_ = _tmp117_;
		if (_tmp118_ != NULL) {
			ValaNamespace* _tmp119_ = NULL;
			ValaSymbol* _tmp120_ = NULL;
			ValaSymbol* _tmp121_ = NULL;
			const gchar* _tmp122_ = NULL;
			const gchar* _tmp123_ = NULL;
			_tmp119_ = self->priv->current_namespace;
			_tmp120_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp119_);
			_tmp121_ = _tmp120_;
			_tmp122_ = vala_symbol_get_name (_tmp121_);
			_tmp123_ = _tmp122_;
			_tmp115_ = _tmp123_ != NULL;
		} else {
			_tmp115_ = FALSE;
		}
		_tmp124_ = _tmp115_;
		if (_tmp124_) {
			const gchar* _tmp125_ = NULL;
			ValaNamespace* _tmp126_ = NULL;
			ValaSymbol* _tmp127_ = NULL;
			ValaSymbol* _tmp128_ = NULL;
			const gchar* _tmp129_ = NULL;
			const gchar* _tmp130_ = NULL;
			gboolean _tmp131_ = FALSE;
			_tmp125_ = n;
			_tmp126_ = self->priv->current_namespace;
			_tmp127_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp126_);
			_tmp128_ = _tmp127_;
			_tmp129_ = vala_symbol_get_name (_tmp128_);
			_tmp130_ = _tmp129_;
			_tmp131_ = g_str_has_prefix (_tmp125_, _tmp130_);
			_tmp114_ = _tmp131_;
		} else {
			_tmp114_ = FALSE;
		}
		_tmp132_ = _tmp114_;
		if (_tmp132_) {
			ValaUnresolvedType* _tmp133_ = NULL;
			ValaNamespace* _tmp134_ = NULL;
			ValaSymbol* _tmp135_ = NULL;
			ValaSymbol* _tmp136_ = NULL;
			const gchar* _tmp137_ = NULL;
			const gchar* _tmp138_ = NULL;
			ValaUnresolvedSymbol* _tmp139_ = NULL;
			ValaUnresolvedSymbol* _tmp140_ = NULL;
			const gchar* _tmp141_ = NULL;
			ValaNamespace* _tmp142_ = NULL;
			ValaSymbol* _tmp143_ = NULL;
			ValaSymbol* _tmp144_ = NULL;
			const gchar* _tmp145_ = NULL;
			const gchar* _tmp146_ = NULL;
			gint _tmp147_ = 0;
			gint _tmp148_ = 0;
			gchar* _tmp149_ = NULL;
			gchar* _tmp150_ = NULL;
			ValaUnresolvedSymbol* _tmp151_ = NULL;
			ValaUnresolvedSymbol* _tmp152_ = NULL;
			_tmp133_ = type;
			_tmp134_ = self->priv->current_namespace;
			_tmp135_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp134_);
			_tmp136_ = _tmp135_;
			_tmp137_ = vala_symbol_get_name (_tmp136_);
			_tmp138_ = _tmp137_;
			_tmp139_ = vala_unresolved_symbol_new (NULL, _tmp138_, NULL);
			_tmp140_ = _tmp139_;
			_tmp141_ = n;
			_tmp142_ = self->priv->current_namespace;
			_tmp143_ = vala_symbol_get_parent_symbol ((ValaSymbol*) _tmp142_);
			_tmp144_ = _tmp143_;
			_tmp145_ = vala_symbol_get_name (_tmp144_);
			_tmp146_ = _tmp145_;
			_tmp147_ = strlen (_tmp146_);
			_tmp148_ = _tmp147_;
			_tmp149_ = string_substring (_tmp141_, (glong) _tmp148_, (glong) (-1));
			_tmp150_ = _tmp149_;
			_tmp151_ = vala_unresolved_symbol_new (_tmp140_, _tmp150_, NULL);
			_tmp152_ = _tmp151_;
			vala_unresolved_type_set_unresolved_symbol (_tmp133_, _tmp152_);
			_vala_code_node_unref0 (_tmp152_);
			_g_free0 (_tmp150_);
			_vala_code_node_unref0 (_tmp140_);
		} else {
			const gchar* _tmp153_ = NULL;
			gboolean _tmp154_ = FALSE;
			_tmp153_ = n;
			_tmp154_ = g_str_has_prefix (_tmp153_, "G");
			if (_tmp154_) {
				ValaUnresolvedType* _tmp155_ = NULL;
				ValaUnresolvedSymbol* _tmp156_ = NULL;
				ValaUnresolvedSymbol* _tmp157_ = NULL;
				const gchar* _tmp158_ = NULL;
				gchar* _tmp159_ = NULL;
				gchar* _tmp160_ = NULL;
				ValaUnresolvedSymbol* _tmp161_ = NULL;
				ValaUnresolvedSymbol* _tmp162_ = NULL;
				_tmp155_ = type;
				_tmp156_ = vala_unresolved_symbol_new (NULL, "GLib", NULL);
				_tmp157_ = _tmp156_;
				_tmp158_ = n;
				_tmp159_ = string_substring (_tmp158_, (glong) 1, (glong) (-1));
				_tmp160_ = _tmp159_;
				_tmp161_ = vala_unresolved_symbol_new (_tmp157_, _tmp160_, NULL);
				_tmp162_ = _tmp161_;
				vala_unresolved_type_set_unresolved_symbol (_tmp155_, _tmp162_);
				_vala_code_node_unref0 (_tmp162_);
				_g_free0 (_tmp160_);
				_vala_code_node_unref0 (_tmp157_);
			} else {
				gchar** name_parts = NULL;
				const gchar* _tmp163_ = NULL;
				gchar** _tmp164_ = NULL;
				gchar** _tmp165_ = NULL;
				gint name_parts_length1 = 0;
				gint _name_parts_size_ = 0;
				gchar** _tmp166_ = NULL;
				gint _tmp166__length1 = 0;
				const gchar* _tmp167_ = NULL;
				_tmp163_ = n;
				_tmp165_ = _tmp164_ = g_strsplit (_tmp163_, ".", 2);
				name_parts = _tmp165_;
				name_parts_length1 = _vala_array_length (_tmp164_);
				_name_parts_size_ = name_parts_length1;
				_tmp166_ = name_parts;
				_tmp166__length1 = name_parts_length1;
				_tmp167_ = _tmp166_[1];
				if (_tmp167_ == NULL) {
					ValaUnresolvedType* _tmp168_ = NULL;
					gchar** _tmp169_ = NULL;
					gint _tmp169__length1 = 0;
					const gchar* _tmp170_ = NULL;
					ValaUnresolvedSymbol* _tmp171_ = NULL;
					ValaUnresolvedSymbol* _tmp172_ = NULL;
					_tmp168_ = type;
					_tmp169_ = name_parts;
					_tmp169__length1 = name_parts_length1;
					_tmp170_ = _tmp169_[0];
					_tmp171_ = vala_unresolved_symbol_new (NULL, _tmp170_, NULL);
					_tmp172_ = _tmp171_;
					vala_unresolved_type_set_unresolved_symbol (_tmp168_, _tmp172_);
					_vala_code_node_unref0 (_tmp172_);
				} else {
					ValaUnresolvedType* _tmp173_ = NULL;
					gchar** _tmp174_ = NULL;
					gint _tmp174__length1 = 0;
					const gchar* _tmp175_ = NULL;
					ValaUnresolvedSymbol* _tmp176_ = NULL;
					ValaUnresolvedSymbol* _tmp177_ = NULL;
					gchar** _tmp178_ = NULL;
					gint _tmp178__length1 = 0;
					const gchar* _tmp179_ = NULL;
					ValaUnresolvedSymbol* _tmp180_ = NULL;
					ValaUnresolvedSymbol* _tmp181_ = NULL;
					_tmp173_ = type;
					_tmp174_ = name_parts;
					_tmp174__length1 = name_parts_length1;
					_tmp175_ = _tmp174_[0];
					_tmp176_ = vala_unresolved_symbol_new (NULL, _tmp175_, NULL);
					_tmp177_ = _tmp176_;
					_tmp178_ = name_parts;
					_tmp178__length1 = name_parts_length1;
					_tmp179_ = _tmp178_[1];
					_tmp180_ = vala_unresolved_symbol_new (_tmp177_, _tmp179_, NULL);
					_tmp181_ = _tmp180_;
					vala_unresolved_type_set_unresolved_symbol (_tmp173_, _tmp181_);
					_vala_code_node_unref0 (_tmp181_);
					_vala_code_node_unref0 (_tmp177_);
				}
				name_parts = (_vala_array_free (name_parts, name_parts_length1, (GDestroyNotify) g_free), NULL);
			}
		}
	}
	result = (ValaDataType*) type;
	_g_free0 (ns_name);
	type_attributes = (_vala_array_free (type_attributes, type_attributes_length1, (GDestroyNotify) g_free), NULL);
	_vala_code_node_unref0 (dt);
	return result;
}


static ValaDataType* vala_gidl_parser_parse_param (ValaGIdlParser* self, GIdlNodeParam* param, ValaParameterDirection* direction) {
	ValaParameterDirection _vala_direction = 0;
	ValaDataType* result = NULL;
	ValaDataType* type = NULL;
	GIdlNodeParam* _tmp0_ = NULL;
	GIdlNodeType* _tmp1_ = NULL;
	ValaParameterDirection _tmp2_ = 0;
	ValaDataType* _tmp3_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (param != NULL, NULL);
	_tmp0_ = param;
	_tmp1_ = _tmp0_->type;
	_tmp3_ = vala_gidl_parser_parse_type (self, _tmp1_, &_tmp2_);
	_vala_direction = _tmp2_;
	type = _tmp3_;
	result = type;
	if (direction) {
		*direction = _vala_direction;
	}
	return result;
}


static ValaUnresolvedSymbol* vala_gidl_parser_parse_symbol_from_string (ValaGIdlParser* self, const gchar* symbol_string, ValaSourceReference* source_reference) {
	ValaUnresolvedSymbol* result = NULL;
	ValaUnresolvedSymbol* sym = NULL;
	const gchar* _tmp0_ = NULL;
	gchar** _tmp1_ = NULL;
	gchar** _tmp2_ = NULL;
	ValaUnresolvedSymbol* _tmp7_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (symbol_string != NULL, NULL);
	sym = NULL;
	_tmp0_ = symbol_string;
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp2_;
		s_collection_length1 = _vala_array_length (_tmp1_);
		for (s_it = 0; s_it < _vala_array_length (_tmp1_); s_it = s_it + 1) {
			const gchar* s = NULL;
			s = s_collection[s_it];
			{
				ValaUnresolvedSymbol* _tmp3_ = NULL;
				const gchar* _tmp4_ = NULL;
				ValaSourceReference* _tmp5_ = NULL;
				ValaUnresolvedSymbol* _tmp6_ = NULL;
				_tmp3_ = sym;
				_tmp4_ = s;
				_tmp5_ = source_reference;
				_tmp6_ = vala_unresolved_symbol_new (_tmp3_, _tmp4_, _tmp5_);
				_vala_code_node_unref0 (sym);
				sym = _tmp6_;
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp7_ = sym;
	if (_tmp7_ == NULL) {
		ValaSourceReference* _tmp8_ = NULL;
		_tmp8_ = source_reference;
		vala_report_error (_tmp8_, "a symbol must be specified");
	}
	result = sym;
	return result;
}


static gchar string_get (const gchar* self, glong index) {
	gchar result = '\0';
	glong _tmp0_ = 0L;
	gchar _tmp1_ = '\0';
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = index;
	_tmp1_ = ((gchar*) self)[_tmp0_];
	result = _tmp1_;
	return result;
}


static gboolean vala_gidl_parser_parse_type_arguments_from_string (ValaGIdlParser* self, ValaDataType* parent_type, const gchar* type_arguments, ValaSourceReference* source_reference) {
	gboolean result = FALSE;
	gint type_arguments_length = 0;
	const gchar* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	GString* current = NULL;
	gint _tmp3_ = 0;
	GString* _tmp4_ = NULL;
	gint depth = 0;
	ValaDataType* dt = NULL;
	GString* _tmp56_ = NULL;
	const gchar* _tmp57_ = NULL;
	ValaSourceReference* _tmp58_ = NULL;
	ValaDataType* _tmp59_ = NULL;
	ValaDataType* _tmp60_ = NULL;
	ValaDataType* _tmp61_ = NULL;
	ValaDataType* _tmp62_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (parent_type != NULL, FALSE);
	g_return_val_if_fail (type_arguments != NULL, FALSE);
	_tmp0_ = type_arguments;
	_tmp1_ = strlen (_tmp0_);
	_tmp2_ = _tmp1_;
	type_arguments_length = (gint) _tmp2_;
	_tmp3_ = type_arguments_length;
	_tmp4_ = g_string_sized_new ((gsize) _tmp3_);
	current = _tmp4_;
	depth = 0;
	{
		gint c = 0;
		c = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gboolean _tmp6_ = FALSE;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gboolean _tmp10_ = FALSE;
				const gchar* _tmp11_ = NULL;
				gint _tmp12_ = 0;
				gchar _tmp13_ = '\0';
				gboolean _tmp17_ = FALSE;
				_tmp6_ = _tmp5_;
				if (!_tmp6_) {
					gint _tmp7_ = 0;
					_tmp7_ = c;
					c = _tmp7_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp8_ = c;
				_tmp9_ = type_arguments_length;
				if (!(_tmp8_ < _tmp9_)) {
					break;
				}
				_tmp11_ = type_arguments;
				_tmp12_ = c;
				_tmp13_ = string_get (_tmp11_, (glong) _tmp12_);
				if (_tmp13_ == '<') {
					_tmp10_ = TRUE;
				} else {
					const gchar* _tmp14_ = NULL;
					gint _tmp15_ = 0;
					gchar _tmp16_ = '\0';
					_tmp14_ = type_arguments;
					_tmp15_ = c;
					_tmp16_ = string_get (_tmp14_, (glong) _tmp15_);
					_tmp10_ = _tmp16_ == '[';
				}
				_tmp17_ = _tmp10_;
				if (_tmp17_) {
					gint _tmp18_ = 0;
					GString* _tmp19_ = NULL;
					const gchar* _tmp20_ = NULL;
					gint _tmp21_ = 0;
					gchar _tmp22_ = '\0';
					_tmp18_ = depth;
					depth = _tmp18_ + 1;
					_tmp19_ = current;
					_tmp20_ = type_arguments;
					_tmp21_ = c;
					_tmp22_ = string_get (_tmp20_, (glong) _tmp21_);
					g_string_append_unichar (_tmp19_, (gunichar) _tmp22_);
				} else {
					gboolean _tmp23_ = FALSE;
					const gchar* _tmp24_ = NULL;
					gint _tmp25_ = 0;
					gchar _tmp26_ = '\0';
					gboolean _tmp30_ = FALSE;
					_tmp24_ = type_arguments;
					_tmp25_ = c;
					_tmp26_ = string_get (_tmp24_, (glong) _tmp25_);
					if (_tmp26_ == '>') {
						_tmp23_ = TRUE;
					} else {
						const gchar* _tmp27_ = NULL;
						gint _tmp28_ = 0;
						gchar _tmp29_ = '\0';
						_tmp27_ = type_arguments;
						_tmp28_ = c;
						_tmp29_ = string_get (_tmp27_, (glong) _tmp28_);
						_tmp23_ = _tmp29_ == ']';
					}
					_tmp30_ = _tmp23_;
					if (_tmp30_) {
						gint _tmp31_ = 0;
						GString* _tmp32_ = NULL;
						const gchar* _tmp33_ = NULL;
						gint _tmp34_ = 0;
						gchar _tmp35_ = '\0';
						_tmp31_ = depth;
						depth = _tmp31_ - 1;
						_tmp32_ = current;
						_tmp33_ = type_arguments;
						_tmp34_ = c;
						_tmp35_ = string_get (_tmp33_, (glong) _tmp34_);
						g_string_append_unichar (_tmp32_, (gunichar) _tmp35_);
					} else {
						const gchar* _tmp36_ = NULL;
						gint _tmp37_ = 0;
						gchar _tmp38_ = '\0';
						_tmp36_ = type_arguments;
						_tmp37_ = c;
						_tmp38_ = string_get (_tmp36_, (glong) _tmp37_);
						if (_tmp38_ == ',') {
							gint _tmp39_ = 0;
							_tmp39_ = depth;
							if (_tmp39_ == 0) {
								ValaDataType* dt = NULL;
								GString* _tmp40_ = NULL;
								const gchar* _tmp41_ = NULL;
								ValaSourceReference* _tmp42_ = NULL;
								ValaDataType* _tmp43_ = NULL;
								ValaDataType* _tmp44_ = NULL;
								ValaDataType* _tmp45_ = NULL;
								ValaDataType* _tmp46_ = NULL;
								GString* _tmp47_ = NULL;
								_tmp40_ = current;
								_tmp41_ = _tmp40_->str;
								_tmp42_ = source_reference;
								_tmp43_ = vala_gidl_parser_parse_type_from_string (self, _tmp41_, TRUE, _tmp42_);
								dt = _tmp43_;
								_tmp44_ = dt;
								if (_tmp44_ == NULL) {
									result = FALSE;
									_vala_code_node_unref0 (dt);
									_g_string_free0 (current);
									return result;
								}
								_tmp45_ = parent_type;
								_tmp46_ = dt;
								vala_data_type_add_type_argument (_tmp45_, _tmp46_);
								_tmp47_ = current;
								g_string_truncate (_tmp47_, (gsize) 0);
								_vala_code_node_unref0 (dt);
							} else {
								GString* _tmp48_ = NULL;
								const gchar* _tmp49_ = NULL;
								gint _tmp50_ = 0;
								gchar _tmp51_ = '\0';
								_tmp48_ = current;
								_tmp49_ = type_arguments;
								_tmp50_ = c;
								_tmp51_ = string_get (_tmp49_, (glong) _tmp50_);
								g_string_append_unichar (_tmp48_, (gunichar) _tmp51_);
							}
						} else {
							GString* _tmp52_ = NULL;
							const gchar* _tmp53_ = NULL;
							gint _tmp54_ = 0;
							gchar _tmp55_ = '\0';
							_tmp52_ = current;
							_tmp53_ = type_arguments;
							_tmp54_ = c;
							_tmp55_ = string_get (_tmp53_, (glong) _tmp54_);
							g_string_append_unichar (_tmp52_, (gunichar) _tmp55_);
						}
					}
				}
			}
		}
	}
	_tmp56_ = current;
	_tmp57_ = _tmp56_->str;
	_tmp58_ = source_reference;
	_tmp59_ = vala_gidl_parser_parse_type_from_string (self, _tmp57_, TRUE, _tmp58_);
	dt = _tmp59_;
	_tmp60_ = dt;
	if (_tmp60_ == NULL) {
		result = FALSE;
		_vala_code_node_unref0 (dt);
		_g_string_free0 (current);
		return result;
	}
	_tmp61_ = parent_type;
	_tmp62_ = dt;
	vala_data_type_add_type_argument (_tmp61_, _tmp62_);
	result = TRUE;
	_vala_code_node_unref0 (dt);
	_g_string_free0 (current);
	return result;
}


static ValaDataType* vala_gidl_parser_parse_type_from_string (ValaGIdlParser* self, const gchar* type_string, gboolean owned_by_default, ValaSourceReference* source_reference) {
	ValaDataType* result = NULL;
	GRegex* _tmp0_ = NULL;
	GMatchInfo* match = NULL;
	GRegex* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	GMatchInfo* _tmp6_ = NULL;
	gboolean _tmp7_ = FALSE;
	ValaDataType* type = NULL;
	gchar* ownership_data = NULL;
	GMatchInfo* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* type_name = NULL;
	GMatchInfo* _tmp11_ = NULL;
	gchar* _tmp12_ = NULL;
	gchar* type_arguments_data = NULL;
	GMatchInfo* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	gchar* pointers_data = NULL;
	GMatchInfo* _tmp15_ = NULL;
	gchar* _tmp16_ = NULL;
	gchar* array_data = NULL;
	GMatchInfo* _tmp17_ = NULL;
	gchar* _tmp18_ = NULL;
	gchar* array_dimension_data = NULL;
	GMatchInfo* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* nullable_data = NULL;
	GMatchInfo* _tmp21_ = NULL;
	gchar* _tmp22_ = NULL;
	gboolean _tmp23_ = FALSE;
	const gchar* _tmp24_ = NULL;
	gboolean nullable = FALSE;
	gboolean _tmp28_ = FALSE;
	gboolean _tmp29_ = FALSE;
	const gchar* _tmp30_ = NULL;
	gboolean _tmp32_ = FALSE;
	gboolean value_owned = FALSE;
	gboolean _tmp50_ = FALSE;
	const gchar* _tmp51_ = NULL;
	ValaUnresolvedSymbol* sym = NULL;
	const gchar* _tmp53_ = NULL;
	ValaSourceReference* _tmp54_ = NULL;
	ValaUnresolvedSymbol* _tmp55_ = NULL;
	ValaUnresolvedSymbol* _tmp56_ = NULL;
	ValaUnresolvedSymbol* _tmp57_ = NULL;
	ValaSourceReference* _tmp58_ = NULL;
	ValaUnresolvedType* _tmp59_ = NULL;
	gboolean _tmp60_ = FALSE;
	const gchar* _tmp61_ = NULL;
	gboolean _tmp65_ = FALSE;
	const gchar* _tmp70_ = NULL;
	gboolean _tmp80_ = FALSE;
	const gchar* _tmp81_ = NULL;
	gboolean _tmp85_ = FALSE;
	ValaDataType* _tmp92_ = NULL;
	gboolean _tmp93_ = FALSE;
	ValaDataType* _tmp94_ = NULL;
	gboolean _tmp95_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (type_string != NULL, NULL);
	_tmp0_ = vala_gidl_parser_type_from_string_regex;
	if (_tmp0_ == NULL) {
		{
			GRegex* _tmp1_ = NULL;
			GRegex* _tmp2_ = NULL;
			_tmp2_ = g_regex_new ("^(?:(owned|unowned|weak) +)?([0-9a-zA-Z_\\.]+)(?:<(.+)>)?(\\*+)?(\\[(," \
"*)?\\])?(\\?)?$", (G_REGEX_ANCHORED | G_REGEX_DOLLAR_ENDONLY) | G_REGEX_OPTIMIZE, 0, &_inner_error_);
			_tmp1_ = _tmp2_;
			if (_inner_error_ != NULL) {
				if (_inner_error_->domain == G_REGEX_ERROR) {
					goto __catch2_g_regex_error;
				}
				g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_regex_unref0 (vala_gidl_parser_type_from_string_regex);
			vala_gidl_parser_type_from_string_regex = _tmp1_;
		}
		goto __finally2;
		__catch2_g_regex_error:
		{
			GError* e = NULL;
			const gchar* _tmp3_ = NULL;
			e = _inner_error_;
			_inner_error_ = NULL;
			_tmp3_ = e->message;
			g_error ("valagidlparser.vala:2111: Unable to compile regex: %s", _tmp3_);
			_g_error_free0 (e);
		}
		__finally2:
		if (_inner_error_ != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return NULL;
		}
	}
	_tmp4_ = vala_gidl_parser_type_from_string_regex;
	_tmp5_ = type_string;
	_tmp7_ = g_regex_match (_tmp4_, _tmp5_, 0, &_tmp6_);
	_g_match_info_free0 (match);
	match = _tmp6_;
	if (!_tmp7_) {
		ValaSourceReference* _tmp8_ = NULL;
		_tmp8_ = source_reference;
		vala_report_error (_tmp8_, "unable to parse type");
		result = NULL;
		_g_match_info_free0 (match);
		return result;
	}
	type = NULL;
	_tmp9_ = match;
	_tmp10_ = g_match_info_fetch (_tmp9_, 1);
	ownership_data = _tmp10_;
	_tmp11_ = match;
	_tmp12_ = g_match_info_fetch (_tmp11_, 2);
	type_name = _tmp12_;
	_tmp13_ = match;
	_tmp14_ = g_match_info_fetch (_tmp13_, 3);
	type_arguments_data = _tmp14_;
	_tmp15_ = match;
	_tmp16_ = g_match_info_fetch (_tmp15_, 4);
	pointers_data = _tmp16_;
	_tmp17_ = match;
	_tmp18_ = g_match_info_fetch (_tmp17_, 5);
	array_data = _tmp18_;
	_tmp19_ = match;
	_tmp20_ = g_match_info_fetch (_tmp19_, 6);
	array_dimension_data = _tmp20_;
	_tmp21_ = match;
	_tmp22_ = g_match_info_fetch (_tmp21_, 7);
	nullable_data = _tmp22_;
	_tmp24_ = nullable_data;
	if (_tmp24_ != NULL) {
		const gchar* _tmp25_ = NULL;
		gint _tmp26_ = 0;
		gint _tmp27_ = 0;
		_tmp25_ = nullable_data;
		_tmp26_ = strlen (_tmp25_);
		_tmp27_ = _tmp26_;
		_tmp23_ = _tmp27_ > 0;
	} else {
		_tmp23_ = FALSE;
	}
	_tmp28_ = _tmp23_;
	nullable = _tmp28_;
	_tmp30_ = ownership_data;
	if (_tmp30_ == NULL) {
		const gchar* _tmp31_ = NULL;
		_tmp31_ = type_name;
		_tmp29_ = g_strcmp0 (_tmp31_, "void") == 0;
	} else {
		_tmp29_ = FALSE;
	}
	_tmp32_ = _tmp29_;
	if (_tmp32_) {
		gboolean _tmp33_ = FALSE;
		const gchar* _tmp34_ = NULL;
		gboolean _tmp36_ = FALSE;
		_tmp34_ = array_data;
		if (_tmp34_ == NULL) {
			gboolean _tmp35_ = FALSE;
			_tmp35_ = nullable;
			_tmp33_ = !_tmp35_;
		} else {
			_tmp33_ = FALSE;
		}
		_tmp36_ = _tmp33_;
		if (_tmp36_) {
			ValaSourceReference* _tmp37_ = NULL;
			ValaVoidType* _tmp38_ = NULL;
			const gchar* _tmp39_ = NULL;
			_tmp37_ = source_reference;
			_tmp38_ = vala_void_type_new (_tmp37_);
			_vala_code_node_unref0 (type);
			type = (ValaDataType*) _tmp38_;
			_tmp39_ = pointers_data;
			if (_tmp39_ != NULL) {
				{
					gint i = 0;
					i = 0;
					{
						gboolean _tmp40_ = FALSE;
						_tmp40_ = TRUE;
						while (TRUE) {
							gboolean _tmp41_ = FALSE;
							gint _tmp43_ = 0;
							const gchar* _tmp44_ = NULL;
							gint _tmp45_ = 0;
							gint _tmp46_ = 0;
							ValaDataType* _tmp47_ = NULL;
							ValaPointerType* _tmp48_ = NULL;
							_tmp41_ = _tmp40_;
							if (!_tmp41_) {
								gint _tmp42_ = 0;
								_tmp42_ = i;
								i = _tmp42_ + 1;
							}
							_tmp40_ = FALSE;
							_tmp43_ = i;
							_tmp44_ = pointers_data;
							_tmp45_ = strlen (_tmp44_);
							_tmp46_ = _tmp45_;
							if (!(_tmp43_ < _tmp46_)) {
								break;
							}
							_tmp47_ = type;
							_tmp48_ = vala_pointer_type_new (_tmp47_, NULL);
							_vala_code_node_unref0 (type);
							type = (ValaDataType*) _tmp48_;
						}
					}
				}
			}
			result = type;
			_g_free0 (nullable_data);
			_g_free0 (array_dimension_data);
			_g_free0 (array_data);
			_g_free0 (pointers_data);
			_g_free0 (type_arguments_data);
			_g_free0 (type_name);
			_g_free0 (ownership_data);
			_g_match_info_free0 (match);
			return result;
		} else {
			ValaSourceReference* _tmp49_ = NULL;
			_tmp49_ = source_reference;
			vala_report_error (_tmp49_, "invalid void type");
			result = NULL;
			_g_free0 (nullable_data);
			_g_free0 (array_dimension_data);
			_g_free0 (array_data);
			_g_free0 (pointers_data);
			_g_free0 (type_arguments_data);
			_g_free0 (type_name);
			_g_free0 (ownership_data);
			_vala_code_node_unref0 (type);
			_g_match_info_free0 (match);
			return result;
		}
	}
	_tmp50_ = owned_by_default;
	value_owned = _tmp50_;
	_tmp51_ = ownership_data;
	if (g_strcmp0 (_tmp51_, "owned") == 0) {
		value_owned = TRUE;
	} else {
		const gchar* _tmp52_ = NULL;
		_tmp52_ = ownership_data;
		if (g_strcmp0 (_tmp52_, "unowned") == 0) {
			value_owned = FALSE;
		}
	}
	_tmp53_ = type_name;
	_tmp54_ = source_reference;
	_tmp55_ = vala_gidl_parser_parse_symbol_from_string (self, _tmp53_, _tmp54_);
	sym = _tmp55_;
	_tmp56_ = sym;
	if (_tmp56_ == NULL) {
		result = NULL;
		_vala_code_node_unref0 (sym);
		_g_free0 (nullable_data);
		_g_free0 (array_dimension_data);
		_g_free0 (array_data);
		_g_free0 (pointers_data);
		_g_free0 (type_arguments_data);
		_g_free0 (type_name);
		_g_free0 (ownership_data);
		_vala_code_node_unref0 (type);
		_g_match_info_free0 (match);
		return result;
	}
	_tmp57_ = sym;
	_tmp58_ = source_reference;
	_tmp59_ = vala_unresolved_type_new_from_symbol (_tmp57_, _tmp58_);
	_vala_code_node_unref0 (type);
	type = (ValaDataType*) _tmp59_;
	_tmp61_ = type_arguments_data;
	if (_tmp61_ != NULL) {
		const gchar* _tmp62_ = NULL;
		gint _tmp63_ = 0;
		gint _tmp64_ = 0;
		_tmp62_ = type_arguments_data;
		_tmp63_ = strlen (_tmp62_);
		_tmp64_ = _tmp63_;
		_tmp60_ = _tmp64_ > 0;
	} else {
		_tmp60_ = FALSE;
	}
	_tmp65_ = _tmp60_;
	if (_tmp65_) {
		ValaDataType* _tmp66_ = NULL;
		const gchar* _tmp67_ = NULL;
		ValaSourceReference* _tmp68_ = NULL;
		gboolean _tmp69_ = FALSE;
		_tmp66_ = type;
		_tmp67_ = type_arguments_data;
		_tmp68_ = source_reference;
		_tmp69_ = vala_gidl_parser_parse_type_arguments_from_string (self, _tmp66_, _tmp67_, _tmp68_);
		if (!_tmp69_) {
			result = NULL;
			_vala_code_node_unref0 (sym);
			_g_free0 (nullable_data);
			_g_free0 (array_dimension_data);
			_g_free0 (array_data);
			_g_free0 (pointers_data);
			_g_free0 (type_arguments_data);
			_g_free0 (type_name);
			_g_free0 (ownership_data);
			_vala_code_node_unref0 (type);
			_g_match_info_free0 (match);
			return result;
		}
	}
	_tmp70_ = pointers_data;
	if (_tmp70_ != NULL) {
		{
			gint i = 0;
			i = 0;
			{
				gboolean _tmp71_ = FALSE;
				_tmp71_ = TRUE;
				while (TRUE) {
					gboolean _tmp72_ = FALSE;
					gint _tmp74_ = 0;
					const gchar* _tmp75_ = NULL;
					gint _tmp76_ = 0;
					gint _tmp77_ = 0;
					ValaDataType* _tmp78_ = NULL;
					ValaPointerType* _tmp79_ = NULL;
					_tmp72_ = _tmp71_;
					if (!_tmp72_) {
						gint _tmp73_ = 0;
						_tmp73_ = i;
						i = _tmp73_ + 1;
					}
					_tmp71_ = FALSE;
					_tmp74_ = i;
					_tmp75_ = pointers_data;
					_tmp76_ = strlen (_tmp75_);
					_tmp77_ = _tmp76_;
					if (!(_tmp74_ < _tmp77_)) {
						break;
					}
					_tmp78_ = type;
					_tmp79_ = vala_pointer_type_new (_tmp78_, NULL);
					_vala_code_node_unref0 (type);
					type = (ValaDataType*) _tmp79_;
				}
			}
		}
	}
	_tmp81_ = array_data;
	if (_tmp81_ != NULL) {
		const gchar* _tmp82_ = NULL;
		gint _tmp83_ = 0;
		gint _tmp84_ = 0;
		_tmp82_ = array_data;
		_tmp83_ = strlen (_tmp82_);
		_tmp84_ = _tmp83_;
		_tmp80_ = _tmp84_ > 0;
	} else {
		_tmp80_ = FALSE;
	}
	_tmp85_ = _tmp80_;
	if (_tmp85_) {
		ValaDataType* _tmp86_ = NULL;
		const gchar* _tmp87_ = NULL;
		gint _tmp88_ = 0;
		gint _tmp89_ = 0;
		ValaSourceReference* _tmp90_ = NULL;
		ValaArrayType* _tmp91_ = NULL;
		_tmp86_ = type;
		_tmp87_ = array_dimension_data;
		_tmp88_ = strlen (_tmp87_);
		_tmp89_ = _tmp88_;
		_tmp90_ = source_reference;
		_tmp91_ = vala_array_type_new (_tmp86_, _tmp89_ + 1, _tmp90_);
		_vala_code_node_unref0 (type);
		type = (ValaDataType*) _tmp91_;
	}
	_tmp92_ = type;
	_tmp93_ = nullable;
	vala_data_type_set_nullable (_tmp92_, _tmp93_);
	_tmp94_ = type;
	_tmp95_ = value_owned;
	vala_data_type_set_value_owned (_tmp94_, _tmp95_);
	result = type;
	_vala_code_node_unref0 (sym);
	_g_free0 (nullable_data);
	_g_free0 (array_dimension_data);
	_g_free0 (array_data);
	_g_free0 (pointers_data);
	_g_free0 (type_arguments_data);
	_g_free0 (type_name);
	_g_free0 (ownership_data);
	_g_match_info_free0 (match);
	return result;
}


static gboolean int64_try_parse (const gchar* str, gint64* _result_) {
	gint64 _vala_result = 0LL;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gint64 _tmp2_ = 0LL;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = str;
	_tmp2_ = g_ascii_strtoll (_tmp0_, &_tmp1_, (guint) 0);
	endptr = _tmp1_;
	_vala_result = _tmp2_;
	_tmp3_ = endptr;
	_tmp4_ = str;
	_tmp5_ = str;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp3_ == (((gchar*) _tmp4_) + _tmp7_)) {
		result = TRUE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	} else {
		result = FALSE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	}
	if (_result_) {
		*_result_ = _vala_result;
	}
}


static gboolean double_try_parse (const gchar* str, gdouble* _result_) {
	gdouble _vala_result = 0.0;
	gboolean result = FALSE;
	gchar* endptr = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gdouble _tmp2_ = 0.0;
	gchar* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	g_return_val_if_fail (str != NULL, FALSE);
	_tmp0_ = str;
	_tmp2_ = g_ascii_strtod (_tmp0_, &_tmp1_);
	endptr = _tmp1_;
	_vala_result = _tmp2_;
	_tmp3_ = endptr;
	_tmp4_ = str;
	_tmp5_ = str;
	_tmp6_ = strlen (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp3_ == (((gchar*) _tmp4_) + _tmp7_)) {
		result = TRUE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	} else {
		result = FALSE;
		if (_result_) {
			*_result_ = _vala_result;
		}
		return result;
	}
	if (_result_) {
		*_result_ = _vala_result;
	}
}


static ValaMethod* vala_gidl_parser_create_method (ValaGIdlParser* self, const gchar* name, const gchar* symbol, GIdlNodeParam* res, GList* parameters, gboolean is_constructor, gboolean is_interface) {
	ValaMethod* result = NULL;
	ValaDataType* return_type = NULL;
	GIdlNodeParam* _tmp0_ = NULL;
	ValaMethod* m = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp10_ = FALSE;
	ValaMethod* _tmp52_ = NULL;
	ValaSet* _tmp53_ = NULL;
	ValaTypeSymbol* _tmp56_ = NULL;
	gboolean add_ellipsis = FALSE;
	gboolean suppress_throws = FALSE;
	gchar* error_types = NULL;
	ValaSymbol* container = NULL;
	gchar** attributes = NULL;
	const gchar* _tmp80_ = NULL;
	gint _tmp81_ = 0;
	gchar** _tmp82_ = NULL;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp83_ = NULL;
	gint _tmp83__length1 = 0;
	gboolean first = FALSE;
	ValaParameter* last_param = NULL;
	ValaDataType* last_param_type = NULL;
	GList* _tmp344_ = NULL;
	gboolean _tmp769_ = FALSE;
	gboolean _tmp770_ = FALSE;
	gboolean _tmp772_ = FALSE;
	gboolean _tmp785_ = FALSE;
	gboolean _tmp787_ = FALSE;
	ValaParameter* _tmp788_ = NULL;
	gboolean _tmp793_ = FALSE;
	ValaSymbol* _tmp799_ = NULL;
	const gchar* _tmp805_ = NULL;
	ValaMethod* _tmp806_ = NULL;
	ValaSymbol* _tmp807_ = NULL;
	gchar* _tmp808_ = NULL;
	gchar* _tmp809_ = NULL;
	gboolean _tmp810_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (symbol != NULL, NULL);
	return_type = NULL;
	_tmp0_ = res;
	if (_tmp0_ != NULL) {
		GIdlNodeParam* _tmp1_ = NULL;
		ValaDataType* _tmp2_ = NULL;
		_tmp1_ = res;
		_tmp2_ = vala_gidl_parser_parse_param (self, _tmp1_, NULL);
		_vala_code_node_unref0 (return_type);
		return_type = _tmp2_;
	}
	_tmp4_ = is_interface;
	if (!_tmp4_) {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		gboolean _tmp9_ = FALSE;
		_tmp6_ = is_constructor;
		if (_tmp6_) {
			_tmp5_ = TRUE;
		} else {
			const gchar* _tmp7_ = NULL;
			gboolean _tmp8_ = FALSE;
			_tmp7_ = name;
			_tmp8_ = g_str_has_prefix (_tmp7_, "new");
			_tmp5_ = _tmp8_;
		}
		_tmp9_ = _tmp5_;
		_tmp3_ = _tmp9_;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp10_ = _tmp3_;
	if (_tmp10_) {
		const gchar* _tmp11_ = NULL;
		ValaSourceReference* _tmp12_ = NULL;
		ValaCreationMethod* _tmp13_ = NULL;
		ValaMethod* _tmp14_ = NULL;
		ValaMethod* _tmp15_ = NULL;
		const gchar* _tmp16_ = NULL;
		const gchar* _tmp17_ = NULL;
		gboolean _tmp31_ = FALSE;
		ValaTypeSymbol* _tmp32_ = NULL;
		gboolean _tmp34_ = FALSE;
		_tmp11_ = name;
		_tmp12_ = self->priv->current_source_reference;
		_tmp13_ = vala_creation_method_new (NULL, _tmp11_, _tmp12_, NULL);
		_vala_code_node_unref0 (m);
		m = (ValaMethod*) _tmp13_;
		_tmp14_ = m;
		vala_method_set_has_construct_function (_tmp14_, FALSE);
		_tmp15_ = m;
		_tmp16_ = vala_symbol_get_name ((ValaSymbol*) _tmp15_);
		_tmp17_ = _tmp16_;
		if (g_strcmp0 (_tmp17_, "new") == 0) {
			ValaMethod* _tmp18_ = NULL;
			_tmp18_ = m;
			vala_symbol_set_name ((ValaSymbol*) _tmp18_, NULL);
		} else {
			ValaMethod* _tmp19_ = NULL;
			const gchar* _tmp20_ = NULL;
			const gchar* _tmp21_ = NULL;
			gboolean _tmp22_ = FALSE;
			_tmp19_ = m;
			_tmp20_ = vala_symbol_get_name ((ValaSymbol*) _tmp19_);
			_tmp21_ = _tmp20_;
			_tmp22_ = g_str_has_prefix (_tmp21_, "new_");
			if (_tmp22_) {
				ValaMethod* _tmp23_ = NULL;
				ValaMethod* _tmp24_ = NULL;
				const gchar* _tmp25_ = NULL;
				const gchar* _tmp26_ = NULL;
				gint _tmp27_ = 0;
				gint _tmp28_ = 0;
				gchar* _tmp29_ = NULL;
				gchar* _tmp30_ = NULL;
				_tmp23_ = m;
				_tmp24_ = m;
				_tmp25_ = vala_symbol_get_name ((ValaSymbol*) _tmp24_);
				_tmp26_ = _tmp25_;
				_tmp27_ = strlen ("new_");
				_tmp28_ = _tmp27_;
				_tmp29_ = string_substring (_tmp26_, (glong) _tmp28_, (glong) (-1));
				_tmp30_ = _tmp29_;
				vala_symbol_set_name ((ValaSymbol*) _tmp23_, _tmp30_);
				_g_free0 (_tmp30_);
			}
		}
		_tmp32_ = self->priv->current_data_type;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp32_, VALA_TYPE_CLASS)) {
			GIdlNodeParam* _tmp33_ = NULL;
			_tmp33_ = res;
			_tmp31_ = _tmp33_ != NULL;
		} else {
			_tmp31_ = FALSE;
		}
		_tmp34_ = _tmp31_;
		if (_tmp34_) {
			ValaTypeSymbol* _tmp35_ = NULL;
			gchar* _tmp36_ = NULL;
			gchar* _tmp37_ = NULL;
			gchar* _tmp38_ = NULL;
			gchar* _tmp39_ = NULL;
			GIdlNodeParam* _tmp40_ = NULL;
			GIdlNodeType* _tmp41_ = NULL;
			const gchar* _tmp42_ = NULL;
			gboolean _tmp43_ = FALSE;
			_tmp35_ = self->priv->current_data_type;
			_tmp36_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp35_, NULL);
			_tmp37_ = _tmp36_;
			_tmp38_ = g_strdup_printf ("%s*", _tmp37_);
			_tmp39_ = _tmp38_;
			_tmp40_ = res;
			_tmp41_ = _tmp40_->type;
			_tmp42_ = _tmp41_->unparsed;
			_tmp43_ = g_strcmp0 (_tmp39_, _tmp42_) != 0;
			_g_free0 (_tmp39_);
			_g_free0 (_tmp37_);
			if (_tmp43_) {
				ValaMethod* _tmp44_ = NULL;
				GIdlNodeParam* _tmp45_ = NULL;
				GIdlNodeType* _tmp46_ = NULL;
				const gchar* _tmp47_ = NULL;
				_tmp44_ = m;
				_tmp45_ = res;
				_tmp46_ = _tmp45_->type;
				_tmp47_ = _tmp46_->unparsed;
				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp44_, "CCode", "type", _tmp47_, NULL);
			}
		}
	} else {
		const gchar* _tmp48_ = NULL;
		ValaDataType* _tmp49_ = NULL;
		ValaSourceReference* _tmp50_ = NULL;
		ValaMethod* _tmp51_ = NULL;
		_tmp48_ = name;
		_tmp49_ = return_type;
		_tmp50_ = self->priv->current_source_reference;
		_tmp51_ = vala_method_new (_tmp48_, _tmp49_, _tmp50_, NULL);
		_vala_code_node_unref0 (m);
		m = _tmp51_;
	}
	_tmp52_ = m;
	vala_symbol_set_access ((ValaSymbol*) _tmp52_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	_tmp53_ = self->priv->current_type_symbol_set;
	if (_tmp53_ != NULL) {
		ValaSet* _tmp54_ = NULL;
		const gchar* _tmp55_ = NULL;
		_tmp54_ = self->priv->current_type_symbol_set;
		_tmp55_ = name;
		vala_collection_add ((ValaCollection*) _tmp54_, _tmp55_);
	}
	_tmp56_ = self->priv->current_data_type;
	if (_tmp56_ != NULL) {
		gchar** sig_attributes = NULL;
		ValaTypeSymbol* _tmp57_ = NULL;
		gchar* _tmp58_ = NULL;
		gchar* _tmp59_ = NULL;
		const gchar* _tmp60_ = NULL;
		gchar* _tmp61_ = NULL;
		gchar* _tmp62_ = NULL;
		gint _tmp63_ = 0;
		gchar** _tmp64_ = NULL;
		gchar** _tmp65_ = NULL;
		gint _tmp65__length1 = 0;
		gint sig_attributes_length1 = 0;
		gint _sig_attributes_size_ = 0;
		gchar** _tmp66_ = NULL;
		gint _tmp66__length1 = 0;
		_tmp57_ = self->priv->current_data_type;
		_tmp58_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp57_, NULL);
		_tmp59_ = _tmp58_;
		_tmp60_ = name;
		_tmp61_ = g_strdup_printf ("%s::%s", _tmp59_, _tmp60_);
		_tmp62_ = _tmp61_;
		_tmp64_ = vala_gidl_parser_get_attributes (self, _tmp62_, &_tmp63_);
		_tmp65_ = _tmp64_;
		_tmp65__length1 = _tmp63_;
		_g_free0 (_tmp62_);
		_g_free0 (_tmp59_);
		sig_attributes = _tmp65_;
		sig_attributes_length1 = _tmp65__length1;
		_sig_attributes_size_ = sig_attributes_length1;
		_tmp66_ = sig_attributes;
		_tmp66__length1 = sig_attributes_length1;
		if (_tmp66_ != NULL) {
			gchar** _tmp67_ = NULL;
			gint _tmp67__length1 = 0;
			_tmp67_ = sig_attributes;
			_tmp67__length1 = sig_attributes_length1;
			{
				gchar** attr_collection = NULL;
				gint attr_collection_length1 = 0;
				gint _attr_collection_size_ = 0;
				gint attr_it = 0;
				attr_collection = _tmp67_;
				attr_collection_length1 = _tmp67__length1;
				for (attr_it = 0; attr_it < _tmp67__length1; attr_it = attr_it + 1) {
					gchar* _tmp68_ = NULL;
					gchar* attr = NULL;
					_tmp68_ = g_strdup (attr_collection[attr_it]);
					attr = _tmp68_;
					{
						gchar** nv = NULL;
						const gchar* _tmp69_ = NULL;
						gchar** _tmp70_ = NULL;
						gchar** _tmp71_ = NULL;
						gint nv_length1 = 0;
						gint _nv_size_ = 0;
						gboolean _tmp72_ = FALSE;
						gchar** _tmp73_ = NULL;
						gint _tmp73__length1 = 0;
						const gchar* _tmp74_ = NULL;
						gboolean _tmp79_ = FALSE;
						_tmp69_ = attr;
						_tmp71_ = _tmp70_ = g_strsplit (_tmp69_, "=", 2);
						nv = _tmp71_;
						nv_length1 = _vala_array_length (_tmp70_);
						_nv_size_ = nv_length1;
						_tmp73_ = nv;
						_tmp73__length1 = nv_length1;
						_tmp74_ = _tmp73_[0];
						if (g_strcmp0 (_tmp74_, "has_emitter") == 0) {
							gchar** _tmp75_ = NULL;
							gint _tmp75__length1 = 0;
							const gchar* _tmp76_ = NULL;
							gchar* _tmp77_ = NULL;
							gchar* _tmp78_ = NULL;
							_tmp75_ = nv;
							_tmp75__length1 = nv_length1;
							_tmp76_ = _tmp75_[1];
							_tmp77_ = vala_gidl_parser_eval (self, _tmp76_);
							_tmp78_ = _tmp77_;
							_tmp72_ = g_strcmp0 (_tmp78_, "1") == 0;
							_g_free0 (_tmp78_);
						} else {
							_tmp72_ = FALSE;
						}
						_tmp79_ = _tmp72_;
						if (_tmp79_) {
							result = NULL;
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
							sig_attributes = (_vala_array_free (sig_attributes, sig_attributes_length1, (GDestroyNotify) g_free), NULL);
							_vala_code_node_unref0 (m);
							_vala_code_node_unref0 (return_type);
							return result;
						}
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
					}
				}
			}
		}
		sig_attributes = (_vala_array_free (sig_attributes, sig_attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	add_ellipsis = FALSE;
	suppress_throws = FALSE;
	error_types = NULL;
	container = NULL;
	_tmp80_ = symbol;
	_tmp82_ = vala_gidl_parser_get_attributes (self, _tmp80_, &_tmp81_);
	attributes = _tmp82_;
	attributes_length1 = _tmp81_;
	_attributes_size_ = attributes_length1;
	_tmp83_ = attributes;
	_tmp83__length1 = attributes_length1;
	if (_tmp83_ != NULL) {
		gchar** _tmp84_ = NULL;
		gint _tmp84__length1 = 0;
		_tmp84_ = attributes;
		_tmp84__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp84_;
			attr_collection_length1 = _tmp84__length1;
			for (attr_it = 0; attr_it < _tmp84__length1; attr_it = attr_it + 1) {
				gchar* _tmp85_ = NULL;
				gchar* attr = NULL;
				_tmp85_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp85_;
				{
					gchar** nv = NULL;
					const gchar* _tmp86_ = NULL;
					gchar** _tmp87_ = NULL;
					gchar** _tmp88_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp89_ = NULL;
					gint _tmp89__length1 = 0;
					const gchar* _tmp90_ = NULL;
					_tmp86_ = attr;
					_tmp88_ = _tmp87_ = g_strsplit (_tmp86_, "=", 2);
					nv = _tmp88_;
					nv_length1 = _vala_array_length (_tmp87_);
					_nv_size_ = nv_length1;
					_tmp89_ = nv;
					_tmp89__length1 = nv_length1;
					_tmp90_ = _tmp89_[0];
					if (g_strcmp0 (_tmp90_, "name") == 0) {
						ValaMethod* _tmp91_ = NULL;
						gchar** _tmp92_ = NULL;
						gint _tmp92__length1 = 0;
						const gchar* _tmp93_ = NULL;
						gchar* _tmp94_ = NULL;
						gchar* _tmp95_ = NULL;
						_tmp91_ = m;
						_tmp92_ = nv;
						_tmp92__length1 = nv_length1;
						_tmp93_ = _tmp92_[1];
						_tmp94_ = vala_gidl_parser_eval (self, _tmp93_);
						_tmp95_ = _tmp94_;
						vala_symbol_set_name ((ValaSymbol*) _tmp91_, _tmp95_);
						_g_free0 (_tmp95_);
					} else {
						gchar** _tmp96_ = NULL;
						gint _tmp96__length1 = 0;
						const gchar* _tmp97_ = NULL;
						_tmp96_ = nv;
						_tmp96__length1 = nv_length1;
						_tmp97_ = _tmp96_[0];
						if (g_strcmp0 (_tmp97_, "hidden") == 0) {
							gchar** _tmp98_ = NULL;
							gint _tmp98__length1 = 0;
							const gchar* _tmp99_ = NULL;
							gchar* _tmp100_ = NULL;
							gchar* _tmp101_ = NULL;
							gboolean _tmp102_ = FALSE;
							_tmp98_ = nv;
							_tmp98__length1 = nv_length1;
							_tmp99_ = _tmp98_[1];
							_tmp100_ = vala_gidl_parser_eval (self, _tmp99_);
							_tmp101_ = _tmp100_;
							_tmp102_ = g_strcmp0 (_tmp101_, "1") == 0;
							_g_free0 (_tmp101_);
							if (_tmp102_) {
								result = NULL;
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
								attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
								_vala_code_node_unref0 (container);
								_g_free0 (error_types);
								_vala_code_node_unref0 (m);
								_vala_code_node_unref0 (return_type);
								return result;
							}
						} else {
							gchar** _tmp103_ = NULL;
							gint _tmp103__length1 = 0;
							const gchar* _tmp104_ = NULL;
							_tmp103_ = nv;
							_tmp103__length1 = nv_length1;
							_tmp104_ = _tmp103_[0];
							if (g_strcmp0 (_tmp104_, "ellipsis") == 0) {
								gchar** _tmp105_ = NULL;
								gint _tmp105__length1 = 0;
								const gchar* _tmp106_ = NULL;
								gchar* _tmp107_ = NULL;
								gchar* _tmp108_ = NULL;
								gboolean _tmp109_ = FALSE;
								_tmp105_ = nv;
								_tmp105__length1 = nv_length1;
								_tmp106_ = _tmp105_[1];
								_tmp107_ = vala_gidl_parser_eval (self, _tmp106_);
								_tmp108_ = _tmp107_;
								_tmp109_ = g_strcmp0 (_tmp108_, "1") == 0;
								_g_free0 (_tmp108_);
								if (_tmp109_) {
									add_ellipsis = TRUE;
								}
							} else {
								gchar** _tmp110_ = NULL;
								gint _tmp110__length1 = 0;
								const gchar* _tmp111_ = NULL;
								_tmp110_ = nv;
								_tmp110__length1 = nv_length1;
								_tmp111_ = _tmp110_[0];
								if (g_strcmp0 (_tmp111_, "printf_format") == 0) {
									gchar** _tmp112_ = NULL;
									gint _tmp112__length1 = 0;
									const gchar* _tmp113_ = NULL;
									gchar* _tmp114_ = NULL;
									gchar* _tmp115_ = NULL;
									gboolean _tmp116_ = FALSE;
									_tmp112_ = nv;
									_tmp112__length1 = nv_length1;
									_tmp113_ = _tmp112_[1];
									_tmp114_ = vala_gidl_parser_eval (self, _tmp113_);
									_tmp115_ = _tmp114_;
									_tmp116_ = g_strcmp0 (_tmp115_, "1") == 0;
									_g_free0 (_tmp115_);
									if (_tmp116_) {
										ValaMethod* _tmp117_ = NULL;
										_tmp117_ = m;
										vala_code_node_set_attribute ((ValaCodeNode*) _tmp117_, "PrintfFormat", TRUE, NULL);
									}
								} else {
									gchar** _tmp118_ = NULL;
									gint _tmp118__length1 = 0;
									const gchar* _tmp119_ = NULL;
									_tmp118_ = nv;
									_tmp118__length1 = nv_length1;
									_tmp119_ = _tmp118_[0];
									if (g_strcmp0 (_tmp119_, "transfer_ownership") == 0) {
										gchar** _tmp120_ = NULL;
										gint _tmp120__length1 = 0;
										const gchar* _tmp121_ = NULL;
										gchar* _tmp122_ = NULL;
										gchar* _tmp123_ = NULL;
										gboolean _tmp124_ = FALSE;
										_tmp120_ = nv;
										_tmp120__length1 = nv_length1;
										_tmp121_ = _tmp120_[1];
										_tmp122_ = vala_gidl_parser_eval (self, _tmp121_);
										_tmp123_ = _tmp122_;
										_tmp124_ = g_strcmp0 (_tmp123_, "1") == 0;
										_g_free0 (_tmp123_);
										if (_tmp124_) {
											ValaDataType* _tmp125_ = NULL;
											_tmp125_ = return_type;
											vala_data_type_set_value_owned (_tmp125_, TRUE);
										}
									} else {
										gchar** _tmp126_ = NULL;
										gint _tmp126__length1 = 0;
										const gchar* _tmp127_ = NULL;
										_tmp126_ = nv;
										_tmp126__length1 = nv_length1;
										_tmp127_ = _tmp126_[0];
										if (g_strcmp0 (_tmp127_, "destroys_instance") == 0) {
											gchar** _tmp128_ = NULL;
											gint _tmp128__length1 = 0;
											const gchar* _tmp129_ = NULL;
											gchar* _tmp130_ = NULL;
											gchar* _tmp131_ = NULL;
											gboolean _tmp132_ = FALSE;
											_tmp128_ = nv;
											_tmp128__length1 = nv_length1;
											_tmp129_ = _tmp128_[1];
											_tmp130_ = vala_gidl_parser_eval (self, _tmp129_);
											_tmp131_ = _tmp130_;
											_tmp132_ = g_strcmp0 (_tmp131_, "1") == 0;
											_g_free0 (_tmp131_);
											if (_tmp132_) {
												ValaMethod* _tmp133_ = NULL;
												ValaMethod* _tmp134_ = NULL;
												ValaSourceReference* _tmp135_ = NULL;
												ValaSourceReference* _tmp136_ = NULL;
												_tmp133_ = m;
												_tmp134_ = m;
												_tmp135_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp134_);
												_tmp136_ = _tmp135_;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp133_, "DestroysInstance", TRUE, _tmp136_);
											}
										} else {
											gchar** _tmp137_ = NULL;
											gint _tmp137__length1 = 0;
											const gchar* _tmp138_ = NULL;
											_tmp137_ = nv;
											_tmp137__length1 = nv_length1;
											_tmp138_ = _tmp137_[0];
											if (g_strcmp0 (_tmp138_, "nullable") == 0) {
												gchar** _tmp139_ = NULL;
												gint _tmp139__length1 = 0;
												const gchar* _tmp140_ = NULL;
												gchar* _tmp141_ = NULL;
												gchar* _tmp142_ = NULL;
												gboolean _tmp143_ = FALSE;
												_tmp139_ = nv;
												_tmp139__length1 = nv_length1;
												_tmp140_ = _tmp139_[1];
												_tmp141_ = vala_gidl_parser_eval (self, _tmp140_);
												_tmp142_ = _tmp141_;
												_tmp143_ = g_strcmp0 (_tmp142_, "1") == 0;
												_g_free0 (_tmp142_);
												if (_tmp143_) {
													ValaDataType* _tmp144_ = NULL;
													_tmp144_ = return_type;
													vala_data_type_set_nullable (_tmp144_, TRUE);
												}
											} else {
												gchar** _tmp145_ = NULL;
												gint _tmp145__length1 = 0;
												const gchar* _tmp146_ = NULL;
												_tmp145_ = nv;
												_tmp145__length1 = nv_length1;
												_tmp146_ = _tmp145_[0];
												if (g_strcmp0 (_tmp146_, "sentinel") == 0) {
													ValaMethod* _tmp147_ = NULL;
													gchar** _tmp148_ = NULL;
													gint _tmp148__length1 = 0;
													const gchar* _tmp149_ = NULL;
													gchar* _tmp150_ = NULL;
													gchar* _tmp151_ = NULL;
													_tmp147_ = m;
													_tmp148_ = nv;
													_tmp148__length1 = nv_length1;
													_tmp149_ = _tmp148_[1];
													_tmp150_ = vala_gidl_parser_eval (self, _tmp149_);
													_tmp151_ = _tmp150_;
													vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp147_, "CCode", "sentinel", _tmp151_, NULL);
													_g_free0 (_tmp151_);
												} else {
													gchar** _tmp152_ = NULL;
													gint _tmp152__length1 = 0;
													const gchar* _tmp153_ = NULL;
													_tmp152_ = nv;
													_tmp152__length1 = nv_length1;
													_tmp153_ = _tmp152_[0];
													if (g_strcmp0 (_tmp153_, "is_array") == 0) {
														gchar** _tmp154_ = NULL;
														gint _tmp154__length1 = 0;
														const gchar* _tmp155_ = NULL;
														gchar* _tmp156_ = NULL;
														gchar* _tmp157_ = NULL;
														gboolean _tmp158_ = FALSE;
														_tmp154_ = nv;
														_tmp154__length1 = nv_length1;
														_tmp155_ = _tmp154_[1];
														_tmp156_ = vala_gidl_parser_eval (self, _tmp155_);
														_tmp157_ = _tmp156_;
														_tmp158_ = g_strcmp0 (_tmp157_, "1") == 0;
														_g_free0 (_tmp157_);
														if (_tmp158_) {
															ValaDataType* _tmp159_ = NULL;
															ValaDataType* _tmp160_ = NULL;
															ValaSourceReference* _tmp161_ = NULL;
															ValaSourceReference* _tmp162_ = NULL;
															ValaArrayType* _tmp163_ = NULL;
															ValaMethod* _tmp164_ = NULL;
															ValaDataType* _tmp165_ = NULL;
															_tmp159_ = return_type;
															_tmp160_ = return_type;
															_tmp161_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp160_);
															_tmp162_ = _tmp161_;
															_tmp163_ = vala_array_type_new (_tmp159_, 1, _tmp162_);
															_vala_code_node_unref0 (return_type);
															return_type = (ValaDataType*) _tmp163_;
															_tmp164_ = m;
															_tmp165_ = return_type;
															vala_method_set_return_type (_tmp164_, _tmp165_);
														}
													} else {
														gchar** _tmp166_ = NULL;
														gint _tmp166__length1 = 0;
														const gchar* _tmp167_ = NULL;
														_tmp166_ = nv;
														_tmp166__length1 = nv_length1;
														_tmp167_ = _tmp166_[0];
														if (g_strcmp0 (_tmp167_, "is_pointer") == 0) {
															gchar** _tmp168_ = NULL;
															gint _tmp168__length1 = 0;
															const gchar* _tmp169_ = NULL;
															gchar* _tmp170_ = NULL;
															gchar* _tmp171_ = NULL;
															gboolean _tmp172_ = FALSE;
															_tmp168_ = nv;
															_tmp168__length1 = nv_length1;
															_tmp169_ = _tmp168_[1];
															_tmp170_ = vala_gidl_parser_eval (self, _tmp169_);
															_tmp171_ = _tmp170_;
															_tmp172_ = g_strcmp0 (_tmp171_, "1") == 0;
															_g_free0 (_tmp171_);
															if (_tmp172_) {
																ValaDataType* _tmp173_ = NULL;
																ValaDataType* _tmp174_ = NULL;
																ValaSourceReference* _tmp175_ = NULL;
																ValaSourceReference* _tmp176_ = NULL;
																ValaPointerType* _tmp177_ = NULL;
																ValaMethod* _tmp178_ = NULL;
																ValaDataType* _tmp179_ = NULL;
																_tmp173_ = return_type;
																_tmp174_ = return_type;
																_tmp175_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp174_);
																_tmp176_ = _tmp175_;
																_tmp177_ = vala_pointer_type_new (_tmp173_, _tmp176_);
																_vala_code_node_unref0 (return_type);
																return_type = (ValaDataType*) _tmp177_;
																_tmp178_ = m;
																_tmp179_ = return_type;
																vala_method_set_return_type (_tmp178_, _tmp179_);
															}
														} else {
															gchar** _tmp180_ = NULL;
															gint _tmp180__length1 = 0;
															const gchar* _tmp181_ = NULL;
															_tmp180_ = nv;
															_tmp180__length1 = nv_length1;
															_tmp181_ = _tmp180_[0];
															if (g_strcmp0 (_tmp181_, "throws") == 0) {
																gchar** _tmp182_ = NULL;
																gint _tmp182__length1 = 0;
																const gchar* _tmp183_ = NULL;
																gchar* _tmp184_ = NULL;
																gchar* _tmp185_ = NULL;
																gboolean _tmp186_ = FALSE;
																_tmp182_ = nv;
																_tmp182__length1 = nv_length1;
																_tmp183_ = _tmp182_[1];
																_tmp184_ = vala_gidl_parser_eval (self, _tmp183_);
																_tmp185_ = _tmp184_;
																_tmp186_ = g_strcmp0 (_tmp185_, "0") == 0;
																_g_free0 (_tmp185_);
																if (_tmp186_) {
																	suppress_throws = TRUE;
																}
															} else {
																gchar** _tmp187_ = NULL;
																gint _tmp187__length1 = 0;
																const gchar* _tmp188_ = NULL;
																_tmp187_ = nv;
																_tmp187__length1 = nv_length1;
																_tmp188_ = _tmp187_[0];
																if (g_strcmp0 (_tmp188_, "error_types") == 0) {
																	gchar** _tmp189_ = NULL;
																	gint _tmp189__length1 = 0;
																	const gchar* _tmp190_ = NULL;
																	gchar* _tmp191_ = NULL;
																	_tmp189_ = nv;
																	_tmp189__length1 = nv_length1;
																	_tmp190_ = _tmp189_[1];
																	_tmp191_ = vala_gidl_parser_eval (self, _tmp190_);
																	_g_free0 (error_types);
																	error_types = _tmp191_;
																} else {
																	gchar** _tmp192_ = NULL;
																	gint _tmp192__length1 = 0;
																	const gchar* _tmp193_ = NULL;
																	_tmp192_ = nv;
																	_tmp192__length1 = nv_length1;
																	_tmp193_ = _tmp192_[0];
																	if (g_strcmp0 (_tmp193_, "no_array_length") == 0) {
																		gchar** _tmp194_ = NULL;
																		gint _tmp194__length1 = 0;
																		const gchar* _tmp195_ = NULL;
																		gchar* _tmp196_ = NULL;
																		gchar* _tmp197_ = NULL;
																		gboolean _tmp198_ = FALSE;
																		_tmp194_ = nv;
																		_tmp194__length1 = nv_length1;
																		_tmp195_ = _tmp194_[1];
																		_tmp196_ = vala_gidl_parser_eval (self, _tmp195_);
																		_tmp197_ = _tmp196_;
																		_tmp198_ = g_strcmp0 (_tmp197_, "1") == 0;
																		_g_free0 (_tmp197_);
																		if (_tmp198_) {
																			ValaMethod* _tmp199_ = NULL;
																			_tmp199_ = m;
																			vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp199_, "CCode", "array_length", FALSE, NULL);
																		}
																	} else {
																		gchar** _tmp200_ = NULL;
																		gint _tmp200__length1 = 0;
																		const gchar* _tmp201_ = NULL;
																		_tmp200_ = nv;
																		_tmp200__length1 = nv_length1;
																		_tmp201_ = _tmp200_[0];
																		if (g_strcmp0 (_tmp201_, "array_null_terminated") == 0) {
																			gchar** _tmp202_ = NULL;
																			gint _tmp202__length1 = 0;
																			const gchar* _tmp203_ = NULL;
																			gchar* _tmp204_ = NULL;
																			gchar* _tmp205_ = NULL;
																			gboolean _tmp206_ = FALSE;
																			_tmp202_ = nv;
																			_tmp202__length1 = nv_length1;
																			_tmp203_ = _tmp202_[1];
																			_tmp204_ = vala_gidl_parser_eval (self, _tmp203_);
																			_tmp205_ = _tmp204_;
																			_tmp206_ = g_strcmp0 (_tmp205_, "1") == 0;
																			_g_free0 (_tmp205_);
																			if (_tmp206_) {
																				ValaMethod* _tmp207_ = NULL;
																				ValaMethod* _tmp208_ = NULL;
																				_tmp207_ = m;
																				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp207_, "CCode", "array_length", FALSE, NULL);
																				_tmp208_ = m;
																				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp208_, "CCode", "array_null_terminated", TRUE, NULL);
																			}
																		} else {
																			gchar** _tmp209_ = NULL;
																			gint _tmp209__length1 = 0;
																			const gchar* _tmp210_ = NULL;
																			_tmp209_ = nv;
																			_tmp209__length1 = nv_length1;
																			_tmp210_ = _tmp209_[0];
																			if (g_strcmp0 (_tmp210_, "array_length_type") == 0) {
																				ValaMethod* _tmp211_ = NULL;
																				gchar** _tmp212_ = NULL;
																				gint _tmp212__length1 = 0;
																				const gchar* _tmp213_ = NULL;
																				gchar* _tmp214_ = NULL;
																				gchar* _tmp215_ = NULL;
																				_tmp211_ = m;
																				_tmp212_ = nv;
																				_tmp212__length1 = nv_length1;
																				_tmp213_ = _tmp212_[1];
																				_tmp214_ = vala_gidl_parser_eval (self, _tmp213_);
																				_tmp215_ = _tmp214_;
																				vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp211_, "CCode", "array_length_type", _tmp215_, NULL);
																				_g_free0 (_tmp215_);
																			} else {
																				gchar** _tmp216_ = NULL;
																				gint _tmp216__length1 = 0;
																				const gchar* _tmp217_ = NULL;
																				_tmp216_ = nv;
																				_tmp216__length1 = nv_length1;
																				_tmp217_ = _tmp216_[0];
																				if (g_strcmp0 (_tmp217_, "type_name") == 0) {
																					ValaMethod* _tmp218_ = NULL;
																					gchar** _tmp219_ = NULL;
																					gint _tmp219__length1 = 0;
																					const gchar* _tmp220_ = NULL;
																					gchar* _tmp221_ = NULL;
																					gchar* _tmp222_ = NULL;
																					ValaDataType* _tmp223_ = NULL;
																					gboolean _tmp224_ = FALSE;
																					gboolean _tmp225_ = FALSE;
																					ValaDataType* _tmp226_ = NULL;
																					ValaDataType* _tmp227_ = NULL;
																					_tmp218_ = m;
																					_tmp219_ = nv;
																					_tmp219__length1 = nv_length1;
																					_tmp220_ = _tmp219_[1];
																					_tmp221_ = vala_gidl_parser_eval (self, _tmp220_);
																					_tmp222_ = _tmp221_;
																					_tmp223_ = return_type;
																					_tmp224_ = vala_data_type_get_value_owned (_tmp223_);
																					_tmp225_ = _tmp224_;
																					_tmp226_ = vala_gidl_parser_parse_type_from_string (self, _tmp222_, _tmp225_, NULL);
																					_vala_code_node_unref0 (return_type);
																					return_type = _tmp226_;
																					_tmp227_ = return_type;
																					vala_method_set_return_type (_tmp218_, _tmp227_);
																					_g_free0 (_tmp222_);
																				} else {
																					gchar** _tmp228_ = NULL;
																					gint _tmp228__length1 = 0;
																					const gchar* _tmp229_ = NULL;
																					_tmp228_ = nv;
																					_tmp228__length1 = nv_length1;
																					_tmp229_ = _tmp228_[0];
																					if (g_strcmp0 (_tmp229_, "ctype") == 0) {
																						ValaMethod* _tmp230_ = NULL;
																						gchar** _tmp231_ = NULL;
																						gint _tmp231__length1 = 0;
																						const gchar* _tmp232_ = NULL;
																						gchar* _tmp233_ = NULL;
																						gchar* _tmp234_ = NULL;
																						_tmp230_ = m;
																						_tmp231_ = nv;
																						_tmp231__length1 = nv_length1;
																						_tmp232_ = _tmp231_[1];
																						_tmp233_ = vala_gidl_parser_eval (self, _tmp232_);
																						_tmp234_ = _tmp233_;
																						vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp230_, "CCode", "type", _tmp234_, NULL);
																						_g_free0 (_tmp234_);
																					} else {
																						gchar** _tmp235_ = NULL;
																						gint _tmp235__length1 = 0;
																						const gchar* _tmp236_ = NULL;
																						_tmp235_ = nv;
																						_tmp235__length1 = nv_length1;
																						_tmp236_ = _tmp235_[0];
																						if (g_strcmp0 (_tmp236_, "type_arguments") == 0) {
																							ValaDataType* _tmp237_ = NULL;
																							gchar** _tmp238_ = NULL;
																							gint _tmp238__length1 = 0;
																							const gchar* _tmp239_ = NULL;
																							gchar* _tmp240_ = NULL;
																							gchar* _tmp241_ = NULL;
																							_tmp237_ = return_type;
																							_tmp238_ = nv;
																							_tmp238__length1 = nv_length1;
																							_tmp239_ = _tmp238_[1];
																							_tmp240_ = vala_gidl_parser_eval (self, _tmp239_);
																							_tmp241_ = _tmp240_;
																							vala_gidl_parser_parse_type_arguments_from_string (self, _tmp237_, _tmp241_, NULL);
																							_g_free0 (_tmp241_);
																						} else {
																							gchar** _tmp242_ = NULL;
																							gint _tmp242__length1 = 0;
																							const gchar* _tmp243_ = NULL;
																							_tmp242_ = nv;
																							_tmp242__length1 = nv_length1;
																							_tmp243_ = _tmp242_[0];
																							if (g_strcmp0 (_tmp243_, "deprecated") == 0) {
																								gchar** _tmp244_ = NULL;
																								gint _tmp244__length1 = 0;
																								const gchar* _tmp245_ = NULL;
																								gchar* _tmp246_ = NULL;
																								gchar* _tmp247_ = NULL;
																								gboolean _tmp248_ = FALSE;
																								_tmp244_ = nv;
																								_tmp244__length1 = nv_length1;
																								_tmp245_ = _tmp244_[1];
																								_tmp246_ = vala_gidl_parser_eval (self, _tmp245_);
																								_tmp247_ = _tmp246_;
																								_tmp248_ = g_strcmp0 (_tmp247_, "1") == 0;
																								_g_free0 (_tmp247_);
																								if (_tmp248_) {
																									ValaMethod* _tmp249_ = NULL;
																									_tmp249_ = m;
																									vala_code_node_set_attribute ((ValaCodeNode*) _tmp249_, "Deprecated", TRUE, NULL);
																								}
																							} else {
																								gchar** _tmp250_ = NULL;
																								gint _tmp250__length1 = 0;
																								const gchar* _tmp251_ = NULL;
																								_tmp250_ = nv;
																								_tmp250__length1 = nv_length1;
																								_tmp251_ = _tmp250_[0];
																								if (g_strcmp0 (_tmp251_, "replacement") == 0) {
																									ValaMethod* _tmp252_ = NULL;
																									gchar** _tmp253_ = NULL;
																									gint _tmp253__length1 = 0;
																									const gchar* _tmp254_ = NULL;
																									gchar* _tmp255_ = NULL;
																									gchar* _tmp256_ = NULL;
																									_tmp252_ = m;
																									_tmp253_ = nv;
																									_tmp253__length1 = nv_length1;
																									_tmp254_ = _tmp253_[1];
																									_tmp255_ = vala_gidl_parser_eval (self, _tmp254_);
																									_tmp256_ = _tmp255_;
																									vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp252_, "Deprecated", "replacement", _tmp256_, NULL);
																									_g_free0 (_tmp256_);
																								} else {
																									gchar** _tmp257_ = NULL;
																									gint _tmp257__length1 = 0;
																									const gchar* _tmp258_ = NULL;
																									_tmp257_ = nv;
																									_tmp257__length1 = nv_length1;
																									_tmp258_ = _tmp257_[0];
																									if (g_strcmp0 (_tmp258_, "deprecated_since") == 0) {
																										ValaMethod* _tmp259_ = NULL;
																										gchar** _tmp260_ = NULL;
																										gint _tmp260__length1 = 0;
																										const gchar* _tmp261_ = NULL;
																										gchar* _tmp262_ = NULL;
																										gchar* _tmp263_ = NULL;
																										_tmp259_ = m;
																										_tmp260_ = nv;
																										_tmp260__length1 = nv_length1;
																										_tmp261_ = _tmp260_[1];
																										_tmp262_ = vala_gidl_parser_eval (self, _tmp261_);
																										_tmp263_ = _tmp262_;
																										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp259_, "Deprecated", "since", _tmp263_, NULL);
																										_g_free0 (_tmp263_);
																									} else {
																										gchar** _tmp264_ = NULL;
																										gint _tmp264__length1 = 0;
																										const gchar* _tmp265_ = NULL;
																										_tmp264_ = nv;
																										_tmp264__length1 = nv_length1;
																										_tmp265_ = _tmp264_[0];
																										if (g_strcmp0 (_tmp265_, "cheader_filename") == 0) {
																											ValaMethod* _tmp266_ = NULL;
																											gchar** _tmp267_ = NULL;
																											gint _tmp267__length1 = 0;
																											const gchar* _tmp268_ = NULL;
																											gchar* _tmp269_ = NULL;
																											gchar* _tmp270_ = NULL;
																											_tmp266_ = m;
																											_tmp267_ = nv;
																											_tmp267__length1 = nv_length1;
																											_tmp268_ = _tmp267_[1];
																											_tmp269_ = vala_gidl_parser_eval (self, _tmp268_);
																											_tmp270_ = _tmp269_;
																											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp266_, "CCode", "cheader_filename", _tmp270_, NULL);
																											_g_free0 (_tmp270_);
																										} else {
																											gchar** _tmp271_ = NULL;
																											gint _tmp271__length1 = 0;
																											const gchar* _tmp272_ = NULL;
																											_tmp271_ = nv;
																											_tmp271__length1 = nv_length1;
																											_tmp272_ = _tmp271_[0];
																											if (g_strcmp0 (_tmp272_, "abstract") == 0) {
																												gchar** _tmp273_ = NULL;
																												gint _tmp273__length1 = 0;
																												const gchar* _tmp274_ = NULL;
																												gchar* _tmp275_ = NULL;
																												gchar* _tmp276_ = NULL;
																												gboolean _tmp277_ = FALSE;
																												_tmp273_ = nv;
																												_tmp273__length1 = nv_length1;
																												_tmp274_ = _tmp273_[1];
																												_tmp275_ = vala_gidl_parser_eval (self, _tmp274_);
																												_tmp276_ = _tmp275_;
																												_tmp277_ = g_strcmp0 (_tmp276_, "1") == 0;
																												_g_free0 (_tmp276_);
																												if (_tmp277_) {
																													ValaMethod* _tmp278_ = NULL;
																													_tmp278_ = m;
																													vala_method_set_is_abstract (_tmp278_, TRUE);
																												}
																											} else {
																												gchar** _tmp279_ = NULL;
																												gint _tmp279__length1 = 0;
																												const gchar* _tmp280_ = NULL;
																												_tmp279_ = nv;
																												_tmp279__length1 = nv_length1;
																												_tmp280_ = _tmp279_[0];
																												if (g_strcmp0 (_tmp280_, "virtual") == 0) {
																													gchar** _tmp281_ = NULL;
																													gint _tmp281__length1 = 0;
																													const gchar* _tmp282_ = NULL;
																													gchar* _tmp283_ = NULL;
																													gchar* _tmp284_ = NULL;
																													gboolean _tmp285_ = FALSE;
																													_tmp281_ = nv;
																													_tmp281__length1 = nv_length1;
																													_tmp282_ = _tmp281_[1];
																													_tmp283_ = vala_gidl_parser_eval (self, _tmp282_);
																													_tmp284_ = _tmp283_;
																													_tmp285_ = g_strcmp0 (_tmp284_, "1") == 0;
																													_g_free0 (_tmp284_);
																													if (_tmp285_) {
																														ValaMethod* _tmp286_ = NULL;
																														_tmp286_ = m;
																														vala_method_set_is_virtual (_tmp286_, TRUE);
																													}
																												} else {
																													gchar** _tmp287_ = NULL;
																													gint _tmp287__length1 = 0;
																													const gchar* _tmp288_ = NULL;
																													_tmp287_ = nv;
																													_tmp287__length1 = nv_length1;
																													_tmp288_ = _tmp287_[0];
																													if (g_strcmp0 (_tmp288_, "vfunc_name") == 0) {
																														ValaMethod* _tmp289_ = NULL;
																														gchar** _tmp290_ = NULL;
																														gint _tmp290__length1 = 0;
																														const gchar* _tmp291_ = NULL;
																														gchar* _tmp292_ = NULL;
																														gchar* _tmp293_ = NULL;
																														_tmp289_ = m;
																														_tmp290_ = nv;
																														_tmp290__length1 = nv_length1;
																														_tmp291_ = _tmp290_[1];
																														_tmp292_ = vala_gidl_parser_eval (self, _tmp291_);
																														_tmp293_ = _tmp292_;
																														vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp289_, "CCode", "vfunc_name", _tmp293_, NULL);
																														_g_free0 (_tmp293_);
																													} else {
																														gchar** _tmp294_ = NULL;
																														gint _tmp294__length1 = 0;
																														const gchar* _tmp295_ = NULL;
																														_tmp294_ = nv;
																														_tmp294__length1 = nv_length1;
																														_tmp295_ = _tmp294_[0];
																														if (g_strcmp0 (_tmp295_, "finish_name") == 0) {
																															ValaMethod* _tmp296_ = NULL;
																															gchar** _tmp297_ = NULL;
																															gint _tmp297__length1 = 0;
																															const gchar* _tmp298_ = NULL;
																															gchar* _tmp299_ = NULL;
																															gchar* _tmp300_ = NULL;
																															_tmp296_ = m;
																															_tmp297_ = nv;
																															_tmp297__length1 = nv_length1;
																															_tmp298_ = _tmp297_[1];
																															_tmp299_ = vala_gidl_parser_eval (self, _tmp298_);
																															_tmp300_ = _tmp299_;
																															vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp296_, "CCode", "finish_name", _tmp300_, NULL);
																															_g_free0 (_tmp300_);
																														} else {
																															gchar** _tmp301_ = NULL;
																															gint _tmp301__length1 = 0;
																															const gchar* _tmp302_ = NULL;
																															_tmp301_ = nv;
																															_tmp301__length1 = nv_length1;
																															_tmp302_ = _tmp301_[0];
																															if (g_strcmp0 (_tmp302_, "async") == 0) {
																																gchar** _tmp303_ = NULL;
																																gint _tmp303__length1 = 0;
																																const gchar* _tmp304_ = NULL;
																																gchar* _tmp305_ = NULL;
																																gchar* _tmp306_ = NULL;
																																gboolean _tmp307_ = FALSE;
																																_tmp303_ = nv;
																																_tmp303__length1 = nv_length1;
																																_tmp304_ = _tmp303_[1];
																																_tmp305_ = vala_gidl_parser_eval (self, _tmp304_);
																																_tmp306_ = _tmp305_;
																																_tmp307_ = g_strcmp0 (_tmp306_, "1") == 0;
																																_g_free0 (_tmp306_);
																																if (_tmp307_) {
																																	ValaMethod* _tmp308_ = NULL;
																																	_tmp308_ = m;
																																	vala_method_set_coroutine (_tmp308_, TRUE);
																																}
																															} else {
																																gchar** _tmp309_ = NULL;
																																gint _tmp309__length1 = 0;
																																const gchar* _tmp310_ = NULL;
																																_tmp309_ = nv;
																																_tmp309__length1 = nv_length1;
																																_tmp310_ = _tmp309_[0];
																																if (g_strcmp0 (_tmp310_, "parent") == 0) {
																																	gchar** _tmp311_ = NULL;
																																	gint _tmp311__length1 = 0;
																																	const gchar* _tmp312_ = NULL;
																																	gchar* _tmp313_ = NULL;
																																	gchar* _tmp314_ = NULL;
																																	ValaSymbol* _tmp315_ = NULL;
																																	gchar* prefix = NULL;
																																	ValaSymbol* _tmp316_ = NULL;
																																	gchar* _tmp317_ = NULL;
																																	const gchar* _tmp318_ = NULL;
																																	const gchar* _tmp319_ = NULL;
																																	gboolean _tmp320_ = FALSE;
																																	_tmp311_ = nv;
																																	_tmp311__length1 = nv_length1;
																																	_tmp312_ = _tmp311_[1];
																																	_tmp313_ = vala_gidl_parser_eval (self, _tmp312_);
																																	_tmp314_ = _tmp313_;
																																	_tmp315_ = vala_gidl_parser_get_container_from_name (self, _tmp314_);
																																	_vala_code_node_unref0 (container);
																																	container = _tmp315_;
																																	_g_free0 (_tmp314_);
																																	_tmp316_ = container;
																																	_tmp317_ = vala_gidl_parser_get_lower_case_cprefix (self, _tmp316_);
																																	prefix = _tmp317_;
																																	_tmp318_ = symbol;
																																	_tmp319_ = prefix;
																																	_tmp320_ = g_str_has_prefix (_tmp318_, _tmp319_);
																																	if (_tmp320_) {
																																		ValaMethod* _tmp321_ = NULL;
																																		const gchar* _tmp322_ = NULL;
																																		const gchar* _tmp323_ = NULL;
																																		gint _tmp324_ = 0;
																																		gint _tmp325_ = 0;
																																		gchar* _tmp326_ = NULL;
																																		gchar* _tmp327_ = NULL;
																																		_tmp321_ = m;
																																		_tmp322_ = symbol;
																																		_tmp323_ = prefix;
																																		_tmp324_ = strlen (_tmp323_);
																																		_tmp325_ = _tmp324_;
																																		_tmp326_ = string_substring (_tmp322_, (glong) _tmp325_, (glong) (-1));
																																		_tmp327_ = _tmp326_;
																																		vala_symbol_set_name ((ValaSymbol*) _tmp321_, _tmp327_);
																																		_g_free0 (_tmp327_);
																																	}
																																	_g_free0 (prefix);
																																} else {
																																	gchar** _tmp328_ = NULL;
																																	gint _tmp328__length1 = 0;
																																	const gchar* _tmp329_ = NULL;
																																	_tmp328_ = nv;
																																	_tmp328__length1 = nv_length1;
																																	_tmp329_ = _tmp328_[0];
																																	if (g_strcmp0 (_tmp329_, "experimental") == 0) {
																																		gchar** _tmp330_ = NULL;
																																		gint _tmp330__length1 = 0;
																																		const gchar* _tmp331_ = NULL;
																																		gchar* _tmp332_ = NULL;
																																		gchar* _tmp333_ = NULL;
																																		gboolean _tmp334_ = FALSE;
																																		_tmp330_ = nv;
																																		_tmp330__length1 = nv_length1;
																																		_tmp331_ = _tmp330_[1];
																																		_tmp332_ = vala_gidl_parser_eval (self, _tmp331_);
																																		_tmp333_ = _tmp332_;
																																		_tmp334_ = g_strcmp0 (_tmp333_, "1") == 0;
																																		_g_free0 (_tmp333_);
																																		if (_tmp334_) {
																																			ValaMethod* _tmp335_ = NULL;
																																			_tmp335_ = m;
																																			vala_code_node_set_attribute ((ValaCodeNode*) _tmp335_, "Experimental", TRUE, NULL);
																																		}
																																	} else {
																																		gchar** _tmp336_ = NULL;
																																		gint _tmp336__length1 = 0;
																																		const gchar* _tmp337_ = NULL;
																																		_tmp336_ = nv;
																																		_tmp336__length1 = nv_length1;
																																		_tmp337_ = _tmp336_[0];
																																		if (g_strcmp0 (_tmp337_, "simple_generics") == 0) {
																																			gchar** _tmp338_ = NULL;
																																			gint _tmp338__length1 = 0;
																																			const gchar* _tmp339_ = NULL;
																																			gchar* _tmp340_ = NULL;
																																			gchar* _tmp341_ = NULL;
																																			gboolean _tmp342_ = FALSE;
																																			_tmp338_ = nv;
																																			_tmp338__length1 = nv_length1;
																																			_tmp339_ = _tmp338_[1];
																																			_tmp340_ = vala_gidl_parser_eval (self, _tmp339_);
																																			_tmp341_ = _tmp340_;
																																			_tmp342_ = g_strcmp0 (_tmp341_, "1") == 0;
																																			_g_free0 (_tmp341_);
																																			if (_tmp342_) {
																																				ValaMethod* _tmp343_ = NULL;
																																				_tmp343_ = m;
																																				vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp343_, "CCode", "simple_generics", TRUE, NULL);
																																			}
																																		}
																																	}
																																}
																															}
																														}
																													}
																												}
																											}
																										}
																									}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	first = TRUE;
	last_param = NULL;
	last_param_type = NULL;
	_tmp344_ = parameters;
	{
		GList* param_collection = NULL;
		GList* param_it = NULL;
		param_collection = _tmp344_;
		for (param_it = param_collection; param_it != NULL; param_it = param_it->next) {
			GIdlNodeParam* param = NULL;
			param = (GIdlNodeParam*) param_it->data;
			{
				GIdlNode* param_node = NULL;
				GIdlNodeParam* _tmp345_ = NULL;
				gboolean _tmp346_ = FALSE;
				gboolean _tmp414_ = FALSE;
				GIdlNodeParam* _tmp415_ = NULL;
				GIdlNodeType* _tmp416_ = NULL;
				const gchar* _tmp417_ = NULL;
				gboolean _tmp425_ = FALSE;
				gboolean _tmp427_ = FALSE;
				gboolean _tmp428_ = FALSE;
				gboolean _tmp431_ = FALSE;
				gchar* param_name = NULL;
				GIdlNode* _tmp438_ = NULL;
				const gchar* _tmp439_ = NULL;
				gchar* _tmp440_ = NULL;
				const gchar* _tmp441_ = NULL;
				ValaParameterDirection direction = 0;
				ValaDataType* param_type = NULL;
				GIdlNodeParam* _tmp445_ = NULL;
				ValaParameterDirection _tmp446_ = 0;
				ValaDataType* _tmp447_ = NULL;
				ValaParameter* p = NULL;
				const gchar* _tmp448_ = NULL;
				ValaDataType* _tmp449_ = NULL;
				ValaParameter* _tmp450_ = NULL;
				ValaParameter* _tmp451_ = NULL;
				ValaParameterDirection _tmp452_ = 0;
				gboolean hide_param = FALSE;
				gboolean show_param = FALSE;
				gboolean set_array_length_pos = FALSE;
				gdouble array_length_pos = 0.0;
				gboolean set_delegate_target_pos = FALSE;
				gdouble delegate_target_pos = 0.0;
				gboolean array_requested = FALSE;
				gboolean out_requested = FALSE;
				const gchar* _tmp453_ = NULL;
				GIdlNode* _tmp454_ = NULL;
				const gchar* _tmp455_ = NULL;
				gchar* _tmp456_ = NULL;
				gchar* _tmp457_ = NULL;
				gint _tmp458_ = 0;
				gchar** _tmp459_ = NULL;
				gchar** _tmp460_ = NULL;
				gint _tmp460__length1 = 0;
				gboolean _tmp727_ = FALSE;
				ValaParameter* _tmp728_ = NULL;
				gboolean _tmp737_ = FALSE;
				gboolean _tmp753_ = FALSE;
				gboolean _tmp754_ = FALSE;
				gboolean _tmp756_ = FALSE;
				ValaParameter* _tmp765_ = NULL;
				ValaParameter* _tmp766_ = NULL;
				ValaDataType* _tmp767_ = NULL;
				ValaDataType* _tmp768_ = NULL;
				_tmp345_ = param;
				param_node = (GIdlNode*) _tmp345_;
				_tmp346_ = first;
				if (_tmp346_) {
					gboolean _tmp347_ = FALSE;
					gboolean _tmp348_ = FALSE;
					gboolean _tmp349_ = FALSE;
					ValaMethod* _tmp350_ = NULL;
					gboolean _tmp352_ = FALSE;
					gboolean _tmp356_ = FALSE;
					gboolean _tmp368_ = FALSE;
					first = FALSE;
					_tmp350_ = m;
					if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp350_, VALA_TYPE_CREATION_METHOD)) {
						ValaTypeSymbol* _tmp351_ = NULL;
						_tmp351_ = self->priv->current_data_type;
						_tmp349_ = _tmp351_ != NULL;
					} else {
						_tmp349_ = FALSE;
					}
					_tmp352_ = _tmp349_;
					if (_tmp352_) {
						GIdlNodeParam* _tmp353_ = NULL;
						GIdlNodeType* _tmp354_ = NULL;
						gboolean _tmp355_ = FALSE;
						_tmp353_ = param;
						_tmp354_ = _tmp353_->type;
						_tmp355_ = _tmp354_->is_interface;
						_tmp348_ = _tmp355_;
					} else {
						_tmp348_ = FALSE;
					}
					_tmp356_ = _tmp348_;
					if (_tmp356_) {
						gboolean _tmp357_ = FALSE;
						GIdlNode* _tmp358_ = NULL;
						const gchar* _tmp359_ = NULL;
						gboolean _tmp367_ = FALSE;
						_tmp358_ = param_node;
						_tmp359_ = _tmp358_->name;
						if (g_strcmp0 (_tmp359_, "self") == 0) {
							_tmp357_ = TRUE;
						} else {
							GIdlNodeParam* _tmp360_ = NULL;
							GIdlNodeType* _tmp361_ = NULL;
							const gchar* _tmp362_ = NULL;
							ValaTypeSymbol* _tmp363_ = NULL;
							gchar* _tmp364_ = NULL;
							gchar* _tmp365_ = NULL;
							gboolean _tmp366_ = FALSE;
							_tmp360_ = param;
							_tmp361_ = _tmp360_->type;
							_tmp362_ = _tmp361_->interface;
							_tmp363_ = self->priv->current_data_type;
							_tmp364_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp363_, NULL);
							_tmp365_ = _tmp364_;
							_tmp366_ = g_str_has_suffix (_tmp362_, _tmp365_);
							_tmp357_ = _tmp366_;
							_g_free0 (_tmp365_);
						}
						_tmp367_ = _tmp357_;
						_tmp347_ = _tmp367_;
					} else {
						_tmp347_ = FALSE;
					}
					_tmp368_ = _tmp347_;
					if (_tmp368_) {
						continue;
					} else {
						gboolean _tmp369_ = FALSE;
						gboolean _tmp370_ = FALSE;
						gboolean _tmp371_ = FALSE;
						ValaMethod* _tmp372_ = NULL;
						gboolean _tmp374_ = FALSE;
						gboolean _tmp378_ = FALSE;
						gboolean _tmp392_ = FALSE;
						_tmp372_ = m;
						if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp372_, VALA_TYPE_CREATION_METHOD)) {
							ValaTypeSymbol* _tmp373_ = NULL;
							_tmp373_ = self->priv->current_data_type;
							_tmp371_ = _tmp373_ != NULL;
						} else {
							_tmp371_ = FALSE;
						}
						_tmp374_ = _tmp371_;
						if (_tmp374_) {
							GIdlNodeParam* _tmp375_ = NULL;
							GIdlNodeType* _tmp376_ = NULL;
							gboolean _tmp377_ = FALSE;
							_tmp375_ = param;
							_tmp376_ = _tmp375_->type;
							_tmp377_ = _tmp376_->is_interface;
							_tmp370_ = _tmp377_;
						} else {
							_tmp370_ = FALSE;
						}
						_tmp378_ = _tmp370_;
						if (_tmp378_) {
							gboolean _tmp379_ = FALSE;
							GIdlNode* _tmp380_ = NULL;
							const gchar* _tmp381_ = NULL;
							gboolean _tmp391_ = FALSE;
							_tmp380_ = param_node;
							_tmp381_ = _tmp380_->name;
							if (g_strcmp0 (_tmp381_, "klass") == 0) {
								_tmp379_ = TRUE;
							} else {
								GIdlNodeParam* _tmp382_ = NULL;
								GIdlNodeType* _tmp383_ = NULL;
								const gchar* _tmp384_ = NULL;
								ValaTypeSymbol* _tmp385_ = NULL;
								gchar* _tmp386_ = NULL;
								gchar* _tmp387_ = NULL;
								gchar* _tmp388_ = NULL;
								gchar* _tmp389_ = NULL;
								gboolean _tmp390_ = FALSE;
								_tmp382_ = param;
								_tmp383_ = _tmp382_->type;
								_tmp384_ = _tmp383_->interface;
								_tmp385_ = self->priv->current_data_type;
								_tmp386_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp385_, NULL);
								_tmp387_ = _tmp386_;
								_tmp388_ = g_strdup_printf ("%sClass", _tmp387_);
								_tmp389_ = _tmp388_;
								_tmp390_ = g_str_has_suffix (_tmp384_, _tmp389_);
								_tmp379_ = _tmp390_;
								_g_free0 (_tmp389_);
								_g_free0 (_tmp387_);
							}
							_tmp391_ = _tmp379_;
							_tmp369_ = _tmp391_;
						} else {
							_tmp369_ = FALSE;
						}
						_tmp392_ = _tmp369_;
						if (_tmp392_) {
							ValaMethod* _tmp393_ = NULL;
							ValaMethod* _tmp394_ = NULL;
							const gchar* _tmp395_ = NULL;
							const gchar* _tmp396_ = NULL;
							gboolean _tmp397_ = FALSE;
							_tmp393_ = m;
							vala_method_set_binding (_tmp393_, VALA_MEMBER_BINDING_CLASS);
							_tmp394_ = m;
							_tmp395_ = vala_symbol_get_name ((ValaSymbol*) _tmp394_);
							_tmp396_ = _tmp395_;
							_tmp397_ = g_str_has_prefix (_tmp396_, "class_");
							if (_tmp397_) {
								ValaMethod* _tmp398_ = NULL;
								ValaMethod* _tmp399_ = NULL;
								const gchar* _tmp400_ = NULL;
								const gchar* _tmp401_ = NULL;
								gint _tmp402_ = 0;
								gint _tmp403_ = 0;
								ValaMethod* _tmp404_ = NULL;
								const gchar* _tmp405_ = NULL;
								const gchar* _tmp406_ = NULL;
								gint _tmp407_ = 0;
								gint _tmp408_ = 0;
								gint _tmp409_ = 0;
								gint _tmp410_ = 0;
								gchar* _tmp411_ = NULL;
								gchar* _tmp412_ = NULL;
								_tmp398_ = m;
								_tmp399_ = m;
								_tmp400_ = vala_symbol_get_name ((ValaSymbol*) _tmp399_);
								_tmp401_ = _tmp400_;
								_tmp402_ = strlen ("class_");
								_tmp403_ = _tmp402_;
								_tmp404_ = m;
								_tmp405_ = vala_symbol_get_name ((ValaSymbol*) _tmp404_);
								_tmp406_ = _tmp405_;
								_tmp407_ = strlen (_tmp406_);
								_tmp408_ = _tmp407_;
								_tmp409_ = strlen ("class_");
								_tmp410_ = _tmp409_;
								_tmp411_ = string_substring (_tmp401_, (glong) _tmp403_, (glong) (_tmp408_ - _tmp410_));
								_tmp412_ = _tmp411_;
								vala_symbol_set_name ((ValaSymbol*) _tmp398_, _tmp412_);
								_g_free0 (_tmp412_);
							}
							continue;
						} else {
							ValaMethod* _tmp413_ = NULL;
							_tmp413_ = m;
							vala_method_set_binding (_tmp413_, VALA_MEMBER_BINDING_STATIC);
						}
					}
				}
				_tmp415_ = param;
				_tmp416_ = _tmp415_->type;
				_tmp417_ = _tmp416_->interface;
				if (g_strcmp0 (_tmp417_, "GAsyncReadyCallback") == 0) {
					gboolean _tmp418_ = FALSE;
					const gchar* _tmp419_ = NULL;
					gboolean _tmp420_ = FALSE;
					gboolean _tmp424_ = FALSE;
					_tmp419_ = symbol;
					_tmp420_ = g_str_has_suffix (_tmp419_, "_async");
					if (_tmp420_) {
						_tmp418_ = TRUE;
					} else {
						ValaMethod* _tmp421_ = NULL;
						gboolean _tmp422_ = FALSE;
						gboolean _tmp423_ = FALSE;
						_tmp421_ = m;
						_tmp422_ = vala_method_get_coroutine (_tmp421_);
						_tmp423_ = _tmp422_;
						_tmp418_ = _tmp423_;
					}
					_tmp424_ = _tmp418_;
					_tmp414_ = _tmp424_;
				} else {
					_tmp414_ = FALSE;
				}
				_tmp425_ = _tmp414_;
				if (_tmp425_) {
					ValaMethod* _tmp426_ = NULL;
					_tmp426_ = m;
					vala_method_set_coroutine (_tmp426_, TRUE);
					continue;
				}
				_tmp428_ = suppress_throws;
				if (_tmp428_ == FALSE) {
					GIdlNodeParam* _tmp429_ = NULL;
					gboolean _tmp430_ = FALSE;
					_tmp429_ = param;
					_tmp430_ = vala_gidl_parser_param_is_exception (self, _tmp429_);
					_tmp427_ = _tmp430_;
				} else {
					_tmp427_ = FALSE;
				}
				_tmp431_ = _tmp427_;
				if (_tmp431_) {
					const gchar* _tmp432_ = NULL;
					_tmp432_ = error_types;
					if (_tmp432_ == NULL) {
						ValaMethod* _tmp433_ = NULL;
						GIdlNodeParam* _tmp434_ = NULL;
						GIdlNodeType* _tmp435_ = NULL;
						ValaDataType* _tmp436_ = NULL;
						ValaDataType* _tmp437_ = NULL;
						_tmp433_ = m;
						_tmp434_ = param;
						_tmp435_ = _tmp434_->type;
						_tmp436_ = vala_gidl_parser_parse_type (self, _tmp435_, NULL);
						_tmp437_ = _tmp436_;
						vala_code_node_add_error_type ((ValaCodeNode*) _tmp433_, _tmp437_);
						_vala_code_node_unref0 (_tmp437_);
					}
					continue;
				}
				_tmp438_ = param_node;
				_tmp439_ = _tmp438_->name;
				_tmp440_ = g_strdup (_tmp439_);
				param_name = _tmp440_;
				_tmp441_ = param_name;
				if (g_strcmp0 (_tmp441_, "result") == 0) {
					gchar* _tmp442_ = NULL;
					_tmp442_ = g_strdup ("_result");
					_g_free0 (param_name);
					param_name = _tmp442_;
				} else {
					const gchar* _tmp443_ = NULL;
					_tmp443_ = param_name;
					if (g_strcmp0 (_tmp443_, "string") == 0) {
						gchar* _tmp444_ = NULL;
						_tmp444_ = g_strdup ("str");
						_g_free0 (param_name);
						param_name = _tmp444_;
					}
				}
				_tmp445_ = param;
				_tmp447_ = vala_gidl_parser_parse_param (self, _tmp445_, &_tmp446_);
				direction = _tmp446_;
				param_type = _tmp447_;
				_tmp448_ = param_name;
				_tmp449_ = param_type;
				_tmp450_ = vala_parameter_new (_tmp448_, _tmp449_, NULL);
				p = _tmp450_;
				_tmp451_ = p;
				_tmp452_ = direction;
				vala_parameter_set_direction (_tmp451_, _tmp452_);
				hide_param = FALSE;
				show_param = FALSE;
				set_array_length_pos = FALSE;
				array_length_pos = (gdouble) 0;
				set_delegate_target_pos = FALSE;
				delegate_target_pos = (gdouble) 0;
				array_requested = FALSE;
				out_requested = FALSE;
				_tmp453_ = symbol;
				_tmp454_ = param_node;
				_tmp455_ = _tmp454_->name;
				_tmp456_ = g_strdup_printf ("%s.%s", _tmp453_, _tmp455_);
				_tmp457_ = _tmp456_;
				_tmp459_ = vala_gidl_parser_get_attributes (self, _tmp457_, &_tmp458_);
				attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
				attributes = _tmp459_;
				attributes_length1 = _tmp458_;
				_attributes_size_ = attributes_length1;
				_g_free0 (_tmp457_);
				_tmp460_ = attributes;
				_tmp460__length1 = attributes_length1;
				if (_tmp460_ != NULL) {
					gchar** _tmp461_ = NULL;
					gint _tmp461__length1 = 0;
					_tmp461_ = attributes;
					_tmp461__length1 = attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp461_;
						attr_collection_length1 = _tmp461__length1;
						for (attr_it = 0; attr_it < _tmp461__length1; attr_it = attr_it + 1) {
							gchar* _tmp462_ = NULL;
							gchar* attr = NULL;
							_tmp462_ = g_strdup (attr_collection[attr_it]);
							attr = _tmp462_;
							{
								gchar** nv = NULL;
								const gchar* _tmp463_ = NULL;
								gchar** _tmp464_ = NULL;
								gchar** _tmp465_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gchar** _tmp466_ = NULL;
								gint _tmp466__length1 = 0;
								const gchar* _tmp467_ = NULL;
								_tmp463_ = attr;
								_tmp465_ = _tmp464_ = g_strsplit (_tmp463_, "=", 2);
								nv = _tmp465_;
								nv_length1 = _vala_array_length (_tmp464_);
								_nv_size_ = nv_length1;
								_tmp466_ = nv;
								_tmp466__length1 = nv_length1;
								_tmp467_ = _tmp466_[0];
								if (g_strcmp0 (_tmp467_, "is_array") == 0) {
									gchar** _tmp468_ = NULL;
									gint _tmp468__length1 = 0;
									const gchar* _tmp469_ = NULL;
									gchar* _tmp470_ = NULL;
									gchar* _tmp471_ = NULL;
									gboolean _tmp472_ = FALSE;
									_tmp468_ = nv;
									_tmp468__length1 = nv_length1;
									_tmp469_ = _tmp468_[1];
									_tmp470_ = vala_gidl_parser_eval (self, _tmp469_);
									_tmp471_ = _tmp470_;
									_tmp472_ = g_strcmp0 (_tmp471_, "1") == 0;
									_g_free0 (_tmp471_);
									if (_tmp472_) {
										ValaDataType* _tmp473_ = NULL;
										ValaDataType* _tmp474_ = NULL;
										ValaSourceReference* _tmp475_ = NULL;
										ValaSourceReference* _tmp476_ = NULL;
										ValaArrayType* _tmp477_ = NULL;
										ValaParameter* _tmp478_ = NULL;
										ValaDataType* _tmp479_ = NULL;
										gboolean _tmp480_ = FALSE;
										_tmp473_ = param_type;
										_tmp474_ = param_type;
										_tmp475_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp474_);
										_tmp476_ = _tmp475_;
										_tmp477_ = vala_array_type_new (_tmp473_, 1, _tmp476_);
										_vala_code_node_unref0 (param_type);
										param_type = (ValaDataType*) _tmp477_;
										_tmp478_ = p;
										_tmp479_ = param_type;
										vala_variable_set_variable_type ((ValaVariable*) _tmp478_, _tmp479_);
										_tmp480_ = out_requested;
										if (!_tmp480_) {
											ValaParameter* _tmp481_ = NULL;
											_tmp481_ = p;
											vala_parameter_set_direction (_tmp481_, VALA_PARAMETER_DIRECTION_IN);
										}
										array_requested = TRUE;
									}
								} else {
									gchar** _tmp482_ = NULL;
									gint _tmp482__length1 = 0;
									const gchar* _tmp483_ = NULL;
									_tmp482_ = nv;
									_tmp482__length1 = nv_length1;
									_tmp483_ = _tmp482_[0];
									if (g_strcmp0 (_tmp483_, "is_pointer") == 0) {
										gchar** _tmp484_ = NULL;
										gint _tmp484__length1 = 0;
										const gchar* _tmp485_ = NULL;
										gchar* _tmp486_ = NULL;
										gchar* _tmp487_ = NULL;
										gboolean _tmp488_ = FALSE;
										_tmp484_ = nv;
										_tmp484__length1 = nv_length1;
										_tmp485_ = _tmp484_[1];
										_tmp486_ = vala_gidl_parser_eval (self, _tmp485_);
										_tmp487_ = _tmp486_;
										_tmp488_ = g_strcmp0 (_tmp487_, "1") == 0;
										_g_free0 (_tmp487_);
										if (_tmp488_) {
											ValaDataType* _tmp489_ = NULL;
											ValaDataType* _tmp490_ = NULL;
											ValaSourceReference* _tmp491_ = NULL;
											ValaSourceReference* _tmp492_ = NULL;
											ValaPointerType* _tmp493_ = NULL;
											ValaParameter* _tmp494_ = NULL;
											ValaDataType* _tmp495_ = NULL;
											gboolean _tmp496_ = FALSE;
											_tmp489_ = param_type;
											_tmp490_ = return_type;
											_tmp491_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp490_);
											_tmp492_ = _tmp491_;
											_tmp493_ = vala_pointer_type_new (_tmp489_, _tmp492_);
											_vala_code_node_unref0 (param_type);
											param_type = (ValaDataType*) _tmp493_;
											_tmp494_ = p;
											_tmp495_ = param_type;
											vala_variable_set_variable_type ((ValaVariable*) _tmp494_, _tmp495_);
											_tmp496_ = out_requested;
											if (!_tmp496_) {
												ValaParameter* _tmp497_ = NULL;
												_tmp497_ = p;
												vala_parameter_set_direction (_tmp497_, VALA_PARAMETER_DIRECTION_IN);
											}
										}
									} else {
										gchar** _tmp498_ = NULL;
										gint _tmp498__length1 = 0;
										const gchar* _tmp499_ = NULL;
										_tmp498_ = nv;
										_tmp498__length1 = nv_length1;
										_tmp499_ = _tmp498_[0];
										if (g_strcmp0 (_tmp499_, "is_out") == 0) {
											gchar** _tmp500_ = NULL;
											gint _tmp500__length1 = 0;
											const gchar* _tmp501_ = NULL;
											gchar* _tmp502_ = NULL;
											gchar* _tmp503_ = NULL;
											gboolean _tmp504_ = FALSE;
											_tmp500_ = nv;
											_tmp500__length1 = nv_length1;
											_tmp501_ = _tmp500_[1];
											_tmp502_ = vala_gidl_parser_eval (self, _tmp501_);
											_tmp503_ = _tmp502_;
											_tmp504_ = g_strcmp0 (_tmp503_, "1") == 0;
											_g_free0 (_tmp503_);
											if (_tmp504_) {
												ValaParameter* _tmp505_ = NULL;
												gboolean _tmp506_ = FALSE;
												gboolean _tmp507_ = FALSE;
												gboolean _tmp509_ = FALSE;
												_tmp505_ = p;
												vala_parameter_set_direction (_tmp505_, VALA_PARAMETER_DIRECTION_OUT);
												out_requested = TRUE;
												_tmp507_ = array_requested;
												if (!_tmp507_) {
													ValaDataType* _tmp508_ = NULL;
													_tmp508_ = param_type;
													_tmp506_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp508_, VALA_TYPE_ARRAY_TYPE);
												} else {
													_tmp506_ = FALSE;
												}
												_tmp509_ = _tmp506_;
												if (_tmp509_) {
													ValaArrayType* array_type = NULL;
													ValaDataType* _tmp510_ = NULL;
													ValaArrayType* _tmp511_ = NULL;
													ValaArrayType* _tmp512_ = NULL;
													ValaDataType* _tmp513_ = NULL;
													ValaDataType* _tmp514_ = NULL;
													ValaDataType* _tmp515_ = NULL;
													ValaParameter* _tmp516_ = NULL;
													ValaDataType* _tmp517_ = NULL;
													_tmp510_ = param_type;
													_tmp511_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp510_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
													array_type = _tmp511_;
													_tmp512_ = array_type;
													_tmp513_ = vala_array_type_get_element_type (_tmp512_);
													_tmp514_ = _tmp513_;
													_tmp515_ = _vala_code_node_ref0 (_tmp514_);
													_vala_code_node_unref0 (param_type);
													param_type = _tmp515_;
													_tmp516_ = p;
													_tmp517_ = param_type;
													vala_variable_set_variable_type ((ValaVariable*) _tmp516_, _tmp517_);
													_vala_code_node_unref0 (array_type);
												}
											}
										} else {
											gchar** _tmp518_ = NULL;
											gint _tmp518__length1 = 0;
											const gchar* _tmp519_ = NULL;
											_tmp518_ = nv;
											_tmp518__length1 = nv_length1;
											_tmp519_ = _tmp518_[0];
											if (g_strcmp0 (_tmp519_, "is_ref") == 0) {
												gchar** _tmp520_ = NULL;
												gint _tmp520__length1 = 0;
												const gchar* _tmp521_ = NULL;
												gchar* _tmp522_ = NULL;
												gchar* _tmp523_ = NULL;
												gboolean _tmp524_ = FALSE;
												_tmp520_ = nv;
												_tmp520__length1 = nv_length1;
												_tmp521_ = _tmp520_[1];
												_tmp522_ = vala_gidl_parser_eval (self, _tmp521_);
												_tmp523_ = _tmp522_;
												_tmp524_ = g_strcmp0 (_tmp523_, "1") == 0;
												_g_free0 (_tmp523_);
												if (_tmp524_) {
													ValaParameter* _tmp525_ = NULL;
													gboolean _tmp526_ = FALSE;
													gboolean _tmp527_ = FALSE;
													gboolean _tmp529_ = FALSE;
													_tmp525_ = p;
													vala_parameter_set_direction (_tmp525_, VALA_PARAMETER_DIRECTION_REF);
													_tmp527_ = array_requested;
													if (!_tmp527_) {
														ValaDataType* _tmp528_ = NULL;
														_tmp528_ = param_type;
														_tmp526_ = G_TYPE_CHECK_INSTANCE_TYPE (_tmp528_, VALA_TYPE_ARRAY_TYPE);
													} else {
														_tmp526_ = FALSE;
													}
													_tmp529_ = _tmp526_;
													if (_tmp529_) {
														ValaArrayType* array_type = NULL;
														ValaDataType* _tmp530_ = NULL;
														ValaArrayType* _tmp531_ = NULL;
														ValaArrayType* _tmp532_ = NULL;
														ValaDataType* _tmp533_ = NULL;
														ValaDataType* _tmp534_ = NULL;
														ValaDataType* _tmp535_ = NULL;
														ValaParameter* _tmp536_ = NULL;
														ValaDataType* _tmp537_ = NULL;
														_tmp530_ = param_type;
														_tmp531_ = _vala_code_node_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp530_, VALA_TYPE_ARRAY_TYPE, ValaArrayType));
														array_type = _tmp531_;
														_tmp532_ = array_type;
														_tmp533_ = vala_array_type_get_element_type (_tmp532_);
														_tmp534_ = _tmp533_;
														_tmp535_ = _vala_code_node_ref0 (_tmp534_);
														_vala_code_node_unref0 (param_type);
														param_type = _tmp535_;
														_tmp536_ = p;
														_tmp537_ = param_type;
														vala_variable_set_variable_type ((ValaVariable*) _tmp536_, _tmp537_);
														_vala_code_node_unref0 (array_type);
													}
												}
											} else {
												gchar** _tmp538_ = NULL;
												gint _tmp538__length1 = 0;
												const gchar* _tmp539_ = NULL;
												_tmp538_ = nv;
												_tmp538__length1 = nv_length1;
												_tmp539_ = _tmp538_[0];
												if (g_strcmp0 (_tmp539_, "nullable") == 0) {
													gchar** _tmp540_ = NULL;
													gint _tmp540__length1 = 0;
													const gchar* _tmp541_ = NULL;
													gchar* _tmp542_ = NULL;
													gchar* _tmp543_ = NULL;
													gboolean _tmp544_ = FALSE;
													_tmp540_ = nv;
													_tmp540__length1 = nv_length1;
													_tmp541_ = _tmp540_[1];
													_tmp542_ = vala_gidl_parser_eval (self, _tmp541_);
													_tmp543_ = _tmp542_;
													_tmp544_ = g_strcmp0 (_tmp543_, "1") == 0;
													_g_free0 (_tmp543_);
													if (_tmp544_) {
														ValaDataType* _tmp545_ = NULL;
														_tmp545_ = param_type;
														vala_data_type_set_nullable (_tmp545_, TRUE);
													}
												} else {
													gchar** _tmp546_ = NULL;
													gint _tmp546__length1 = 0;
													const gchar* _tmp547_ = NULL;
													_tmp546_ = nv;
													_tmp546__length1 = nv_length1;
													_tmp547_ = _tmp546_[0];
													if (g_strcmp0 (_tmp547_, "transfer_ownership") == 0) {
														gchar** _tmp548_ = NULL;
														gint _tmp548__length1 = 0;
														const gchar* _tmp549_ = NULL;
														gchar* _tmp550_ = NULL;
														gchar* _tmp551_ = NULL;
														gboolean _tmp552_ = FALSE;
														_tmp548_ = nv;
														_tmp548__length1 = nv_length1;
														_tmp549_ = _tmp548_[1];
														_tmp550_ = vala_gidl_parser_eval (self, _tmp549_);
														_tmp551_ = _tmp550_;
														_tmp552_ = g_strcmp0 (_tmp551_, "1") == 0;
														_g_free0 (_tmp551_);
														if (_tmp552_) {
															ValaDataType* _tmp553_ = NULL;
															_tmp553_ = param_type;
															vala_data_type_set_value_owned (_tmp553_, TRUE);
														}
													} else {
														gchar** _tmp554_ = NULL;
														gint _tmp554__length1 = 0;
														const gchar* _tmp555_ = NULL;
														_tmp554_ = nv;
														_tmp554__length1 = nv_length1;
														_tmp555_ = _tmp554_[0];
														if (g_strcmp0 (_tmp555_, "takes_ownership") == 0) {
															gchar** _tmp556_ = NULL;
															gint _tmp556__length1 = 0;
															const gchar* _tmp557_ = NULL;
															gchar* _tmp558_ = NULL;
															gchar* _tmp559_ = NULL;
															gboolean _tmp560_ = FALSE;
															_tmp556_ = nv;
															_tmp556__length1 = nv_length1;
															_tmp557_ = _tmp556_[1];
															_tmp558_ = vala_gidl_parser_eval (self, _tmp557_);
															_tmp559_ = _tmp558_;
															_tmp560_ = g_strcmp0 (_tmp559_, "1") == 0;
															_g_free0 (_tmp559_);
															if (_tmp560_) {
																ValaDataType* _tmp561_ = NULL;
																_tmp561_ = param_type;
																vala_data_type_set_value_owned (_tmp561_, TRUE);
															}
														} else {
															gchar** _tmp562_ = NULL;
															gint _tmp562__length1 = 0;
															const gchar* _tmp563_ = NULL;
															_tmp562_ = nv;
															_tmp562__length1 = nv_length1;
															_tmp563_ = _tmp562_[0];
															if (g_strcmp0 (_tmp563_, "value_owned") == 0) {
																gchar** _tmp564_ = NULL;
																gint _tmp564__length1 = 0;
																const gchar* _tmp565_ = NULL;
																gchar* _tmp566_ = NULL;
																gchar* _tmp567_ = NULL;
																gboolean _tmp568_ = FALSE;
																_tmp564_ = nv;
																_tmp564__length1 = nv_length1;
																_tmp565_ = _tmp564_[1];
																_tmp566_ = vala_gidl_parser_eval (self, _tmp565_);
																_tmp567_ = _tmp566_;
																_tmp568_ = g_strcmp0 (_tmp567_, "0") == 0;
																_g_free0 (_tmp567_);
																if (_tmp568_) {
																	ValaDataType* _tmp569_ = NULL;
																	_tmp569_ = param_type;
																	vala_data_type_set_value_owned (_tmp569_, FALSE);
																} else {
																	gchar** _tmp570_ = NULL;
																	gint _tmp570__length1 = 0;
																	const gchar* _tmp571_ = NULL;
																	gchar* _tmp572_ = NULL;
																	gchar* _tmp573_ = NULL;
																	gboolean _tmp574_ = FALSE;
																	_tmp570_ = nv;
																	_tmp570__length1 = nv_length1;
																	_tmp571_ = _tmp570_[1];
																	_tmp572_ = vala_gidl_parser_eval (self, _tmp571_);
																	_tmp573_ = _tmp572_;
																	_tmp574_ = g_strcmp0 (_tmp573_, "1") == 0;
																	_g_free0 (_tmp573_);
																	if (_tmp574_) {
																		ValaDataType* _tmp575_ = NULL;
																		_tmp575_ = param_type;
																		vala_data_type_set_value_owned (_tmp575_, TRUE);
																	}
																}
															} else {
																gchar** _tmp576_ = NULL;
																gint _tmp576__length1 = 0;
																const gchar* _tmp577_ = NULL;
																_tmp576_ = nv;
																_tmp576__length1 = nv_length1;
																_tmp577_ = _tmp576_[0];
																if (g_strcmp0 (_tmp577_, "hidden") == 0) {
																	gchar** _tmp578_ = NULL;
																	gint _tmp578__length1 = 0;
																	const gchar* _tmp579_ = NULL;
																	gchar* _tmp580_ = NULL;
																	gchar* _tmp581_ = NULL;
																	gboolean _tmp582_ = FALSE;
																	_tmp578_ = nv;
																	_tmp578__length1 = nv_length1;
																	_tmp579_ = _tmp578_[1];
																	_tmp580_ = vala_gidl_parser_eval (self, _tmp579_);
																	_tmp581_ = _tmp580_;
																	_tmp582_ = g_strcmp0 (_tmp581_, "1") == 0;
																	_g_free0 (_tmp581_);
																	if (_tmp582_) {
																		hide_param = TRUE;
																	} else {
																		gchar** _tmp583_ = NULL;
																		gint _tmp583__length1 = 0;
																		const gchar* _tmp584_ = NULL;
																		gchar* _tmp585_ = NULL;
																		gchar* _tmp586_ = NULL;
																		gboolean _tmp587_ = FALSE;
																		_tmp583_ = nv;
																		_tmp583__length1 = nv_length1;
																		_tmp584_ = _tmp583_[1];
																		_tmp585_ = vala_gidl_parser_eval (self, _tmp584_);
																		_tmp586_ = _tmp585_;
																		_tmp587_ = g_strcmp0 (_tmp586_, "0") == 0;
																		_g_free0 (_tmp586_);
																		if (_tmp587_) {
																			show_param = TRUE;
																		}
																	}
																} else {
																	gchar** _tmp588_ = NULL;
																	gint _tmp588__length1 = 0;
																	const gchar* _tmp589_ = NULL;
																	_tmp588_ = nv;
																	_tmp588__length1 = nv_length1;
																	_tmp589_ = _tmp588_[0];
																	if (g_strcmp0 (_tmp589_, "no_array_length") == 0) {
																		gchar** _tmp590_ = NULL;
																		gint _tmp590__length1 = 0;
																		const gchar* _tmp591_ = NULL;
																		gchar* _tmp592_ = NULL;
																		gchar* _tmp593_ = NULL;
																		gboolean _tmp594_ = FALSE;
																		_tmp590_ = nv;
																		_tmp590__length1 = nv_length1;
																		_tmp591_ = _tmp590_[1];
																		_tmp592_ = vala_gidl_parser_eval (self, _tmp591_);
																		_tmp593_ = _tmp592_;
																		_tmp594_ = g_strcmp0 (_tmp593_, "1") == 0;
																		_g_free0 (_tmp593_);
																		if (_tmp594_) {
																			ValaParameter* _tmp595_ = NULL;
																			_tmp595_ = p;
																			vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp595_, "CCode", "array_length", FALSE, NULL);
																		}
																	} else {
																		gchar** _tmp596_ = NULL;
																		gint _tmp596__length1 = 0;
																		const gchar* _tmp597_ = NULL;
																		_tmp596_ = nv;
																		_tmp596__length1 = nv_length1;
																		_tmp597_ = _tmp596_[0];
																		if (g_strcmp0 (_tmp597_, "array_length_type") == 0) {
																			ValaParameter* _tmp598_ = NULL;
																			gchar** _tmp599_ = NULL;
																			gint _tmp599__length1 = 0;
																			const gchar* _tmp600_ = NULL;
																			gchar* _tmp601_ = NULL;
																			gchar* _tmp602_ = NULL;
																			_tmp598_ = p;
																			_tmp599_ = nv;
																			_tmp599__length1 = nv_length1;
																			_tmp600_ = _tmp599_[1];
																			_tmp601_ = vala_gidl_parser_eval (self, _tmp600_);
																			_tmp602_ = _tmp601_;
																			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp598_, "CCode", "array_length_type", _tmp602_, NULL);
																			_g_free0 (_tmp602_);
																		} else {
																			gchar** _tmp603_ = NULL;
																			gint _tmp603__length1 = 0;
																			const gchar* _tmp604_ = NULL;
																			_tmp603_ = nv;
																			_tmp603__length1 = nv_length1;
																			_tmp604_ = _tmp603_[0];
																			if (g_strcmp0 (_tmp604_, "array_null_terminated") == 0) {
																				gchar** _tmp605_ = NULL;
																				gint _tmp605__length1 = 0;
																				const gchar* _tmp606_ = NULL;
																				gchar* _tmp607_ = NULL;
																				gchar* _tmp608_ = NULL;
																				gboolean _tmp609_ = FALSE;
																				_tmp605_ = nv;
																				_tmp605__length1 = nv_length1;
																				_tmp606_ = _tmp605_[1];
																				_tmp607_ = vala_gidl_parser_eval (self, _tmp606_);
																				_tmp608_ = _tmp607_;
																				_tmp609_ = g_strcmp0 (_tmp608_, "1") == 0;
																				_g_free0 (_tmp608_);
																				if (_tmp609_) {
																					ValaParameter* _tmp610_ = NULL;
																					ValaParameter* _tmp611_ = NULL;
																					_tmp610_ = p;
																					vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp610_, "CCode", "array_length", FALSE, NULL);
																					_tmp611_ = p;
																					vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp611_, "CCode", "array_null_terminated", TRUE, NULL);
																				}
																			} else {
																				gchar** _tmp612_ = NULL;
																				gint _tmp612__length1 = 0;
																				const gchar* _tmp613_ = NULL;
																				_tmp612_ = nv;
																				_tmp612__length1 = nv_length1;
																				_tmp613_ = _tmp612_[0];
																				if (g_strcmp0 (_tmp613_, "array_length_pos") == 0) {
																					gchar** _tmp614_ = NULL;
																					gint _tmp614__length1 = 0;
																					const gchar* _tmp615_ = NULL;
																					gchar* _tmp616_ = NULL;
																					gchar* _tmp617_ = NULL;
																					gdouble _tmp618_ = 0.0;
																					set_array_length_pos = TRUE;
																					_tmp614_ = nv;
																					_tmp614__length1 = nv_length1;
																					_tmp615_ = _tmp614_[1];
																					_tmp616_ = vala_gidl_parser_eval (self, _tmp615_);
																					_tmp617_ = _tmp616_;
																					_tmp618_ = double_parse (_tmp617_);
																					array_length_pos = _tmp618_;
																					_g_free0 (_tmp617_);
																				} else {
																					gchar** _tmp619_ = NULL;
																					gint _tmp619__length1 = 0;
																					const gchar* _tmp620_ = NULL;
																					_tmp619_ = nv;
																					_tmp619__length1 = nv_length1;
																					_tmp620_ = _tmp619_[0];
																					if (g_strcmp0 (_tmp620_, "delegate_target_pos") == 0) {
																						gchar** _tmp621_ = NULL;
																						gint _tmp621__length1 = 0;
																						const gchar* _tmp622_ = NULL;
																						gchar* _tmp623_ = NULL;
																						gchar* _tmp624_ = NULL;
																						gdouble _tmp625_ = 0.0;
																						set_delegate_target_pos = TRUE;
																						_tmp621_ = nv;
																						_tmp621__length1 = nv_length1;
																						_tmp622_ = _tmp621_[1];
																						_tmp623_ = vala_gidl_parser_eval (self, _tmp622_);
																						_tmp624_ = _tmp623_;
																						_tmp625_ = double_parse (_tmp624_);
																						delegate_target_pos = _tmp625_;
																						_g_free0 (_tmp624_);
																					} else {
																						gchar** _tmp626_ = NULL;
																						gint _tmp626__length1 = 0;
																						const gchar* _tmp627_ = NULL;
																						_tmp626_ = nv;
																						_tmp626__length1 = nv_length1;
																						_tmp627_ = _tmp626_[0];
																						if (g_strcmp0 (_tmp627_, "type_name") == 0) {
																							ValaParameter* _tmp628_ = NULL;
																							gchar** _tmp629_ = NULL;
																							gint _tmp629__length1 = 0;
																							const gchar* _tmp630_ = NULL;
																							gchar* _tmp631_ = NULL;
																							gchar* _tmp632_ = NULL;
																							ValaDataType* _tmp633_ = NULL;
																							ValaDataType* _tmp634_ = NULL;
																							_tmp628_ = p;
																							_tmp629_ = nv;
																							_tmp629__length1 = nv_length1;
																							_tmp630_ = _tmp629_[1];
																							_tmp631_ = vala_gidl_parser_eval (self, _tmp630_);
																							_tmp632_ = _tmp631_;
																							_tmp633_ = vala_gidl_parser_parse_type_from_string (self, _tmp632_, FALSE, NULL);
																							_vala_code_node_unref0 (param_type);
																							param_type = _tmp633_;
																							_tmp634_ = param_type;
																							vala_variable_set_variable_type ((ValaVariable*) _tmp628_, _tmp634_);
																							_g_free0 (_tmp632_);
																						} else {
																							gchar** _tmp635_ = NULL;
																							gint _tmp635__length1 = 0;
																							const gchar* _tmp636_ = NULL;
																							_tmp635_ = nv;
																							_tmp635__length1 = nv_length1;
																							_tmp636_ = _tmp635_[0];
																							if (g_strcmp0 (_tmp636_, "ctype") == 0) {
																								ValaParameter* _tmp637_ = NULL;
																								gchar** _tmp638_ = NULL;
																								gint _tmp638__length1 = 0;
																								const gchar* _tmp639_ = NULL;
																								gchar* _tmp640_ = NULL;
																								gchar* _tmp641_ = NULL;
																								_tmp637_ = p;
																								_tmp638_ = nv;
																								_tmp638__length1 = nv_length1;
																								_tmp639_ = _tmp638_[1];
																								_tmp640_ = vala_gidl_parser_eval (self, _tmp639_);
																								_tmp641_ = _tmp640_;
																								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp637_, "CCode", "type", _tmp641_, NULL);
																								_g_free0 (_tmp641_);
																							} else {
																								gchar** _tmp642_ = NULL;
																								gint _tmp642__length1 = 0;
																								const gchar* _tmp643_ = NULL;
																								_tmp642_ = nv;
																								_tmp642__length1 = nv_length1;
																								_tmp643_ = _tmp642_[0];
																								if (g_strcmp0 (_tmp643_, "type_arguments") == 0) {
																									ValaDataType* _tmp644_ = NULL;
																									gchar** _tmp645_ = NULL;
																									gint _tmp645__length1 = 0;
																									const gchar* _tmp646_ = NULL;
																									gchar* _tmp647_ = NULL;
																									gchar* _tmp648_ = NULL;
																									_tmp644_ = param_type;
																									_tmp645_ = nv;
																									_tmp645__length1 = nv_length1;
																									_tmp646_ = _tmp645_[1];
																									_tmp647_ = vala_gidl_parser_eval (self, _tmp646_);
																									_tmp648_ = _tmp647_;
																									vala_gidl_parser_parse_type_arguments_from_string (self, _tmp644_, _tmp648_, NULL);
																									_g_free0 (_tmp648_);
																								} else {
																									gchar** _tmp649_ = NULL;
																									gint _tmp649__length1 = 0;
																									const gchar* _tmp650_ = NULL;
																									_tmp649_ = nv;
																									_tmp649__length1 = nv_length1;
																									_tmp650_ = _tmp649_[0];
																									if (g_strcmp0 (_tmp650_, "default_value") == 0) {
																										gchar* val = NULL;
																										gchar** _tmp651_ = NULL;
																										gint _tmp651__length1 = 0;
																										const gchar* _tmp652_ = NULL;
																										gchar* _tmp653_ = NULL;
																										const gchar* _tmp654_ = NULL;
																										_tmp651_ = nv;
																										_tmp651__length1 = nv_length1;
																										_tmp652_ = _tmp651_[1];
																										_tmp653_ = vala_gidl_parser_eval (self, _tmp652_);
																										val = _tmp653_;
																										_tmp654_ = val;
																										if (g_strcmp0 (_tmp654_, "null") == 0) {
																											ValaParameter* _tmp655_ = NULL;
																											ValaDataType* _tmp656_ = NULL;
																											ValaSourceReference* _tmp657_ = NULL;
																											ValaSourceReference* _tmp658_ = NULL;
																											ValaNullLiteral* _tmp659_ = NULL;
																											ValaNullLiteral* _tmp660_ = NULL;
																											_tmp655_ = p;
																											_tmp656_ = param_type;
																											_tmp657_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp656_);
																											_tmp658_ = _tmp657_;
																											_tmp659_ = vala_null_literal_new (_tmp658_);
																											_tmp660_ = _tmp659_;
																											vala_variable_set_initializer ((ValaVariable*) _tmp655_, (ValaExpression*) _tmp660_);
																											_vala_code_node_unref0 (_tmp660_);
																										} else {
																											const gchar* _tmp661_ = NULL;
																											_tmp661_ = val;
																											if (g_strcmp0 (_tmp661_, "true") == 0) {
																												ValaParameter* _tmp662_ = NULL;
																												ValaDataType* _tmp663_ = NULL;
																												ValaSourceReference* _tmp664_ = NULL;
																												ValaSourceReference* _tmp665_ = NULL;
																												ValaBooleanLiteral* _tmp666_ = NULL;
																												ValaBooleanLiteral* _tmp667_ = NULL;
																												_tmp662_ = p;
																												_tmp663_ = param_type;
																												_tmp664_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp663_);
																												_tmp665_ = _tmp664_;
																												_tmp666_ = vala_boolean_literal_new (TRUE, _tmp665_);
																												_tmp667_ = _tmp666_;
																												vala_variable_set_initializer ((ValaVariable*) _tmp662_, (ValaExpression*) _tmp667_);
																												_vala_code_node_unref0 (_tmp667_);
																											} else {
																												const gchar* _tmp668_ = NULL;
																												_tmp668_ = val;
																												if (g_strcmp0 (_tmp668_, "false") == 0) {
																													ValaParameter* _tmp669_ = NULL;
																													ValaDataType* _tmp670_ = NULL;
																													ValaSourceReference* _tmp671_ = NULL;
																													ValaSourceReference* _tmp672_ = NULL;
																													ValaBooleanLiteral* _tmp673_ = NULL;
																													ValaBooleanLiteral* _tmp674_ = NULL;
																													_tmp669_ = p;
																													_tmp670_ = param_type;
																													_tmp671_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp670_);
																													_tmp672_ = _tmp671_;
																													_tmp673_ = vala_boolean_literal_new (FALSE, _tmp672_);
																													_tmp674_ = _tmp673_;
																													vala_variable_set_initializer ((ValaVariable*) _tmp669_, (ValaExpression*) _tmp674_);
																													_vala_code_node_unref0 (_tmp674_);
																												} else {
																													const gchar* _tmp675_ = NULL;
																													_tmp675_ = val;
																													if (g_strcmp0 (_tmp675_, "") == 0) {
																														ValaParameter* _tmp676_ = NULL;
																														ValaDataType* _tmp677_ = NULL;
																														ValaSourceReference* _tmp678_ = NULL;
																														ValaSourceReference* _tmp679_ = NULL;
																														ValaStringLiteral* _tmp680_ = NULL;
																														ValaStringLiteral* _tmp681_ = NULL;
																														_tmp676_ = p;
																														_tmp677_ = param_type;
																														_tmp678_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp677_);
																														_tmp679_ = _tmp678_;
																														_tmp680_ = vala_string_literal_new ("\"\"", _tmp679_);
																														_tmp681_ = _tmp680_;
																														vala_variable_set_initializer ((ValaVariable*) _tmp676_, (ValaExpression*) _tmp681_);
																														_vala_code_node_unref0 (_tmp681_);
																													} else {
																														const gchar* _tmp682_ = NULL;
																														gboolean _tmp683_ = FALSE;
																														_tmp682_ = val;
																														_tmp683_ = int64_try_parse (_tmp682_, NULL);
																														if (_tmp683_) {
																															ValaParameter* _tmp684_ = NULL;
																															const gchar* _tmp685_ = NULL;
																															ValaDataType* _tmp686_ = NULL;
																															ValaSourceReference* _tmp687_ = NULL;
																															ValaSourceReference* _tmp688_ = NULL;
																															ValaIntegerLiteral* _tmp689_ = NULL;
																															ValaIntegerLiteral* _tmp690_ = NULL;
																															_tmp684_ = p;
																															_tmp685_ = val;
																															_tmp686_ = param_type;
																															_tmp687_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp686_);
																															_tmp688_ = _tmp687_;
																															_tmp689_ = vala_integer_literal_new (_tmp685_, _tmp688_);
																															_tmp690_ = _tmp689_;
																															vala_variable_set_initializer ((ValaVariable*) _tmp684_, (ValaExpression*) _tmp690_);
																															_vala_code_node_unref0 (_tmp690_);
																														} else {
																															const gchar* _tmp691_ = NULL;
																															gboolean _tmp692_ = FALSE;
																															_tmp691_ = val;
																															_tmp692_ = double_try_parse (_tmp691_, NULL);
																															if (_tmp692_) {
																																ValaParameter* _tmp693_ = NULL;
																																const gchar* _tmp694_ = NULL;
																																ValaDataType* _tmp695_ = NULL;
																																ValaSourceReference* _tmp696_ = NULL;
																																ValaSourceReference* _tmp697_ = NULL;
																																ValaRealLiteral* _tmp698_ = NULL;
																																ValaRealLiteral* _tmp699_ = NULL;
																																_tmp693_ = p;
																																_tmp694_ = val;
																																_tmp695_ = param_type;
																																_tmp696_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp695_);
																																_tmp697_ = _tmp696_;
																																_tmp698_ = vala_real_literal_new (_tmp694_, _tmp697_);
																																_tmp699_ = _tmp698_;
																																vala_variable_set_initializer ((ValaVariable*) _tmp693_, (ValaExpression*) _tmp699_);
																																_vala_code_node_unref0 (_tmp699_);
																															} else {
																																gboolean _tmp700_ = FALSE;
																																const gchar* _tmp701_ = NULL;
																																gboolean _tmp702_ = FALSE;
																																gboolean _tmp705_ = FALSE;
																																_tmp701_ = val;
																																_tmp702_ = g_str_has_prefix (_tmp701_, "\"");
																																if (_tmp702_) {
																																	const gchar* _tmp703_ = NULL;
																																	gboolean _tmp704_ = FALSE;
																																	_tmp703_ = val;
																																	_tmp704_ = g_str_has_suffix (_tmp703_, "\"");
																																	_tmp700_ = _tmp704_;
																																} else {
																																	_tmp700_ = FALSE;
																																}
																																_tmp705_ = _tmp700_;
																																if (_tmp705_) {
																																	ValaParameter* _tmp706_ = NULL;
																																	const gchar* _tmp707_ = NULL;
																																	ValaDataType* _tmp708_ = NULL;
																																	ValaSourceReference* _tmp709_ = NULL;
																																	ValaSourceReference* _tmp710_ = NULL;
																																	ValaStringLiteral* _tmp711_ = NULL;
																																	ValaStringLiteral* _tmp712_ = NULL;
																																	_tmp706_ = p;
																																	_tmp707_ = val;
																																	_tmp708_ = param_type;
																																	_tmp709_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp708_);
																																	_tmp710_ = _tmp709_;
																																	_tmp711_ = vala_string_literal_new (_tmp707_, _tmp710_);
																																	_tmp712_ = _tmp711_;
																																	vala_variable_set_initializer ((ValaVariable*) _tmp706_, (ValaExpression*) _tmp712_);
																																	_vala_code_node_unref0 (_tmp712_);
																																} else {
																																	const gchar* _tmp713_ = NULL;
																																	gchar** _tmp714_ = NULL;
																																	gchar** _tmp715_ = NULL;
																																	_tmp713_ = val;
																																	_tmp715_ = _tmp714_ = g_strsplit (_tmp713_, ".", 0);
																																	{
																																		gchar** member_collection = NULL;
																																		gint member_collection_length1 = 0;
																																		gint _member_collection_size_ = 0;
																																		gint member_it = 0;
																																		member_collection = _tmp715_;
																																		member_collection_length1 = _vala_array_length (_tmp714_);
																																		for (member_it = 0; member_it < _vala_array_length (_tmp714_); member_it = member_it + 1) {
																																			gchar* _tmp716_ = NULL;
																																			gchar* member = NULL;
																																			_tmp716_ = g_strdup (member_collection[member_it]);
																																			member = _tmp716_;
																																			{
																																				ValaParameter* _tmp717_ = NULL;
																																				ValaParameter* _tmp718_ = NULL;
																																				ValaExpression* _tmp719_ = NULL;
																																				ValaExpression* _tmp720_ = NULL;
																																				const gchar* _tmp721_ = NULL;
																																				ValaDataType* _tmp722_ = NULL;
																																				ValaSourceReference* _tmp723_ = NULL;
																																				ValaSourceReference* _tmp724_ = NULL;
																																				ValaMemberAccess* _tmp725_ = NULL;
																																				ValaMemberAccess* _tmp726_ = NULL;
																																				_tmp717_ = p;
																																				_tmp718_ = p;
																																				_tmp719_ = vala_variable_get_initializer ((ValaVariable*) _tmp718_);
																																				_tmp720_ = _tmp719_;
																																				_tmp721_ = member;
																																				_tmp722_ = param_type;
																																				_tmp723_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp722_);
																																				_tmp724_ = _tmp723_;
																																				_tmp725_ = vala_member_access_new (_tmp720_, _tmp721_, _tmp724_);
																																				_tmp726_ = _tmp725_;
																																				vala_variable_set_initializer ((ValaVariable*) _tmp717_, (ValaExpression*) _tmp726_);
																																				_vala_code_node_unref0 (_tmp726_);
																																				_g_free0 (member);
																																			}
																																		}
																																		member_collection = (_vala_array_free (member_collection, member_collection_length1, (GDestroyNotify) g_free), NULL);
																																	}
																																}
																															}
																														}
																													}
																												}
																											}
																										}
																										_g_free0 (val);
																									}
																								}
																							}
																						}
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
							}
						}
					}
				}
				_tmp728_ = last_param;
				if (_tmp728_ != NULL) {
					ValaParameter* _tmp729_ = NULL;
					const gchar* _tmp730_ = NULL;
					const gchar* _tmp731_ = NULL;
					ValaParameter* _tmp732_ = NULL;
					const gchar* _tmp733_ = NULL;
					const gchar* _tmp734_ = NULL;
					gchar* _tmp735_ = NULL;
					gchar* _tmp736_ = NULL;
					_tmp729_ = p;
					_tmp730_ = vala_symbol_get_name ((ValaSymbol*) _tmp729_);
					_tmp731_ = _tmp730_;
					_tmp732_ = last_param;
					_tmp733_ = vala_symbol_get_name ((ValaSymbol*) _tmp732_);
					_tmp734_ = _tmp733_;
					_tmp735_ = g_strconcat ("n_", _tmp734_, NULL);
					_tmp736_ = _tmp735_;
					_tmp727_ = g_strcmp0 (_tmp731_, _tmp736_) == 0;
					_g_free0 (_tmp736_);
				} else {
					_tmp727_ = FALSE;
				}
				_tmp737_ = _tmp727_;
				if (_tmp737_) {
					ValaDataType* _tmp738_ = NULL;
					_tmp738_ = last_param_type;
					if (!G_TYPE_CHECK_INSTANCE_TYPE (_tmp738_, VALA_TYPE_ARRAY_TYPE)) {
						ValaDataType* _tmp739_ = NULL;
						ValaDataType* _tmp740_ = NULL;
						ValaSourceReference* _tmp741_ = NULL;
						ValaSourceReference* _tmp742_ = NULL;
						ValaArrayType* _tmp743_ = NULL;
						ValaParameter* _tmp744_ = NULL;
						ValaDataType* _tmp745_ = NULL;
						ValaParameter* _tmp746_ = NULL;
						_tmp739_ = last_param_type;
						_tmp740_ = last_param_type;
						_tmp741_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp740_);
						_tmp742_ = _tmp741_;
						_tmp743_ = vala_array_type_new (_tmp739_, 1, _tmp742_);
						_vala_code_node_unref0 (last_param_type);
						last_param_type = (ValaDataType*) _tmp743_;
						_tmp744_ = last_param;
						_tmp745_ = last_param_type;
						vala_variable_set_variable_type ((ValaVariable*) _tmp744_, _tmp745_);
						_tmp746_ = last_param;
						vala_parameter_set_direction (_tmp746_, VALA_PARAMETER_DIRECTION_IN);
					}
					hide_param = TRUE;
				} else {
					gboolean _tmp747_ = FALSE;
					ValaParameter* _tmp748_ = NULL;
					gboolean _tmp752_ = FALSE;
					_tmp748_ = last_param;
					if (_tmp748_ != NULL) {
						ValaParameter* _tmp749_ = NULL;
						const gchar* _tmp750_ = NULL;
						const gchar* _tmp751_ = NULL;
						_tmp749_ = p;
						_tmp750_ = vala_symbol_get_name ((ValaSymbol*) _tmp749_);
						_tmp751_ = _tmp750_;
						_tmp747_ = g_strcmp0 (_tmp751_, "user_data") == 0;
					} else {
						_tmp747_ = FALSE;
					}
					_tmp752_ = _tmp747_;
					if (_tmp752_) {
						hide_param = TRUE;
					}
				}
				_tmp754_ = show_param;
				if (_tmp754_) {
					_tmp753_ = TRUE;
				} else {
					gboolean _tmp755_ = FALSE;
					_tmp755_ = hide_param;
					_tmp753_ = !_tmp755_;
				}
				_tmp756_ = _tmp753_;
				if (_tmp756_) {
					ValaMethod* _tmp757_ = NULL;
					ValaParameter* _tmp758_ = NULL;
					gboolean _tmp759_ = FALSE;
					gboolean _tmp762_ = FALSE;
					_tmp757_ = m;
					_tmp758_ = p;
					vala_method_add_parameter (_tmp757_, _tmp758_);
					_tmp759_ = set_array_length_pos;
					if (_tmp759_) {
						ValaParameter* _tmp760_ = NULL;
						gdouble _tmp761_ = 0.0;
						_tmp760_ = p;
						_tmp761_ = array_length_pos;
						vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp760_, "CCode", "array_length_pos", _tmp761_, NULL);
					}
					_tmp762_ = set_delegate_target_pos;
					if (_tmp762_) {
						ValaParameter* _tmp763_ = NULL;
						gdouble _tmp764_ = 0.0;
						_tmp763_ = p;
						_tmp764_ = delegate_target_pos;
						vala_code_node_set_attribute_double ((ValaCodeNode*) _tmp763_, "CCode", "delegate_target_pos", _tmp764_, NULL);
					}
				}
				_tmp765_ = p;
				_tmp766_ = _vala_code_node_ref0 (_tmp765_);
				_vala_code_node_unref0 (last_param);
				last_param = _tmp766_;
				_tmp767_ = param_type;
				_tmp768_ = _vala_code_node_ref0 (_tmp767_);
				_vala_code_node_unref0 (last_param_type);
				last_param_type = _tmp768_;
				_vala_code_node_unref0 (p);
				_vala_code_node_unref0 (param_type);
				_g_free0 (param_name);
			}
		}
	}
	_tmp770_ = suppress_throws;
	if (_tmp770_ == FALSE) {
		const gchar* _tmp771_ = NULL;
		_tmp771_ = error_types;
		_tmp769_ = _tmp771_ != NULL;
	} else {
		_tmp769_ = FALSE;
	}
	_tmp772_ = _tmp769_;
	if (_tmp772_) {
		gchar** type_args = NULL;
		const gchar* _tmp773_ = NULL;
		gchar* _tmp774_ = NULL;
		gchar* _tmp775_ = NULL;
		gchar** _tmp776_ = NULL;
		gchar** _tmp777_ = NULL;
		gchar** _tmp778_ = NULL;
		gint _tmp778__length1 = 0;
		gint type_args_length1 = 0;
		gint _type_args_size_ = 0;
		gchar** _tmp779_ = NULL;
		gint _tmp779__length1 = 0;
		_tmp773_ = error_types;
		_tmp774_ = vala_gidl_parser_eval (self, _tmp773_);
		_tmp775_ = _tmp774_;
		_tmp777_ = _tmp776_ = g_strsplit (_tmp775_, ",", 0);
		_tmp778_ = _tmp777_;
		_tmp778__length1 = _vala_array_length (_tmp776_);
		_g_free0 (_tmp775_);
		type_args = _tmp778_;
		type_args_length1 = _tmp778__length1;
		_type_args_size_ = type_args_length1;
		_tmp779_ = type_args;
		_tmp779__length1 = type_args_length1;
		{
			gchar** type_arg_collection = NULL;
			gint type_arg_collection_length1 = 0;
			gint _type_arg_collection_size_ = 0;
			gint type_arg_it = 0;
			type_arg_collection = _tmp779_;
			type_arg_collection_length1 = _tmp779__length1;
			for (type_arg_it = 0; type_arg_it < _tmp779__length1; type_arg_it = type_arg_it + 1) {
				gchar* _tmp780_ = NULL;
				gchar* type_arg = NULL;
				_tmp780_ = g_strdup (type_arg_collection[type_arg_it]);
				type_arg = _tmp780_;
				{
					ValaMethod* _tmp781_ = NULL;
					const gchar* _tmp782_ = NULL;
					ValaDataType* _tmp783_ = NULL;
					ValaDataType* _tmp784_ = NULL;
					_tmp781_ = m;
					_tmp782_ = type_arg;
					_tmp783_ = vala_gidl_parser_parse_type_from_string (self, _tmp782_, TRUE, NULL);
					_tmp784_ = _tmp783_;
					vala_code_node_add_error_type ((ValaCodeNode*) _tmp781_, _tmp784_);
					_vala_code_node_unref0 (_tmp784_);
					_g_free0 (type_arg);
				}
			}
		}
		type_args = (_vala_array_free (type_args, type_args_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp785_ = first;
	if (_tmp785_) {
		ValaMethod* _tmp786_ = NULL;
		_tmp786_ = m;
		vala_method_set_binding (_tmp786_, VALA_MEMBER_BINDING_STATIC);
	}
	_tmp788_ = last_param;
	if (_tmp788_ != NULL) {
		ValaParameter* _tmp789_ = NULL;
		const gchar* _tmp790_ = NULL;
		const gchar* _tmp791_ = NULL;
		gboolean _tmp792_ = FALSE;
		_tmp789_ = last_param;
		_tmp790_ = vala_symbol_get_name ((ValaSymbol*) _tmp789_);
		_tmp791_ = _tmp790_;
		_tmp792_ = g_str_has_prefix (_tmp791_, "first_");
		_tmp787_ = _tmp792_;
	} else {
		_tmp787_ = FALSE;
	}
	_tmp793_ = _tmp787_;
	if (_tmp793_) {
		ValaParameter* _tmp794_ = NULL;
		_tmp794_ = last_param;
		vala_parameter_set_ellipsis (_tmp794_, TRUE);
	} else {
		gboolean _tmp795_ = FALSE;
		_tmp795_ = add_ellipsis;
		if (_tmp795_) {
			ValaMethod* _tmp796_ = NULL;
			ValaParameter* _tmp797_ = NULL;
			ValaParameter* _tmp798_ = NULL;
			_tmp796_ = m;
			_tmp797_ = vala_parameter_new_with_ellipsis (NULL);
			_tmp798_ = _tmp797_;
			vala_method_add_parameter (_tmp796_, _tmp798_);
			_vala_code_node_unref0 (_tmp798_);
		}
	}
	_tmp799_ = container;
	if (_tmp799_ == NULL) {
		ValaTypeSymbol* _tmp800_ = NULL;
		ValaSymbol* _tmp801_ = NULL;
		ValaSymbol* _tmp802_ = NULL;
		_tmp800_ = self->priv->current_data_type;
		_tmp801_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp800_);
		_vala_code_node_unref0 (container);
		container = _tmp801_;
		_tmp802_ = container;
		if (_tmp802_ == NULL) {
			ValaNamespace* _tmp803_ = NULL;
			ValaSymbol* _tmp804_ = NULL;
			_tmp803_ = self->priv->current_namespace;
			_tmp804_ = _vala_code_node_ref0 ((ValaSymbol*) _tmp803_);
			_vala_code_node_unref0 (container);
			container = _tmp804_;
		}
	}
	_tmp805_ = symbol;
	_tmp806_ = m;
	_tmp807_ = container;
	_tmp808_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp806_, _tmp807_);
	_tmp809_ = _tmp808_;
	_tmp810_ = g_strcmp0 (_tmp805_, _tmp809_) != 0;
	_g_free0 (_tmp809_);
	if (_tmp810_) {
		ValaMethod* _tmp811_ = NULL;
		const gchar* _tmp812_ = NULL;
		_tmp811_ = m;
		_tmp812_ = symbol;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp811_, "CCode", "cname", _tmp812_, NULL);
	}
	result = m;
	_vala_code_node_unref0 (last_param_type);
	_vala_code_node_unref0 (last_param);
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_vala_code_node_unref0 (container);
	_g_free0 (error_types);
	_vala_code_node_unref0 (return_type);
	return result;
}


static gchar* string_chomp (const gchar* self) {
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_strdup (self);
	_result_ = _tmp0_;
	_tmp1_ = _result_;
	g_strchomp (_tmp1_);
	result = _result_;
	return result;
}


static gboolean vala_gidl_parser_param_is_exception (ValaGIdlParser* self, GIdlNodeParam* param) {
	gboolean result = FALSE;
	GIdlNodeParam* _tmp0_ = NULL;
	GIdlNodeType* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gchar* s = NULL;
	GIdlNodeParam* _tmp3_ = NULL;
	GIdlNodeType* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	const gchar* _tmp7_ = NULL;
	gboolean _tmp8_ = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (param != NULL, FALSE);
	_tmp0_ = param;
	_tmp1_ = _tmp0_->type;
	_tmp2_ = _tmp1_->is_error;
	if (!_tmp2_) {
		result = FALSE;
		return result;
	}
	_tmp3_ = param;
	_tmp4_ = _tmp3_->type;
	_tmp5_ = _tmp4_->unparsed;
	_tmp6_ = string_chomp (_tmp5_);
	s = _tmp6_;
	_tmp7_ = s;
	_tmp8_ = g_str_has_suffix (_tmp7_, "**");
	if (_tmp8_) {
		result = TRUE;
		_g_free0 (s);
		return result;
	}
	result = FALSE;
	_g_free0 (s);
	return result;
}


static ValaMethod* vala_gidl_parser_parse_function (ValaGIdlParser* self, GIdlNodeFunction* f, gboolean is_interface) {
	ValaMethod* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeFunction* _tmp0_ = NULL;
	GIdlNodeFunction* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	GIdlNode* _tmp3_ = NULL;
	const gchar* _tmp4_ = NULL;
	GIdlNodeFunction* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	GIdlNodeFunction* _tmp7_ = NULL;
	GIdlNodeParam* _tmp8_ = NULL;
	GIdlNodeFunction* _tmp9_ = NULL;
	GList* _tmp10_ = NULL;
	GIdlNodeFunction* _tmp11_ = NULL;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	ValaMethod* _tmp14_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (f != NULL, NULL);
	_tmp0_ = f;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = f;
	_tmp2_ = _tmp1_->deprecated;
	if (_tmp2_) {
		result = NULL;
		return result;
	}
	_tmp3_ = node;
	_tmp4_ = _tmp3_->name;
	_tmp5_ = f;
	_tmp6_ = _tmp5_->symbol;
	_tmp7_ = f;
	_tmp8_ = _tmp7_->result;
	_tmp9_ = f;
	_tmp10_ = _tmp9_->parameters;
	_tmp11_ = f;
	_tmp12_ = _tmp11_->is_constructor;
	_tmp13_ = is_interface;
	_tmp14_ = vala_gidl_parser_create_method (self, _tmp4_, _tmp6_, _tmp8_, _tmp10_, _tmp12_, _tmp13_);
	result = _tmp14_;
	return result;
}


static ValaMethod* vala_gidl_parser_parse_virtual (ValaGIdlParser* self, GIdlNodeVFunc* v, GIdlNodeFunction* func, gboolean is_interface) {
	ValaMethod* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeVFunc* _tmp0_ = NULL;
	gchar* symbol = NULL;
	ValaTypeSymbol* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	gchar* _tmp3_ = NULL;
	GIdlNode* _tmp4_ = NULL;
	const gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GIdlNodeFunction* _tmp8_ = NULL;
	GList* _tmp12_ = NULL;
	GIdlNodeFunction* _tmp13_ = NULL;
	ValaMethod* m = NULL;
	GIdlNode* _tmp18_ = NULL;
	const gchar* _tmp19_ = NULL;
	const gchar* _tmp20_ = NULL;
	GIdlNodeVFunc* _tmp21_ = NULL;
	GIdlNodeParam* _tmp22_ = NULL;
	GList* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	ValaMethod* _tmp25_ = NULL;
	ValaMethod* _tmp26_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (v != NULL, NULL);
	_tmp0_ = v;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = self->priv->current_data_type;
	_tmp2_ = vala_gidl_parser_get_lower_case_cprefix (self, (ValaSymbol*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = node;
	_tmp5_ = _tmp4_->name;
	_tmp6_ = g_strdup_printf ("%s%s", _tmp3_, _tmp5_);
	_tmp7_ = _tmp6_;
	_g_free0 (_tmp3_);
	symbol = _tmp7_;
	_tmp8_ = func;
	if (_tmp8_ != NULL) {
		GIdlNodeFunction* _tmp9_ = NULL;
		const gchar* _tmp10_ = NULL;
		gchar* _tmp11_ = NULL;
		_tmp9_ = func;
		_tmp10_ = _tmp9_->symbol;
		_tmp11_ = g_strdup (_tmp10_);
		_g_free0 (symbol);
		symbol = _tmp11_;
	}
	_tmp13_ = func;
	if (_tmp13_ != NULL) {
		GIdlNodeFunction* _tmp14_ = NULL;
		GList* _tmp15_ = NULL;
		_tmp14_ = func;
		_tmp15_ = _tmp14_->parameters;
		_tmp12_ = _tmp15_;
	} else {
		GIdlNodeVFunc* _tmp16_ = NULL;
		GList* _tmp17_ = NULL;
		_tmp16_ = v;
		_tmp17_ = _tmp16_->parameters;
		_tmp12_ = _tmp17_;
	}
	_tmp18_ = node;
	_tmp19_ = _tmp18_->name;
	_tmp20_ = symbol;
	_tmp21_ = v;
	_tmp22_ = _tmp21_->result;
	_tmp23_ = _tmp12_;
	_tmp24_ = is_interface;
	_tmp25_ = vala_gidl_parser_create_method (self, _tmp19_, _tmp20_, _tmp22_, _tmp23_, FALSE, _tmp24_);
	m = _tmp25_;
	_tmp26_ = m;
	if (_tmp26_ != NULL) {
		ValaMethod* _tmp27_ = NULL;
		gboolean _tmp28_ = FALSE;
		ValaMethod* _tmp29_ = NULL;
		gboolean _tmp30_ = FALSE;
		gboolean _tmp31_ = FALSE;
		ValaMethod* _tmp33_ = NULL;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		ValaMethod* _tmp36_ = NULL;
		gboolean _tmp37_ = FALSE;
		gboolean _tmp38_ = FALSE;
		ValaMethod* _tmp40_ = NULL;
		gboolean _tmp41_ = FALSE;
		gchar** attributes = NULL;
		const gchar* _tmp42_ = NULL;
		gint _tmp43_ = 0;
		gchar** _tmp44_ = NULL;
		gint attributes_length1 = 0;
		gint _attributes_size_ = 0;
		gchar** _tmp45_ = NULL;
		gint _tmp45__length1 = 0;
		GIdlNodeFunction* _tmp62_ = NULL;
		_tmp27_ = m;
		vala_method_set_binding (_tmp27_, VALA_MEMBER_BINDING_INSTANCE);
		_tmp29_ = m;
		_tmp30_ = vala_method_get_is_abstract (_tmp29_);
		_tmp31_ = _tmp30_;
		if (_tmp31_) {
			_tmp28_ = TRUE;
		} else {
			gboolean _tmp32_ = FALSE;
			_tmp32_ = is_interface;
			_tmp28_ = _tmp32_;
		}
		_tmp33_ = m;
		_tmp34_ = _tmp28_;
		vala_method_set_is_virtual (_tmp33_, !_tmp34_);
		_tmp36_ = m;
		_tmp37_ = vala_method_get_is_abstract (_tmp36_);
		_tmp38_ = _tmp37_;
		if (_tmp38_) {
			_tmp35_ = TRUE;
		} else {
			gboolean _tmp39_ = FALSE;
			_tmp39_ = is_interface;
			_tmp35_ = _tmp39_;
		}
		_tmp40_ = m;
		_tmp41_ = _tmp35_;
		vala_method_set_is_abstract (_tmp40_, _tmp41_);
		_tmp42_ = symbol;
		_tmp44_ = vala_gidl_parser_get_attributes (self, _tmp42_, &_tmp43_);
		attributes = _tmp44_;
		attributes_length1 = _tmp43_;
		_attributes_size_ = attributes_length1;
		_tmp45_ = attributes;
		_tmp45__length1 = attributes_length1;
		if (_tmp45_ != NULL) {
			gchar** _tmp46_ = NULL;
			gint _tmp46__length1 = 0;
			_tmp46_ = attributes;
			_tmp46__length1 = attributes_length1;
			{
				gchar** attr_collection = NULL;
				gint attr_collection_length1 = 0;
				gint _attr_collection_size_ = 0;
				gint attr_it = 0;
				attr_collection = _tmp46_;
				attr_collection_length1 = _tmp46__length1;
				for (attr_it = 0; attr_it < _tmp46__length1; attr_it = attr_it + 1) {
					gchar* _tmp47_ = NULL;
					gchar* attr = NULL;
					_tmp47_ = g_strdup (attr_collection[attr_it]);
					attr = _tmp47_;
					{
						gchar** nv = NULL;
						const gchar* _tmp48_ = NULL;
						gchar** _tmp49_ = NULL;
						gchar** _tmp50_ = NULL;
						gint nv_length1 = 0;
						gint _nv_size_ = 0;
						gchar** _tmp51_ = NULL;
						gint _tmp51__length1 = 0;
						const gchar* _tmp52_ = NULL;
						_tmp48_ = attr;
						_tmp50_ = _tmp49_ = g_strsplit (_tmp48_, "=", 2);
						nv = _tmp50_;
						nv_length1 = _vala_array_length (_tmp49_);
						_nv_size_ = nv_length1;
						_tmp51_ = nv;
						_tmp51__length1 = nv_length1;
						_tmp52_ = _tmp51_[0];
						if (g_strcmp0 (_tmp52_, "virtual") == 0) {
							gchar** _tmp53_ = NULL;
							gint _tmp53__length1 = 0;
							const gchar* _tmp54_ = NULL;
							gchar* _tmp55_ = NULL;
							gchar* _tmp56_ = NULL;
							gboolean _tmp57_ = FALSE;
							_tmp53_ = nv;
							_tmp53__length1 = nv_length1;
							_tmp54_ = _tmp53_[1];
							_tmp55_ = vala_gidl_parser_eval (self, _tmp54_);
							_tmp56_ = _tmp55_;
							_tmp57_ = g_strcmp0 (_tmp56_, "0") == 0;
							_g_free0 (_tmp56_);
							if (_tmp57_) {
								ValaMethod* _tmp58_ = NULL;
								ValaMethod* _tmp59_ = NULL;
								_tmp58_ = m;
								vala_method_set_is_virtual (_tmp58_, FALSE);
								_tmp59_ = m;
								vala_method_set_is_abstract (_tmp59_, FALSE);
							} else {
								ValaMethod* _tmp60_ = NULL;
								ValaMethod* _tmp61_ = NULL;
								_tmp60_ = m;
								vala_method_set_is_virtual (_tmp60_, TRUE);
								_tmp61_ = m;
								vala_method_set_is_abstract (_tmp61_, FALSE);
							}
						}
						nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
						_g_free0 (attr);
					}
				}
			}
		}
		_tmp62_ = func;
		if (_tmp62_ == NULL) {
			ValaMethod* _tmp63_ = NULL;
			_tmp63_ = m;
			vala_code_node_set_attribute ((ValaCodeNode*) _tmp63_, "NoWrapper", TRUE, NULL);
		}
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	}
	result = m;
	_g_free0 (symbol);
	return result;
}


static gchar* vala_gidl_parser_fix_prop_name (ValaGIdlParser* self, const gchar* name) {
	gchar* result = NULL;
	GString* str = NULL;
	GString* _tmp0_ = NULL;
	gchar* i = NULL;
	const gchar* _tmp1_ = NULL;
	gchar* _tmp2_ = NULL;
	GString* _tmp15_ = NULL;
	const gchar* _tmp16_ = NULL;
	gchar* _tmp17_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (name != NULL, NULL);
	_tmp0_ = g_string_new ("");
	str = _tmp0_;
	_tmp1_ = name;
	_tmp2_ = g_strdup (_tmp1_);
	i = _tmp2_;
	while (TRUE) {
		const gchar* _tmp3_ = NULL;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gunichar c = 0U;
		const gchar* _tmp6_ = NULL;
		gunichar _tmp7_ = 0U;
		gunichar _tmp8_ = 0U;
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gchar* _tmp14_ = NULL;
		_tmp3_ = i;
		_tmp4_ = strlen (_tmp3_);
		_tmp5_ = _tmp4_;
		if (!(_tmp5_ > 0)) {
			break;
		}
		_tmp6_ = i;
		_tmp7_ = string_get_char (_tmp6_, (glong) 0);
		c = _tmp7_;
		_tmp8_ = c;
		if (_tmp8_ == ((gunichar) '-')) {
			GString* _tmp9_ = NULL;
			_tmp9_ = str;
			g_string_append_c (_tmp9_, '_');
		} else {
			GString* _tmp10_ = NULL;
			gunichar _tmp11_ = 0U;
			_tmp10_ = str;
			_tmp11_ = c;
			g_string_append_unichar (_tmp10_, _tmp11_);
		}
		_tmp12_ = i;
		_tmp13_ = g_utf8_next_char (_tmp12_);
		_tmp14_ = g_strdup (_tmp13_);
		_g_free0 (i);
		i = _tmp14_;
	}
	_tmp15_ = str;
	_tmp16_ = _tmp15_->str;
	_tmp17_ = g_strdup (_tmp16_);
	result = _tmp17_;
	_g_free0 (i);
	_g_string_free0 (str);
	return result;
}


static ValaProperty* vala_gidl_parser_parse_property (ValaGIdlParser* self, GIdlNodeProperty* prop_node) {
	ValaProperty* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeProperty* _tmp0_ = NULL;
	GIdlNodeProperty* _tmp1_ = NULL;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GIdlNodeProperty* _tmp4_ = NULL;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp8_ = FALSE;
	ValaProperty* prop = NULL;
	GIdlNode* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gchar* _tmp13_ = NULL;
	gchar* _tmp14_ = NULL;
	GIdlNodeProperty* _tmp15_ = NULL;
	GIdlNodeType* _tmp16_ = NULL;
	ValaDataType* _tmp17_ = NULL;
	ValaDataType* _tmp18_ = NULL;
	ValaSourceReference* _tmp19_ = NULL;
	ValaProperty* _tmp20_ = NULL;
	ValaProperty* _tmp21_ = NULL;
	ValaProperty* _tmp22_ = NULL;
	ValaProperty* _tmp23_ = NULL;
	gboolean _tmp24_ = FALSE;
	GIdlNodeProperty* _tmp25_ = NULL;
	GIdlNodeType* _tmp26_ = NULL;
	gboolean _tmp27_ = FALSE;
	gboolean _tmp31_ = FALSE;
	GIdlNodeProperty* _tmp34_ = NULL;
	gboolean _tmp35_ = FALSE;
	GIdlNodeProperty* _tmp44_ = NULL;
	gboolean _tmp45_ = FALSE;
	gchar** attributes = NULL;
	ValaTypeSymbol* _tmp67_ = NULL;
	gchar* _tmp68_ = NULL;
	gchar* _tmp69_ = NULL;
	GIdlNode* _tmp70_ = NULL;
	const gchar* _tmp71_ = NULL;
	gchar* _tmp72_ = NULL;
	gchar* _tmp73_ = NULL;
	gint _tmp74_ = 0;
	gchar** _tmp75_ = NULL;
	gchar** _tmp76_ = NULL;
	gint _tmp76__length1 = 0;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp77_ = NULL;
	gint _tmp77__length1 = 0;
	ValaSet* _tmp176_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (prop_node != NULL, NULL);
	_tmp0_ = prop_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = prop_node;
	_tmp2_ = _tmp1_->deprecated;
	if (_tmp2_) {
		result = NULL;
		return result;
	}
	_tmp4_ = prop_node;
	_tmp5_ = _tmp4_->readable;
	if (!_tmp5_) {
		GIdlNodeProperty* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = prop_node;
		_tmp7_ = _tmp6_->writable;
		_tmp3_ = !_tmp7_;
	} else {
		_tmp3_ = FALSE;
	}
	_tmp8_ = _tmp3_;
	if (_tmp8_) {
		GIdlNodeProperty* _tmp9_ = NULL;
		GIdlNodeProperty* _tmp10_ = NULL;
		_tmp9_ = prop_node;
		_tmp9_->readable = TRUE;
		_tmp10_ = prop_node;
		_tmp10_->writable = TRUE;
	}
	_tmp11_ = node;
	_tmp12_ = _tmp11_->name;
	_tmp13_ = vala_gidl_parser_fix_prop_name (self, _tmp12_);
	_tmp14_ = _tmp13_;
	_tmp15_ = prop_node;
	_tmp16_ = _tmp15_->type;
	_tmp17_ = vala_gidl_parser_parse_type (self, _tmp16_, NULL);
	_tmp18_ = _tmp17_;
	_tmp19_ = self->priv->current_source_reference;
	_tmp20_ = vala_property_new (_tmp14_, _tmp18_, NULL, NULL, _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_vala_code_node_unref0 (_tmp18_);
	_g_free0 (_tmp14_);
	prop = _tmp21_;
	_tmp22_ = prop;
	vala_symbol_set_access ((ValaSymbol*) _tmp22_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	_tmp23_ = prop;
	vala_property_set_interface_only (_tmp23_, TRUE);
	_tmp25_ = prop_node;
	_tmp26_ = _tmp25_->type;
	_tmp27_ = _tmp26_->is_interface;
	if (_tmp27_) {
		GIdlNodeProperty* _tmp28_ = NULL;
		GIdlNodeType* _tmp29_ = NULL;
		const gchar* _tmp30_ = NULL;
		_tmp28_ = prop_node;
		_tmp29_ = _tmp28_->type;
		_tmp30_ = _tmp29_->interface;
		_tmp24_ = g_strcmp0 (_tmp30_, "GStrv") == 0;
	} else {
		_tmp24_ = FALSE;
	}
	_tmp31_ = _tmp24_;
	if (_tmp31_) {
		ValaProperty* _tmp32_ = NULL;
		ValaProperty* _tmp33_ = NULL;
		_tmp32_ = prop;
		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp32_, "CCode", "array_length", FALSE, NULL);
		_tmp33_ = prop;
		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp33_, "CCode", "array_null_terminated", TRUE, NULL);
	}
	_tmp34_ = prop_node;
	_tmp35_ = _tmp34_->readable;
	if (_tmp35_) {
		ValaProperty* _tmp36_ = NULL;
		ValaProperty* _tmp37_ = NULL;
		ValaDataType* _tmp38_ = NULL;
		ValaDataType* _tmp39_ = NULL;
		ValaDataType* _tmp40_ = NULL;
		ValaDataType* _tmp41_ = NULL;
		ValaPropertyAccessor* _tmp42_ = NULL;
		ValaPropertyAccessor* _tmp43_ = NULL;
		_tmp36_ = prop;
		_tmp37_ = prop;
		_tmp38_ = vala_property_get_property_type (_tmp37_);
		_tmp39_ = _tmp38_;
		_tmp40_ = vala_data_type_copy (_tmp39_);
		_tmp41_ = _tmp40_;
		_tmp42_ = vala_property_accessor_new (TRUE, FALSE, FALSE, _tmp41_, NULL, NULL, NULL);
		_tmp43_ = _tmp42_;
		vala_property_set_get_accessor (_tmp36_, _tmp43_);
		_vala_code_node_unref0 (_tmp43_);
		_vala_code_node_unref0 (_tmp41_);
	}
	_tmp44_ = prop_node;
	_tmp45_ = _tmp44_->writable;
	if (_tmp45_) {
		ValaProperty* _tmp46_ = NULL;
		ValaProperty* _tmp47_ = NULL;
		ValaDataType* _tmp48_ = NULL;
		ValaDataType* _tmp49_ = NULL;
		ValaDataType* _tmp50_ = NULL;
		ValaDataType* _tmp51_ = NULL;
		ValaPropertyAccessor* _tmp52_ = NULL;
		ValaPropertyAccessor* _tmp53_ = NULL;
		GIdlNodeProperty* _tmp54_ = NULL;
		gboolean _tmp55_ = FALSE;
		_tmp46_ = prop;
		_tmp47_ = prop;
		_tmp48_ = vala_property_get_property_type (_tmp47_);
		_tmp49_ = _tmp48_;
		_tmp50_ = vala_data_type_copy (_tmp49_);
		_tmp51_ = _tmp50_;
		_tmp52_ = vala_property_accessor_new (FALSE, FALSE, FALSE, _tmp51_, NULL, NULL, NULL);
		_tmp53_ = _tmp52_;
		vala_property_set_set_accessor (_tmp46_, _tmp53_);
		_vala_code_node_unref0 (_tmp53_);
		_vala_code_node_unref0 (_tmp51_);
		_tmp54_ = prop_node;
		_tmp55_ = _tmp54_->construct_only;
		if (_tmp55_) {
			ValaProperty* _tmp56_ = NULL;
			ValaPropertyAccessor* _tmp57_ = NULL;
			ValaPropertyAccessor* _tmp58_ = NULL;
			_tmp56_ = prop;
			_tmp57_ = vala_property_get_set_accessor (_tmp56_);
			_tmp58_ = _tmp57_;
			vala_property_accessor_set_construction (_tmp58_, TRUE);
		} else {
			ValaProperty* _tmp59_ = NULL;
			ValaPropertyAccessor* _tmp60_ = NULL;
			ValaPropertyAccessor* _tmp61_ = NULL;
			ValaProperty* _tmp62_ = NULL;
			ValaPropertyAccessor* _tmp63_ = NULL;
			ValaPropertyAccessor* _tmp64_ = NULL;
			GIdlNodeProperty* _tmp65_ = NULL;
			gboolean _tmp66_ = FALSE;
			_tmp59_ = prop;
			_tmp60_ = vala_property_get_set_accessor (_tmp59_);
			_tmp61_ = _tmp60_;
			vala_property_accessor_set_writable (_tmp61_, TRUE);
			_tmp62_ = prop;
			_tmp63_ = vala_property_get_set_accessor (_tmp62_);
			_tmp64_ = _tmp63_;
			_tmp65_ = prop_node;
			_tmp66_ = _tmp65_->construct;
			vala_property_accessor_set_construction (_tmp64_, _tmp66_);
		}
	}
	_tmp67_ = self->priv->current_data_type;
	_tmp68_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp67_, NULL);
	_tmp69_ = _tmp68_;
	_tmp70_ = node;
	_tmp71_ = _tmp70_->name;
	_tmp72_ = g_strdup_printf ("%s:%s", _tmp69_, _tmp71_);
	_tmp73_ = _tmp72_;
	_tmp75_ = vala_gidl_parser_get_attributes (self, _tmp73_, &_tmp74_);
	_tmp76_ = _tmp75_;
	_tmp76__length1 = _tmp74_;
	_g_free0 (_tmp73_);
	_g_free0 (_tmp69_);
	attributes = _tmp76_;
	attributes_length1 = _tmp76__length1;
	_attributes_size_ = attributes_length1;
	_tmp77_ = attributes;
	_tmp77__length1 = attributes_length1;
	if (_tmp77_ != NULL) {
		gchar** _tmp78_ = NULL;
		gint _tmp78__length1 = 0;
		_tmp78_ = attributes;
		_tmp78__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp78_;
			attr_collection_length1 = _tmp78__length1;
			for (attr_it = 0; attr_it < _tmp78__length1; attr_it = attr_it + 1) {
				gchar* _tmp79_ = NULL;
				gchar* attr = NULL;
				_tmp79_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp79_;
				{
					gchar** nv = NULL;
					const gchar* _tmp80_ = NULL;
					gchar** _tmp81_ = NULL;
					gchar** _tmp82_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp83_ = NULL;
					gint _tmp83__length1 = 0;
					const gchar* _tmp84_ = NULL;
					_tmp80_ = attr;
					_tmp82_ = _tmp81_ = g_strsplit (_tmp80_, "=", 2);
					nv = _tmp82_;
					nv_length1 = _vala_array_length (_tmp81_);
					_nv_size_ = nv_length1;
					_tmp83_ = nv;
					_tmp83__length1 = nv_length1;
					_tmp84_ = _tmp83_[0];
					if (g_strcmp0 (_tmp84_, "hidden") == 0) {
						gchar** _tmp85_ = NULL;
						gint _tmp85__length1 = 0;
						const gchar* _tmp86_ = NULL;
						gchar* _tmp87_ = NULL;
						gchar* _tmp88_ = NULL;
						gboolean _tmp89_ = FALSE;
						_tmp85_ = nv;
						_tmp85__length1 = nv_length1;
						_tmp86_ = _tmp85_[1];
						_tmp87_ = vala_gidl_parser_eval (self, _tmp86_);
						_tmp88_ = _tmp87_;
						_tmp89_ = g_strcmp0 (_tmp88_, "1") == 0;
						_g_free0 (_tmp88_);
						if (_tmp89_) {
							result = NULL;
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
							attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
							_vala_code_node_unref0 (prop);
							return result;
						}
					} else {
						gchar** _tmp90_ = NULL;
						gint _tmp90__length1 = 0;
						const gchar* _tmp91_ = NULL;
						_tmp90_ = nv;
						_tmp90__length1 = nv_length1;
						_tmp91_ = _tmp90_[0];
						if (g_strcmp0 (_tmp91_, "type_arguments") == 0) {
							ValaProperty* _tmp92_ = NULL;
							ValaDataType* _tmp93_ = NULL;
							ValaDataType* _tmp94_ = NULL;
							gchar** _tmp95_ = NULL;
							gint _tmp95__length1 = 0;
							const gchar* _tmp96_ = NULL;
							gchar* _tmp97_ = NULL;
							gchar* _tmp98_ = NULL;
							_tmp92_ = prop;
							_tmp93_ = vala_property_get_property_type (_tmp92_);
							_tmp94_ = _tmp93_;
							_tmp95_ = nv;
							_tmp95__length1 = nv_length1;
							_tmp96_ = _tmp95_[1];
							_tmp97_ = vala_gidl_parser_eval (self, _tmp96_);
							_tmp98_ = _tmp97_;
							vala_gidl_parser_parse_type_arguments_from_string (self, _tmp94_, _tmp98_, NULL);
							_g_free0 (_tmp98_);
						} else {
							gchar** _tmp99_ = NULL;
							gint _tmp99__length1 = 0;
							const gchar* _tmp100_ = NULL;
							_tmp99_ = nv;
							_tmp99__length1 = nv_length1;
							_tmp100_ = _tmp99_[0];
							if (g_strcmp0 (_tmp100_, "deprecated") == 0) {
								gchar** _tmp101_ = NULL;
								gint _tmp101__length1 = 0;
								const gchar* _tmp102_ = NULL;
								gchar* _tmp103_ = NULL;
								gchar* _tmp104_ = NULL;
								gboolean _tmp105_ = FALSE;
								_tmp101_ = nv;
								_tmp101__length1 = nv_length1;
								_tmp102_ = _tmp101_[1];
								_tmp103_ = vala_gidl_parser_eval (self, _tmp102_);
								_tmp104_ = _tmp103_;
								_tmp105_ = g_strcmp0 (_tmp104_, "1") == 0;
								_g_free0 (_tmp104_);
								if (_tmp105_) {
									ValaProperty* _tmp106_ = NULL;
									_tmp106_ = prop;
									vala_code_node_set_attribute ((ValaCodeNode*) _tmp106_, "Deprecated", TRUE, NULL);
								}
							} else {
								gchar** _tmp107_ = NULL;
								gint _tmp107__length1 = 0;
								const gchar* _tmp108_ = NULL;
								_tmp107_ = nv;
								_tmp107__length1 = nv_length1;
								_tmp108_ = _tmp107_[0];
								if (g_strcmp0 (_tmp108_, "replacement") == 0) {
									ValaProperty* _tmp109_ = NULL;
									gchar** _tmp110_ = NULL;
									gint _tmp110__length1 = 0;
									const gchar* _tmp111_ = NULL;
									gchar* _tmp112_ = NULL;
									gchar* _tmp113_ = NULL;
									_tmp109_ = prop;
									_tmp110_ = nv;
									_tmp110__length1 = nv_length1;
									_tmp111_ = _tmp110_[1];
									_tmp112_ = vala_gidl_parser_eval (self, _tmp111_);
									_tmp113_ = _tmp112_;
									vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp109_, "Deprecated", "replacement", _tmp113_, NULL);
									_g_free0 (_tmp113_);
								} else {
									gchar** _tmp114_ = NULL;
									gint _tmp114__length1 = 0;
									const gchar* _tmp115_ = NULL;
									_tmp114_ = nv;
									_tmp114__length1 = nv_length1;
									_tmp115_ = _tmp114_[0];
									if (g_strcmp0 (_tmp115_, "deprecated_since") == 0) {
										ValaProperty* _tmp116_ = NULL;
										gchar** _tmp117_ = NULL;
										gint _tmp117__length1 = 0;
										const gchar* _tmp118_ = NULL;
										gchar* _tmp119_ = NULL;
										gchar* _tmp120_ = NULL;
										_tmp116_ = prop;
										_tmp117_ = nv;
										_tmp117__length1 = nv_length1;
										_tmp118_ = _tmp117_[1];
										_tmp119_ = vala_gidl_parser_eval (self, _tmp118_);
										_tmp120_ = _tmp119_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp116_, "Deprecated", "since", _tmp120_, NULL);
										_g_free0 (_tmp120_);
									} else {
										gchar** _tmp121_ = NULL;
										gint _tmp121__length1 = 0;
										const gchar* _tmp122_ = NULL;
										_tmp121_ = nv;
										_tmp121__length1 = nv_length1;
										_tmp122_ = _tmp121_[0];
										if (g_strcmp0 (_tmp122_, "accessor_method") == 0) {
											gchar** _tmp123_ = NULL;
											gint _tmp123__length1 = 0;
											const gchar* _tmp124_ = NULL;
											gchar* _tmp125_ = NULL;
											gchar* _tmp126_ = NULL;
											gboolean _tmp127_ = FALSE;
											_tmp123_ = nv;
											_tmp123__length1 = nv_length1;
											_tmp124_ = _tmp123_[1];
											_tmp125_ = vala_gidl_parser_eval (self, _tmp124_);
											_tmp126_ = _tmp125_;
											_tmp127_ = g_strcmp0 (_tmp126_, "0") == 0;
											_g_free0 (_tmp126_);
											if (_tmp127_) {
												ValaProperty* _tmp128_ = NULL;
												_tmp128_ = prop;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp128_, "NoAccessorMethod", TRUE, NULL);
											}
										} else {
											gchar** _tmp129_ = NULL;
											gint _tmp129__length1 = 0;
											const gchar* _tmp130_ = NULL;
											_tmp129_ = nv;
											_tmp129__length1 = nv_length1;
											_tmp130_ = _tmp129_[0];
											if (g_strcmp0 (_tmp130_, "owned_get") == 0) {
												gchar** _tmp131_ = NULL;
												gint _tmp131__length1 = 0;
												const gchar* _tmp132_ = NULL;
												gchar* _tmp133_ = NULL;
												gchar* _tmp134_ = NULL;
												gboolean _tmp135_ = FALSE;
												_tmp131_ = nv;
												_tmp131__length1 = nv_length1;
												_tmp132_ = _tmp131_[1];
												_tmp133_ = vala_gidl_parser_eval (self, _tmp132_);
												_tmp134_ = _tmp133_;
												_tmp135_ = g_strcmp0 (_tmp134_, "1") == 0;
												_g_free0 (_tmp134_);
												if (_tmp135_) {
													ValaProperty* _tmp136_ = NULL;
													ValaPropertyAccessor* _tmp137_ = NULL;
													ValaPropertyAccessor* _tmp138_ = NULL;
													ValaDataType* _tmp139_ = NULL;
													ValaDataType* _tmp140_ = NULL;
													_tmp136_ = prop;
													_tmp137_ = vala_property_get_get_accessor (_tmp136_);
													_tmp138_ = _tmp137_;
													_tmp139_ = vala_property_accessor_get_value_type (_tmp138_);
													_tmp140_ = _tmp139_;
													vala_data_type_set_value_owned (_tmp140_, TRUE);
												}
											} else {
												gchar** _tmp141_ = NULL;
												gint _tmp141__length1 = 0;
												const gchar* _tmp142_ = NULL;
												_tmp141_ = nv;
												_tmp141__length1 = nv_length1;
												_tmp142_ = _tmp141_[0];
												if (g_strcmp0 (_tmp142_, "type_name") == 0) {
													ValaProperty* _tmp143_ = NULL;
													gchar** _tmp144_ = NULL;
													gint _tmp144__length1 = 0;
													const gchar* _tmp145_ = NULL;
													gchar* _tmp146_ = NULL;
													gchar* _tmp147_ = NULL;
													ValaDataType* _tmp148_ = NULL;
													ValaDataType* _tmp149_ = NULL;
													_tmp143_ = prop;
													_tmp144_ = nv;
													_tmp144__length1 = nv_length1;
													_tmp145_ = _tmp144_[1];
													_tmp146_ = vala_gidl_parser_eval (self, _tmp145_);
													_tmp147_ = _tmp146_;
													_tmp148_ = vala_gidl_parser_parse_type_from_string (self, _tmp147_, FALSE, NULL);
													_tmp149_ = _tmp148_;
													vala_property_set_property_type (_tmp143_, _tmp149_);
													_vala_code_node_unref0 (_tmp149_);
													_g_free0 (_tmp147_);
												} else {
													gchar** _tmp150_ = NULL;
													gint _tmp150__length1 = 0;
													const gchar* _tmp151_ = NULL;
													_tmp150_ = nv;
													_tmp150__length1 = nv_length1;
													_tmp151_ = _tmp150_[0];
													if (g_strcmp0 (_tmp151_, "experimental") == 0) {
														gchar** _tmp152_ = NULL;
														gint _tmp152__length1 = 0;
														const gchar* _tmp153_ = NULL;
														gchar* _tmp154_ = NULL;
														gchar* _tmp155_ = NULL;
														gboolean _tmp156_ = FALSE;
														_tmp152_ = nv;
														_tmp152__length1 = nv_length1;
														_tmp153_ = _tmp152_[1];
														_tmp154_ = vala_gidl_parser_eval (self, _tmp153_);
														_tmp155_ = _tmp154_;
														_tmp156_ = g_strcmp0 (_tmp155_, "1") == 0;
														_g_free0 (_tmp155_);
														if (_tmp156_) {
															ValaProperty* _tmp157_ = NULL;
															_tmp157_ = prop;
															vala_code_node_set_attribute ((ValaCodeNode*) _tmp157_, "Experimental", TRUE, NULL);
														}
													} else {
														gchar** _tmp158_ = NULL;
														gint _tmp158__length1 = 0;
														const gchar* _tmp159_ = NULL;
														_tmp158_ = nv;
														_tmp158__length1 = nv_length1;
														_tmp159_ = _tmp158_[0];
														if (g_strcmp0 (_tmp159_, "nullable") == 0) {
															gchar** _tmp160_ = NULL;
															gint _tmp160__length1 = 0;
															const gchar* _tmp161_ = NULL;
															gchar* _tmp162_ = NULL;
															gchar* _tmp163_ = NULL;
															gboolean _tmp164_ = FALSE;
															_tmp160_ = nv;
															_tmp160__length1 = nv_length1;
															_tmp161_ = _tmp160_[1];
															_tmp162_ = vala_gidl_parser_eval (self, _tmp161_);
															_tmp163_ = _tmp162_;
															_tmp164_ = g_strcmp0 (_tmp163_, "1") == 0;
															_g_free0 (_tmp163_);
															if (_tmp164_) {
																ValaProperty* _tmp165_ = NULL;
																ValaDataType* _tmp166_ = NULL;
																ValaDataType* _tmp167_ = NULL;
																_tmp165_ = prop;
																_tmp166_ = vala_property_get_property_type (_tmp165_);
																_tmp167_ = _tmp166_;
																vala_data_type_set_nullable (_tmp167_, TRUE);
															}
														} else {
															gchar** _tmp168_ = NULL;
															gint _tmp168__length1 = 0;
															const gchar* _tmp169_ = NULL;
															_tmp168_ = nv;
															_tmp168__length1 = nv_length1;
															_tmp169_ = _tmp168_[0];
															if (g_strcmp0 (_tmp169_, "abstract") == 0) {
																gchar** _tmp170_ = NULL;
																gint _tmp170__length1 = 0;
																const gchar* _tmp171_ = NULL;
																gchar* _tmp172_ = NULL;
																gchar* _tmp173_ = NULL;
																gboolean _tmp174_ = FALSE;
																_tmp170_ = nv;
																_tmp170__length1 = nv_length1;
																_tmp171_ = _tmp170_[1];
																_tmp172_ = vala_gidl_parser_eval (self, _tmp171_);
																_tmp173_ = _tmp172_;
																_tmp174_ = g_strcmp0 (_tmp173_, "1") == 0;
																_g_free0 (_tmp173_);
																if (_tmp174_) {
																	ValaProperty* _tmp175_ = NULL;
																	_tmp175_ = prop;
																	vala_property_set_is_abstract (_tmp175_, TRUE);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp176_ = self->priv->current_type_symbol_set;
	if (_tmp176_ != NULL) {
		ValaSet* _tmp177_ = NULL;
		ValaProperty* _tmp178_ = NULL;
		const gchar* _tmp179_ = NULL;
		const gchar* _tmp180_ = NULL;
		_tmp177_ = self->priv->current_type_symbol_set;
		_tmp178_ = prop;
		_tmp179_ = vala_symbol_get_name ((ValaSymbol*) _tmp178_);
		_tmp180_ = _tmp179_;
		vala_collection_add ((ValaCollection*) _tmp177_, _tmp180_);
	}
	result = prop;
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


static ValaConstant* vala_gidl_parser_parse_constant (ValaGIdlParser* self, GIdlNodeConstant* const_node) {
	ValaConstant* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeConstant* _tmp0_ = NULL;
	ValaDataType* type = NULL;
	GIdlNodeConstant* _tmp1_ = NULL;
	GIdlNodeType* _tmp2_ = NULL;
	ValaDataType* _tmp3_ = NULL;
	ValaDataType* _tmp4_ = NULL;
	ValaConstant* c = NULL;
	GIdlNode* _tmp5_ = NULL;
	const gchar* _tmp6_ = NULL;
	ValaDataType* _tmp7_ = NULL;
	ValaSourceReference* _tmp8_ = NULL;
	ValaConstant* _tmp9_ = NULL;
	ValaConstant* _tmp10_ = NULL;
	gchar** attributes = NULL;
	GIdlNode* _tmp11_ = NULL;
	const gchar* _tmp12_ = NULL;
	gint _tmp13_ = 0;
	gchar** _tmp14_ = NULL;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	ValaConstant* _tmp65_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (const_node != NULL, NULL);
	_tmp0_ = const_node;
	node = (GIdlNode*) _tmp0_;
	_tmp1_ = const_node;
	_tmp2_ = _tmp1_->type;
	_tmp3_ = vala_gidl_parser_parse_type (self, _tmp2_, NULL);
	type = _tmp3_;
	_tmp4_ = type;
	if (_tmp4_ == NULL) {
		result = NULL;
		_vala_code_node_unref0 (type);
		return result;
	}
	_tmp5_ = node;
	_tmp6_ = _tmp5_->name;
	_tmp7_ = type;
	_tmp8_ = self->priv->current_source_reference;
	_tmp9_ = vala_constant_new (_tmp6_, _tmp7_, NULL, _tmp8_, NULL);
	c = _tmp9_;
	_tmp10_ = c;
	vala_symbol_set_external ((ValaSymbol*) _tmp10_, TRUE);
	_tmp11_ = node;
	_tmp12_ = _tmp11_->name;
	_tmp14_ = vala_gidl_parser_get_attributes (self, _tmp12_, &_tmp13_);
	attributes = _tmp14_;
	attributes_length1 = _tmp13_;
	_attributes_size_ = attributes_length1;
	_tmp15_ = attributes;
	_tmp15__length1 = attributes_length1;
	if (_tmp15_ != NULL) {
		gchar** _tmp16_ = NULL;
		gint _tmp16__length1 = 0;
		_tmp16_ = attributes;
		_tmp16__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp16_;
			attr_collection_length1 = _tmp16__length1;
			for (attr_it = 0; attr_it < _tmp16__length1; attr_it = attr_it + 1) {
				gchar* _tmp17_ = NULL;
				gchar* attr = NULL;
				_tmp17_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp17_;
				{
					gchar** nv = NULL;
					const gchar* _tmp18_ = NULL;
					gchar** _tmp19_ = NULL;
					gchar** _tmp20_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp21_ = NULL;
					gint _tmp21__length1 = 0;
					const gchar* _tmp22_ = NULL;
					_tmp18_ = attr;
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "=", 2);
					nv = _tmp20_;
					nv_length1 = _vala_array_length (_tmp19_);
					_nv_size_ = nv_length1;
					_tmp21_ = nv;
					_tmp21__length1 = nv_length1;
					_tmp22_ = _tmp21_[0];
					if (g_strcmp0 (_tmp22_, "cheader_filename") == 0) {
						ValaConstant* _tmp23_ = NULL;
						gchar** _tmp24_ = NULL;
						gint _tmp24__length1 = 0;
						const gchar* _tmp25_ = NULL;
						gchar* _tmp26_ = NULL;
						gchar* _tmp27_ = NULL;
						_tmp23_ = c;
						_tmp24_ = nv;
						_tmp24__length1 = nv_length1;
						_tmp25_ = _tmp24_[1];
						_tmp26_ = vala_gidl_parser_eval (self, _tmp25_);
						_tmp27_ = _tmp26_;
						vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp23_, "CCode", "cheader_filename", _tmp27_, NULL);
						_g_free0 (_tmp27_);
					} else {
						gchar** _tmp28_ = NULL;
						gint _tmp28__length1 = 0;
						const gchar* _tmp29_ = NULL;
						_tmp28_ = nv;
						_tmp28__length1 = nv_length1;
						_tmp29_ = _tmp28_[0];
						if (g_strcmp0 (_tmp29_, "deprecated") == 0) {
							gchar** _tmp30_ = NULL;
							gint _tmp30__length1 = 0;
							const gchar* _tmp31_ = NULL;
							gchar* _tmp32_ = NULL;
							gchar* _tmp33_ = NULL;
							gboolean _tmp34_ = FALSE;
							_tmp30_ = nv;
							_tmp30__length1 = nv_length1;
							_tmp31_ = _tmp30_[1];
							_tmp32_ = vala_gidl_parser_eval (self, _tmp31_);
							_tmp33_ = _tmp32_;
							_tmp34_ = g_strcmp0 (_tmp33_, "1") == 0;
							_g_free0 (_tmp33_);
							if (_tmp34_) {
								ValaConstant* _tmp35_ = NULL;
								_tmp35_ = c;
								vala_code_node_set_attribute ((ValaCodeNode*) _tmp35_, "Deprecated", TRUE, NULL);
							}
						} else {
							gchar** _tmp36_ = NULL;
							gint _tmp36__length1 = 0;
							const gchar* _tmp37_ = NULL;
							_tmp36_ = nv;
							_tmp36__length1 = nv_length1;
							_tmp37_ = _tmp36_[0];
							if (g_strcmp0 (_tmp37_, "replacement") == 0) {
								ValaConstant* _tmp38_ = NULL;
								gchar** _tmp39_ = NULL;
								gint _tmp39__length1 = 0;
								const gchar* _tmp40_ = NULL;
								gchar* _tmp41_ = NULL;
								gchar* _tmp42_ = NULL;
								_tmp38_ = c;
								_tmp39_ = nv;
								_tmp39__length1 = nv_length1;
								_tmp40_ = _tmp39_[1];
								_tmp41_ = vala_gidl_parser_eval (self, _tmp40_);
								_tmp42_ = _tmp41_;
								vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp38_, "Deprecated", "replacement", _tmp42_, NULL);
								_g_free0 (_tmp42_);
							} else {
								gchar** _tmp43_ = NULL;
								gint _tmp43__length1 = 0;
								const gchar* _tmp44_ = NULL;
								_tmp43_ = nv;
								_tmp43__length1 = nv_length1;
								_tmp44_ = _tmp43_[0];
								if (g_strcmp0 (_tmp44_, "deprecated_since") == 0) {
									ValaConstant* _tmp45_ = NULL;
									gchar** _tmp46_ = NULL;
									gint _tmp46__length1 = 0;
									const gchar* _tmp47_ = NULL;
									gchar* _tmp48_ = NULL;
									gchar* _tmp49_ = NULL;
									_tmp45_ = c;
									_tmp46_ = nv;
									_tmp46__length1 = nv_length1;
									_tmp47_ = _tmp46_[1];
									_tmp48_ = vala_gidl_parser_eval (self, _tmp47_);
									_tmp49_ = _tmp48_;
									vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp45_, "Deprecated", "since", _tmp49_, NULL);
									_g_free0 (_tmp49_);
								} else {
									gchar** _tmp50_ = NULL;
									gint _tmp50__length1 = 0;
									const gchar* _tmp51_ = NULL;
									_tmp50_ = nv;
									_tmp50__length1 = nv_length1;
									_tmp51_ = _tmp50_[0];
									if (g_strcmp0 (_tmp51_, "hidden") == 0) {
										gchar** _tmp52_ = NULL;
										gint _tmp52__length1 = 0;
										const gchar* _tmp53_ = NULL;
										gchar* _tmp54_ = NULL;
										gchar* _tmp55_ = NULL;
										gboolean _tmp56_ = FALSE;
										_tmp52_ = nv;
										_tmp52__length1 = nv_length1;
										_tmp53_ = _tmp52_[1];
										_tmp54_ = vala_gidl_parser_eval (self, _tmp53_);
										_tmp55_ = _tmp54_;
										_tmp56_ = g_strcmp0 (_tmp55_, "1") == 0;
										_g_free0 (_tmp55_);
										if (_tmp56_) {
											result = NULL;
											nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
											_g_free0 (attr);
											attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
											_vala_code_node_unref0 (c);
											_vala_code_node_unref0 (type);
											return result;
										}
									} else {
										gchar** _tmp57_ = NULL;
										gint _tmp57__length1 = 0;
										const gchar* _tmp58_ = NULL;
										_tmp57_ = nv;
										_tmp57__length1 = nv_length1;
										_tmp58_ = _tmp57_[0];
										if (g_strcmp0 (_tmp58_, "experimental") == 0) {
											gchar** _tmp59_ = NULL;
											gint _tmp59__length1 = 0;
											const gchar* _tmp60_ = NULL;
											gchar* _tmp61_ = NULL;
											gchar* _tmp62_ = NULL;
											gboolean _tmp63_ = FALSE;
											_tmp59_ = nv;
											_tmp59__length1 = nv_length1;
											_tmp60_ = _tmp59_[1];
											_tmp61_ = vala_gidl_parser_eval (self, _tmp60_);
											_tmp62_ = _tmp61_;
											_tmp63_ = g_strcmp0 (_tmp62_, "1") == 0;
											_g_free0 (_tmp62_);
											if (_tmp63_) {
												ValaConstant* _tmp64_ = NULL;
												_tmp64_ = c;
												vala_code_node_set_attribute ((ValaCodeNode*) _tmp64_, "Experimental", TRUE, NULL);
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp65_ = c;
	vala_symbol_set_access ((ValaSymbol*) _tmp65_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	result = c;
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_vala_code_node_unref0 (type);
	return result;
}


static ValaField* vala_gidl_parser_parse_field (ValaGIdlParser* self, GIdlNodeField* field_node) {
	ValaField* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeField* _tmp0_ = NULL;
	gboolean unhidden = FALSE;
	ValaDataType* type = NULL;
	GIdlNodeField* _tmp1_ = NULL;
	GIdlNodeType* _tmp2_ = NULL;
	ValaDataType* _tmp3_ = NULL;
	ValaDataType* _tmp4_ = NULL;
	gchar* cheader_filename = NULL;
	gchar* ctype = NULL;
	gchar* array_length_cname = NULL;
	gchar* array_length_type = NULL;
	gboolean array_null_terminated = FALSE;
	gboolean deprecated = FALSE;
	gchar* deprecated_since = NULL;
	gchar* replacement = NULL;
	gboolean experimental = FALSE;
	gboolean no_delegate_target = FALSE;
	gchar** attributes = NULL;
	ValaTypeSymbol* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	GIdlNode* _tmp8_ = NULL;
	const gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	gchar* _tmp11_ = NULL;
	gint _tmp12_ = 0;
	gchar** _tmp13_ = NULL;
	gchar** _tmp14_ = NULL;
	gint _tmp14__length1 = 0;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp15_ = NULL;
	gint _tmp15__length1 = 0;
	gboolean _tmp134_ = FALSE;
	GIdlNode* _tmp135_ = NULL;
	const gchar* _tmp136_ = NULL;
	gboolean _tmp137_ = FALSE;
	gboolean _tmp139_ = FALSE;
	ValaSet* _tmp140_ = NULL;
	gchar* field_name = NULL;
	GIdlNode* _tmp144_ = NULL;
	const gchar* _tmp145_ = NULL;
	gchar* _tmp146_ = NULL;
	const gchar* _tmp147_ = NULL;
	ValaField* field = NULL;
	const gchar* _tmp149_ = NULL;
	ValaDataType* _tmp150_ = NULL;
	ValaSourceReference* _tmp151_ = NULL;
	ValaField* _tmp152_ = NULL;
	ValaField* _tmp153_ = NULL;
	const gchar* _tmp154_ = NULL;
	GIdlNode* _tmp155_ = NULL;
	const gchar* _tmp156_ = NULL;
	gboolean _tmp160_ = FALSE;
	gboolean _tmp168_ = FALSE;
	const gchar* _tmp170_ = NULL;
	const gchar* _tmp173_ = NULL;
	gboolean _tmp176_ = FALSE;
	gboolean _tmp178_ = FALSE;
	const gchar* _tmp179_ = NULL;
	gboolean _tmp181_ = FALSE;
	gboolean _tmp192_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (field_node != NULL, NULL);
	_tmp0_ = field_node;
	node = (GIdlNode*) _tmp0_;
	unhidden = FALSE;
	_tmp1_ = field_node;
	_tmp2_ = _tmp1_->type;
	_tmp3_ = vala_gidl_parser_parse_type (self, _tmp2_, NULL);
	type = _tmp3_;
	_tmp4_ = type;
	if (_tmp4_ == NULL) {
		result = NULL;
		_vala_code_node_unref0 (type);
		return result;
	}
	cheader_filename = NULL;
	ctype = NULL;
	array_length_cname = NULL;
	array_length_type = NULL;
	array_null_terminated = FALSE;
	deprecated = FALSE;
	deprecated_since = NULL;
	replacement = NULL;
	experimental = FALSE;
	no_delegate_target = FALSE;
	_tmp5_ = self->priv->current_data_type;
	_tmp6_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp5_, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = node;
	_tmp9_ = _tmp8_->name;
	_tmp10_ = g_strdup_printf ("%s.%s", _tmp7_, _tmp9_);
	_tmp11_ = _tmp10_;
	_tmp13_ = vala_gidl_parser_get_attributes (self, _tmp11_, &_tmp12_);
	_tmp14_ = _tmp13_;
	_tmp14__length1 = _tmp12_;
	_g_free0 (_tmp11_);
	_g_free0 (_tmp7_);
	attributes = _tmp14_;
	attributes_length1 = _tmp14__length1;
	_attributes_size_ = attributes_length1;
	_tmp15_ = attributes;
	_tmp15__length1 = attributes_length1;
	if (_tmp15_ != NULL) {
		gchar** _tmp16_ = NULL;
		gint _tmp16__length1 = 0;
		_tmp16_ = attributes;
		_tmp16__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp16_;
			attr_collection_length1 = _tmp16__length1;
			for (attr_it = 0; attr_it < _tmp16__length1; attr_it = attr_it + 1) {
				gchar* _tmp17_ = NULL;
				gchar* attr = NULL;
				_tmp17_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp17_;
				{
					gchar** nv = NULL;
					const gchar* _tmp18_ = NULL;
					gchar** _tmp19_ = NULL;
					gchar** _tmp20_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp21_ = NULL;
					gint _tmp21__length1 = 0;
					const gchar* _tmp22_ = NULL;
					_tmp18_ = attr;
					_tmp20_ = _tmp19_ = g_strsplit (_tmp18_, "=", 2);
					nv = _tmp20_;
					nv_length1 = _vala_array_length (_tmp19_);
					_nv_size_ = nv_length1;
					_tmp21_ = nv;
					_tmp21__length1 = nv_length1;
					_tmp22_ = _tmp21_[0];
					if (g_strcmp0 (_tmp22_, "hidden") == 0) {
						gchar** _tmp23_ = NULL;
						gint _tmp23__length1 = 0;
						const gchar* _tmp24_ = NULL;
						gchar* _tmp25_ = NULL;
						gchar* _tmp26_ = NULL;
						gboolean _tmp27_ = FALSE;
						_tmp23_ = nv;
						_tmp23__length1 = nv_length1;
						_tmp24_ = _tmp23_[1];
						_tmp25_ = vala_gidl_parser_eval (self, _tmp24_);
						_tmp26_ = _tmp25_;
						_tmp27_ = g_strcmp0 (_tmp26_, "1") == 0;
						_g_free0 (_tmp26_);
						if (_tmp27_) {
							result = NULL;
							nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (attr);
							attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
							_g_free0 (replacement);
							_g_free0 (deprecated_since);
							_g_free0 (array_length_type);
							_g_free0 (array_length_cname);
							_g_free0 (ctype);
							_g_free0 (cheader_filename);
							_vala_code_node_unref0 (type);
							return result;
						} else {
							unhidden = TRUE;
						}
					} else {
						gchar** _tmp28_ = NULL;
						gint _tmp28__length1 = 0;
						const gchar* _tmp29_ = NULL;
						_tmp28_ = nv;
						_tmp28__length1 = nv_length1;
						_tmp29_ = _tmp28_[0];
						if (g_strcmp0 (_tmp29_, "is_array") == 0) {
							gchar** _tmp30_ = NULL;
							gint _tmp30__length1 = 0;
							const gchar* _tmp31_ = NULL;
							gchar* _tmp32_ = NULL;
							gchar* _tmp33_ = NULL;
							gboolean _tmp34_ = FALSE;
							_tmp30_ = nv;
							_tmp30__length1 = nv_length1;
							_tmp31_ = _tmp30_[1];
							_tmp32_ = vala_gidl_parser_eval (self, _tmp31_);
							_tmp33_ = _tmp32_;
							_tmp34_ = g_strcmp0 (_tmp33_, "1") == 0;
							_g_free0 (_tmp33_);
							if (_tmp34_) {
								ValaDataType* _tmp35_ = NULL;
								ValaDataType* _tmp36_ = NULL;
								ValaSourceReference* _tmp37_ = NULL;
								ValaSourceReference* _tmp38_ = NULL;
								ValaArrayType* _tmp39_ = NULL;
								_tmp35_ = type;
								_tmp36_ = type;
								_tmp37_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp36_);
								_tmp38_ = _tmp37_;
								_tmp39_ = vala_array_type_new (_tmp35_, 1, _tmp38_);
								_vala_code_node_unref0 (type);
								type = (ValaDataType*) _tmp39_;
							}
						} else {
							gchar** _tmp40_ = NULL;
							gint _tmp40__length1 = 0;
							const gchar* _tmp41_ = NULL;
							_tmp40_ = nv;
							_tmp40__length1 = nv_length1;
							_tmp41_ = _tmp40_[0];
							if (g_strcmp0 (_tmp41_, "weak") == 0) {
								gchar** _tmp42_ = NULL;
								gint _tmp42__length1 = 0;
								const gchar* _tmp43_ = NULL;
								gchar* _tmp44_ = NULL;
								gchar* _tmp45_ = NULL;
								gboolean _tmp46_ = FALSE;
								_tmp42_ = nv;
								_tmp42__length1 = nv_length1;
								_tmp43_ = _tmp42_[1];
								_tmp44_ = vala_gidl_parser_eval (self, _tmp43_);
								_tmp45_ = _tmp44_;
								_tmp46_ = g_strcmp0 (_tmp45_, "0") == 0;
								_g_free0 (_tmp45_);
								if (_tmp46_) {
									ValaDataType* _tmp47_ = NULL;
									_tmp47_ = type;
									vala_data_type_set_value_owned (_tmp47_, TRUE);
								}
							} else {
								gchar** _tmp48_ = NULL;
								gint _tmp48__length1 = 0;
								const gchar* _tmp49_ = NULL;
								_tmp48_ = nv;
								_tmp48__length1 = nv_length1;
								_tmp49_ = _tmp48_[0];
								if (g_strcmp0 (_tmp49_, "value_owned") == 0) {
									gchar** _tmp50_ = NULL;
									gint _tmp50__length1 = 0;
									const gchar* _tmp51_ = NULL;
									gchar* _tmp52_ = NULL;
									gchar* _tmp53_ = NULL;
									gboolean _tmp54_ = FALSE;
									_tmp50_ = nv;
									_tmp50__length1 = nv_length1;
									_tmp51_ = _tmp50_[1];
									_tmp52_ = vala_gidl_parser_eval (self, _tmp51_);
									_tmp53_ = _tmp52_;
									_tmp54_ = g_strcmp0 (_tmp53_, "0") == 0;
									_g_free0 (_tmp53_);
									if (_tmp54_) {
										ValaDataType* _tmp55_ = NULL;
										_tmp55_ = type;
										vala_data_type_set_value_owned (_tmp55_, FALSE);
									} else {
										gchar** _tmp56_ = NULL;
										gint _tmp56__length1 = 0;
										const gchar* _tmp57_ = NULL;
										gchar* _tmp58_ = NULL;
										gchar* _tmp59_ = NULL;
										gboolean _tmp60_ = FALSE;
										_tmp56_ = nv;
										_tmp56__length1 = nv_length1;
										_tmp57_ = _tmp56_[1];
										_tmp58_ = vala_gidl_parser_eval (self, _tmp57_);
										_tmp59_ = _tmp58_;
										_tmp60_ = g_strcmp0 (_tmp59_, "1") == 0;
										_g_free0 (_tmp59_);
										if (_tmp60_) {
											ValaDataType* _tmp61_ = NULL;
											_tmp61_ = type;
											vala_data_type_set_value_owned (_tmp61_, TRUE);
										}
									}
								} else {
									gchar** _tmp62_ = NULL;
									gint _tmp62__length1 = 0;
									const gchar* _tmp63_ = NULL;
									_tmp62_ = nv;
									_tmp62__length1 = nv_length1;
									_tmp63_ = _tmp62_[0];
									if (g_strcmp0 (_tmp63_, "type_name") == 0) {
										gchar** _tmp64_ = NULL;
										gint _tmp64__length1 = 0;
										const gchar* _tmp65_ = NULL;
										gchar* _tmp66_ = NULL;
										gchar* _tmp67_ = NULL;
										ValaDataType* _tmp68_ = NULL;
										_tmp64_ = nv;
										_tmp64__length1 = nv_length1;
										_tmp65_ = _tmp64_[1];
										_tmp66_ = vala_gidl_parser_eval (self, _tmp65_);
										_tmp67_ = _tmp66_;
										_tmp68_ = vala_gidl_parser_parse_type_from_string (self, _tmp67_, TRUE, NULL);
										_vala_code_node_unref0 (type);
										type = _tmp68_;
										_g_free0 (_tmp67_);
									} else {
										gchar** _tmp69_ = NULL;
										gint _tmp69__length1 = 0;
										const gchar* _tmp70_ = NULL;
										_tmp69_ = nv;
										_tmp69__length1 = nv_length1;
										_tmp70_ = _tmp69_[0];
										if (g_strcmp0 (_tmp70_, "type_arguments") == 0) {
											ValaDataType* _tmp71_ = NULL;
											gchar** _tmp72_ = NULL;
											gint _tmp72__length1 = 0;
											const gchar* _tmp73_ = NULL;
											gchar* _tmp74_ = NULL;
											gchar* _tmp75_ = NULL;
											_tmp71_ = type;
											_tmp72_ = nv;
											_tmp72__length1 = nv_length1;
											_tmp73_ = _tmp72_[1];
											_tmp74_ = vala_gidl_parser_eval (self, _tmp73_);
											_tmp75_ = _tmp74_;
											vala_gidl_parser_parse_type_arguments_from_string (self, _tmp71_, _tmp75_, NULL);
											_g_free0 (_tmp75_);
										} else {
											gchar** _tmp76_ = NULL;
											gint _tmp76__length1 = 0;
											const gchar* _tmp77_ = NULL;
											_tmp76_ = nv;
											_tmp76__length1 = nv_length1;
											_tmp77_ = _tmp76_[0];
											if (g_strcmp0 (_tmp77_, "deprecated") == 0) {
												gchar** _tmp78_ = NULL;
												gint _tmp78__length1 = 0;
												const gchar* _tmp79_ = NULL;
												gchar* _tmp80_ = NULL;
												gchar* _tmp81_ = NULL;
												gboolean _tmp82_ = FALSE;
												_tmp78_ = nv;
												_tmp78__length1 = nv_length1;
												_tmp79_ = _tmp78_[1];
												_tmp80_ = vala_gidl_parser_eval (self, _tmp79_);
												_tmp81_ = _tmp80_;
												_tmp82_ = g_strcmp0 (_tmp81_, "1") == 0;
												_g_free0 (_tmp81_);
												if (_tmp82_) {
													deprecated = TRUE;
												}
											} else {
												gchar** _tmp83_ = NULL;
												gint _tmp83__length1 = 0;
												const gchar* _tmp84_ = NULL;
												_tmp83_ = nv;
												_tmp83__length1 = nv_length1;
												_tmp84_ = _tmp83_[0];
												if (g_strcmp0 (_tmp84_, "replacement") == 0) {
													gchar** _tmp85_ = NULL;
													gint _tmp85__length1 = 0;
													const gchar* _tmp86_ = NULL;
													gchar* _tmp87_ = NULL;
													_tmp85_ = nv;
													_tmp85__length1 = nv_length1;
													_tmp86_ = _tmp85_[1];
													_tmp87_ = vala_gidl_parser_eval (self, _tmp86_);
													_g_free0 (replacement);
													replacement = _tmp87_;
												} else {
													gchar** _tmp88_ = NULL;
													gint _tmp88__length1 = 0;
													const gchar* _tmp89_ = NULL;
													_tmp88_ = nv;
													_tmp88__length1 = nv_length1;
													_tmp89_ = _tmp88_[0];
													if (g_strcmp0 (_tmp89_, "deprecated_since") == 0) {
														gchar** _tmp90_ = NULL;
														gint _tmp90__length1 = 0;
														const gchar* _tmp91_ = NULL;
														gchar* _tmp92_ = NULL;
														_tmp90_ = nv;
														_tmp90__length1 = nv_length1;
														_tmp91_ = _tmp90_[1];
														_tmp92_ = vala_gidl_parser_eval (self, _tmp91_);
														_g_free0 (deprecated_since);
														deprecated_since = _tmp92_;
													} else {
														gchar** _tmp93_ = NULL;
														gint _tmp93__length1 = 0;
														const gchar* _tmp94_ = NULL;
														_tmp93_ = nv;
														_tmp93__length1 = nv_length1;
														_tmp94_ = _tmp93_[0];
														if (g_strcmp0 (_tmp94_, "cheader_filename") == 0) {
															gchar** _tmp95_ = NULL;
															gint _tmp95__length1 = 0;
															const gchar* _tmp96_ = NULL;
															gchar* _tmp97_ = NULL;
															_tmp95_ = nv;
															_tmp95__length1 = nv_length1;
															_tmp96_ = _tmp95_[1];
															_tmp97_ = vala_gidl_parser_eval (self, _tmp96_);
															_g_free0 (cheader_filename);
															cheader_filename = _tmp97_;
														} else {
															gchar** _tmp98_ = NULL;
															gint _tmp98__length1 = 0;
															const gchar* _tmp99_ = NULL;
															_tmp98_ = nv;
															_tmp98__length1 = nv_length1;
															_tmp99_ = _tmp98_[0];
															if (g_strcmp0 (_tmp99_, "ctype") == 0) {
																gchar** _tmp100_ = NULL;
																gint _tmp100__length1 = 0;
																const gchar* _tmp101_ = NULL;
																gchar* _tmp102_ = NULL;
																_tmp100_ = nv;
																_tmp100__length1 = nv_length1;
																_tmp101_ = _tmp100_[1];
																_tmp102_ = vala_gidl_parser_eval (self, _tmp101_);
																_g_free0 (ctype);
																ctype = _tmp102_;
															} else {
																gchar** _tmp103_ = NULL;
																gint _tmp103__length1 = 0;
																const gchar* _tmp104_ = NULL;
																_tmp103_ = nv;
																_tmp103__length1 = nv_length1;
																_tmp104_ = _tmp103_[0];
																if (g_strcmp0 (_tmp104_, "array_null_terminated") == 0) {
																	gchar** _tmp105_ = NULL;
																	gint _tmp105__length1 = 0;
																	const gchar* _tmp106_ = NULL;
																	gchar* _tmp107_ = NULL;
																	gchar* _tmp108_ = NULL;
																	gboolean _tmp109_ = FALSE;
																	_tmp105_ = nv;
																	_tmp105__length1 = nv_length1;
																	_tmp106_ = _tmp105_[1];
																	_tmp107_ = vala_gidl_parser_eval (self, _tmp106_);
																	_tmp108_ = _tmp107_;
																	_tmp109_ = g_strcmp0 (_tmp108_, "1") == 0;
																	_g_free0 (_tmp108_);
																	if (_tmp109_) {
																		array_null_terminated = TRUE;
																	}
																} else {
																	gchar** _tmp110_ = NULL;
																	gint _tmp110__length1 = 0;
																	const gchar* _tmp111_ = NULL;
																	_tmp110_ = nv;
																	_tmp110__length1 = nv_length1;
																	_tmp111_ = _tmp110_[0];
																	if (g_strcmp0 (_tmp111_, "array_length_cname") == 0) {
																		gchar** _tmp112_ = NULL;
																		gint _tmp112__length1 = 0;
																		const gchar* _tmp113_ = NULL;
																		gchar* _tmp114_ = NULL;
																		_tmp112_ = nv;
																		_tmp112__length1 = nv_length1;
																		_tmp113_ = _tmp112_[1];
																		_tmp114_ = vala_gidl_parser_eval (self, _tmp113_);
																		_g_free0 (array_length_cname);
																		array_length_cname = _tmp114_;
																	} else {
																		gchar** _tmp115_ = NULL;
																		gint _tmp115__length1 = 0;
																		const gchar* _tmp116_ = NULL;
																		_tmp115_ = nv;
																		_tmp115__length1 = nv_length1;
																		_tmp116_ = _tmp115_[0];
																		if (g_strcmp0 (_tmp116_, "array_length_type") == 0) {
																			gchar** _tmp117_ = NULL;
																			gint _tmp117__length1 = 0;
																			const gchar* _tmp118_ = NULL;
																			gchar* _tmp119_ = NULL;
																			_tmp117_ = nv;
																			_tmp117__length1 = nv_length1;
																			_tmp118_ = _tmp117_[1];
																			_tmp119_ = vala_gidl_parser_eval (self, _tmp118_);
																			_g_free0 (array_length_type);
																			array_length_type = _tmp119_;
																		} else {
																			gchar** _tmp120_ = NULL;
																			gint _tmp120__length1 = 0;
																			const gchar* _tmp121_ = NULL;
																			_tmp120_ = nv;
																			_tmp120__length1 = nv_length1;
																			_tmp121_ = _tmp120_[0];
																			if (g_strcmp0 (_tmp121_, "no_delegate_target") == 0) {
																				gchar** _tmp122_ = NULL;
																				gint _tmp122__length1 = 0;
																				const gchar* _tmp123_ = NULL;
																				gchar* _tmp124_ = NULL;
																				gchar* _tmp125_ = NULL;
																				gboolean _tmp126_ = FALSE;
																				_tmp122_ = nv;
																				_tmp122__length1 = nv_length1;
																				_tmp123_ = _tmp122_[1];
																				_tmp124_ = vala_gidl_parser_eval (self, _tmp123_);
																				_tmp125_ = _tmp124_;
																				_tmp126_ = g_strcmp0 (_tmp125_, "1") == 0;
																				_g_free0 (_tmp125_);
																				if (_tmp126_) {
																					no_delegate_target = TRUE;
																				}
																			} else {
																				gchar** _tmp127_ = NULL;
																				gint _tmp127__length1 = 0;
																				const gchar* _tmp128_ = NULL;
																				_tmp127_ = nv;
																				_tmp127__length1 = nv_length1;
																				_tmp128_ = _tmp127_[0];
																				if (g_strcmp0 (_tmp128_, "experimental") == 0) {
																					gchar** _tmp129_ = NULL;
																					gint _tmp129__length1 = 0;
																					const gchar* _tmp130_ = NULL;
																					gchar* _tmp131_ = NULL;
																					gchar* _tmp132_ = NULL;
																					gboolean _tmp133_ = FALSE;
																					_tmp129_ = nv;
																					_tmp129__length1 = nv_length1;
																					_tmp130_ = _tmp129_[1];
																					_tmp131_ = vala_gidl_parser_eval (self, _tmp130_);
																					_tmp132_ = _tmp131_;
																					_tmp133_ = g_strcmp0 (_tmp132_, "1") == 0;
																					_g_free0 (_tmp132_);
																					if (_tmp133_) {
																						experimental = TRUE;
																					}
																				}
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
	}
	_tmp135_ = node;
	_tmp136_ = _tmp135_->name;
	_tmp137_ = g_str_has_prefix (_tmp136_, "_");
	if (_tmp137_) {
		gboolean _tmp138_ = FALSE;
		_tmp138_ = unhidden;
		_tmp134_ = !_tmp138_;
	} else {
		_tmp134_ = FALSE;
	}
	_tmp139_ = _tmp134_;
	if (_tmp139_) {
		result = NULL;
		attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (replacement);
		_g_free0 (deprecated_since);
		_g_free0 (array_length_type);
		_g_free0 (array_length_cname);
		_g_free0 (ctype);
		_g_free0 (cheader_filename);
		_vala_code_node_unref0 (type);
		return result;
	}
	_tmp140_ = self->priv->current_type_symbol_set;
	if (_tmp140_ != NULL) {
		ValaSet* _tmp141_ = NULL;
		GIdlNode* _tmp142_ = NULL;
		const gchar* _tmp143_ = NULL;
		_tmp141_ = self->priv->current_type_symbol_set;
		_tmp142_ = node;
		_tmp143_ = _tmp142_->name;
		vala_collection_add ((ValaCollection*) _tmp141_, _tmp143_);
	}
	_tmp144_ = node;
	_tmp145_ = _tmp144_->name;
	_tmp146_ = g_strdup (_tmp145_);
	field_name = _tmp146_;
	_tmp147_ = field_name;
	if (g_strcmp0 (_tmp147_, "string") == 0) {
		gchar* _tmp148_ = NULL;
		_tmp148_ = g_strdup ("str");
		_g_free0 (field_name);
		field_name = _tmp148_;
	}
	_tmp149_ = field_name;
	_tmp150_ = type;
	_tmp151_ = self->priv->current_source_reference;
	_tmp152_ = vala_field_new (_tmp149_, _tmp150_, NULL, _tmp151_, NULL);
	field = _tmp152_;
	_tmp153_ = field;
	vala_symbol_set_access ((ValaSymbol*) _tmp153_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	_tmp154_ = field_name;
	_tmp155_ = node;
	_tmp156_ = _tmp155_->name;
	if (g_strcmp0 (_tmp154_, _tmp156_) != 0) {
		ValaField* _tmp157_ = NULL;
		GIdlNode* _tmp158_ = NULL;
		const gchar* _tmp159_ = NULL;
		_tmp157_ = field;
		_tmp158_ = node;
		_tmp159_ = _tmp158_->name;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp157_, "CCode", "cname", _tmp159_, NULL);
	}
	_tmp160_ = deprecated;
	if (_tmp160_) {
		ValaField* _tmp161_ = NULL;
		const gchar* _tmp162_ = NULL;
		const gchar* _tmp165_ = NULL;
		_tmp161_ = field;
		vala_code_node_set_attribute ((ValaCodeNode*) _tmp161_, "Deprecated", TRUE, NULL);
		_tmp162_ = deprecated_since;
		if (_tmp162_ != NULL) {
			ValaField* _tmp163_ = NULL;
			const gchar* _tmp164_ = NULL;
			_tmp163_ = field;
			_tmp164_ = deprecated_since;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp163_, "Deprecated", "since", _tmp164_, NULL);
		}
		_tmp165_ = replacement;
		if (_tmp165_ != NULL) {
			ValaField* _tmp166_ = NULL;
			const gchar* _tmp167_ = NULL;
			_tmp166_ = field;
			_tmp167_ = replacement;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp166_, "Deprecated", "replacement", _tmp167_, NULL);
		}
	}
	_tmp168_ = experimental;
	if (_tmp168_) {
		ValaField* _tmp169_ = NULL;
		_tmp169_ = field;
		vala_code_node_set_attribute ((ValaCodeNode*) _tmp169_, "Experimental", TRUE, NULL);
	}
	_tmp170_ = ctype;
	if (_tmp170_ != NULL) {
		ValaField* _tmp171_ = NULL;
		const gchar* _tmp172_ = NULL;
		_tmp171_ = field;
		_tmp172_ = ctype;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp171_, "CCode", "type", _tmp172_, NULL);
	}
	_tmp173_ = cheader_filename;
	if (_tmp173_ != NULL) {
		ValaField* _tmp174_ = NULL;
		const gchar* _tmp175_ = NULL;
		_tmp174_ = field;
		_tmp175_ = cheader_filename;
		vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp174_, "CCode", "cheader_filename", _tmp175_, NULL);
	}
	_tmp176_ = array_null_terminated;
	if (_tmp176_) {
		ValaField* _tmp177_ = NULL;
		_tmp177_ = field;
		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp177_, "CCode", "array_null_terminated", TRUE, NULL);
	}
	_tmp179_ = array_length_cname;
	if (_tmp179_ != NULL) {
		_tmp178_ = TRUE;
	} else {
		const gchar* _tmp180_ = NULL;
		_tmp180_ = array_length_type;
		_tmp178_ = _tmp180_ != NULL;
	}
	_tmp181_ = _tmp178_;
	if (_tmp181_) {
		const gchar* _tmp182_ = NULL;
		const gchar* _tmp185_ = NULL;
		_tmp182_ = array_length_cname;
		if (_tmp182_ != NULL) {
			ValaField* _tmp183_ = NULL;
			const gchar* _tmp184_ = NULL;
			_tmp183_ = field;
			_tmp184_ = array_length_cname;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp183_, "CCode", "array_length_cname", _tmp184_, NULL);
		}
		_tmp185_ = array_length_type;
		if (_tmp185_ != NULL) {
			ValaField* _tmp186_ = NULL;
			const gchar* _tmp187_ = NULL;
			_tmp186_ = field;
			_tmp187_ = array_length_type;
			vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp186_, "CCode", "array_length_type", _tmp187_, NULL);
		}
	} else {
		ValaField* _tmp188_ = NULL;
		ValaDataType* _tmp189_ = NULL;
		ValaDataType* _tmp190_ = NULL;
		_tmp188_ = field;
		_tmp189_ = vala_variable_get_variable_type ((ValaVariable*) _tmp188_);
		_tmp190_ = _tmp189_;
		if (G_TYPE_CHECK_INSTANCE_TYPE (_tmp190_, VALA_TYPE_ARRAY_TYPE)) {
			ValaField* _tmp191_ = NULL;
			_tmp191_ = field;
			vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp191_, "CCode", "array_length", FALSE, NULL);
		}
	}
	_tmp192_ = no_delegate_target;
	if (_tmp192_) {
		ValaField* _tmp193_ = NULL;
		_tmp193_ = field;
		vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp193_, "CCode", "delegate_target", FALSE, NULL);
	}
	result = field;
	_g_free0 (field_name);
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (replacement);
	_g_free0 (deprecated_since);
	_g_free0 (array_length_type);
	_g_free0 (array_length_cname);
	_g_free0 (ctype);
	_g_free0 (cheader_filename);
	_vala_code_node_unref0 (type);
	return result;
}


static gint string_index_of_nth_char (const gchar* self, glong c) {
	gint result = 0;
	glong _tmp0_ = 0L;
	gchar* _tmp1_ = NULL;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = c;
	_tmp1_ = g_utf8_offset_to_pointer (self, _tmp0_);
	result = (gint) (_tmp1_ - ((gchar*) self));
	return result;
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_slist_free__g_free0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_free0_, NULL);
	g_slist_free (self);
}


static gchar** vala_gidl_parser_get_attributes (ValaGIdlParser* self, const gchar* codenode, int* result_length1) {
	gchar** result = NULL;
	gchar* attributes = NULL;
	ValaMap* _tmp0_ = NULL;
	const gchar* _tmp1_ = NULL;
	gpointer _tmp2_ = NULL;
	const gchar* _tmp3_ = NULL;
	const gchar* _tmp38_ = NULL;
	GSList* attr_list = NULL;
	GString* attr = NULL;
	const gchar* _tmp40_ = NULL;
	gint _tmp41_ = 0;
	gint _tmp42_ = 0;
	GString* _tmp43_ = NULL;
	gint attributes_len = 0;
	const gchar* _tmp44_ = NULL;
	gint _tmp45_ = 0;
	gint _tmp46_ = 0;
	const gchar* remaining = NULL;
	const gchar* _tmp47_ = NULL;
	gboolean quoted = FALSE;
	gboolean escaped = FALSE;
	GString* _tmp76_ = NULL;
	gssize _tmp77_ = 0L;
	gchar** attrs = NULL;
	GSList* _tmp81_ = NULL;
	guint _tmp82_ = 0U;
	gchar** _tmp83_ = NULL;
	gint attrs_length1 = 0;
	gint _attrs_size_ = 0;
	GSList* attr_i = NULL;
	GSList* _tmp84_ = NULL;
	gchar** _tmp99_ = NULL;
	gint _tmp99__length1 = 0;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (codenode != NULL, NULL);
	_tmp0_ = self->priv->codenode_attributes_map;
	_tmp1_ = codenode;
	_tmp2_ = vala_map_get (_tmp0_, _tmp1_);
	attributes = (gchar*) _tmp2_;
	_tmp3_ = attributes;
	if (_tmp3_ == NULL) {
		gboolean dot_required = FALSE;
		const gchar* _tmp4_ = NULL;
		gint _tmp5_ = 0;
		gboolean colon_required = FALSE;
		const gchar* _tmp6_ = NULL;
		gint _tmp7_ = 0;
		ValaSet* pattern_specs = NULL;
		ValaMap* _tmp8_ = NULL;
		ValaSet* _tmp9_ = NULL;
		_tmp4_ = codenode;
		_tmp5_ = string_index_of_char (_tmp4_, (gunichar) '.', 0);
		dot_required = (-1) != _tmp5_;
		_tmp6_ = codenode;
		_tmp7_ = string_index_of_char (_tmp6_, (gunichar) ':', 0);
		colon_required = (-1) != _tmp7_;
		_tmp8_ = self->priv->codenode_attributes_patterns;
		_tmp9_ = vala_map_get_keys (_tmp8_);
		pattern_specs = _tmp9_;
		{
			ValaIterator* _pattern_it = NULL;
			ValaSet* _tmp10_ = NULL;
			ValaIterator* _tmp11_ = NULL;
			_tmp10_ = pattern_specs;
			_tmp11_ = vala_iterable_iterator ((ValaIterable*) _tmp10_);
			_pattern_it = _tmp11_;
			while (TRUE) {
				ValaIterator* _tmp12_ = NULL;
				gboolean _tmp13_ = FALSE;
				GPatternSpec* pattern = NULL;
				ValaIterator* _tmp14_ = NULL;
				gpointer _tmp15_ = NULL;
				gchar* pspec = NULL;
				ValaMap* _tmp16_ = NULL;
				GPatternSpec* _tmp17_ = NULL;
				gpointer _tmp18_ = NULL;
				gboolean _tmp19_ = FALSE;
				gboolean _tmp20_ = FALSE;
				gboolean _tmp21_ = FALSE;
				gboolean _tmp24_ = FALSE;
				gboolean _tmp30_ = FALSE;
				GPatternSpec* _tmp31_ = NULL;
				const gchar* _tmp32_ = NULL;
				gboolean _tmp33_ = FALSE;
				_tmp12_ = _pattern_it;
				_tmp13_ = vala_iterator_next (_tmp12_);
				if (!_tmp13_) {
					break;
				}
				_tmp14_ = _pattern_it;
				_tmp15_ = vala_iterator_get (_tmp14_);
				pattern = _tmp15_;
				_tmp16_ = self->priv->codenode_attributes_patterns;
				_tmp17_ = pattern;
				_tmp18_ = vala_map_get (_tmp16_, _tmp17_);
				pspec = (gchar*) _tmp18_;
				_tmp21_ = dot_required;
				if (_tmp21_) {
					const gchar* _tmp22_ = NULL;
					gint _tmp23_ = 0;
					_tmp22_ = pspec;
					_tmp23_ = string_index_of_char (_tmp22_, (gunichar) '.', 0);
					_tmp20_ = (-1) == _tmp23_;
				} else {
					_tmp20_ = FALSE;
				}
				_tmp24_ = _tmp20_;
				if (_tmp24_) {
					_tmp19_ = TRUE;
				} else {
					gboolean _tmp25_ = FALSE;
					gboolean _tmp26_ = FALSE;
					gboolean _tmp29_ = FALSE;
					_tmp26_ = colon_required;
					if (_tmp26_) {
						const gchar* _tmp27_ = NULL;
						gint _tmp28_ = 0;
						_tmp27_ = pspec;
						_tmp28_ = string_index_of_char (_tmp27_, (gunichar) ':', 0);
						_tmp25_ = (-1) == _tmp28_;
					} else {
						_tmp25_ = FALSE;
					}
					_tmp29_ = _tmp25_;
					_tmp19_ = _tmp29_;
				}
				_tmp30_ = _tmp19_;
				if (_tmp30_) {
					_g_free0 (pspec);
					continue;
				}
				_tmp31_ = pattern;
				_tmp32_ = codenode;
				_tmp33_ = g_pattern_match_string (_tmp31_, _tmp32_);
				if (_tmp33_) {
					const gchar* _tmp34_ = NULL;
					gint _tmp35_ = 0;
					gchar** _tmp36_ = NULL;
					gchar** _tmp37_ = NULL;
					gint _tmp37__length1 = 0;
					_tmp34_ = pspec;
					_tmp36_ = vala_gidl_parser_get_attributes (self, _tmp34_, &_tmp35_);
					_tmp37_ = _tmp36_;
					_tmp37__length1 = _tmp35_;
					if (result_length1) {
						*result_length1 = _tmp37__length1;
					}
					result = _tmp37_;
					_g_free0 (pspec);
					_vala_iterator_unref0 (_pattern_it);
					_vala_iterable_unref0 (pattern_specs);
					_g_free0 (attributes);
					return result;
				}
				_g_free0 (pspec);
			}
			_vala_iterator_unref0 (_pattern_it);
		}
		_vala_iterable_unref0 (pattern_specs);
	}
	_tmp38_ = attributes;
	if (_tmp38_ == NULL) {
		gchar** _tmp39_ = NULL;
		gint _tmp39__length1 = 0;
		_tmp39_ = NULL;
		_tmp39__length1 = 0;
		if (result_length1) {
			*result_length1 = _tmp39__length1;
		}
		result = _tmp39_;
		_g_free0 (attributes);
		return result;
	}
	attr_list = NULL;
	_tmp40_ = attributes;
	_tmp41_ = strlen (_tmp40_);
	_tmp42_ = _tmp41_;
	_tmp43_ = g_string_sized_new ((gsize) _tmp42_);
	attr = _tmp43_;
	_tmp44_ = attributes;
	_tmp45_ = strlen (_tmp44_);
	_tmp46_ = _tmp45_;
	attributes_len = _tmp46_;
	_tmp47_ = attributes;
	remaining = _tmp47_;
	quoted = FALSE;
	escaped = FALSE;
	{
		gint b = 0;
		b = 0;
		{
			gboolean _tmp48_ = FALSE;
			_tmp48_ = TRUE;
			while (TRUE) {
				gboolean _tmp49_ = FALSE;
				gint _tmp51_ = 0;
				gint _tmp52_ = 0;
				gunichar c = 0U;
				const gchar* _tmp53_ = NULL;
				gunichar _tmp54_ = 0U;
				gboolean _tmp55_ = FALSE;
				const gchar* _tmp73_ = NULL;
				const gchar* _tmp74_ = NULL;
				gint _tmp75_ = 0;
				_tmp49_ = _tmp48_;
				if (!_tmp49_) {
					gint _tmp50_ = 0;
					_tmp50_ = b;
					b = _tmp50_ + 1;
				}
				_tmp48_ = FALSE;
				_tmp51_ = b;
				_tmp52_ = attributes_len;
				if (!(_tmp51_ < _tmp52_)) {
					break;
				}
				_tmp53_ = remaining;
				_tmp54_ = string_get_char (_tmp53_, (glong) 0);
				c = _tmp54_;
				_tmp55_ = escaped;
				if (_tmp55_) {
					GString* _tmp56_ = NULL;
					gunichar _tmp57_ = 0U;
					escaped = FALSE;
					_tmp56_ = attr;
					_tmp57_ = c;
					g_string_append_unichar (_tmp56_, _tmp57_);
				} else {
					gunichar _tmp58_ = 0U;
					_tmp58_ = c;
					if (_tmp58_ == ((gunichar) '"')) {
						GString* _tmp59_ = NULL;
						gunichar _tmp60_ = 0U;
						gboolean _tmp61_ = FALSE;
						_tmp59_ = attr;
						_tmp60_ = c;
						g_string_append_unichar (_tmp59_, _tmp60_);
						_tmp61_ = quoted;
						quoted = !_tmp61_;
					} else {
						gunichar _tmp62_ = 0U;
						_tmp62_ = c;
						if (_tmp62_ == ((gunichar) '\\')) {
							escaped = TRUE;
						} else {
							gboolean _tmp63_ = FALSE;
							gboolean _tmp64_ = FALSE;
							gboolean _tmp66_ = FALSE;
							_tmp64_ = quoted;
							if (!_tmp64_) {
								gunichar _tmp65_ = 0U;
								_tmp65_ = c;
								_tmp63_ = _tmp65_ == ((gunichar) ' ');
							} else {
								_tmp63_ = FALSE;
							}
							_tmp66_ = _tmp63_;
							if (_tmp66_) {
								GString* _tmp67_ = NULL;
								const gchar* _tmp68_ = NULL;
								gchar* _tmp69_ = NULL;
								GString* _tmp70_ = NULL;
								_tmp67_ = attr;
								_tmp68_ = _tmp67_->str;
								_tmp69_ = g_strdup (_tmp68_);
								attr_list = g_slist_prepend (attr_list, _tmp69_);
								_tmp70_ = attr;
								g_string_truncate (_tmp70_, (gsize) 0);
							} else {
								GString* _tmp71_ = NULL;
								gunichar _tmp72_ = 0U;
								_tmp71_ = attr;
								_tmp72_ = c;
								g_string_append_unichar (_tmp71_, _tmp72_);
							}
						}
					}
				}
				_tmp73_ = remaining;
				_tmp74_ = remaining;
				_tmp75_ = string_index_of_nth_char (_tmp74_, (glong) 1);
				remaining = (const gchar*) (((gchar*) _tmp73_) + _tmp75_);
			}
		}
	}
	_tmp76_ = attr;
	_tmp77_ = _tmp76_->len;
	if (_tmp77_ > ((gssize) 0)) {
		GString* _tmp78_ = NULL;
		const gchar* _tmp79_ = NULL;
		gchar* _tmp80_ = NULL;
		_tmp78_ = attr;
		_tmp79_ = _tmp78_->str;
		_tmp80_ = g_strdup (_tmp79_);
		attr_list = g_slist_prepend (attr_list, _tmp80_);
	}
	_tmp81_ = attr_list;
	_tmp82_ = g_slist_length (_tmp81_);
	_tmp83_ = g_new0 (gchar*, _tmp82_ + 1);
	attrs = _tmp83_;
	attrs_length1 = _tmp82_;
	_attrs_size_ = attrs_length1;
	_tmp84_ = attr_list;
	attr_i = _tmp84_;
	{
		gint a = 0;
		a = 0;
		{
			gboolean _tmp85_ = FALSE;
			_tmp85_ = TRUE;
			while (TRUE) {
				gboolean _tmp86_ = FALSE;
				gint _tmp90_ = 0;
				gchar** _tmp91_ = NULL;
				gint _tmp91__length1 = 0;
				gchar** _tmp92_ = NULL;
				gint _tmp92__length1 = 0;
				gchar** _tmp93_ = NULL;
				gint _tmp93__length1 = 0;
				gint _tmp94_ = 0;
				GSList* _tmp95_ = NULL;
				gconstpointer _tmp96_ = NULL;
				gchar* _tmp97_ = NULL;
				gchar* _tmp98_ = NULL;
				_tmp86_ = _tmp85_;
				if (!_tmp86_) {
					gint _tmp87_ = 0;
					GSList* _tmp88_ = NULL;
					GSList* _tmp89_ = NULL;
					_tmp87_ = a;
					a = _tmp87_ + 1;
					_tmp88_ = attr_i;
					_tmp89_ = _tmp88_->next;
					attr_i = _tmp89_;
				}
				_tmp85_ = FALSE;
				_tmp90_ = a;
				_tmp91_ = attrs;
				_tmp91__length1 = attrs_length1;
				if (!(_tmp90_ < _tmp91__length1)) {
					break;
				}
				_tmp92_ = attrs;
				_tmp92__length1 = attrs_length1;
				_tmp93_ = attrs;
				_tmp93__length1 = attrs_length1;
				_tmp94_ = a;
				_tmp95_ = attr_i;
				_tmp96_ = _tmp95_->data;
				_tmp97_ = g_strdup ((const gchar*) _tmp96_);
				_g_free0 (_tmp92_[(_tmp93__length1 - 1) - _tmp94_]);
				_tmp92_[(_tmp93__length1 - 1) - _tmp94_] = _tmp97_;
				_tmp98_ = _tmp92_[(_tmp93__length1 - 1) - _tmp94_];
			}
		}
	}
	_tmp99_ = attrs;
	_tmp99__length1 = attrs_length1;
	if (result_length1) {
		*result_length1 = _tmp99__length1;
	}
	result = _tmp99_;
	_g_string_free0 (attr);
	__g_slist_free__g_free0_0 (attr_list);
	_g_free0 (attributes);
	return result;
}


static gchar* vala_gidl_parser_eval (ValaGIdlParser* self, const gchar* s) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_ = NULL;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp11_ = FALSE;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (s != NULL, NULL);
	_tmp3_ = s;
	_tmp4_ = strlen (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_ >= 2) {
		const gchar* _tmp6_ = NULL;
		gboolean _tmp7_ = FALSE;
		_tmp6_ = s;
		_tmp7_ = g_str_has_prefix (_tmp6_, "\"");
		_tmp2_ = _tmp7_;
	} else {
		_tmp2_ = FALSE;
	}
	_tmp8_ = _tmp2_;
	if (_tmp8_) {
		const gchar* _tmp9_ = NULL;
		gboolean _tmp10_ = FALSE;
		_tmp9_ = s;
		_tmp10_ = g_str_has_suffix (_tmp9_, "\"");
		_tmp1_ = _tmp10_;
	} else {
		_tmp1_ = FALSE;
	}
	_tmp11_ = _tmp1_;
	if (_tmp11_) {
		const gchar* _tmp12_ = NULL;
		const gchar* _tmp13_ = NULL;
		gint _tmp14_ = 0;
		gint _tmp15_ = 0;
		gchar* _tmp16_ = NULL;
		_tmp12_ = s;
		_tmp13_ = s;
		_tmp14_ = strlen (_tmp13_);
		_tmp15_ = _tmp14_;
		_tmp16_ = string_substring (_tmp12_, (glong) 1, (glong) (_tmp15_ - 2));
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp16_;
	} else {
		const gchar* _tmp17_ = NULL;
		gchar* _tmp18_ = NULL;
		_tmp17_ = s;
		_tmp18_ = g_strdup (_tmp17_);
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp18_;
	}
	result = _tmp0_;
	return result;
}


static ValaSignal* vala_gidl_parser_parse_signal (ValaGIdlParser* self, GIdlNodeSignal* sig_node) {
	ValaSignal* result = NULL;
	GIdlNode* node = NULL;
	GIdlNodeSignal* _tmp0_ = NULL;
	gboolean _tmp1_ = FALSE;
	GIdlNodeSignal* _tmp2_ = NULL;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp6_ = FALSE;
	ValaSignal* sig = NULL;
	GIdlNode* _tmp7_ = NULL;
	const gchar* _tmp8_ = NULL;
	gchar* _tmp9_ = NULL;
	gchar* _tmp10_ = NULL;
	GIdlNodeSignal* _tmp11_ = NULL;
	GIdlNodeParam* _tmp12_ = NULL;
	ValaDataType* _tmp13_ = NULL;
	ValaDataType* _tmp14_ = NULL;
	ValaSourceReference* _tmp15_ = NULL;
	ValaSignal* _tmp16_ = NULL;
	ValaSignal* _tmp17_ = NULL;
	ValaSignal* _tmp18_ = NULL;
	gchar** attributes = NULL;
	ValaTypeSymbol* _tmp19_ = NULL;
	gchar* _tmp20_ = NULL;
	gchar* _tmp21_ = NULL;
	ValaSignal* _tmp22_ = NULL;
	const gchar* _tmp23_ = NULL;
	const gchar* _tmp24_ = NULL;
	gchar* _tmp25_ = NULL;
	gchar* _tmp26_ = NULL;
	gint _tmp27_ = 0;
	gchar** _tmp28_ = NULL;
	gchar** _tmp29_ = NULL;
	gint _tmp29__length1 = 0;
	gint attributes_length1 = 0;
	gint _attributes_size_ = 0;
	gchar** _tmp30_ = NULL;
	gint _tmp30__length1 = 0;
	ValaSignal* _tmp135_ = NULL;
	gboolean first = FALSE;
	GIdlNodeSignal* _tmp136_ = NULL;
	GList* _tmp137_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (sig_node != NULL, NULL);
	_tmp0_ = sig_node;
	node = (GIdlNode*) _tmp0_;
	_tmp2_ = sig_node;
	_tmp3_ = _tmp2_->deprecated;
	if (_tmp3_) {
		_tmp1_ = TRUE;
	} else {
		GIdlNodeSignal* _tmp4_ = NULL;
		GIdlNodeParam* _tmp5_ = NULL;
		_tmp4_ = sig_node;
		_tmp5_ = _tmp4_->result;
		_tmp1_ = _tmp5_ == NULL;
	}
	_tmp6_ = _tmp1_;
	if (_tmp6_) {
		result = NULL;
		return result;
	}
	_tmp7_ = node;
	_tmp8_ = _tmp7_->name;
	_tmp9_ = vala_gidl_parser_fix_prop_name (self, _tmp8_);
	_tmp10_ = _tmp9_;
	_tmp11_ = sig_node;
	_tmp12_ = _tmp11_->result;
	_tmp13_ = vala_gidl_parser_parse_param (self, _tmp12_, NULL);
	_tmp14_ = _tmp13_;
	_tmp15_ = self->priv->current_source_reference;
	_tmp16_ = vala_signal_new (_tmp10_, _tmp14_, _tmp15_, NULL);
	_tmp17_ = _tmp16_;
	_vala_code_node_unref0 (_tmp14_);
	_g_free0 (_tmp10_);
	sig = _tmp17_;
	_tmp18_ = sig;
	vala_symbol_set_access ((ValaSymbol*) _tmp18_, VALA_SYMBOL_ACCESSIBILITY_PUBLIC);
	_tmp19_ = self->priv->current_data_type;
	_tmp20_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp19_, NULL);
	_tmp21_ = _tmp20_;
	_tmp22_ = sig;
	_tmp23_ = vala_symbol_get_name ((ValaSymbol*) _tmp22_);
	_tmp24_ = _tmp23_;
	_tmp25_ = g_strdup_printf ("%s::%s", _tmp21_, _tmp24_);
	_tmp26_ = _tmp25_;
	_tmp28_ = vala_gidl_parser_get_attributes (self, _tmp26_, &_tmp27_);
	_tmp29_ = _tmp28_;
	_tmp29__length1 = _tmp27_;
	_g_free0 (_tmp26_);
	_g_free0 (_tmp21_);
	attributes = _tmp29_;
	attributes_length1 = _tmp29__length1;
	_attributes_size_ = attributes_length1;
	_tmp30_ = attributes;
	_tmp30__length1 = attributes_length1;
	if (_tmp30_ != NULL) {
		gchar* ns_name = NULL;
		gchar** _tmp31_ = NULL;
		gint _tmp31__length1 = 0;
		const gchar* _tmp126_ = NULL;
		ns_name = NULL;
		_tmp31_ = attributes;
		_tmp31__length1 = attributes_length1;
		{
			gchar** attr_collection = NULL;
			gint attr_collection_length1 = 0;
			gint _attr_collection_size_ = 0;
			gint attr_it = 0;
			attr_collection = _tmp31_;
			attr_collection_length1 = _tmp31__length1;
			for (attr_it = 0; attr_it < _tmp31__length1; attr_it = attr_it + 1) {
				gchar* _tmp32_ = NULL;
				gchar* attr = NULL;
				_tmp32_ = g_strdup (attr_collection[attr_it]);
				attr = _tmp32_;
				{
					gchar** nv = NULL;
					const gchar* _tmp33_ = NULL;
					gchar** _tmp34_ = NULL;
					gchar** _tmp35_ = NULL;
					gint nv_length1 = 0;
					gint _nv_size_ = 0;
					gchar** _tmp36_ = NULL;
					gint _tmp36__length1 = 0;
					const gchar* _tmp37_ = NULL;
					_tmp33_ = attr;
					_tmp35_ = _tmp34_ = g_strsplit (_tmp33_, "=", 2);
					nv = _tmp35_;
					nv_length1 = _vala_array_length (_tmp34_);
					_nv_size_ = nv_length1;
					_tmp36_ = nv;
					_tmp36__length1 = nv_length1;
					_tmp37_ = _tmp36_[0];
					if (g_strcmp0 (_tmp37_, "name") == 0) {
						ValaSignal* _tmp38_ = NULL;
						ValaSignal* _tmp39_ = NULL;
						const gchar* _tmp40_ = NULL;
						const gchar* _tmp41_ = NULL;
						ValaSignal* _tmp42_ = NULL;
						gchar** _tmp43_ = NULL;
						gint _tmp43__length1 = 0;
						const gchar* _tmp44_ = NULL;
						gchar* _tmp45_ = NULL;
						gchar* _tmp46_ = NULL;
						_tmp38_ = sig;
						_tmp39_ = sig;
						_tmp40_ = vala_symbol_get_name ((ValaSymbol*) _tmp39_);
						_tmp41_ = _tmp40_;
						vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp38_, "CCode", "cname", _tmp41_, NULL);
						_tmp42_ = sig;
						_tmp43_ = nv;
						_tmp43__length1 = nv_length1;
						_tmp44_ = _tmp43_[1];
						_tmp45_ = vala_gidl_parser_eval (self, _tmp44_);
						_tmp46_ = _tmp45_;
						vala_symbol_set_name ((ValaSymbol*) _tmp42_, _tmp46_);
						_g_free0 (_tmp46_);
					} else {
						gboolean _tmp47_ = FALSE;
						gchar** _tmp48_ = NULL;
						gint _tmp48__length1 = 0;
						const gchar* _tmp49_ = NULL;
						gboolean _tmp54_ = FALSE;
						_tmp48_ = nv;
						_tmp48__length1 = nv_length1;
						_tmp49_ = _tmp48_[0];
						if (g_strcmp0 (_tmp49_, "has_emitter") == 0) {
							gchar** _tmp50_ = NULL;
							gint _tmp50__length1 = 0;
							const gchar* _tmp51_ = NULL;
							gchar* _tmp52_ = NULL;
							gchar* _tmp53_ = NULL;
							_tmp50_ = nv;
							_tmp50__length1 = nv_length1;
							_tmp51_ = _tmp50_[1];
							_tmp52_ = vala_gidl_parser_eval (self, _tmp51_);
							_tmp53_ = _tmp52_;
							_tmp47_ = g_strcmp0 (_tmp53_, "1") == 0;
							_g_free0 (_tmp53_);
						} else {
							_tmp47_ = FALSE;
						}
						_tmp54_ = _tmp47_;
						if (_tmp54_) {
							ValaSignal* _tmp55_ = NULL;
							_tmp55_ = sig;
							vala_code_node_set_attribute ((ValaCodeNode*) _tmp55_, "HasEmitter", TRUE, NULL);
						} else {
							gchar** _tmp56_ = NULL;
							gint _tmp56__length1 = 0;
							const gchar* _tmp57_ = NULL;
							_tmp56_ = nv;
							_tmp56__length1 = nv_length1;
							_tmp57_ = _tmp56_[0];
							if (g_strcmp0 (_tmp57_, "hidden") == 0) {
								gchar** _tmp58_ = NULL;
								gint _tmp58__length1 = 0;
								const gchar* _tmp59_ = NULL;
								gchar* _tmp60_ = NULL;
								gchar* _tmp61_ = NULL;
								gboolean _tmp62_ = FALSE;
								_tmp58_ = nv;
								_tmp58__length1 = nv_length1;
								_tmp59_ = _tmp58_[1];
								_tmp60_ = vala_gidl_parser_eval (self, _tmp59_);
								_tmp61_ = _tmp60_;
								_tmp62_ = g_strcmp0 (_tmp61_, "1") == 0;
								_g_free0 (_tmp61_);
								if (_tmp62_) {
									result = NULL;
									nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
									_g_free0 (attr);
									_g_free0 (ns_name);
									attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
									_vala_code_node_unref0 (sig);
									return result;
								}
							} else {
								gchar** _tmp63_ = NULL;
								gint _tmp63__length1 = 0;
								const gchar* _tmp64_ = NULL;
								_tmp63_ = nv;
								_tmp63__length1 = nv_length1;
								_tmp64_ = _tmp63_[0];
								if (g_strcmp0 (_tmp64_, "deprecated") == 0) {
									gchar** _tmp65_ = NULL;
									gint _tmp65__length1 = 0;
									const gchar* _tmp66_ = NULL;
									gchar* _tmp67_ = NULL;
									gchar* _tmp68_ = NULL;
									gboolean _tmp69_ = FALSE;
									_tmp65_ = nv;
									_tmp65__length1 = nv_length1;
									_tmp66_ = _tmp65_[1];
									_tmp67_ = vala_gidl_parser_eval (self, _tmp66_);
									_tmp68_ = _tmp67_;
									_tmp69_ = g_strcmp0 (_tmp68_, "1") == 0;
									_g_free0 (_tmp68_);
									if (_tmp69_) {
										ValaSignal* _tmp70_ = NULL;
										_tmp70_ = sig;
										vala_code_node_set_attribute ((ValaCodeNode*) _tmp70_, "Deprecated", TRUE, NULL);
									}
								} else {
									gchar** _tmp71_ = NULL;
									gint _tmp71__length1 = 0;
									const gchar* _tmp72_ = NULL;
									_tmp71_ = nv;
									_tmp71__length1 = nv_length1;
									_tmp72_ = _tmp71_[0];
									if (g_strcmp0 (_tmp72_, "replacement") == 0) {
										ValaSignal* _tmp73_ = NULL;
										gchar** _tmp74_ = NULL;
										gint _tmp74__length1 = 0;
										const gchar* _tmp75_ = NULL;
										gchar* _tmp76_ = NULL;
										gchar* _tmp77_ = NULL;
										_tmp73_ = sig;
										_tmp74_ = nv;
										_tmp74__length1 = nv_length1;
										_tmp75_ = _tmp74_[1];
										_tmp76_ = vala_gidl_parser_eval (self, _tmp75_);
										_tmp77_ = _tmp76_;
										vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp73_, "Deprecated", "replacement", _tmp77_, NULL);
										_g_free0 (_tmp77_);
									} else {
										gchar** _tmp78_ = NULL;
										gint _tmp78__length1 = 0;
										const gchar* _tmp79_ = NULL;
										_tmp78_ = nv;
										_tmp78__length1 = nv_length1;
										_tmp79_ = _tmp78_[0];
										if (g_strcmp0 (_tmp79_, "deprecated_since") == 0) {
											ValaSignal* _tmp80_ = NULL;
											gchar** _tmp81_ = NULL;
											gint _tmp81__length1 = 0;
											const gchar* _tmp82_ = NULL;
											gchar* _tmp83_ = NULL;
											gchar* _tmp84_ = NULL;
											_tmp80_ = sig;
											_tmp81_ = nv;
											_tmp81__length1 = nv_length1;
											_tmp82_ = _tmp81_[1];
											_tmp83_ = vala_gidl_parser_eval (self, _tmp82_);
											_tmp84_ = _tmp83_;
											vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp80_, "Deprecated", "since", _tmp84_, NULL);
											_g_free0 (_tmp84_);
										} else {
											gchar** _tmp85_ = NULL;
											gint _tmp85__length1 = 0;
											const gchar* _tmp86_ = NULL;
											_tmp85_ = nv;
											_tmp85__length1 = nv_length1;
											_tmp86_ = _tmp85_[0];
											if (g_strcmp0 (_tmp86_, "transfer_ownership") == 0) {
												gchar** _tmp87_ = NULL;
												gint _tmp87__length1 = 0;
												const gchar* _tmp88_ = NULL;
												gchar* _tmp89_ = NULL;
												gchar* _tmp90_ = NULL;
												gboolean _tmp91_ = FALSE;
												_tmp87_ = nv;
												_tmp87__length1 = nv_length1;
												_tmp88_ = _tmp87_[1];
												_tmp89_ = vala_gidl_parser_eval (self, _tmp88_);
												_tmp90_ = _tmp89_;
												_tmp91_ = g_strcmp0 (_tmp90_, "1") == 0;
												_g_free0 (_tmp90_);
												if (_tmp91_) {
													ValaSignal* _tmp92_ = NULL;
													ValaDataType* _tmp93_ = NULL;
													ValaDataType* _tmp94_ = NULL;
													_tmp92_ = sig;
													_tmp93_ = vala_signal_get_return_type (_tmp92_);
													_tmp94_ = _tmp93_;
													vala_data_type_set_value_owned (_tmp94_, TRUE);
												}
											} else {
												gchar** _tmp95_ = NULL;
												gint _tmp95__length1 = 0;
												const gchar* _tmp96_ = NULL;
												_tmp95_ = nv;
												_tmp95__length1 = nv_length1;
												_tmp96_ = _tmp95_[0];
												if (g_strcmp0 (_tmp96_, "namespace_name") == 0) {
													gchar** _tmp97_ = NULL;
													gint _tmp97__length1 = 0;
													const gchar* _tmp98_ = NULL;
													gchar* _tmp99_ = NULL;
													_tmp97_ = nv;
													_tmp97__length1 = nv_length1;
													_tmp98_ = _tmp97_[1];
													_tmp99_ = vala_gidl_parser_eval (self, _tmp98_);
													_g_free0 (ns_name);
													ns_name = _tmp99_;
												} else {
													gchar** _tmp100_ = NULL;
													gint _tmp100__length1 = 0;
													const gchar* _tmp101_ = NULL;
													_tmp100_ = nv;
													_tmp100__length1 = nv_length1;
													_tmp101_ = _tmp100_[0];
													if (g_strcmp0 (_tmp101_, "type_name") == 0) {
														ValaSignal* _tmp102_ = NULL;
														gchar** _tmp103_ = NULL;
														gint _tmp103__length1 = 0;
														const gchar* _tmp104_ = NULL;
														gchar* _tmp105_ = NULL;
														gchar* _tmp106_ = NULL;
														ValaDataType* _tmp107_ = NULL;
														ValaDataType* _tmp108_ = NULL;
														_tmp102_ = sig;
														_tmp103_ = nv;
														_tmp103__length1 = nv_length1;
														_tmp104_ = _tmp103_[1];
														_tmp105_ = vala_gidl_parser_eval (self, _tmp104_);
														_tmp106_ = _tmp105_;
														_tmp107_ = vala_gidl_parser_parse_type_from_string (self, _tmp106_, FALSE, NULL);
														_tmp108_ = _tmp107_;
														vala_signal_set_return_type (_tmp102_, _tmp108_);
														_vala_code_node_unref0 (_tmp108_);
														_g_free0 (_tmp106_);
													} else {
														gchar** _tmp109_ = NULL;
														gint _tmp109__length1 = 0;
														const gchar* _tmp110_ = NULL;
														_tmp109_ = nv;
														_tmp109__length1 = nv_length1;
														_tmp110_ = _tmp109_[0];
														if (g_strcmp0 (_tmp110_, "type_arguments") == 0) {
															ValaSignal* _tmp111_ = NULL;
															ValaDataType* _tmp112_ = NULL;
															ValaDataType* _tmp113_ = NULL;
															gchar** _tmp114_ = NULL;
															gint _tmp114__length1 = 0;
															const gchar* _tmp115_ = NULL;
															gchar* _tmp116_ = NULL;
															gchar* _tmp117_ = NULL;
															_tmp111_ = sig;
															_tmp112_ = vala_signal_get_return_type (_tmp111_);
															_tmp113_ = _tmp112_;
															_tmp114_ = nv;
															_tmp114__length1 = nv_length1;
															_tmp115_ = _tmp114_[1];
															_tmp116_ = vala_gidl_parser_eval (self, _tmp115_);
															_tmp117_ = _tmp116_;
															vala_gidl_parser_parse_type_arguments_from_string (self, _tmp113_, _tmp117_, NULL);
															_g_free0 (_tmp117_);
														} else {
															gchar** _tmp118_ = NULL;
															gint _tmp118__length1 = 0;
															const gchar* _tmp119_ = NULL;
															_tmp118_ = nv;
															_tmp118__length1 = nv_length1;
															_tmp119_ = _tmp118_[0];
															if (g_strcmp0 (_tmp119_, "experimental") == 0) {
																gchar** _tmp120_ = NULL;
																gint _tmp120__length1 = 0;
																const gchar* _tmp121_ = NULL;
																gchar* _tmp122_ = NULL;
																gchar* _tmp123_ = NULL;
																gboolean _tmp124_ = FALSE;
																_tmp120_ = nv;
																_tmp120__length1 = nv_length1;
																_tmp121_ = _tmp120_[1];
																_tmp122_ = vala_gidl_parser_eval (self, _tmp121_);
																_tmp123_ = _tmp122_;
																_tmp124_ = g_strcmp0 (_tmp123_, "1") == 0;
																_g_free0 (_tmp123_);
																if (_tmp124_) {
																	ValaSignal* _tmp125_ = NULL;
																	_tmp125_ = sig;
																	vala_code_node_set_attribute ((ValaCodeNode*) _tmp125_, "Experimental", TRUE, NULL);
																}
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
					nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (attr);
				}
			}
		}
		_tmp126_ = ns_name;
		if (_tmp126_ != NULL) {
			ValaSignal* _tmp127_ = NULL;
			ValaDataType* _tmp128_ = NULL;
			ValaDataType* _tmp129_ = NULL;
			ValaUnresolvedSymbol* _tmp130_ = NULL;
			ValaUnresolvedSymbol* _tmp131_ = NULL;
			const gchar* _tmp132_ = NULL;
			ValaUnresolvedSymbol* _tmp133_ = NULL;
			ValaUnresolvedSymbol* _tmp134_ = NULL;
			_tmp127_ = sig;
			_tmp128_ = vala_signal_get_return_type (_tmp127_);
			_tmp129_ = _tmp128_;
			_tmp130_ = vala_unresolved_type_get_unresolved_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp129_, VALA_TYPE_UNRESOLVED_TYPE, ValaUnresolvedType));
			_tmp131_ = _tmp130_;
			_tmp132_ = ns_name;
			_tmp133_ = vala_unresolved_symbol_new (NULL, _tmp132_, NULL);
			_tmp134_ = _tmp133_;
			vala_unresolved_symbol_set_inner (_tmp131_, _tmp134_);
			_vala_code_node_unref0 (_tmp134_);
		}
		_g_free0 (ns_name);
	}
	_tmp135_ = sig;
	vala_signal_set_is_virtual (_tmp135_, TRUE);
	first = TRUE;
	_tmp136_ = sig_node;
	_tmp137_ = _tmp136_->parameters;
	{
		GList* param_collection = NULL;
		GList* param_it = NULL;
		param_collection = _tmp137_;
		for (param_it = param_collection; param_it != NULL; param_it = param_it->next) {
			GIdlNodeParam* param = NULL;
			param = (GIdlNodeParam*) param_it->data;
			{
				gboolean _tmp138_ = FALSE;
				GIdlNode* param_node = NULL;
				GIdlNodeParam* _tmp139_ = NULL;
				ValaParameterDirection direction = 0;
				ValaDataType* param_type = NULL;
				GIdlNodeParam* _tmp140_ = NULL;
				ValaParameterDirection _tmp141_ = 0;
				ValaDataType* _tmp142_ = NULL;
				ValaParameter* p = NULL;
				GIdlNode* _tmp143_ = NULL;
				const gchar* _tmp144_ = NULL;
				ValaDataType* _tmp145_ = NULL;
				ValaParameter* _tmp146_ = NULL;
				ValaParameter* _tmp147_ = NULL;
				ValaParameterDirection _tmp148_ = 0;
				gboolean hide_param = FALSE;
				gboolean show_param = FALSE;
				ValaTypeSymbol* _tmp149_ = NULL;
				gchar* _tmp150_ = NULL;
				gchar* _tmp151_ = NULL;
				ValaSignal* _tmp152_ = NULL;
				const gchar* _tmp153_ = NULL;
				const gchar* _tmp154_ = NULL;
				GIdlNode* _tmp155_ = NULL;
				const gchar* _tmp156_ = NULL;
				gchar* _tmp157_ = NULL;
				gchar* _tmp158_ = NULL;
				gint _tmp159_ = 0;
				gchar** _tmp160_ = NULL;
				gchar** _tmp161_ = NULL;
				gint _tmp161__length1 = 0;
				gboolean _tmp278_ = FALSE;
				gboolean _tmp279_ = FALSE;
				gboolean _tmp281_ = FALSE;
				_tmp138_ = first;
				if (_tmp138_) {
					first = FALSE;
					continue;
				}
				_tmp139_ = param;
				param_node = (GIdlNode*) _tmp139_;
				_tmp140_ = param;
				_tmp142_ = vala_gidl_parser_parse_param (self, _tmp140_, &_tmp141_);
				direction = _tmp141_;
				param_type = _tmp142_;
				_tmp143_ = param_node;
				_tmp144_ = _tmp143_->name;
				_tmp145_ = param_type;
				_tmp146_ = vala_parameter_new (_tmp144_, _tmp145_, NULL);
				p = _tmp146_;
				_tmp147_ = p;
				_tmp148_ = direction;
				vala_parameter_set_direction (_tmp147_, _tmp148_);
				hide_param = FALSE;
				show_param = FALSE;
				_tmp149_ = self->priv->current_data_type;
				_tmp150_ = vala_gidl_parser_get_cname (self, (ValaSymbol*) _tmp149_, NULL);
				_tmp151_ = _tmp150_;
				_tmp152_ = sig;
				_tmp153_ = vala_symbol_get_name ((ValaSymbol*) _tmp152_);
				_tmp154_ = _tmp153_;
				_tmp155_ = param_node;
				_tmp156_ = _tmp155_->name;
				_tmp157_ = g_strdup_printf ("%s::%s.%s", _tmp151_, _tmp154_, _tmp156_);
				_tmp158_ = _tmp157_;
				_tmp160_ = vala_gidl_parser_get_attributes (self, _tmp158_, &_tmp159_);
				attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
				attributes = _tmp160_;
				attributes_length1 = _tmp159_;
				_attributes_size_ = attributes_length1;
				_g_free0 (_tmp158_);
				_g_free0 (_tmp151_);
				_tmp161_ = attributes;
				_tmp161__length1 = attributes_length1;
				if (_tmp161_ != NULL) {
					gchar* ns_name = NULL;
					gchar** _tmp162_ = NULL;
					gint _tmp162__length1 = 0;
					const gchar* _tmp271_ = NULL;
					ns_name = NULL;
					_tmp162_ = attributes;
					_tmp162__length1 = attributes_length1;
					{
						gchar** attr_collection = NULL;
						gint attr_collection_length1 = 0;
						gint _attr_collection_size_ = 0;
						gint attr_it = 0;
						attr_collection = _tmp162_;
						attr_collection_length1 = _tmp162__length1;
						for (attr_it = 0; attr_it < _tmp162__length1; attr_it = attr_it + 1) {
							gchar* _tmp163_ = NULL;
							gchar* attr = NULL;
							_tmp163_ = g_strdup (attr_collection[attr_it]);
							attr = _tmp163_;
							{
								gchar** nv = NULL;
								const gchar* _tmp164_ = NULL;
								gchar** _tmp165_ = NULL;
								gchar** _tmp166_ = NULL;
								gint nv_length1 = 0;
								gint _nv_size_ = 0;
								gchar** _tmp167_ = NULL;
								gint _tmp167__length1 = 0;
								const gchar* _tmp168_ = NULL;
								_tmp164_ = attr;
								_tmp166_ = _tmp165_ = g_strsplit (_tmp164_, "=", 2);
								nv = _tmp166_;
								nv_length1 = _vala_array_length (_tmp165_);
								_nv_size_ = nv_length1;
								_tmp167_ = nv;
								_tmp167__length1 = nv_length1;
								_tmp168_ = _tmp167_[0];
								if (g_strcmp0 (_tmp168_, "hidden") == 0) {
									gchar** _tmp169_ = NULL;
									gint _tmp169__length1 = 0;
									const gchar* _tmp170_ = NULL;
									gchar* _tmp171_ = NULL;
									gchar* _tmp172_ = NULL;
									gboolean _tmp173_ = FALSE;
									_tmp169_ = nv;
									_tmp169__length1 = nv_length1;
									_tmp170_ = _tmp169_[1];
									_tmp171_ = vala_gidl_parser_eval (self, _tmp170_);
									_tmp172_ = _tmp171_;
									_tmp173_ = g_strcmp0 (_tmp172_, "1") == 0;
									_g_free0 (_tmp172_);
									if (_tmp173_) {
										hide_param = TRUE;
									} else {
										gchar** _tmp174_ = NULL;
										gint _tmp174__length1 = 0;
										const gchar* _tmp175_ = NULL;
										gchar* _tmp176_ = NULL;
										gchar* _tmp177_ = NULL;
										gboolean _tmp178_ = FALSE;
										_tmp174_ = nv;
										_tmp174__length1 = nv_length1;
										_tmp175_ = _tmp174_[1];
										_tmp176_ = vala_gidl_parser_eval (self, _tmp175_);
										_tmp177_ = _tmp176_;
										_tmp178_ = g_strcmp0 (_tmp177_, "0") == 0;
										_g_free0 (_tmp177_);
										if (_tmp178_) {
											show_param = TRUE;
										}
									}
								} else {
									gchar** _tmp179_ = NULL;
									gint _tmp179__length1 = 0;
									const gchar* _tmp180_ = NULL;
									_tmp179_ = nv;
									_tmp179__length1 = nv_length1;
									_tmp180_ = _tmp179_[0];
									if (g_strcmp0 (_tmp180_, "is_array") == 0) {
										gchar** _tmp181_ = NULL;
										gint _tmp181__length1 = 0;
										const gchar* _tmp182_ = NULL;
										gchar* _tmp183_ = NULL;
										gchar* _tmp184_ = NULL;
										gboolean _tmp185_ = FALSE;
										_tmp181_ = nv;
										_tmp181__length1 = nv_length1;
										_tmp182_ = _tmp181_[1];
										_tmp183_ = vala_gidl_parser_eval (self, _tmp182_);
										_tmp184_ = _tmp183_;
										_tmp185_ = g_strcmp0 (_tmp184_, "1") == 0;
										_g_free0 (_tmp184_);
										if (_tmp185_) {
											ValaDataType* _tmp186_ = NULL;
											ValaDataType* _tmp187_ = NULL;
											ValaSourceReference* _tmp188_ = NULL;
											ValaSourceReference* _tmp189_ = NULL;
											ValaArrayType* _tmp190_ = NULL;
											ValaParameter* _tmp191_ = NULL;
											ValaDataType* _tmp192_ = NULL;
											ValaParameter* _tmp193_ = NULL;
											_tmp186_ = param_type;
											_tmp187_ = param_type;
											_tmp188_ = vala_code_node_get_source_reference ((ValaCodeNode*) _tmp187_);
											_tmp189_ = _tmp188_;
											_tmp190_ = vala_array_type_new (_tmp186_, 1, _tmp189_);
											_vala_code_node_unref0 (param_type);
											param_type = (ValaDataType*) _tmp190_;
											_tmp191_ = p;
											_tmp192_ = param_type;
											vala_variable_set_variable_type ((ValaVariable*) _tmp191_, _tmp192_);
											_tmp193_ = p;
											vala_parameter_set_direction (_tmp193_, VALA_PARAMETER_DIRECTION_IN);
										}
									} else {
										gchar** _tmp194_ = NULL;
										gint _tmp194__length1 = 0;
										const gchar* _tmp195_ = NULL;
										_tmp194_ = nv;
										_tmp194__length1 = nv_length1;
										_tmp195_ = _tmp194_[0];
										if (g_strcmp0 (_tmp195_, "no_array_length") == 0) {
											gchar** _tmp196_ = NULL;
											gint _tmp196__length1 = 0;
											const gchar* _tmp197_ = NULL;
											gchar* _tmp198_ = NULL;
											gchar* _tmp199_ = NULL;
											gboolean _tmp200_ = FALSE;
											_tmp196_ = nv;
											_tmp196__length1 = nv_length1;
											_tmp197_ = _tmp196_[1];
											_tmp198_ = vala_gidl_parser_eval (self, _tmp197_);
											_tmp199_ = _tmp198_;
											_tmp200_ = g_strcmp0 (_tmp199_, "1") == 0;
											_g_free0 (_tmp199_);
											if (_tmp200_) {
												ValaParameter* _tmp201_ = NULL;
												_tmp201_ = p;
												vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp201_, "CCode", "array_length", FALSE, NULL);
											}
										} else {
											gchar** _tmp202_ = NULL;
											gint _tmp202__length1 = 0;
											const gchar* _tmp203_ = NULL;
											_tmp202_ = nv;
											_tmp202__length1 = nv_length1;
											_tmp203_ = _tmp202_[0];
											if (g_strcmp0 (_tmp203_, "array_length_type") == 0) {
												ValaParameter* _tmp204_ = NULL;
												gchar** _tmp205_ = NULL;
												gint _tmp205__length1 = 0;
												const gchar* _tmp206_ = NULL;
												_tmp204_ = p;
												_tmp205_ = nv;
												_tmp205__length1 = nv_length1;
												_tmp206_ = _tmp205_[1];
												vala_code_node_set_attribute_string ((ValaCodeNode*) _tmp204_, "CCode", "array_length_type", _tmp206_, NULL);
											} else {
												gchar** _tmp207_ = NULL;
												gint _tmp207__length1 = 0;
												const gchar* _tmp208_ = NULL;
												_tmp207_ = nv;
												_tmp207__length1 = nv_length1;
												_tmp208_ = _tmp207_[0];
												if (g_strcmp0 (_tmp208_, "array_null_terminated") == 0) {
													gchar** _tmp209_ = NULL;
													gint _tmp209__length1 = 0;
													const gchar* _tmp210_ = NULL;
													gchar* _tmp211_ = NULL;
													gchar* _tmp212_ = NULL;
													gboolean _tmp213_ = FALSE;
													_tmp209_ = nv;
													_tmp209__length1 = nv_length1;
													_tmp210_ = _tmp209_[1];
													_tmp211_ = vala_gidl_parser_eval (self, _tmp210_);
													_tmp212_ = _tmp211_;
													_tmp213_ = g_strcmp0 (_tmp212_, "1") == 0;
													_g_free0 (_tmp212_);
													if (_tmp213_) {
														ValaParameter* _tmp214_ = NULL;
														ValaParameter* _tmp215_ = NULL;
														_tmp214_ = p;
														vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp214_, "CCode", "array_length", FALSE, NULL);
														_tmp215_ = p;
														vala_code_node_set_attribute_bool ((ValaCodeNode*) _tmp215_, "CCode", "array_null_terminated", TRUE, NULL);
													}
												} else {
													gchar** _tmp216_ = NULL;
													gint _tmp216__length1 = 0;
													const gchar* _tmp217_ = NULL;
													_tmp216_ = nv;
													_tmp216__length1 = nv_length1;
													_tmp217_ = _tmp216_[0];
													if (g_strcmp0 (_tmp217_, "is_out") == 0) {
														gchar** _tmp218_ = NULL;
														gint _tmp218__length1 = 0;
														const gchar* _tmp219_ = NULL;
														gchar* _tmp220_ = NULL;
														gchar* _tmp221_ = NULL;
														gboolean _tmp222_ = FALSE;
														_tmp218_ = nv;
														_tmp218__length1 = nv_length1;
														_tmp219_ = _tmp218_[1];
														_tmp220_ = vala_gidl_parser_eval (self, _tmp219_);
														_tmp221_ = _tmp220_;
														_tmp222_ = g_strcmp0 (_tmp221_, "1") == 0;
														_g_free0 (_tmp221_);
														if (_tmp222_) {
															ValaParameter* _tmp223_ = NULL;
															_tmp223_ = p;
															vala_parameter_set_direction (_tmp223_, VALA_PARAMETER_DIRECTION_OUT);
														}
													} else {
														gchar** _tmp224_ = NULL;
														gint _tmp224__length1 = 0;
														const gchar* _tmp225_ = NULL;
														_tmp224_ = nv;
														_tmp224__length1 = nv_length1;
														_tmp225_ = _tmp224_[0];
														if (g_strcmp0 (_tmp225_, "is_ref") == 0) {
															gchar** _tmp226_ = NULL;
															gint _tmp226__length1 = 0;
															const gchar* _tmp227_ = NULL;
															gchar* _tmp228_ = NULL;
															gchar* _tmp229_ = NULL;
															gboolean _tmp230_ = FALSE;
															_tmp226_ = nv;
															_tmp226__length1 = nv_length1;
															_tmp227_ = _tmp226_[1];
															_tmp228_ = vala_gidl_parser_eval (self, _tmp227_);
															_tmp229_ = _tmp228_;
															_tmp230_ = g_strcmp0 (_tmp229_, "1") == 0;
															_g_free0 (_tmp229_);
															if (_tmp230_) {
																ValaParameter* _tmp231_ = NULL;
																_tmp231_ = p;
																vala_parameter_set_direction (_tmp231_, VALA_PARAMETER_DIRECTION_REF);
															}
														} else {
															gchar** _tmp232_ = NULL;
															gint _tmp232__length1 = 0;
															const gchar* _tmp233_ = NULL;
															_tmp232_ = nv;
															_tmp232__length1 = nv_length1;
															_tmp233_ = _tmp232_[0];
															if (g_strcmp0 (_tmp233_, "nullable") == 0) {
																gchar** _tmp234_ = NULL;
																gint _tmp234__length1 = 0;
																const gchar* _tmp235_ = NULL;
																gchar* _tmp236_ = NULL;
																gchar* _tmp237_ = NULL;
																gboolean _tmp238_ = FALSE;
																_tmp234_ = nv;
																_tmp234__length1 = nv_length1;
																_tmp235_ = _tmp234_[1];
																_tmp236_ = vala_gidl_parser_eval (self, _tmp235_);
																_tmp237_ = _tmp236_;
																_tmp238_ = g_strcmp0 (_tmp237_, "1") == 0;
																_g_free0 (_tmp237_);
																if (_tmp238_) {
																	ValaDataType* _tmp239_ = NULL;
																	_tmp239_ = param_type;
																	vala_data_type_set_nullable (_tmp239_, TRUE);
																}
															} else {
																gchar** _tmp240_ = NULL;
																gint _tmp240__length1 = 0;
																const gchar* _tmp241_ = NULL;
																_tmp240_ = nv;
																_tmp240__length1 = nv_length1;
																_tmp241_ = _tmp240_[0];
																if (g_strcmp0 (_tmp241_, "transfer_ownership") == 0) {
																	gchar** _tmp242_ = NULL;
																	gint _tmp242__length1 = 0;
																	const gchar* _tmp243_ = NULL;
																	gchar* _tmp244_ = NULL;
																	gchar* _tmp245_ = NULL;
																	gboolean _tmp246_ = FALSE;
																	_tmp242_ = nv;
																	_tmp242__length1 = nv_length1;
																	_tmp243_ = _tmp242_[1];
																	_tmp244_ = vala_gidl_parser_eval (self, _tmp243_);
																	_tmp245_ = _tmp244_;
																	_tmp246_ = g_strcmp0 (_tmp245_, "1") == 0;
																	_g_free0 (_tmp245_);
																	if (_tmp246_) {
																		ValaDataType* _tmp247_ = NULL;
																		_tmp247_ = param_type;
																		vala_data_type_set_value_owned (_tmp247_, TRUE);
																	}
																} else {
																	gchar** _tmp248_ = NULL;
																	gint _tmp248__length1 = 0;
																	const gchar* _tmp249_ = NULL;
																	_tmp248_ = nv;
																	_tmp248__length1 = nv_length1;
																	_tmp249_ = _tmp248_[0];
																	if (g_strcmp0 (_tmp249_, "type_name") == 0) {
																		ValaParameter* _tmp250_ = NULL;
																		gchar** _tmp251_ = NULL;
																		gint _tmp251__length1 = 0;
																		const gchar* _tmp252_ = NULL;
																		gchar* _tmp253_ = NULL;
																		gchar* _tmp254_ = NULL;
																		ValaDataType* _tmp255_ = NULL;
																		ValaDataType* _tmp256_ = NULL;
																		_tmp250_ = p;
																		_tmp251_ = nv;
																		_tmp251__length1 = nv_length1;
																		_tmp252_ = _tmp251_[1];
																		_tmp253_ = vala_gidl_parser_eval (self, _tmp252_);
																		_tmp254_ = _tmp253_;
																		_tmp255_ = vala_gidl_parser_parse_type_from_string (self, _tmp254_, FALSE, NULL);
																		_vala_code_node_unref0 (param_type);
																		param_type = _tmp255_;
																		_tmp256_ = param_type;
																		vala_variable_set_variable_type ((ValaVariable*) _tmp250_, _tmp256_);
																		_g_free0 (_tmp254_);
																	} else {
																		gchar** _tmp257_ = NULL;
																		gint _tmp257__length1 = 0;
																		const gchar* _tmp258_ = NULL;
																		_tmp257_ = nv;
																		_tmp257__length1 = nv_length1;
																		_tmp258_ = _tmp257_[0];
																		if (g_strcmp0 (_tmp258_, "type_arguments") == 0) {
																			ValaParameter* _tmp259_ = NULL;
																			ValaDataType* _tmp260_ = NULL;
																			ValaDataType* _tmp261_ = NULL;
																			gchar** _tmp262_ = NULL;
																			gint _tmp262__length1 = 0;
																			const gchar* _tmp263_ = NULL;
																			gchar* _tmp264_ = NULL;
																			gchar* _tmp265_ = NULL;
																			_tmp259_ = p;
																			_tmp260_ = vala_variable_get_variable_type ((ValaVariable*) _tmp259_);
																			_tmp261_ = _tmp260_;
																			_tmp262_ = nv;
																			_tmp262__length1 = nv_length1;
																			_tmp263_ = _tmp262_[1];
																			_tmp264_ = vala_gidl_parser_eval (self, _tmp263_);
																			_tmp265_ = _tmp264_;
																			vala_gidl_parser_parse_type_arguments_from_string (self, _tmp261_, _tmp265_, NULL);
																			_g_free0 (_tmp265_);
																		} else {
																			gchar** _tmp266_ = NULL;
																			gint _tmp266__length1 = 0;
																			const gchar* _tmp267_ = NULL;
																			_tmp266_ = nv;
																			_tmp266__length1 = nv_length1;
																			_tmp267_ = _tmp266_[0];
																			if (g_strcmp0 (_tmp267_, "namespace_name") == 0) {
																				gchar** _tmp268_ = NULL;
																				gint _tmp268__length1 = 0;
																				const gchar* _tmp269_ = NULL;
																				gchar* _tmp270_ = NULL;
																				_tmp268_ = nv;
																				_tmp268__length1 = nv_length1;
																				_tmp269_ = _tmp268_[1];
																				_tmp270_ = vala_gidl_parser_eval (self, _tmp269_);
																				_g_free0 (ns_name);
																				ns_name = _tmp270_;
																			}
																		}
																	}
																}
															}
														}
													}
												}
											}
										}
									}
								}
								nv = (_vala_array_free (nv, nv_length1, (GDestroyNotify) g_free), NULL);
								_g_free0 (attr);
							}
						}
					}
					_tmp271_ = ns_name;
					if (_tmp271_ != NULL) {
						ValaDataType* _tmp272_ = NULL;
						ValaUnresolvedSymbol* _tmp273_ = NULL;
						ValaUnresolvedSymbol* _tmp274_ = NULL;
						const gchar* _tmp275_ = NULL;
						ValaUnresolvedSymbol* _tmp276_ = NULL;
						ValaUnresolvedSymbol* _tmp277_ = NULL;
						_tmp272_ = param_type;
						_tmp273_ = vala_unresolved_type_get_unresolved_symbol (G_TYPE_CHECK_INSTANCE_CAST (_tmp272_, VALA_TYPE_UNRESOLVED_TYPE, ValaUnresolvedType));
						_tmp274_ = _tmp273_;
						_tmp275_ = ns_name;
						_tmp276_ = vala_unresolved_symbol_new (NULL, _tmp275_, NULL);
						_tmp277_ = _tmp276_;
						vala_unresolved_symbol_set_inner (_tmp274_, _tmp277_);
						_vala_code_node_unref0 (_tmp277_);
					}
					_g_free0 (ns_name);
				}
				_tmp279_ = show_param;
				if (_tmp279_) {
					_tmp278_ = TRUE;
				} else {
					gboolean _tmp280_ = FALSE;
					_tmp280_ = hide_param;
					_tmp278_ = !_tmp280_;
				}
				_tmp281_ = _tmp278_;
				if (_tmp281_) {
					ValaSignal* _tmp282_ = NULL;
					ValaParameter* _tmp283_ = NULL;
					_tmp282_ = sig;
					_tmp283_ = p;
					vala_signal_add_parameter (_tmp282_, _tmp283_);
				}
				_vala_code_node_unref0 (p);
				_vala_code_node_unref0 (param_type);
			}
		}
	}
	result = sig;
	attributes = (_vala_array_free (attributes, attributes_length1, (GDestroyNotify) g_free), NULL);
	return result;
}


ValaGIdlParser* vala_gidl_parser_construct (GType object_type) {
	ValaGIdlParser* self = NULL;
	self = (ValaGIdlParser*) vala_code_visitor_construct (object_type);
	return self;
}


ValaGIdlParser* vala_gidl_parser_new (void) {
	return vala_gidl_parser_construct (VALA_TYPE_GIDL_PARSER);
}


static void vala_gidl_parser_class_init (ValaGIdlParserClass * klass) {
	vala_gidl_parser_parent_class = g_type_class_peek_parent (klass);
	VALA_CODE_VISITOR_CLASS (klass)->finalize = vala_gidl_parser_finalize;
	g_type_class_add_private (klass, sizeof (ValaGIdlParserPrivate));
	VALA_CODE_VISITOR_CLASS (klass)->visit_namespace = vala_gidl_parser_real_visit_namespace;
	VALA_CODE_VISITOR_CLASS (klass)->visit_class = vala_gidl_parser_real_visit_class;
	VALA_CODE_VISITOR_CLASS (klass)->visit_struct = vala_gidl_parser_real_visit_struct;
	VALA_CODE_VISITOR_CLASS (klass)->visit_interface = vala_gidl_parser_real_visit_interface;
	VALA_CODE_VISITOR_CLASS (klass)->visit_enum = vala_gidl_parser_real_visit_enum;
	VALA_CODE_VISITOR_CLASS (klass)->visit_error_domain = vala_gidl_parser_real_visit_error_domain;
	VALA_CODE_VISITOR_CLASS (klass)->visit_delegate = vala_gidl_parser_real_visit_delegate;
	VALA_CODE_VISITOR_CLASS (klass)->visit_source_file = vala_gidl_parser_real_visit_source_file;
}


static void vala_gidl_parser_instance_init (ValaGIdlParser * self) {
	self->priv = VALA_GIDL_PARSER_GET_PRIVATE (self);
}


static void vala_gidl_parser_finalize (ValaCodeVisitor* obj) {
	ValaGIdlParser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, VALA_TYPE_GIDL_PARSER, ValaGIdlParser);
	_vala_code_context_unref0 (self->priv->context);
	_vala_source_file_unref0 (self->priv->current_source_file);
	_vala_source_reference_unref0 (self->priv->current_source_reference);
	_vala_code_node_unref0 (self->priv->current_namespace);
	_vala_code_node_unref0 (self->priv->current_data_type);
	_vala_map_unref0 (self->priv->codenode_attributes_map);
	_vala_map_unref0 (self->priv->codenode_attributes_patterns);
	_vala_iterable_unref0 (self->priv->current_type_symbol_set);
	_vala_map_unref0 (self->priv->cname_type_map);
	VALA_CODE_VISITOR_CLASS (vala_gidl_parser_parent_class)->finalize (obj);
}


/**
 * Code visitor parsing all GIDL files.
 */
GType vala_gidl_parser_get_type (void) {
	static volatile gsize vala_gidl_parser_type_id__volatile = 0;
	if (g_once_init_enter (&vala_gidl_parser_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ValaGIdlParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) vala_gidl_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ValaGIdlParser), 0, (GInstanceInitFunc) vala_gidl_parser_instance_init, NULL };
		GType vala_gidl_parser_type_id;
		vala_gidl_parser_type_id = g_type_register_static (VALA_TYPE_CODE_VISITOR, "ValaGIdlParser", &g_define_type_info, 0);
		g_once_init_leave (&vala_gidl_parser_type_id__volatile, vala_gidl_parser_type_id);
	}
	return vala_gidl_parser_type_id__volatile;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint _vala_array_length (gpointer array) {
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



